import { Injectable } from '@angular/core';
import { CanActivate, Router,CanActivateChild ,RouterStateSnapshot,ActivatedRouteSnapshot} from '@angular/router';
import {Observable} from 'rxjs/Observable';
import { CommonService } from './common-service.service';

@Injectable()
export class AuthGuard implements  CanActivate, CanActivateChild {
  
  constructor(private commonService: CommonService,private router: Router ) {}
  
  canActivate(route: ActivatedRouteSnapshot,state: RouterStateSnapshot): boolean {
    
    let module_name = route.data.module;    
    let routeData = route.data || {};
    if(module_name)
    { 
      return this.commonService.sendRequestToNode({method :'get',path:'get-login-detail',url:'http://localhost:8042'})
      .map(data => {
        if(data.status == true)
            {
              let loginData;
              loginData = JSON.stringify(data.loginData);
              localStorage.setItem(this.commonService.prefix+'userData', loginData);
              if((data.loginData.role_id == 1 && !routeData.onlySuperAdmin) || data.loginData.role_id == 0){
                return true;
              }
              else if(module_name == "common"){ // this for all accessible
                return true;
              }
              else{
                let permission = data.loginData.permission ? JSON.parse(data.loginData.permission) : ''; 
                if(permission[module_name])
                {
                  return true;
                }
              }
              
              this.router.navigate(['authentication/403']);
              return false;
            }
            else{
              console.log('error occured in get login data')
                // return false;
              
                localStorage.removeItem(this.commonService.prefix+'userData');
                this.router.navigate(['/login'] 
                // {
                //   queryParams: {
                //     return: state.url
                //   }
                // }
                );
          
            }
      })
  
    }
    else
    {
      alert('this route not part any module ,pls define module ')
      return true;
    }
  }

  canActivateChild() {
    return true;
  }

}