import { Component, AfterViewInit,OnInit, ElementRef,ViewChild } from '@angular/core';
import { NgbModal } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';
//import { parse } from 'path';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';

@Component({
  templateUrl: './auto_reports.component.html',
  styleUrls: ['./auto_reports.component.scss']
})
export class AutoReportsComponent implements AfterViewInit,OnInit {

  public config: PerfectScrollbarConfigInterface = {};

    //old code
  // public daily;
  // public weekly;
  // public monthly;


  public user_dropdown;
  public template_type_dropdown = [];
  public frequency =[
    { ID:'weekly',FREQUENCY:'Weekly'},
    { ID:'monthly',FREQUENCY:'Monthly'},
    { ID:'quaterly',FREQUENCY:'Quarterly'},
    { ID:'sixth_month',FREQUENCY:'Six Monthly'},
    { ID:'yearly',FREQUENCY:'Annually'},
  ];
  public week_day =[
    { ID:0,DAY:'Sunday'},
    { ID:1,DAY:'Monday'},
    { ID:2,DAY:'Tuesday'},
    { ID:3,DAY:'Wednesday'},
    { ID:4,DAY:'Thursday'},
    { ID:5,DAY:'Friday'},
    { ID:6,DAY:'Saturday'},
  ];
  public month_day =[
    { ID:1,DATE:1},
    { ID:2,DATE:2},
    { ID:3,DATE:3},
    { ID:4,DATE:4},
    { ID:5,DATE:5},
    { ID:6,DATE:6},
    { ID:7,DATE:7},
    { ID:8,DATE:8},
    { ID:8,DATE:8},
    { ID:9,DATE:9},
    { ID:10,DATE:10},
    { ID:11,DATE:11},
    { ID:12,DATE:12},
    { ID:13,DATE:13},
    { ID:14,DATE:14},
    { ID:15,DATE:15},
    { ID:16,DATE:16},
    { ID:17,DATE:17},
    { ID:18,DATE:18},
    { ID:19,DATE:19},
    { ID:20,DATE:20},
    { ID:21,DATE:21},
    { ID:22,DATE:22},
    { ID:23,DATE:23},
    { ID:24,DATE:24},
    { ID:25,DATE:25},
    { ID:26,DATE:26},
    { ID:27,DATE:27},
    { ID:28,DATE:28},
    { ID:29,DATE:29},
    { ID:30,DATE:30},
  ];
  public timespan =[
    { ID:'last_week',TIMESPAN:'Last Week'},
    { ID:'last_month',TIMESPAN:'Last Month'},
    { ID:'last_quarter',TIMESPAN:'Last Quarter'},
    { ID:'last_six_monthly',TIMESPAN:'Last Six Month'},
    { ID:'last_year',TIMESPAN:'Last Year'},
  ];
  public sire_reports_format = [
    {value : 'fleet_x_avgObs',title : 'Fleet Wise Average Number Of Observations'},
    {value : 'fleet_x_avgRisk',title : 'Fleet Wise Average Risk Value'},
    {value : 'vessel_x_avgObs',title : 'Ship Wise Average Number Of Observations'},
    {value : 'vessel_x_totalInspection',title : 'Ship Wise Number Of Inspection'},
    {value : 'vessel_x_totalObs',title : 'Ship Wise Number Of Observation'},
    {value : 'vessel_x_avgRisk',title : 'Ship Wise Average Risk Value'},
    {value : 'marineSupr_x_avgObs',title : 'Average Number Of Observations Of Marine Superintendents'},
    {value : 'marineSupr_x_avgRisk',title : 'Average Risk Value Of Observations Of Marine Superintendents'},
    {value : 'technicalSupr_x_avgObs',title : 'Average Number Of Observations Of Technical Superintendents'},
    {value : 'technicalSupr_x_avgRisk',title : 'Average Risk Value Of Observations Of Technical Superintendents'},
    {value : 'oil_major_percentage',title : 'Oil Major % chart'},
    // {value : 'chapter_wise_perfomance_of_fleet',title : 'Chapter wise performance of entire fleet in SIRE inspection in the Last Year'},
    {value : 'top_10_repeated_obs',title : 'Top 10 Most Repeated Observation',type : "report"},
    {value : 'high_veryHigh_obs',title : 'Very High Risk and High Risk Observations',type : "report"},
    {value : 'upcoming_inspection',title : 'Upcoming Inspections',type : "report"},
    //remains
    {value : 'companyByMonths_x_totalObs',title : 'The Average Number Of Observations For Company By Months',type : "report"},
    {value : 'companyByMonths_x_avgRisk',title : 'The Average Risk Value For Company By Months'},
    {value : 'operator_response_due',title : 'Operator Response Due',type : "report"},
    {value : 'vesselOwner_x_avgObs',title : 'The Average Number Of Observations Of Vessel Owner'},
    {value : 'oilMajor_x_avgObs',title : 'The Average Number Of Observations Of Oil Major'},
    {value : 'total_inspection',title : 'Total Number Of Inspections'},
    {value : 'count_number_obs_per_chapter',title : 'Count Of Number Of Observations Per VIQ Chapter'},
    {value : 'average_number_obs_per_chapter',title : 'Average Number Of Observations Per VIQ chapter'},
    {value : 'chapter_wise_performance_inspection',title : 'Chapter Wise Performance Of Entire Fleet In SIRE Inspection'}

  ];

  public tmsa_reports_format = [
    {value : '',title : ''}
  ];

  public validators = [this.emailValid];
  public errorMessages = {
    'emailValid': 'Please Enter Valid Email Address',
  };
  public autoReportForm:FormGroup;
  public edit_id = "";
  public showLoader = false;
  public formSubmittedAttempt = false;
  
  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;

  @ViewChild('autofocus') el:ElementRef;

  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private formBuilder: FormBuilder,
    private route: ActivatedRoute,
    private router: Router
    ){
      this.route.params.subscribe(params => {
        this.edit_id = params.id
     });
  }

  private emailValid(control: FormControl) {
    var re = /^(([^<>()\[\]\\.,;:\s@"]+(\.[^<>()\[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/;
    if (!re.test(String(control.value).toLowerCase())) {
        return {
            'emailValid': true
        };
    }

    return null;
}


  ngAfterViewInit(){
  }

  ngOnInit(){
    this.userDropDown();
    this.templateTypeDropdown()
    this.addForm(); 
    if(this.edit_id){
      this.getDataFromId(this.edit_id);
    } 
  }
  getDataFromId(autoReportID){
    this.showLoader = true;  
    this.commonService.sendRequestToNode({method :'get',path:'auto-report-template/' + autoReportID}).subscribe(
      result => {
        if(result.status){
          let data = result.data[0];
          let userIds = '';
          if( data.USER_IDS && data.USER_IDS.split(',').length > 0 ) {
            userIds = data.USER_IDS.split(',').map((v)=>{
              return parseInt(v);
            });
          }
          this.autoReportForm.patchValue({
            TEMPLATE_NAME : data.TEMPLATE_NAME,
            USER_EMAILS : data.USER_EMAILS ? data.USER_EMAILS.split(',') : '',
            USER_IDS : userIds ,
            SEND_FREQUENCY : data.SEND_FREQUENCY,
            SEND_DAY : data.SEND_DAY,
            REPORTS_FORMAT : data.REPORTS_FORMAT ? JSON.parse(data.REPORTS_FORMAT) : [],
            REPORTS_FORMAT_TMSA : data.REPORTS_FORMAT_TMSA ? JSON.parse(data.REPORTS_FORMAT_TMSA) : []
          });
          this.showLoader = false;
        }
        else{
          alert(result.message);
          this.router.navigate(["/auto-reports"]);
        }
    })

  }

  addForm() {
    this.autoReportForm = this.formBuilder.group({
      TEMPLATE_NAME : ['',[Validators.required]],
      USER_EMAILS : ['',] ,
      USER_IDS : [''] ,
      SEND_FREQUENCY : [undefined,[Validators.required]] ,
      SEND_DAY : [undefined],
      REPORTS_FORMAT : [[]],
      REPORTS_FORMAT_TMSA : [[]]       
    });
  
  }

  changeFrequency(){
    this.autoReportForm.patchValue({
      SEND_DAY : undefined
    })
  }

  addReportFormat(isTmsa = 0){
     //return;
      // alert( 'i am ')
    if(isTmsa){
      // alert('here');
      let v = this.autoReportForm.get('REPORTS_FORMAT_TMSA').value;
      v.push({});
      this.autoReportForm.patchValue({
        'REPORTS_FORMAT_TMSA' : v
      })
    }
    else {
      // alert('fff');
      let v = this.autoReportForm.get('REPORTS_FORMAT').value;
      v.push({});
      this.autoReportForm.patchValue({
        'REPORTS_FORMAT' : v
      })
    }
  }
  removeReportFormat(i,isTmsa = 0){
    if(isTmsa){
      let v = this.autoReportForm.get('REPORTS_FORMAT_TMSA').value;
      v.splice(i,1);
      this.autoReportForm.patchValue({
        'REPORTS_FORMAT_TMSA' : v
      })
    }
    else{
      let v = this.autoReportForm.get('REPORTS_FORMAT').value;
      v.splice(i,1);
      this.autoReportForm.patchValue({
        'REPORTS_FORMAT' : v
      })
    }
  }

  saveReportTemplate(){
    this.formSubmittedAttempt = true;
    let flagSireReport = false;
    if(this.autoReportForm.value.REPORTS_FORMAT.length > 0){
      this.autoReportForm.value.REPORTS_FORMAT.forEach(element => {
        
        if(!element.report_title){
          flagSireReport = true;
        }
        else if(element.report_title != 'upcoming_inspection' && element.report_title != 'operator_response_due'){
          if(element.report_title && !element.timespan){
            flagSireReport = true;
          }
        }
      });
    }
    
    if(this.autoReportForm.valid){
      if(flagSireReport){
        alert('Please Select Report Title And Timespan');return false;
      }
      swal({
        title: 'Are you sure?',
        text: "As per your selection, the system is about to send you emails! Do you want to confirm?",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, Save It!',
         buttonsStyling: false
      }).then((result) => {
        if (result.value) {
          if(this.edit_id){
            this.commonService.sendRequestToNode({method :'put',path:'auto-report-template/'+this.edit_id,postData : this.autoReportForm.value}).subscribe(result => {
              if(result.status){
                var dialogueTitle = "Updated!"
                swal({
                  title: dialogueTitle,
                  text: result.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                }).then(res=>{
                  this.router.navigate(["/auto-reports"]);
                })
              }
              else{
                alert(result.message);
              }
            })
          }
          else{
            this.commonService.sendRequestToNode({method :'post',path:'auto-report-template',postData : this.autoReportForm.value}).subscribe(result => {
              if(result.status){
                var dialogueTitle = "Updated!"
                swal({
                  title: dialogueTitle,
                  text: result.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                }).then(res=>{
                  this.router.navigate(["/auto-reports"]);
                })
              }
              else{
                alert(result.message);
              }
            })
          }
        }
        
      })
    }
    
    
    
  }

  userDropDown(){
    this.commonService.sendRequestToNode({method :'get',path:'user-dropdown'}).subscribe(result => {
      if(result.status){
        this.user_dropdown = result.data;
      }
      else{
        this.user_dropdown = [];
        alert(result.message);
      }
    })
  }

  templateTypeDropdown() {
    //sire-dropdown
    this.commonService.sendRequestToNode({ method: 'get', path: 'template-type-dropdown' }).subscribe(result => {
        if (result.status) {
            let array = [];
            result.data.forEach(element => {
                array.push({ value: JSON.stringify(element), display: element.TEMPLATE_TYPE })
            });
            this.template_type_dropdown = array;
        }
        else {
          this.template_type_dropdown = [];
        }
    });
}

  Cancel(){
    this.router.navigate(["/auto-reports"])
  }
}
 
