import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule,ReactiveFormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

import { AutoReportsComponent } from './addEdit/auto_reports.component';
import { AutoReportsListComponent } from './list/auto_reports_list.component';
import { AutoReportsViewComponent } from './view/auto_reports_view.component';

import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { UiSwitchModule } from 'ngx-toggle-switch';
import { NgSelectModule } from '@ng-select/ng-select';
import { TagInputModule } from 'ngx-chips';
import { GridViewModule} from '../shared/grid-view/grid-view.module';
// import { decodeJson } from '../../app/common.pipe';


const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};

const routes: Routes = [
  {
    path: 'add',
    data: {
      title: 'Auto Reports',
      urls: [
        { title: 'Dashboard', url: '/dashboard' },
        { title: 'Auto Reports', url: '/auto-reports' },
        { title: 'Add' }
      ]
    },
    component: AutoReportsComponent
  },
  {
    path: 'edit/:id',
    data: {
      title: 'Auto Reports',
      urls: [
        { title: 'Dashboard', url: '/dashboard' },
        { title: 'Auto Reports', url: '/auto-reports' },
        { title: 'Edit' }
      ]
    },
    component: AutoReportsComponent
  },
  {
    path: 'view/:id',
    data: {
      title: 'Auto Reports',
      urls: [
        { title: 'Dashboard', url: '/dashboard' },
        { title: 'Auto Report', url: '/auto-reports' },
        { title: 'View' }
      ]
    },
    component: AutoReportsViewComponent
  },
  {
    path: '',
    data: {
      title: 'Auto Reports',
      urls: [
        { title: 'Dashboard', url: '/dashboard' },
        { title: 'Auto Reports' }
      ]
    },
    component: AutoReportsListComponent
  }
  
];

@NgModule({
  imports: [
    FormsModule,
    CommonModule,
    RouterModule.forChild(routes),
    NgbModule,
    ReactiveFormsModule,
    PerfectScrollbarModule,
    UiSwitchModule,
    NgSelectModule,
    TagInputModule,
    GridViewModule
  ],
  declarations: [
    AutoReportsComponent,
    AutoReportsListComponent,
    AutoReportsViewComponent,
    // decodeJson
  ],
  providers: [
    {
      provide: PERFECT_SCROLLBAR_CONFIG,
      useValue: DEFAULT_PERFECT_SCROLLBAR_CONFIG
    },
  ]
})
export class AutoReportsModule {}
