import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';
//import { parse } from 'path';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';

@Component({
  templateUrl: './auto_reports_list.component.html',
  styleUrls: ['./auto_reports_list.component.scss']
})
export class AutoReportsListComponent implements AfterViewInit,OnInit {

  public config: PerfectScrollbarConfigInterface = {};
  
  // public frequency =[
  //   { ID:'weekly',FREQUENCY:'Weekly'},
  //   { ID:'monthly',FREQUENCY:'Monthly'},
  //   { ID:'quaterly',FREQUENCY:'Quarterly'},
  //   { ID:'sixth_month',FREQUENCY:'Six Monthly'},
  //   { ID:'yearly',FREQUENCY:'Annually'},
  // ];
  public frequency ={
    'weekly' : 'Weekly',
    'monthly' : 'Monthly',
    'quaterly' : 'Quarterly',
    'sixth_month' : 'Six Monthly',
    'yearly' : 'Annually'
  } 
  public week_day =[
    { ID:0,DAY:'Sunday'},
    { ID:1,DAY:'Monday'},
    { ID:2,DAY:'Tuesday'},
    { ID:3,DAY:'Wednesday'},
    { ID:4,DAY:'Thursday'},
    { ID:5,DAY:'Friday'},
    { ID:6,DAY:'Saturday'},
  ];
  
  public timespan =[
    { ID:'Last Week',TIMESPAN:'Last Week'},
    { ID:'Last Month',TIMESPAN:'Last Month'},
    { ID:'Last Quarter',TIMESPAN:'Last Quarter'},
    { ID:'Last Six Monthly',TIMESPAN:'Last Six Month'},
    { ID:'Last Year',TIMESPAN:'Last Year'},
  ];
  public sire_reports_format = {
    'fleet_x_avgObs' : 'Fleet Wise Average Number Of Observations',
    'fleet_x_avgRisk' : 'Fleet Wise Average Risk Value',
    'vessel_x_avgRisk' : 'Ship Wise Average Risk Value',
    'vessel_x_avgObs' : 'Ship Wise Average Number Of Observations',
    'vessel_x_totalInspection' : 'Ship Wise Number Of Inspection',
    'vessel_x_totalObs' : 'Ship Wise Number Of Observation',
    'marineSupr_x_avgObs' : 'Average Number Of Observations Of Marine Superintendents',
    'marineSupr_x_avgRisk' : 'Average Risk Value Of Observations Of Marine Superintendents',
    'technicalSupr_x_avgObs' : 'Average Number Of Observations Of Technical Superintendents',
    'technicalSupr_x_avgRisk' : 'Average Risk Value Of Observations Of Technical Superintendents',
    'top_10_repeated_obs' : 'Top 10 Most Repeated Observation',
    'high_veryHigh_obs' : 'Very High Risk and High Risk Observations',
    'oil_major_percentage' : 'Oil Major % chart',
    'upcoming_inspection' : 'Upcoming Inspections',
    'companyByMonths_x_totalObs' : 'The Average Number Of Observations For Company By Months', 
    'companyByMonths_x_avgRisk' : 'The Average Risk Value For Company By Months',
    'operator_response_due' : 'Operator Response Due',
    'vesselOwner_x_avgObs' : 'The Average Number Of Observations Of Vessel Owner', 
    'oilMajor_x_avgObs' : 'The Average Number Of Observations Of Oil Major', 
    'total_inspection' : 'Total Number Of Inspections',
    'chapter_wise_performance_inspection' : 'Chapter Wise Performance Of Entire Fleet In SIRE Inspection'
  }

  
  public tmsa_reports_format = [
    {value : '',title : ''}
  ]

  public reportTemplateData;
  public filterObj:any = {};
  public sortFilter:any = {};
  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;

  //for grid 
  public headerInformation;
  public actionButtons;

  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private router: Router
    ){

        let filterObj = this.commonService.getRouteData('auto_report_filter_data');
    if(filterObj){
      this.filterObj = filterObj;
      this.commonService.clearRouteData('auto_report_filter_data')
    }
  }


  ngAfterViewInit(){
  }

  ngOnInit(){
    this.getReportTemplateData(); 
    this.declareGridVariable();
  }
  
  declareGridVariable(){
    this.headerInformation = [
      {
        title : 'Template Name',// show title table header
        nameIcon : true,// show icon of First letter
        name:'TEMPLATE_NAME',// name of column in data source
        width : '20%',// width of column in table
        isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Template Name'
        }
      },
      {
        title : 'Send Frequency',// show title table header
        nameIcon : true,// show icon of First letter
        name:'SEND_FREQUENCY',// name of column in data source
        display_value : this.frequency,
        width : '20%',// width of column in table
        // isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'select',
          options_value : ['weekly','monthly','quaterly','sixth_month','yearly'],
          options_display : ['Weekly','Monthly','Quarterly','Six Monthly','Annually'],
          placeholder : 'Filter By Send Frequency'
        }
      },
      {title : '',name:'',width : '40%'},
      {title : 'Action',name:'action',width : '20%'}
    ];
    this.actionButtons = [
      {title:'Edit',class : "far fa-edit"},
      {title:'Delete',class : "far fa-trash-alt"},
      {title:'View',class : "fa fa-eye"},
      {title:'Download-Report',class : "fa fa-download"}
    ]
  }
  //part of grid
  clickOnAction(actionObj){
    if(actionObj.actionName == 'Edit'){
      this.edit(actionObj.object.ID)
    }else if(actionObj.actionName == 'Delete'){
      this.delete(actionObj.object.ID)
    }else if(actionObj.actionName == 'View'){
      this.View(actionObj.object.ID)
    }
    else if(actionObj.actionName == 'Download-Report'){
      this.download(actionObj.object.ID)
    }
  }
  download(id){
    window.location.href = this.commonService.getNodeApi() + '/download-chart-data/'+id ;
  }
  edit(id){
    this.commonService.setRouteData('auto_report_filter_data',this.filterObj);
    this.router.navigate(["/auto-reports/edit/"+id]);
  }

  View(id){
    this.commonService.setRouteData('auto_report_filter_data',this.filterObj);
    this.router.navigate(["/auto-reports/view/"+id]);
  }

  delete(id){
    if(id){
      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, delete it!',
         buttonsStyling: false
      }).then((result) => {
        if (result.value) {
          this.commonService.sendRequestToNode({method :'delete',path:'auto-report-template/'+id}).subscribe(
          data => {
          if(data.status){
            var dialogueTitle = "Deleted!"
            if(this.reportTemplateData.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
              if(this.currentPage>1){
                this.currentPage--;
              }
            }
            this.getReportTemplateData();
            swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
          }         
          
      })
         }
      })      
    }
  }

  getReportTemplateData()
  {
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    // pagination
    filterParams.currentPage = this.currentPage-1;
    filterParams.itemsPerPage = this.itemsPerPage;
    // pagination - end

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end

      this.commonService.sendRequestToNode({method :'get',path:'auto-report-template',queryParam:filterParams}).subscribe(
      result => {
        if(result.status)
        {
          if(result.data.length > 0){
            this.totalItems = result.data[0].total_records;
            this.reportTemplateData = result.data;
          }else{
            this.reportTemplateData = [];
          }
        }
        else{
          this.reportTemplateData = [];
          alert(result.message);
        }
    })
  }

  //click on Add button
  funOpenRightSidebar(){
    this.commonService.setRouteData('auto_report_filter_data',this.filterObj);
    this.router.navigate(["/auto-reports/add"]);
    // this.openRightSidebar = true; 
  }
  filter($event) {
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getReportTemplateData();
  }

}
 
