import { Component, Input, ViewChild,Renderer,forwardRef, Output,EventEmitter } from '@angular/core';
import {ControlValueAccessor, NG_VALUE_ACCESSOR} from '@angular/forms';

const VALUE_ACCESSOR = {
  provide: NG_VALUE_ACCESSOR,
  useExisting: forwardRef(() => InlineEditComponentComp),
  multi: true
};

@Component({
  selector: 'app-inline-edit-comp',
  templateUrl: './inline-edit.component.html',
  providers: [VALUE_ACCESSOR],
  styleUrls: ['./inline-edit.component.scss']
})

export class InlineEditComponentComp implements ControlValueAccessor{
  @Input() label: string = "Enter value"; 
  @Input() required: boolean = true; 
  
  
  @Output() updateData = new EventEmitter<any>();
  private _value: string = ''; 
  private preValue: string = '';
  public editing: boolean = false; 
  public onChange: any = Function.prototype; 
  public onTouched: any = Function.prototype; 

  get value(): any {
    return this._value;
  }

  set value(v: any) {
    if (v !== this._value) {
      this._value = v;
      this.onChange(v);
    }
  }

  writeValue(value: any) {
    this._value = value;
  }

  public registerOnChange(fn: (_: any) => {}): void {
    this.onChange = fn;
  }

  public registerOnTouched(fn: () => {}): void {
    this.onTouched = fn;
  }

  onBlur($event: Event) {
    this.editing = false;
    if ( typeof this._value == 'number' && this._value == 0 ){
      this._value = "Zero";
    } else  if ( typeof this._value == 'number' && this._value != 0){
      this._value = this._value;
    } else if(typeof this._value == 'object' )  {
      this._value = "No value available";
    }
    this.updateData.emit(this._value);
  }

  beginEdit(value) {
    // this.nativeElement.focus
    this.preValue = value;
    this.editing = true;
  }
}
