import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule,ReactiveFormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import { UiSwitchModule } from 'ngx-toggle-switch';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { NgSelectModule } from '@ng-select/ng-select';
// import { InlineEditComponent } from '../component/inline-edit-component/inline-edit.component';
const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};
import { InlineEditComponentComp } from './inline-edit.component';


@NgModule({
    imports: [FormsModule,
    CommonModule,
    NgbModule,
    ReactiveFormsModule,
    PerfectScrollbarModule,
    NgSelectModule,
    UiSwitchModule],
    declarations: [ InlineEditComponentComp],
    exports: [ InlineEditComponentComp ],
    providers:[{
      provide: PERFECT_SCROLLBAR_CONFIG,
      useValue: DEFAULT_PERFECT_SCROLLBAR_CONFIG
    }]
})

export class InlineEditModule {}