import { Component, AfterViewInit, ViewChild, OnInit } from '@angular/core';
import { CommonService } from '../common-service.service';
import { Router, ActivatedRoute } from "@angular/router";
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';

//this is define because some issue in retention page(when load this page and go)
import * as pluginAnnotations from 'chartjs-plugin-annotation';
import 'chartjs-plugin-labels';

import { ConsoleService } from '@ng-select/ng-select/ng-select/console.service';
import { log } from 'util';

const monthNames = ["January", "February", "March", "April", "May", "June",
  "July", "August", "September", "October", "November", "December"
];

@Component({
  templateUrl: './dashboard-demo.component.html',
  styleUrls: ['./dashboard-demo.component.scss']
})
export class DashboardDemoComponent implements AfterViewInit {


  tabStatus = 'justified';
  public expanded = [];
  public questions_dropdown = [];
  public sire_template_dropdown = [];
  public vesselFleet_dropdown = [];
  public vesselGroup_dropdown = [];
  public pastAdminObservationDataCount = [];
  public vessel_dropdown = [];
  public isRiskForCompany = false; //calculate risk For Company or admin
  displayMonths = 2;
  public modalRef: NgbModalRef;
  public filterObjObsChart: any        = { start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))), end_date: this.commonService.formatDate(new Date()) };
  public filterObjRiskChart: any       = { start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))), end_date: this.commonService.formatDate(new Date()) };;
  public filterObjSireRiskBreakUp: any = { start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))), end_date: this.commonService.formatDate(new Date()) };;
  public filterObjInspectionMajor: any = { start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))), end_date: this.commonService.formatDate(new Date()) };;
  public filterObjNoOfInspBreakUp: any = { start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))), end_date: this.commonService.formatDate(new Date()) };;
  public filterObjOfKpi: any = {};
  public filterObjOfAllVesselKpi: any = {};
  
  public resultOfObservation: any = {};
  public resultOfRisk: any = {};
  public filterObjGauge_chart: any = {};
  public vessel_id = {};
  public pluginAnnotations = pluginAnnotations;

  public inspectionPerOilMajorData = [];
  public inspectionPerOilMajorDataFinal = '';
  public inspectionPerOilMajorDataName = [];
  public inspectionPerOilMajorDataNameFinal = '';
  public topTwentyObservationCountData;
  public sireHighRiskObservationDataCount;
  public sireHighRiskObservationDataComCount;
  public pastObservationDataCount = [];
  public totalPastObservationDataCount;
  public chart_type = 'admin';
  public INSPECTOR_ID;
  public INSPECTOR_NAME;
  public IS_COMPANY_OBS = false;
  public upcoming_Inspection;
  public selected_template;
  public selected_question_no;

  //this is for kpi value
  public configuration:any = {};
  // Initial Risk Pie chart
  public initialRiskLabels: string[] = [
    'LOW',
    'MEDIUM',
    'HIGH',
    'V.HIGH'
  ];
  public initialRiskType = 'pie';

  public initialRiskOptions1: any = {
    title: {
      text: 'SIRE Observations as per value',
      display: true,
      position: 'bottom'
    },
  plugins: {
    labels: {
      // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
      render: 'value',

      // precision for percentage, default is 0
      precision: 0,

      // identifies whether or not labels of value 0 are displayed, default is false
      showZero: false,

      // font size, default is defaultFontSize
      fontSize: 10,

      // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
      fontColor: '#000',

      // font style, default is defaultFontStyle
      fontStyle: 'normal',

      // font family, default is defaultFontFamily
      fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",

      // draw text shadows under labels, default is false
    //   textShadow: true,

      // text shadow intensity, default is 6
    //   shadowBlur: 10,

      // text shadow X offset, default is 3
      shadowOffsetX: -5,

      // text shadow Y offset, default is 3
      shadowOffsetY: 5,

      // text shadow color, default is 'rgba(0,0,0,0.3)'
      shadowColor: 'rgba(255,0,0,0.75)',

      // draw label in arc, default is false
      // bar chart ignores this
      arc: true,

      // position to draw label, available value is 'default', 'border' and 'outside'
      // bar chart ignores this
      // default is 'default'
      position: 'default',

      // draw label even it's overlap, default is true
      // bar chart ignores this
      overlap: true,

      // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
      showActualPercentages: true,

      

      // add padding when position is `outside`
      // default is 2
      outsidePadding: 4,

      // add margin of text when position is `outside` or `border`
      // default is 2
      textMargin: 2
    }
  }

  }
  public initialRiskOptions2: any = {
    title: {
      text: 'Inspection By Vessel Type',
      display: true,
      position: 'bottom'
    },
  plugins: {
    labels: {
      // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
      render: 'value',

      // precision for percentage, default is 0
      precision: 0,

      // identifies whether or not labels of value 0 are displayed, default is false
      showZero: false,

      // font size, default is defaultFontSize
      fontSize: 10,

      // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
      fontColor: '#000',

      // font style, default is defaultFontStyle
      fontStyle: 'normal',

      // font family, default is defaultFontFamily
      fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",

      // draw text shadows under labels, default is false
    //   textShadow: true,

      // text shadow intensity, default is 6
    //   shadowBlur: 10,

      // text shadow X offset, default is 3
      shadowOffsetX: -5,

      // text shadow Y offset, default is 3
      shadowOffsetY: 5,

      // text shadow color, default is 'rgba(0,0,0,0.3)'
      shadowColor: 'rgba(255,0,0,0.75)',

      // draw label in arc, default is false
      // bar chart ignores this
      arc: true,

      // position to draw label, available value is 'default', 'border' and 'outside'
      // bar chart ignores this
      // default is 'default'
      position: 'default',

      // draw label even it's overlap, default is true
      // bar chart ignores this
      overlap: true,

      // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
      showActualPercentages: true,

      

      // add padding when position is `outside`
      // default is 2
      outsidePadding: 4,

      // add margin of text when position is `outside` or `border`
      // default is 2
      textMargin: 2
    }
  }

  }
  // Inspection by Ship Pie chart

  public initialRiskData: number[] = [];
  public riskIndex = [];

  // public inspectionByShipData: number[] = [200, 200, 200, 200, 200];
  public inspectionByShipType = 'pie';


  //

  public barChartLabels: Array<any>;

  public barChartType = 'bar';
  public barChartLegend = true;
  public inspectionByShipData: number[] = [];
  public inspectionByShipLabels: string[] = [];
  public inspectionByShipByColors = [];

  public barChartData: any[] = [];
  
  public barChartColors: Array<any> = [
    // { backgroundColor: '#36bea6' },
    { backgroundColor: '#1C4E80' }
  ];




  constructor(private commonService: CommonService,
    private modalService: NgbModal, private router: Router, ) {
  }

  ngOnInit() {
    this.sireVersionDropdown();
    this.vesselFleetDropDown();
    this.vesselGroupDropDown();
    this.vesselMasterDropDown();
    this.load_pie_chart();
    this.loadPieChart_2();
    this.getAverageObservationDataForChart(this.filterObjObsChart, 1);
    this.getAllVesselReport();
    this.getParticularsVesselReport();
    this.getData( );
    this.getTopTwentyCountData();
    this.getHighriskCountData();
    this.getCompanyInspectors();
    this.getPastObservationData();
    this.upcomingInspection();
    // this.getConfiguration();
    this.getAdminPastObservationData();
  }

  ngAfterViewInit() {
  }
  //this is fir observation chart
  public lineChartData: Array<any> = [];
  public lineChartLabels: Array<any> = [];
  public lineChartOptions: any = {
    responsive: true,
    scales: {
      xAxes: [{
          ticks: {
              autoSkip : false,
          },
      }],
      yAxes: [{
        display: true,
        ticks: {
             beginAtZero: true
         },
      }],
    },
    tooltips: {
      callbacks: {
          label: function(tooltipItem, data) {
              var label = data.datasets[tooltipItem.datasetIndex].label || '';

              if (label) {
                  label += ': ';
              }
              let arr = tooltipItem.yLabel.toString().split('.');
              arr[1] = arr[1] ? arr[1] : '00' // if NoT available Decimal Points
              label += arr[0]+'.'+((arr[1]+'0').slice(0,2));
              return label;
          }
      },
    }
  };
    // bar chart
    public barChartOptions1: any = {
      title: {
        text: 'Average Observation Chart',
        display: true,
        position: 'bottom'
      },
      scaleShowVerticalLines: true,
      responsive: true,
      barThickness: 1,
      scales: {
        xAxes: [{
            ticks: {
                autoSkip : true,
            },
        }],
      },
      
      plugins: {
        labels: {
          // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
          render: 'value',
  
          // precision for percentage, default is 0
          precision: 0,
  
          // identifies whether or not labels of value 0 are displayed, default is false
          showZero: false,
  
          // font size, default is defaultFontSize
          fontSize: 10,
  
          // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
          fontColor: '#000',
  
          // font style, default is defaultFontStyle
          fontStyle: 'normal',
  
          // font family, default is defaultFontFamily
          fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
  
          // draw text shadows under labels, default is false
        //   textShadow: true,
  
          // text shadow intensity, default is 6
        //   shadowBlur: 10,
  
          // text shadow X offset, default is 3
          shadowOffsetX: -5,
  
          // text shadow Y offset, default is 3
          shadowOffsetY: 5,
  
          // text shadow color, default is 'rgba(0,0,0,0.3)'
          shadowColor: 'rgba(255,0,0,0.75)',
  
          // draw label in arc, default is false
          // bar chart ignores this
          arc: true,
  
          // position to draw label, available value is 'default', 'border' and 'outside'
          // bar chart ignores this
          // default is 'default'
          position: 'default',
  
          // draw label even it's overlap, default is true
          // bar chart ignores this
          overlap: true,
  
          // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
          showActualPercentages: true,
  
          
  
          // add padding when position is `outside`
          // default is 2
          outsidePadding: 4,
  
          // add margin of text when position is `outside` or `border`
          // default is 2
          textMargin: 2
        }
      }
    };
    public barChartOptions2: any = {
      title: {
        text: 'Average Risk Chart',
        display: true,
        position: 'bottom'
      },
      scaleShowVerticalLines: true,
      responsive: true,
      barThickness: 1,
      scales: {
        xAxes: [{
            ticks: {
                autoSkip : true,
            },
        }],
      },
      
      plugins: {
        labels: {
          // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
          render: 'value',
  
          // precision for percentage, default is 0
          precision: 0,
  
          // identifies whether or not labels of value 0 are displayed, default is false
          showZero: false,
  
          // font size, default is defaultFontSize
          fontSize: 10,
  
          // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
          fontColor: '#000',
  
          // font style, default is defaultFontStyle
          fontStyle: 'normal',
  
          // font family, default is defaultFontFamily
          fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
  
          // draw text shadows under labels, default is false
        //   textShadow: true,
  
          // text shadow intensity, default is 6
        //   shadowBlur: 10,
  
          // text shadow X offset, default is 3
          shadowOffsetX: -5,
  
          // text shadow Y offset, default is 3
          shadowOffsetY: 5,
  
          // text shadow color, default is 'rgba(0,0,0,0.3)'
          shadowColor: 'rgba(255,0,0,0.75)',
  
          // draw label in arc, default is false
          // bar chart ignores this
          arc: true,
  
          // position to draw label, available value is 'default', 'border' and 'outside'
          // bar chart ignores this
          // default is 'default'
          position: 'default',
  
          // draw label even it's overlap, default is true
          // bar chart ignores this
          overlap: true,
  
          // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
          showActualPercentages: true,
  
          
  
          // add padding when position is `outside`
          // default is 2
          outsidePadding: 4,
  
          // add margin of text when position is `outside` or `border`
          // default is 2
          textMargin: 2
        }
      }
    };
    public barChartOptions3: any = {
      title: {
        text: 'Inspections as per Oil Major',
        display: true,
        position: 'bottom'
      },
      scaleShowVerticalLines: true,
      responsive: true,
      barThickness: 1,
      scales: {
        xAxes: [{
            ticks: {
                autoSkip : true,
            },
        }],
      },
      
      plugins: {
        labels: {
          // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
          render: 'value',
  
          // precision for percentage, default is 0
          precision: 0,
  
          // identifies whether or not labels of value 0 are displayed, default is false
          showZero: false,
  
          // font size, default is defaultFontSize
          fontSize: 10,
  
          // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
          fontColor: '#000',
  
          // font style, default is defaultFontStyle
          fontStyle: 'normal',
  
          // font family, default is defaultFontFamily
          fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
  
          // draw text shadows under labels, default is false
        //   textShadow: true,
  
          // text shadow intensity, default is 6
        //   shadowBlur: 10,
  
          // text shadow X offset, default is 3
          shadowOffsetX: -5,
  
          // text shadow Y offset, default is 3
          shadowOffsetY: 5,
  
          // text shadow color, default is 'rgba(0,0,0,0.3)'
          shadowColor: 'rgba(255,0,0,0.75)',
  
          // draw label in arc, default is false
          // bar chart ignores this
          arc: true,
  
          // position to draw label, available value is 'default', 'border' and 'outside'
          // bar chart ignores this
          // default is 'default'
          position: 'default',
  
          // draw label even it's overlap, default is true
          // bar chart ignores this
          overlap: true,
  
          // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
          showActualPercentages: true,
  
          
  
          // add padding when position is `outside`
          // default is 2
          outsidePadding: 4,
  
          // add margin of text when position is `outside` or `border`
          // default is 2
          textMargin: 2
        }
      }
    };

  public lineChartColors: Array<any>;
  public lineChartLegend = true;
  public lineChartType = 'line';

  //this is fir risk chart
  public riskLineChartData: Array<any> = [];
  public companyRiskLineChartData: Array<any> = [];
  public riskLineChartLabels: Array<any> = [];
  public riskLineChartOptions: any = {
    responsive: true,
    tooltips: {
      callbacks: {
          label: function(tooltipItem, data) {
              var label = data.datasets[tooltipItem.datasetIndex].label || '';
              if (label) {
                  label += ': ';
              }
              let arr = tooltipItem.yLabel.toString().split('.');
              arr[1] = arr[1] ? arr[1] : '00' // if NoT available Decimal Points
              label += arr[0]+'.'+((arr[1]+'0').slice(0,2));
              return label;
          }
      }
    },
    scales: {
      yAxes: [{
        ticks: {
          beginAtZero : true,
        },
      }]
    } ,
    
  };
  public riskLineChartColors: Array<any>;
  public riskLineChartLegend = true;
  public riskLineChartType = 'line';
  public inspector_dropdown = [];

  public vesselReportArr = [];
  public vesselDisplayReportArr = [];
  public totalVesselInspection = 0;
  public totalVesselObs = 0;
  public avgVesselObs;
  public kpiAvgVesselObs;

  getParticularsVesselReport() {
    this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-particular-vessel-kpi-report', postData: this.filterObjOfKpi }).subscribe(result => {
      this.vesselReportArr = result.data;
      this.vesselDisplayReportArr = result.data;
    })
  }
  
  getAllVesselReport(){
    this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-all-vessel-kpi-report', postData: this.filterObjOfAllVesselKpi }).subscribe(result => {
      this.totalVesselInspection = result.data[0].total_inspection;
      this.totalVesselObs = result.data[0].total_obs;
      this.avgVesselObs = this.totalVesselObs ? (this.totalVesselObs / this.totalVesselInspection).toFixed(2) : 0.00;  
      this.kpiAvgVesselObs = result.data[0].KPI
    })
  }

  getAverageObservationDataForChart(filter: any = {}, isRiskChartLoad = 0) {

    // alert(this.filterObjObsChart.start_date_old != filter.start_date)
    // if(filter.start_date_old != filter.start_date || filter.end_date_old != filter.end_date){
    // filter.start_date_old = filter.start_date;
    // filter.end_date_old = filter.end_date;
    this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-avg-observation-for-chart', postData: filter }).subscribe(result => {
      if (result.status) {
        this.resultOfObservation = result;

        this.calculateDataFoRiskChart(filter);
        if (isRiskChartLoad) {
          this.resultOfRisk = result;
          this.calculateDataFoRiskChart(filter, 1);
        }
      }
    })
  }

  getAverageRiskDataForChart(filter: any = {}) {
    // console.log(filter);
    this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-avg-observation-for-chart', postData: filter }).subscribe(result => {
      if (result.status) {
        this.resultOfRisk = result;
        this.calculateDataFoRiskChart(filter, 1)
      }
    })
  }

  calculateDataFoRiskChart(filter: any = {}, isRiskChart = 0) {
    let resultData: any;
    if (isRiskChart) {
      resultData = this.resultOfRisk
    }
    else {
      resultData = this.resultOfObservation
    }
    if (resultData.status) {
      // blank y axis
      if (isRiskChart) {
        this.riskLineChartData.length = 0;
        this.companyRiskLineChartData.length = 0;
        this.riskLineChartLabels.length = 0;
      }
      else {
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
      }


      //this is for all data chart
      let data = [];
      let allRiskdata = [];
      let allCompanyRiskdata = [];

      let month: any = new Date(filter.start_date).getMonth();;
      let vessel_array: any = {} //= {104:[],105:[]};
      let makeDataArray: any = {};
      let vesselHaveInFleet: any = {};

      if (filter.vessel_name && filter.vessel_name.length > 0) {
        filter.vessel_name.forEach(element => {
          let jsonToObj = JSON.parse(element);
          vessel_array[jsonToObj.ID] = { data: [], riskData: [], companyRiskData: [], label: jsonToObj.VESSEL_NAME };
        })
      }
      else if (filter.vessel_fleet && filter.vessel_fleet.length > 0) {
        filter.vessel_fleet.forEach(element => {
          let jsonToObj = JSON.parse(element);
          makeDataArray[jsonToObj.ID] = { vessels: jsonToObj.VESSEL_FK.split(','), data: [], riskData: [], companyRiskData: [], label: jsonToObj.FLEET_NAME }
        });
      }
      else if (filter.vessel_group && filter.vessel_group.length > 0) {
        filter.vessel_group.forEach(element => {
          let jsonToObj = JSON.parse(element);
          makeDataArray[jsonToObj.ID] = { vessels: jsonToObj.VESSEL_FK.split(','), data: [], riskData: [], companyRiskData: [], label: jsonToObj.GROUP_NAME }
        });
      }
      var dateForGetMonth = new Date();

      resultData.data.forEach(element => {
        if (element.VESSEL_FLEET_FK && element.VESSEL_FLEET_FK != null) {
          element.VESSEL_FLEET_FK.split(',').forEach(vessel => {
            if (vesselHaveInFleet[vessel.split(':')[1]]) {
              vesselHaveInFleet[vessel.split(':')[1]].push(vessel.split(':')[0])
            }
            else {
              vesselHaveInFleet[vessel.split(':')[1]] = [vessel.split(':')[0]];
            }
          });
        }

        let vessel_array_inner: any = {};
        let fleet_array_inner: any = {};
        element.vessel_combination.split(',').forEach(ele => {
          let splitElement = ele.split(':');

          // for vessel
          if (vessel_array_inner[ele.split(':')[0]]) {
            vessel_array_inner[ele.split(':')[0]].obs += parseInt(splitElement[2]);
            vessel_array_inner[ele.split(':')[0]].risk += parseInt(splitElement[3]);
            vessel_array_inner[ele.split(':')[0]].company_risk += parseInt(splitElement[4]);
            vessel_array_inner[ele.split(':')[0]].total_inpsection += 1;
          }
          else {
            vessel_array_inner[splitElement[0]] = { obs: parseInt(splitElement[2]), risk: parseInt(splitElement[3]), company_risk: parseInt(splitElement[4]), total_inpsection: 1 };
          }

          //for fleet
          if (makeDataArray) {
            Object.keys(makeDataArray).forEach((key) => {
              let splitElement = ele.split(':');
              if (vesselHaveInFleet[key] && vesselHaveInFleet[key].indexOf(splitElement[0]) > -1) {
                if (fleet_array_inner[key]) {
                  fleet_array_inner[key].obs += parseInt(splitElement[2]);
                  fleet_array_inner[key].risk += parseInt(splitElement[3]);
                  fleet_array_inner[key].company_risk += parseInt(splitElement[4]);
                  fleet_array_inner[key].total_inpsection += 1;
                }
                else {
                  fleet_array_inner[key] = { obs: parseInt(splitElement[2]), risk: parseInt(splitElement[3]), company_risk: parseInt(splitElement[4]), total_inpsection: 1 }
                }
              }
            });
          }

        });

        if (month) {
          if (element.month_no - month > 1) {
            for (let i = 0; i < Math.abs(element.month_no - month) - 1; i++) {
              dateForGetMonth.setMonth(parseInt(month) + i);
              if (isRiskChart) {
                this.riskLineChartLabels.push(monthNames[dateForGetMonth.getMonth()]);
                allCompanyRiskdata.push(0);
                allRiskdata.push(0);
              }
              else {
                this.lineChartLabels.push(monthNames[dateForGetMonth.getMonth()]);
                data.push(0);
              }

              //for vessel
              if (vessel_array) {
                  Object.keys(vessel_array).forEach(element => {

                  vessel_array[element].data.push(0);
                  vessel_array[element].riskData.push(0);
                  vessel_array[element].companyRiskData.push(0);
                });
              }
              if (makeDataArray) {
                Object.keys(makeDataArray).forEach(element => {
                  // makeDataArray[element]
                  if (makeDataArray[element].data) {
                    makeDataArray[element].data.push(0);
                    makeDataArray[element].riskData.push(0);
                    makeDataArray[element].companyRiskData.push(0);
                  }
                  else {
                    makeDataArray[element].data = [0];
                    makeDataArray[element].companyRiskData = [0];
                    makeDataArray[element].riskData = [0];
                  }

                });
              }

              //  
            }
          }
          else if (-11 < element.month_no - month && element.month_no - month < 1) {
            for (let i = 0; i < (11 - Math.abs(element.month_no - month)); i++) {
              dateForGetMonth.setMonth(parseInt(month) + i)
              if (isRiskChart) {
                this.riskLineChartLabels.push(monthNames[dateForGetMonth.getMonth()]);
              }
              else {
                this.lineChartLabels.push(monthNames[dateForGetMonth.getMonth()]);
              }

              data.push(0);
              allRiskdata.push(0);
              allCompanyRiskdata.push(0);
              //for vessel
              if (vessel_array) {
                Object.keys(vessel_array).forEach(element => {
                  vessel_array[element].data.push(0);
                  vessel_array[element].riskData.push(0);
                  vessel_array[element].companyRiskData.push(0);
                });
              }
              if (makeDataArray) {
                Object.keys(makeDataArray).forEach(element => {
                  // makeDataArray[element]
                  if (makeDataArray[element].data) {
                    makeDataArray[element].data.push(0);
                    makeDataArray[element].riskData.push(0);
                    makeDataArray[element].companyRiskData.push(0);
                  }
                  else {
                    makeDataArray[element].data = [0];
                    makeDataArray[element].riskData = [0];
                    makeDataArray[element].companyRiskData = [0];
                  }
                });
              }
            }
          }
        }
        month = element.month_no;
        if (isRiskChart) {
          this.riskLineChartLabels.push(element.month_name);
        }
        else {
          this.lineChartLabels.push(element.month_name);
        }

        // for vessel
        // for vessel wise data
        if (vessel_array) {
          Object.keys(vessel_array).forEach(element => {
            if (vessel_array_inner[element]) {
              vessel_array[element].data.push(vessel_array_inner[element].total_inpsection ? (vessel_array_inner[element].obs / vessel_array_inner[element].total_inpsection) : 0);
              vessel_array[element].riskData.push(vessel_array_inner[element].risk ? (vessel_array_inner[element].risk / vessel_array_inner[element].obs) : 0);
              vessel_array[element].companyRiskData.push(vessel_array_inner[element].company_risk ? (vessel_array_inner[element].company_risk / vessel_array_inner[element].obs) : 0);
            }
            else {
              vessel_array[element].data.push(0);
              vessel_array[element].riskData.push(0);
              vessel_array[element].companyRiskData.push(0);
            }
          });
          
        }

        // for fleet wise data
        if (makeDataArray) {
          Object.keys(makeDataArray).forEach(element => {
            // makeDataArray[element]
            if (fleet_array_inner[element]) {
              if (makeDataArray[element].data) {
                makeDataArray[element].data.push(fleet_array_inner[element].total_inpsection ? (fleet_array_inner[element].obs / fleet_array_inner[element].total_inpsection) : 0);
                makeDataArray[element].riskData.push(fleet_array_inner[element].obs ? (fleet_array_inner[element].risk / fleet_array_inner[element].obs) : 0);
                makeDataArray[element].companyRiskData.push(fleet_array_inner[element].obs ? (fleet_array_inner[element].company_risk / fleet_array_inner[element].obs) : 0);
              }
              else {
                makeDataArray[element].data = [fleet_array_inner[element].total_inpsection ? (fleet_array_inner[element].obs / fleet_array_inner[element].total_inpsection) : 0];
                makeDataArray[element].riskData = [fleet_array_inner[element].obs ? (fleet_array_inner[element].risk / fleet_array_inner[element].obs) : 0];
                makeDataArray[element].companyRiskData = [fleet_array_inner[element].obs ? (fleet_array_inner[element].company_risk / fleet_array_inner[element].obs) : 0];
              }
              // makeDataArray[element].data.push(fleet_array_inner[element].total_inpsection ? (vessel_array_inner[element].obs/vessel_array_inner[element].total_inpsection) : 0);
            }
            else {
              if (makeDataArray[element].data) {
                makeDataArray[element].data.push(0);
                makeDataArray[element].riskData.push(0);
                makeDataArray[element].companyRiskData.push(0);
              }
              else {
                makeDataArray[element].data = [0];
              }
            }
          });
        }

        // for all data
        if (element.total_inpsection) {
          data.push(element.total_inpsection ? (element.total_obs / element.total_inpsection).toFixed(2) : 0)
          allRiskdata.push(element.total_obs ? (element.total_risk / element.total_final_obs).toFixed(2) : 0)
          allCompanyRiskdata.push(element.total_obs ? (element.company_total_risk / element.total_final_obs).toFixed(2) : 0)

        }
        else {
          data.push(0);
          allRiskdata.push(0);
          allCompanyRiskdata.push(0);
        }

      });
      if (vessel_array) { 
        Object.keys(vessel_array).forEach((vessel_id) => {
          if (isRiskChart) {
            this.riskLineChartData.push({ data: vessel_array[vessel_id].riskData, type:'line', options: {
              scales: {
                  yAxes: [{
                      display: true,
                      ticks: {
                          beginAtZero: true
                      }
                  }]
              }
            }, label: vessel_array[vessel_id].label })
            this.companyRiskLineChartData.push({ data: vessel_array[vessel_id].companyRiskData, type:'line', options: {
              scales: {
                  yAxes: [{
                      display: true,
                      ticks: {
                          beginAtZero: true
                      }
                  }]
              }
            }, label: vessel_array[vessel_id].label })
          }
          else {
            this.lineChartData.push({ data: vessel_array[vessel_id].data,type:'line', options: {
              scales: {
                  yAxes: [{
                      display: true,
                      ticks: {
                          beginAtZero: true,
                      }
                  }]
              }
            },  label: vessel_array[vessel_id].label })
          }
        });
      }
      if (makeDataArray) {
        Object.keys(makeDataArray).forEach((id) => {//id is group or fleet id 
          if (isRiskChart) {
            this.riskLineChartData.push({ data: makeDataArray[id].riskData, type:'line', options: {
              scales: {
                  yAxes: [{
                      display: true,
                      ticks: {
                          beginAtZero: true
                      }
                  }]
              }
            }, label: makeDataArray[id].label })
            this.companyRiskLineChartData.push({ data: makeDataArray[id].companyRiskData,type:'line', options: {
              scales: {
                  yAxes: [{
                      display: true,
                      ticks: {
                          beginAtZero: true
                      }
                  }]
              }
            }, label: makeDataArray[id].label })
          } else {
            this.lineChartData.push({ data: makeDataArray[id].data,type:'line', options: {
              scales: {
                  yAxes: [{
                      display: true,
                      ticks: {
                          beginAtZero: true
                      }
                  }]
              }
            }, label: makeDataArray[id].label })
          }
        });
      }
      if (isRiskChart) {
        this.riskLineChartData.push({ data: allRiskdata, type:'line', options: {
          scales: {
              yAxes: [{
                  display: true,
                  ticks: {
                      beginAtZero: true
                  }
              }]
          }
        }, label: 'All Vessel' })
        this.companyRiskLineChartData.push({ data: allCompanyRiskdata, type:'line', options: {
          scales: {
              yAxes: [{
                  display: true,
                  ticks: {
                      beginAtZero: true
                  }
              }]
          }
        }, label: 'All Vessel' })
      }
      else {
        this.lineChartData.push({ data: data,type:'line', options: {
          scales: {
              yAxes: [{
                  display: true,
                  ticks: {
                      beginAtZero: true
                  }
              }]
          }
        },label: 'All Vessel' })
      }


      this.lineChartColors = [
        {
          // grey
          backgroundColor: 'rgb(246,196,41,.5)',
          borderColor: '#F6C429',
          pointBackgroundColor: '#F6C429',
          pointBorderColor: '#fff',
          pointHoverBackgroundColor: '#fff',
          pointHoverBorderColor: '#F6C429'
        },
        {
          // dark grey
          backgroundColor: 'rgb(41,98,255,.5)',
          borderColor: '#2962FF',
          pointBackgroundColor: '#2962FF',
          pointBorderColor: '#fff',
          pointHoverBackgroundColor: '#fff',
          pointHoverBorderColor: '#2962FF'
        }
      ];

      this.riskLineChartColors = [
        {
          // grey
          backgroundColor: 'rgb(246,196,41,.5)',
          borderColor: '#F6C429',
          pointBackgroundColor: '#F6C429',
          pointBorderColor: '#fff',
          pointHoverBackgroundColor: '#fff',
          pointHoverBorderColor: '#F6C429'
        },
        {
          // dark grey
          backgroundColor: 'rgb(41,98,255,.5)',
          borderColor: '#2962FF',
          pointBackgroundColor: '#2962FF',
          pointBorderColor: '#fff',
          pointHoverBackgroundColor: '#fff',
          pointHoverBorderColor: '#2962FF'
        }
      ];
    }
  }
  
  openModel(content) {
    this.modalRef = this.modalService.open(content, { size: 'sm' });
  }
  sireVersionDropdown() {
    //sire-dropdown
    this.commonService.sendRequestToNode({ method: 'get', path: 'template-type-dropdown' }).subscribe(result => {
        if (result.status) {
            let array = [];
            result.data.forEach(element => {
              let sire_ids = element.sireFk ? element.sireFk.split(',') : [];
              let versions = element.vesrion ? element.vesrion.split(',') : [];
              let max_version = Math.max(...versions);
              let latest_sire_id = sire_ids[versions.indexOf(max_version.toString())];
              element.latest_sire_id = latest_sire_id
                array.push({ value: JSON.stringify({sire_id : latest_sire_id,ID : element.ID,TEMPLATE_TYPE : element.TEMPLATE_TYPE}), display: element.TEMPLATE_TYPE })
            });
            this.sire_template_dropdown = array;
        }
        else {
            this.sire_template_dropdown = [];
        }
    });
  }
  getViqNoByTemplate(e){
    let obj = JSON.parse(e.value);
    this.commonService.sendRequestToNode({ method: 'get', path: 'questionnaire/viq-numbers-from-sire-id',queryParam : { sire_id : obj.sire_id } }).subscribe(result => {
      if (result.status) {
        this.questions_dropdown = result.data
      }
      else {
        this.questions_dropdown = [];
        alert(result.message);  
      }
    })
  }
  getReportByViqNumber(){
    let obj = this.selected_template ? JSON.parse(this.selected_template) : '';
    if(obj && this.selected_question_no){

        let template_type_Id = obj.ID;
        this.router.navigate(["/observation-by-viq-ref/", { template_type : obj.TEMPLATE_TYPE,template_type_id : template_type_Id, question_no: this.selected_question_no}]);
    }
    
  }
  vesselFleetDropDown() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'fleet/fleet-dropdown-with-vessel' }).subscribe(result => {
      if (result.status) {
        result.data.forEach(element => {
          this.vesselFleet_dropdown.push({
            value: JSON.stringify(element),
            display: element.FLEET_NAME
          })
        });
      }
      else {
        this.vesselFleet_dropdown = [];
        alert(result.message);
      }
    })
  }

  vesselMasterDropDown() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-dropdown',queryParam : {ACTIVE_FLAG : 1}}).subscribe(result => {
      if (result.status) {
        result.data.forEach(element => {
          this.vessel_dropdown.push({
            value: JSON.stringify(element),
            display: element.VESSEL_NAME
          })
        })
      }
      else {
        this.vessel_dropdown = [];
        alert(result.message);
      }
    })
  }
  vesselGroupDropDown() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'group/group-dropdown-with-vessel' }).subscribe(result => {
      if (result.status) {
        result.data.forEach(element => {
          this.vesselGroup_dropdown.push({
            value: JSON.stringify(element),
            display: element.GROUP_NAME
          })
        });
      }
      else {
        this.vesselGroup_dropdown = [];
        alert(result.message);
      }
    })
  }

  load_pie_chart() {
    this.filterObjSireRiskBreakUp.isRiskForCompany = this.isRiskForCompany;

    if(this.filterObjSireRiskBreakUp.start_date > this.filterObjSireRiskBreakUp.end_date){
      alert('Please Enter Valid Date');
    }else{
      if(this.modalRef){
        this.modalRef.close();
      }
      this.commonService.sendRequestToNode({ method: 'post', path: 'chart/loadPieChart', postData: this.filterObjSireRiskBreakUp }).subscribe(result => {
        if (result.status) {
          this.initialRiskLabels.length = 0;
          this.initialRiskData = [];
          let label = [
            'LOW',
            'MEDIUM',
            'HIGH',
            'V.HIGH'
          ];
          this.riskIndex = [];
          result.data.forEach(element => {
            if(element.risk - 1 >= 0){
              this.initialRiskLabels.push(label[element.risk - 1]+'('+ element.count +')');
              this.riskIndex.push(element.risk);
              this.initialRiskData.push(element.count);
            } 
          });
         
        }
        else {
          this.initialRiskData = [];
        }
      })
      
    }
    // let filter = { isRiskForCompany: this.isRiskForCompany };
  }

  loadPieChart_2() {

    if(this.filterObjNoOfInspBreakUp.start_date > this.filterObjNoOfInspBreakUp.end_date){
      alert('Please Enter Valid Date');
    }else{
      if(this.modalRef){
        this.modalRef.close();
      }
      this.commonService.sendRequestToNode({ method: 'post', path: 'chart/loadPieChart_2',postData:this.filterObjNoOfInspBreakUp }).subscribe(result => {
        if (result.status) {
          this.inspectionByShipLabels.length = 0;
          this.inspectionByShipData = [];
          this.inspectionByShipByColors = [];
          for (let i = 0; i < result.data.length; i++) {
            this.vessel_id[result.data[i].VESSEL_TYPE] = result.data[i].ID;
            this.inspectionByShipLabels.push(result.data[i].VESSEL_TYPE + '(' + result.data[i].count + ')');
            this.inspectionByShipData.push(result.data[i].count);
            this.inspectionByShipByColors.push("rgb(" + (Math.floor(Math.random() * Math.floor(255))) + "," + (Math.floor(Math.random() * Math.floor(255))) + "," + (Math.floor(Math.random() * Math.floor(255))) + ")");
          }
        }
        else {
          this.inspectionByShipLabels = [];
          this.inspectionByShipData = [];
          this.inspectionByShipByColors = [];
          alert(result.message);
        }
      })
    }
  }
  
  ObservationChart() {
    
    var canvas:any = document.getElementById("observationChart");
    var image = canvas.toDataURL("image/png"); 
    var link = document.createElement('a');
        link.download = 'observationChart.png';
        link.href = image;
        link.click();
    
    // domtoimage.toJpeg(document.getElementById('observationChart'), { quality: 1.0, bgcolor: '#fff' })
    //   .then(function (dataUrl) {
    //     var link = document.createElement('a');
    //     link.download = 'observationChart.jpeg';
    //     link.href = dataUrl;
    //     link.click();
    //   });
  }

  riskChart() {
    
    var canvas:any = document.getElementById("riskChart");
    var image = canvas.toDataURL("image/png"); 
    var link = document.createElement('a');
        link.download = 'riskChart.png';
        link.href = image;
        link.click();
    
    // domtoimage.toJpeg(document.getElementById('riskChart'), { quality: 1.0, bgcolor: '#fff' })
    //   .then(function (dataUrl) {
    //     var link = document.createElement('a');
    //     link.download = 'riskChart.jpeg';
    //     link.href = dataUrl;
    //     link.click();
    //   });
  }

  oilMajorChart() {
    
    var canvas:any = document.getElementById("oilMajorChart");
    var image = canvas.toDataURL("image/png"); 
    var link = document.createElement('a');
        link.download = 'oilMajorChart.png';
        link.href = image;
        link.click();

    // domtoimage.toJpeg(document.getElementById('oilMajorChart'), { quality: 1.0, bgcolor: '#fff' })
    //   .then(function (dataUrl) {
    //     var link = document.createElement('a');
    //     link.download = 'oilMajorChart.jpeg';
    //     link.href = dataUrl;
    //     link.click();
    //   });
  }
  

  sireRiskBreakupChart() {
    

    var canvas:any = document.getElementById("sireRiskBreakupChart");
    var image = canvas.toDataURL("image/png"); 
    var link = document.createElement('a');
        link.download = 'sireRiskBreakupChart.png';
        link.href = image;
        link.click();

    // domtoimage.toJpeg(document.getElementById('sireRiskBreakupChart'), { quality: 1.0, bgcolor: '#fff' })
    //   .then(function (dataUrl) {
    //     var link = document.createElement('a');
    //     link.download = 'sireRiskBreakupChart.jpeg';
    //     link.href = dataUrl;
    //     link.click();
    //   });
  }

  numberOfInspectionChart() {
    
    var canvas:any = document.getElementById("numberOfInspectionChart");
    var image = canvas.toDataURL("image/png"); 
    var link = document.createElement('a');
        link.download = 'numberOfInspectionChart.png';
        link.href = image;
        link.click();

    // domtoimage.toJpeg(document.getElementById('numberOfInspectionChart'), { quality: 1.0, bgcolor: '#fff' })
    //   .then(function (dataUrl) {
    //     var link = document.createElement('a');
    //     link.download = 'numberOfInspectionChart.jpeg';
    //     link.href = dataUrl;
    //     link.click();
    //   });
  }

  getData(filter:any={}) {

    if(filter.start_date > filter.end_date){
      alert('Please Enter Valid Date');
    }else {
      if(this.modalRef){
        this.modalRef.close();
      }
      if( filter.start_date && filter.end_date ) {
        this.filterObjInspectionMajor.start_date = filter.start_date;
        this.filterObjInspectionMajor.end_date = filter.end_date;
      }

    var joins = '';
    // filterParams.start_date
    this.commonService.sendRequestToNode({ method: 'get', path: 'inspectionPerOilMajor/getData', queryParam:  this.filterObjInspectionMajor }).subscribe(result => {
      if (result.status) {
        this.barChartData = [];
        this.inspectionPerOilMajorData = [];
        this.inspectionPerOilMajorDataName = [];
        for (var i = 0; i < result.data[0].length; i++) {
          if (result.data[0][i].PERCENT > 0) {
            this.inspectionPerOilMajorData.push(result.data[0][i].PERCENT);
            this.inspectionPerOilMajorDataName.push(result.data[0][i].OFFICIAL_NAME);
          }

        }

        this.inspectionPerOilMajorDataFinal = this.inspectionPerOilMajorData.join(',');
        this.inspectionPerOilMajorDataNameFinal = this.inspectionPerOilMajorDataName.join(',');
        this.barChartData.push({ data: this.inspectionPerOilMajorData, label: 'Inspection Per Oil Major' });
 
        
        this.barChartLabels = this.inspectionPerOilMajorDataName;
      }
      else {
        this.inspectionPerOilMajorData = [];
        alert(result.message);
      }
    });
    return joins;
    }
  }

  getReportOftop() {
    this.router.navigate(["/topTwentyObservation/"]);
  }
  
  getReportOfHighRisk(forDta) {
    this.router.navigate(["/sireHighRiskObservation/", { 'type': forDta }]);

  }
  
  getReportOfPastObservation(inspector) {
    let type = '';
    if (this.isRiskForCompany) {
      type = 'com';
    }
    else {
      type = 'glob';
    }
    this.router.navigate(["/pastObservationForInspector/", { inspector: inspector, fullname: this.INSPECTOR_NAME, type: type,  isCompanyObs: this.IS_COMPANY_OBS }]);
  }

  getTopTwentyCountData() {
    // let filterParams: any = {}

    // this.commonService.sendRequestToNode({ method: 'get', path: 'topTwentyObservation/getData', queryParam: filterParams }).subscribe(result => {
    //   if (result.status) {

    //     var data = [];
    //     // this.topTwentyObservationData = result.data[0];     
    //     for (var i = 0; i < result.data.length; i++) {
    //       if (!data[i]) {
    //         data[i] = { detail: [] };

    //       }
    //       data[i]['QUESTION_DESCRIPTION'] = result.data[i].QUESTION_DESCRIPTION;
    //       data[i]['QUESTION_NUMBER'] = result.data[i].QUESTION_NUMBER;
    //       data[i]['QUESTION_REPEAT_COUNT'] = result.data[i].QUESTION_REPEAT_COUNT;
    //       var ins_date = result.data[i].INSPECTION_DATE ? result.data[i].INSPECTION_DATE.split(',') : '';
    //       var ins_obr = result.data[i].INSPECTION_OBSERVATION ? result.data[i].INSPECTION_OBSERVATION.split('||') : '';
    //       var ins_vsl = result.data[i].VESSEL_NAME ? result.data[i].VESSEL_NAME.split('||') : '';
    //       var ins_port = result.data[i].PORT_OF_INSPECTION ? result.data[i].PORT_OF_INSPECTION.split('||') : '';
    //       var ins_oil_major = result.data[i].OIL_MAJOR ? result.data[i].OIL_MAJOR.split('||') : '';
    //       for (var n = 0; n < ins_date.length; n++) {
    //         data[i]['detail'][n] = [];
    //         data[i]['detail'][n]['INSPECTION_DATE'] = ins_date[n];
    //         data[i]['detail'][n]['INSPECTION_OBSERVATION'] = ins_obr[n];
    //         data[i]['detail'][n]['VESSEL_NAME'] = ins_vsl[n];
    //         data[i]['detail'][n]['PORT_OF_INSPECTION'] = ins_port[n];
    //         data[i]['detail'][n]['OIL_MAJOR'] = ins_oil_major[n];

    //       }

    //     }
    //     this.topTwentyObservationCountData = data.length;

    //   }
    //   else {
    //     this.topTwentyObservationCountData;
    //     alert(result.message);
    //   }
    // })
  }

  getHighriskCountData() {
    let filterParams: any = {}

    this.commonService.sendRequestToNode({ method: 'get', path: 'sireHighRiskObservation/getData', queryParam: filterParams }).subscribe(result => {
      if (result.status) {

        var index = 0;
        var finalData = [];
        var dataGlob = result.data;
        var dataCom = result.dataCom;

        if (dataGlob) {
          for (var i = 0; i < dataGlob.length; i++) {
            finalData[index] = dataGlob[i];
            index++;
          }
        }
        if (dataCom) {
          for (var i = 0; i < dataCom.length; i++) {
            finalData[index] = dataCom[i];
            index++;
          }
        }
        this.sireHighRiskObservationDataCount = dataGlob.length;
        this.sireHighRiskObservationDataComCount = dataCom.length;
      }
      else {
        this.sireHighRiskObservationDataCount = '';
        this.sireHighRiskObservationDataComCount = '';
        alert(result.message);
      }
    })
  }

  getPastObservationData() {
    let filterParams: any = {}
    //search filter 

    // var data = [];
    var count = 0;
    this.commonService.sendRequestToNode({ method: 'get', path: 'pastObservationForInspector/getDataForDashboardCount', queryParam: filterParams }).subscribe(result => {
      if (result.status) {

        
        if (this.isRiskForCompany) {
          this.totalPastObservationDataCount = result.dataCom.length;
          for (var i = 0; i < result.dataCom.length; i++) {
            if (!this.pastObservationDataCount[result.dataCom[i].INSPECTOR_FK]) {
              this.pastObservationDataCount[result.dataCom[i].INSPECTOR_FK] = [];
            }
            this.pastObservationDataCount[result.dataCom[i].INSPECTOR_FK][i] = result.dataCom[i];
          }
        }
        else {
          this.totalPastObservationDataCount = result.data.length;
          for (var i = 0; i < result.data.length; i++) {
            if (!this.pastObservationDataCount[result.data[i].INSPECTOR_FK]) {
              this.pastObservationDataCount[result.data[i].INSPECTOR_FK] = [];
            }
            this.pastObservationDataCount[result.data[i].INSPECTOR_FK][i] = result.data[i];
          }
        }



      }
      else {
        alert(result.message);
      }
    })
  }

  getAdminPastObservationData() {
    let filterParams: any = {}
    //search filter 

    // var data = [];
    filterParams.INSPECTOR_FK = this.INSPECTOR_ID;
    
    var count = 0;
    this.commonService.sendRequestToNode({ method: 'get', path: 'pastAdminObservationForInspector/getAdminDataForDashboardCount', queryParam: filterParams }).subscribe(result => {
      if (result.status) {
       
        if (this.isRiskForCompany) {
             console.log('isRiskForCompany')
             console.log(  result.dataCom )
          this.totalPastObservationDataCount = result.dataCom.length;
          for (var i = 0; i < result.dataCom.length; i++) {
            if (!this.pastAdminObservationDataCount[result.dataCom[i].INSPECTOR_FK]) {
              this.pastAdminObservationDataCount[result.dataCom[i].INSPECTOR_FK] = [];
            }
            this.pastAdminObservationDataCount[result.dataCom[i].INSPECTOR_FK][i] = result.dataCom[i];
          }
        }
        else {
             console.log('else isRiskForCompany')
             console.log(  result.data )
             
          this.totalPastObservationDataCount = result.data.length;
          for (var i = 0; i < result.data.length; i++) {
            if (!this.pastAdminObservationDataCount[result.data[i].INSPECTOR_FK]) {
              this.pastAdminObservationDataCount[result.data[i].INSPECTOR_FK] = [];
            }
            this.pastAdminObservationDataCount[result.data[i].INSPECTOR_FK][i] = result.data[i];
          }
        }
        console.log( this.totalPastObservationDataCount )
        console.log( this.pastAdminObservationDataCount )
        

      }
      else {
        alert(result.message);
      }
    })
  }

  getAdminData(){
    this.totalPastObservationDataCount = 0;
   if( this.INSPECTOR_ID && this.IS_COMPANY_OBS ) {
           console.log( this.pastAdminObservationDataCount)
               if( this.pastAdminObservationDataCount[this.INSPECTOR_ID] ) {
                 this.pastAdminObservationDataCount[this.INSPECTOR_ID] = this.pastAdminObservationDataCount[this.INSPECTOR_ID].filter(function (e) {
                   return e;
                 });
                 this.totalPastObservationDataCount = this.pastAdminObservationDataCount[this.INSPECTOR_ID].length;
               } else {
                 this.totalPastObservationDataCount = 0;
               }
   } else {
           
           if( this.pastObservationDataCount[this.INSPECTOR_ID] ) {
             this.pastObservationDataCount[this.INSPECTOR_ID] = this.pastObservationDataCount[this.INSPECTOR_ID].filter(function (e) {
               return e;
             });
             this.totalPastObservationDataCount = this.pastObservationDataCount[this.INSPECTOR_ID].length;
           } else {
             this.totalPastObservationDataCount = 0;
           }
   }
 }
  
  getInspectorCount(id) { 
    console.log( id );
   if (id) {
     this.INSPECTOR_ID = id.ID;
     this.INSPECTOR_NAME = id.FULLNAME;

     if (this.pastObservationDataCount[id.ID]) {
       this.pastObservationDataCount[id.ID] = this.pastObservationDataCount[id.ID].filter(function (e) {
         return e;
       });
       this.totalPastObservationDataCount = this.pastObservationDataCount[id.ID].length;
     } else {
       this.totalPastObservationDataCount = 0;
     }
   } else {
     this.getPastObservationData();
   }


 }
  getCompanyInspectors() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'inspectors/inspector-dropDown' }).subscribe(result => {
      if (result.status) {

        this.inspector_dropdown = result.data;
      }
      else {
        // this.pastObservationForInspectorData = [];
        alert(result.message);
      }
    })
  }

  chartClicked(e) {
    if (e.active[0]) {
      if (e.active && e.active.length > 0) {
        e = e.active[0];
        let forData = (this.riskIndex[e._index]) || 0;
        let type = '';
        if (this.isRiskForCompany) {
          type = 'com';
        }
        else {
          type = 'glob';
        }
        this.router.navigate(["/sireHighRiskObservation/", { 'risk': forData, 'type': type }]);
      }
    }
  }

  chartClicked2(e) {
    if (e.active && e.active.length > 0) {
      e = e.active[0];
    }
  }

  public chartHovered(e:any):void {
  }

  chartClicked3(e) {
    if (e.active[0]) {
      if (e.active && e.active.length > 0) {
        e = e.active[0];
        let str = this.inspectionByShipLabels[e._index];
        let labelStr = str.substring(0,str.lastIndexOf("("));
        let forData = this.vessel_id[labelStr];
        let type = '';
        if (this.isRiskForCompany) {
          type = 'com';
        }
        else {
          type = 'glob';
        }
        this.router.navigate(["/inspectionRisk/", { 'vessel': forData, 'type': type }]);
      }
    }
  }

  createRange(number) {
    var items: number[] = [];
    for (var i = 1; i <= number; i++) {
      items.push(i);
    }
    return items;
  }

  toggle(id) {
    this.expanded[id] = !this.expanded[id];
  }

  //when apply filter 

  applyFilterForObservationChart() {
    if(this.filterObjObsChart.start_date > this.filterObjObsChart.end_date){
      alert('Please Enter Valid Date');
    } else {
      this.getAverageObservationDataForChart(this.filterObjObsChart);
      this.modalRef.close();
    }
  }
  applyFilterForRiskChart() {
    if(this.filterObjRiskChart.start_date > this.filterObjRiskChart.end_date){
      alert('Please Enter Valid Date');
    }else{
    this.getAverageRiskDataForChart(this.filterObjRiskChart);
      this.modalRef.close();
    }

  }

  // applyFilterForKpi() {
  //   let vArr = [];
  //   if (this.filterObjOfKpi.is_radio == "vessel_fleet") {
  //     if (this.filterObjOfKpi.vessel_fleet) {
  //       this.filterObjOfKpi.vessel_fleet.forEach(element => {
  //         JSON.parse(element).VESSEL_FK.split(',').forEach(vFk => {
  //           vArr.push(parseInt(vFk));
  //         });
  //       });
  //     }
  //   }
  //   else if (this.filterObjOfKpi.is_radio == "vessel_fleet") {
  //     if (this.filterObjOfKpi.vessel_group) {
  //       this.filterObjOfKpi.vessel_group.forEach(element => {
  //         JSON.parse(element).VESSEL_FK.split(',').forEach(vFk => {
  //           vArr.push(parseInt(vFk));
  //         });
  //       });
  //     }
  //   }
  //   else if (this.filterObjOfKpi.is_radio == "vessel") {
  //     if (this.filterObjOfKpi.vessel_name) {
  //       this.filterObjOfKpi.vessel_name.forEach(element => {
  //         vArr.push(JSON.parse(element).ID);
  //       });
  //     }

  //   }
  //   console.log(vArr)
  //   this.vesselDisplayReportArr = [];
  //   if (vArr.length > 0) {
  //     this.vesselReportArr.forEach((vesselObj) => {
  //       if (vArr.indexOf(vesselObj.VESSEL_FK) > -1) {
  //         this.vesselDisplayReportArr.push(vesselObj);
  //       }
  //     })
  //   }


  //   // this.vesselReportArr
  // }

  reseTKpiFilter() {
    this.filterObjOfKpi = {};
    this.getParticularsVesselReport();
  }
  reseTAllVesselKpiFilter(){
    this.filterObjOfAllVesselKpi = {};
    this.getAllVesselReport();
  }

  goToInspectionPlanning(){
    this.router.navigate(["/inspectionPlanning"]);
  }

  upcomingInspection(){
    this.commonService.sendRequestToNode({method :'get',path:'home/dashboardBoxInfo'}).subscribe(result => {
        if(result.status)
        {
          this.upcoming_Inspection = result.data[0].count;
        }
        else{
          alert(result.message)
        }
    })
  }

}
