import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { NgSelectModule } from '@ng-select/ng-select';
import { ChartsModule } from 'ng2-charts';
import { GoogleChartsModule } from 'angular-google-charts';
import { UiSwitchModule } from 'ngx-toggle-switch';

import { DashboardDemoComponent } from './dashboard-demo.component';

const routes: Routes = [
  {
    path: '',
    data: {
      title: 'Analytics Dashboard',
      urls: [
        { title: 'Home', url: '/home' },
        { title: 'Analytics Dashboard' }
      ]
    },
    component: DashboardDemoComponent
  }
];

@NgModule({
  imports: [
    FormsModule,
    CommonModule,
    RouterModule.forChild(routes),
    NgbModule,
    NgSelectModule,
    ChartsModule,
    GoogleChartsModule.forRoot(),
    UiSwitchModule
  ],
  declarations: [
    DashboardDemoComponent
  ]
})
export class DashboardDemoModule {}
