import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import { CommonService } from '../common-service.service';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import swal from 'sweetalert2';
import { NgbTabset } from '@ng-bootstrap/ng-bootstrap';
import {FormControl} from '@angular/forms';
import html2canvas from 'html2canvas';
import { saveAs } from 'file-saver';

//this is define because some issue in retention page(when load this page and go)
import * as pluginAnnotations from 'chartjs-plugin-annotation';
import 'chartjs-plugin-labels';

// import { ExternalAuditComponent } from '../tmsa/external_audit/external_audit.component';

//import { GoogleChartComponent } from 'angular-google-charts';

@Component({
    templateUrl: './defect_damage_analytics.component.html',
    styleUrls: ['./defect_damage_analytics.component.scss']
})
export class DefectDamageAnalyticsComponent implements OnInit {
    tabStatus = 'justified';
    nameOfMonth = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];;
    sortNameOfMonth = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'July', 'Aug', 'Sept', 'Oct', 'Nov', 'Dec'];;
    public saved_reports = [];
    // public timeLineArr = [];
    public timeLineArr = [];
    public timeLineLabelArr = [];
    // public timeLineArr = [];
    // public timeLineArr = [];
    
    //dropDown
    public TypeOfDeficiency_dropdown = [];
    public TypeOfDeficiency_dropdown_filter = [];
    public InspectionType_dropdown = [];
    public InspectionType_dropdown_filter = [];
    public DeficiencyCause_dropdown = [];
    public ObserverCodes_dropdown = [];
    public ObserverCodes_dropdown_filter = [];
    

    public PSCMou_dropdown = [];
    public Equipments_dropdown = [];
    public headerInformation = [];
   
    public StatusCodes_dropdown = [];
    public AreaObservation_dropdown = [];
    public chapter_dropdown = [
        {value : 'ALL' , Label : 'All Chapter'},
        {value : 'Ch-1',Label : 'Ch-1'},
        {value : 'Ch-2',Label : 'Ch-2'},
        {value : 'Ch-3',Label : 'Ch-3'},
        {value : 'Ch-4',Label : 'Ch-4'},
        {value : 'Ch-5',Label : 'Ch-5'},
        {value : 'Ch-6',Label : 'Ch-6'},
        {value : 'Ch-7',Label : 'Ch-7'},
        {value : 'Ch-8',Label : 'Ch-8'},
        {value : 'Ch-9',Label : 'Ch-9'},
        {value : 'Ch-10',Label : 'Ch-10'},
        {value : 'Ch-11',Label : 'Ch-11'},
        {value : 'Ch-12',Label : 'Ch-12'},
        {value : 'Ch-13',Label : 'Ch-13'},
        // {value : '14',Label : 'Ch-14'},
        // {value : '15',Label : 'Ch-15'}
    ];

    //pagination for generated Data
    itemsPerPage: number = this.commonService.DefaultItemsPerPage;
    totalItems: number;
    currentPage: number = 1;
    public sortFilter:any = {};

    //dropDown - End 
    public vesselFleet_dropdown = [];
    public vesselGroup_dropdown = [];
    public vesselOwner_dropdown = [];
    public sire_dropdown = [];
    public oilMajor_dropdown = [];
    public vesselType_dropdown = [];
    public vessel_dropdown = [];
    public pluginAnnotations = pluginAnnotations;
    public user_dropdown = [];
    public marineUser_dropDown = [];
    public techinalUser_dropDown = [];
    public isRiskCompany = false;
    public generate_report_id = [];
    public generateReportData;
    public lineChartColors: Array<any> = [];
    public strSelectField ='';
    public filterVessel =[];
    public filterSelectedXaxis =[];
    public filterSelectedYaxis = [];
    public filterObj = {
        from_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))),
        to_date: this.commonService.formatDate(new Date()),
        x_axis: null,
        y_axis: null,
        timespan : null,
        consolidated_ship : 'true',
        selectedValueForX_axis: null,
        selectedValueForX_axis_compare : null,
        selectedValueForY_axis : null,
        audit_type : 0,
        vessel : null,
        X_axis_max_item_selection : 9999, // x-axis max item selection 
        is_critical : 0,
        VESSEL_NAME : null,
        Defciency_Descp :null,
        selected_x_axis_value :null

    }
    public audit_type = [
        {value : 0,display : 'Internal'},
        {value : 1,display : 'External'},
        {value : 2,display : 'Comparison'}
    ]

    public modalObj:any = {};
    public modalRef: NgbModalRef;
    public range_dropdown = [];
    public y_axis_dropdown = [
        { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
        { ID: 'inspection_type', ITEM: "Inspection Type" },
        { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
        { ID: 'equipment', ITEM: "Equipment" },
        { ID: 'viq_ref_number', ITEM: "VIQ Ref. Number" },
        { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
        { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
        { ID: 'observer_code', ITEM: "Observer Code" },
        { ID: 'status_code', ITEM: "Status Code" },
        { ID: 'chapter_number', ITEM: "VIQ Chapter Wise" }
    ];
    public y_axis_label = {
        'deficiency_type': "Type Of Deficiency" ,
        'inspection_type': "Inspection Type" ,
        'deficiency_cause': "Deficiency Cause" ,
        'equipment': "Equipment" ,
        'viq_ref_number': "VIQ Ref. Number" ,
        'areas_Of_observation': "Areas Of Observation" ,
        'psc_mou_region': "PSC MOU Region" ,
        'observer_code': "Observer Code" ,
        'chapter_number' : 'VIQ Chapter Wise'
    };
    public x_axis_dropdown = [];

    
    public x_axis_label = {
        'deficiency_type' :   "Type Of Deficiency" ,
        'inspection_type' :   "Inspection Type" ,
        'deficiency_cause' :   "Deficiency Cause" ,
        'equipment' :   "Equipment" ,
        'viq_ref_number' :   "VIQ Ref. Number" ,
        'areas_Of_observation' :   "Areas Of Observation" ,
        'psc_mou_region' :   "PSC MOU Region" ,
        'observer_code' :   "Observer Code" ,
        'status_code' :   "Status Code" ,
        'timespan' :   "Timespan" ,
        'vessel_group' :   "Vessel Group" ,
        'vessel_fleet' :   "Vessel Fleet" ,
        'vessel_marine' :   "Vessel Marine Superintendent" ,
        'vessel_technical' :   "Vessel Technical Superintendent",
        'top_10_repeat' : 'Top 10 Repeat VIQ Ref. Number',
        'question_number' : 'Question Number',
        'chapter_number' : 'VIQ Chapter Wise'
    };
    public validators = [this.numberValid];
    public errorMessages = {
        'numberValid': 'Entered Value Is Invalid',
    };
    public showLoader = false;
    constructor(private commonService: CommonService,
        private modalService: NgbModal, public tabset: NgbTabset) {
          this.configuration();  
          this.declareGridVariable('Selected X-axis')
    }
    @ViewChild('tabs')
    private tabs: NgbTabset;
    @ViewChild('screen') screen: ElementRef;
    @ViewChild('canvas') canvas: ElementRef;
    @ViewChild('downloadLink') downloadLink: ElementRef;
    
    ngOnInit() {
        this.userDropdown();
        this.get_list_of_report();
        this.vesselDropdown();
        this.getTimeLineInDropDown();
    }
    configuration(){
        this.commonService.sendRequestToNode({method :'get',path:'configuration/list'}).subscribe(result => {
          if(result.status){   
            if(result.data.length){
              this.filterObj.is_critical = result.data[0].CRITICAL_DEFECT_SHOW;
            }
          }
        })
      }
    private numberValid(control: FormControl) {
        var re = /^\d+(\.\d+)*$/;
        if (!re.test(String(control.value).toLowerCase())) {
            return {
                'numberValid': true
            };
        }
    
        return null;
    }

      // part of grid
  declareGridVariable(selectedXaxis){
    this.headerInformation = [
      {
        title : 'Vessel Name',// show title table header
        name:'VESSEL_NAME',// name of column in data source
        width : '20%',// width of column in table
        isSortable : true,// sort by column false or true
        highlight:true, // name highlight
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Vessel Name'
        }
      },
      {
        title : selectedXaxis,// show title table header
        name:'selected_x_axis_value',// name of column in data source
        width : '20%',// width of column in table
        // isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By X-axis'
        }
      },
      {title : 'Record Date',name:'Record_Date',width : '20%',  isSortable : true,},
      {title : 'Target Date',name:'Target_Date',width : '20%',  isSortable : true,},
      { title : 'Deficiency Description',
        name:'Defciency_Descp',
        width : '20%',
        isSortable : true,// sort by column false or true
            isFilter:{ // filter 
                type : 'text',
                placeholder : 'Filter By Description'
            }
        }
    ];
    
  }
 
  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj.VESSEL_NAME = obj.filter.VESSEL_NAME;
    this.filterObj.Defciency_Descp = obj.filter.Defciency_Descp;
    this.filterObj.selected_x_axis_value = obj.filter.selected_x_axis_value;
    this.sortFilter = obj.sort
    this.generateReport();
  }
    

    getXaxis(call_from_save_report = 0) {
        (call_from_save_report == 0) ? this.filterObj.x_axis = null : '';
        if (this.filterObj.y_axis == "deficiency_type") {
            this.x_axis_dropdown = [
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ];
        }
        if (this.filterObj.y_axis == "deficiency_cause") {
            this.x_axis_dropdown = [
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ];
        }
        if (this.filterObj.y_axis == "status_code") {
            this.x_axis_dropdown = [
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ];
        }
        else if (this.filterObj.y_axis == "inspection_type") {
            this.x_axis_dropdown = [
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ];
        }
        else if (this.filterObj.y_axis == "equipment") {
            this.x_axis_dropdown = [
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ];
        }
        else if (this.filterObj.y_axis == "areas_Of_observation") {
            this.x_axis_dropdown = [
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ]
        }
        else if (this.filterObj.y_axis == "psc_mou_region") {
            this.x_axis_dropdown = [
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'observer_code', ITEM: "Observer Code" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" },
            ]
        }
        else if (this.filterObj.y_axis == "observer_code") {
            this.x_axis_dropdown = [
                { ID: 'deficiency_type', ITEM: "Type Of Deficiency" },
                { ID: 'inspection_type', ITEM: "Inspection Type" },
                { ID: 'deficiency_cause', ITEM: "Deficiency Cause" },
                { ID: 'equipment', ITEM: "Equipment" },
                { ID: 'areas_Of_observation', ITEM: "Areas Of Observation" },
                { ID: 'psc_mou_region', ITEM: "PSC MOU Region" },
                { ID: 'status_code', ITEM: "Status Code" },
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" }
            ]
        }
        else if (this.filterObj.y_axis == "viq_ref_number") {
            this.x_axis_dropdown = [
                { ID: 'top_10_repeat', ITEM: "Top 10 Repeat VIQ Ref. Number" },
                { ID: 'question_number', ITEM: "Question Number" },
                { ID: 'chapter_number', ITEM: "VIQ Chapter Wise"}
            ]
        } 
        else if (this.filterObj.y_axis == "chapter_number") {
                this.x_axis_dropdown = [
                    { ID: 'top_10_repeat',      ITEM: "Top 10 Repeat VIQ Ref. Number" },
                    { ID: 'deficiency_cause',   ITEM: "Deficiency Cause" },
                    { ID: 'observer_code',      ITEM: "Observer Code" },
                    { ID: 'status_code',        ITEM: "Status Code" },
                    { ID: 'vessel_group',       ITEM: "Vessel Group" },
                    { ID: 'vessel_fleet',       ITEM: "Vessel Fleet" },
                    { ID: 'vessel_marine',      ITEM: "Vessel Marine Superintendent" },
                    { ID: 'vessel_technical',   ITEM: "Vessel Technical Superintendent" }
                ]
        }
        // remove marin anf tenchinal from Drop Down when Comparision select 
        if(this.filterObj.audit_type == 2) {
            this.x_axis_dropdown = this.x_axis_dropdown.filter(ele=>{
                if(ele.ID != 'top_10_repeat' && ele.ID != 'status_code'){
                    return true;
                }
                else{
                    return false;
                }
            })
        }
        if(this.filterObj.timespan) {
            // remove timespan from x_axis when Default timeSpan selected
            this.x_axis_dropdown = this.x_axis_dropdown.filter(ele=>{
                if(ele.ID == 'timespan'){
                    return false;
                }
                else{
                    return true;
                }
            })
        }

        if(this.filterObj.timespan || this.filterObj.consolidated_ship == 'false' || this.filterObj.audit_type == 2){
            // remove timespan from x_axis when Default timeSpan selected
            this.x_axis_dropdown = this.x_axis_dropdown.filter(ele=>{
                if(ele.ID == 'top_10_repeat'){
                    return false;
                }
                else{
                    return true;
                }
            })
        }
       

    }

    getDropDownFrom_axis() {
        if (this.filterObj.x_axis == 'timespan' || this.filterObj.y_axis == 'timespan') {
            this.getTimeLineInDropDown();
        }
        
         if (this.filterObj.x_axis == 'deficiency_type' || this.filterObj.y_axis == 'deficiency_type') {
            this.getTypeOfDeficiencyData();
        }
        
         if (this.filterObj.x_axis == 'inspection_type' || this.filterObj.y_axis == 'inspection_type') {
            this.getInspectionType();
        }
        
         if (this.filterObj.x_axis == 'deficiency_cause' || this.filterObj.y_axis == 'deficiency_cause') {
            this.getDeficiencyCause();
        }

         if (this.filterObj.x_axis == 'equipment' || this.filterObj.y_axis == 'equipment') {
            this.getEquipments();
        }

         if (this.filterObj.x_axis == 'areas_Of_observation' || this.filterObj.y_axis == 'areas_Of_observation') {
            this.getAreaObservations();
        }

         if (this.filterObj.x_axis == 'psc_mou_region' || this.filterObj.y_axis == 'psc_mou_region') {
            this.getPSCMou();
        }

         if (this.filterObj.x_axis == 'observer_code' || this.filterObj.y_axis == 'observer_code') {
            this.getObserverCodes();
        }
         if (this.filterObj.x_axis == 'status_code' || this.filterObj.y_axis == 'status_code') {
            this.getStatusCodes();
        }

         if (this.filterObj.x_axis == 'vessel_group') {
            this.vesselGroupDropdown();
        }
         if (this.filterObj.x_axis == 'vessel_fleet') {
            this.vesselFleetDropdown();
        }
         if (this.filterObj.x_axis == 'vessel_technical' ) {
            this.technicalUsersDropdown();
        }
         if (this.filterObj.x_axis == 'vessel_marine' ) {
            this.marineUsersDropdown();
        }

        if (this.filterObj.y_axis == 'chapter_number' ) {
            this.chapter_dropdown = this.chapter_dropdown.filter(ele=>{
                if(ele.value != 'ALL' ){
                    return true;
                }
                else{
                    return false;
                }
            })
        }
    }
    
    getTypeOfDeficiencyData(){
        if(this.TypeOfDeficiency_dropdown.length == 0){
            this.commonService.sendRequestToNode({method :'get',path:'typeof-defiency/data_list'}).subscribe(result => {
                if(result.status){   
                this.TypeOfDeficiency_dropdown = result.data;
                this.TypeOfDeficiency_dropdown.forEach(element => {
                    element.ID = JSON.stringify({ID : element.ID,TITLE : element.TYPE_OF_DEFICIENCY});
                    element.AUDIT_TYPE_NAME = (element.AUDIT_TYPE == 1) ? 'Internal' : (element.AUDIT_TYPE == 2 ? 'External' : 'Internal/External');
                });
                this.filterOberverCodeByAuditType();
                }else{
                this.TypeOfDeficiency_dropdown = [];
                this.TypeOfDeficiency_dropdown_filter = [];
                alert(result.message);
                }
            })
        }
    }

    getInspectionType(){
       
        if(this.InspectionType_dropdown.length == 0){
            this.commonService.sendRequestToNode({method :'get',path:'inspection-type-dropdown',queryParam : {ACTIVITY_TRAINING_FLAG : 0 }}).subscribe(result => {
                if(result.status){
                    this.InspectionType_dropdown = result.data;
                    this.InspectionType_dropdown.forEach(element => {
                        element.ID = JSON.stringify(element);
                        element.AUDIT_TYPE_NAME = (element.AUDIT_TYPE == 1) ? 'Internal' : (element.AUDIT_TYPE == 2 ? 'External' : 'Internal/External') 
                    });
                    this.filterOberverCodeByAuditType();
                }else{
                  this.InspectionType_dropdown = [];
                  alert(result.message);
                }
            })
        }
    }

    getDeficiencyCause(){
        if(this.DeficiencyCause_dropdown.length == 0){
            this.commonService.sendRequestToNode({method :'get',path:'deficiency-cause-dropdown'}).subscribe(result => {
                if(result.status){   
                  this.DeficiencyCause_dropdown = result.data;
                  this.DeficiencyCause_dropdown.forEach(element => {
                    element.ID = JSON.stringify({ID : element.ID,TITLE : element.TITLE});
                  });
                }else{
                  this.DeficiencyCause_dropdown = [];
                  alert(result.message);
                }
            })
        }
    }

    filterOberverCodeByAuditType(){
        if(this.filterObj.audit_type == 0){
            // for internal
            this.ObserverCodes_dropdown_filter = this.ObserverCodes_dropdown.filter(ele=>{
                if(parseInt(ele.AUDIT_TYPE) != 2){
                    return true;
                }
                else{
                    return false;
                }
            });
            this.InspectionType_dropdown_filter = this.InspectionType_dropdown.filter(ele=>{
                if(parseInt(ele.AUDIT_TYPE) != 2){
                    return true;
                }
                else{
                    return false;
                }
            });
            this.TypeOfDeficiency_dropdown_filter = this.TypeOfDeficiency_dropdown.filter(ele=>{
                if(parseInt(ele.AUDIT_TYPE) != 2){
                    return true;
                }
                else{
                    return false;
                }
            });
        }
        else if(this.filterObj.audit_type == 1){
            // for External
            this.ObserverCodes_dropdown_filter = this.ObserverCodes_dropdown.filter(ele=>{
                if(parseInt(ele.AUDIT_TYPE) != 1){
                    return true;
                }
                else{
                    return false;
                }
            });
            this.InspectionType_dropdown_filter = this.InspectionType_dropdown.filter(ele=>{
                if(parseInt(ele.AUDIT_TYPE) != 1){
                    return true;
                }
                else{
                    return false;
                }
            });
            this.TypeOfDeficiency_dropdown_filter = this.TypeOfDeficiency_dropdown.filter(ele=>{
                if(parseInt(ele.AUDIT_TYPE) != 1){
                    return true;
                }
                else{
                    return false;
                }
            });
        }
        else{
            // for Comparison
            this.ObserverCodes_dropdown_filter = this.ObserverCodes_dropdown.filter(()=>true);
            this.InspectionType_dropdown_filter = this.InspectionType_dropdown.filter(()=>true);
            this.TypeOfDeficiency_dropdown_filter = this.TypeOfDeficiency_dropdown.filter(()=>true);
        }
       
    }
        
    getObserverCodes(){
        if(this.ObserverCodes_dropdown.length == 0){
            this.commonService.sendRequestToNode({method :'get',path:'observer-codes'}).subscribe(result => {
                if(result.status){   
                    result.data.forEach(element => {
                        element.ID = JSON.stringify({ID : element.ID,TITLE : element.OBSERVER_CODES,AUDIT_TYPE : element.AUDIT_TYPE});
                        element.AUDIT_TYPE_NAME = (element.AUDIT_TYPE == 1) ? 'Internal' : (element.AUDIT_TYPE == 2 ? 'External' : 'Internal/External') 
                    });
                    this.ObserverCodes_dropdown = result.data;
                    this.filterOberverCodeByAuditType();
                }else{
                  this.ObserverCodes_dropdown = [];
                  this.ObserverCodes_dropdown_filter = [];
                  alert(result.message);
                }
              })
        }
    }

    getEquipments(){
    if(this.Equipments_dropdown.length == 0){
        this.commonService.sendRequestToNode({method :'get',path:'equipment-codes'}).subscribe(result => {
            if(result.status){   
                this.Equipments_dropdown = result.data;
                this.Equipments_dropdown.forEach(element => {
                element.ID = JSON.stringify({ID : element.ID,TITLE : element.EQUIPMENT_CODES});
                });
            }else{
                this.Equipments_dropdown = [];
                alert(result.message);
            }
            })
    }
    
    }

    getPSCMou(){
    if(this.PSCMou_dropdown.length == 0){
        this.commonService.sendRequestToNode({method :'get',path:'psc-mou-dropdown'}).subscribe(result => {
            if(result.status){   
                this.PSCMou_dropdown = result.data;
                this.PSCMou_dropdown.forEach(element => {
                    element.ID = JSON.stringify({ID : element.ID,TITLE : element.MOU_NAME});
                });
            }else{
                this.PSCMou_dropdown = [];
                alert(result.message);
            }
            });
    }
    
    }

    getStatusCodes(){
    if(this.StatusCodes_dropdown.length == 0){
        this.commonService.sendRequestToNode({method :'get',path:'status-codes'}).subscribe(result => {
            if(result.status){   
                this.StatusCodes_dropdown = result.data;
                this.StatusCodes_dropdown.forEach(element => {
                    element.ID = JSON.stringify({ID : element.ID,TITLE : element.STATUS_CODES});
                });
            }else{
                this.StatusCodes_dropdown = [];
                alert(result.message);
            }
            })
    }
    
    }

    getAreaObservations(){
        if(this.AreaObservation_dropdown.length == 0){
            this.commonService.sendRequestToNode({method :'get',path:'area-observation-dropdown'}).subscribe(result => {
                if(result.status){   
                  this.AreaObservation_dropdown = result.data;
                  this.AreaObservation_dropdown.forEach(element => {
                    element.ID = JSON.stringify({ID : element.ID,TITLE : element.TITLE});
                });
                }else{
                  this.AreaObservation_dropdown = [];
                  alert(result.message);
                }
            })
        }
        
    }

    monthDiff(DisplayTo, DisplayFrom) {
        return DisplayTo.getMonth() - DisplayFrom.getMonth()
            + (12 * (DisplayTo.getFullYear() - DisplayFrom.getFullYear()));
    }

    delete_wizard_report(id) {
        if (id) {
            console.log("delete this id: " + id);
            swal({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonClass: 'btn btn-success',
                cancelButtonClass: 'btn btn-danger',
                confirmButtonText: 'Yes, delete it!',
                buttonsStyling: false
            }).then((result) => {
                if (result.value) {
                    var dialogueTitle = "Deleted!"
                    this.commonService.sendRequestToNode({ method: 'post', path: 'chart/delete_wizard_report', postData: { ID: id } }).subscribe(result => {
                        if (result.status) {
                            this.get_list_of_report();
                            swal({
                                title: dialogueTitle,
                                text: 'Report Template Deleted Successfully',
                                type: 'success',
                                confirmButtonClass: "btn btn-success",
                                buttonsStyling: false
                            })
                        }
                    })
                }
            })
        }
    }

    get_list_of_report() {
        this.commonService.sendRequestToNode({ method: 'get', path: 'chart/get_wizard_report',queryParam : {IS_FROM_TMSA : 1} }).subscribe(result => {
            if (result.status) {
                this.saved_reports = result.data;
            } else {
                alert(result.message);
            }
        });
    }
    
    saveReport() {
        let name = 'Report';
        swal({
            title: 'Enter Name Of Report',
            confirmButtonClass: "btn btn-success",
            buttonsStyling: false,
            input: 'text',
            showCancelButton: true,
            cancelButtonClass: "btn-danger",
        }).then((popup_responce) => {
            if (popup_responce.value) {
                name = popup_responce.value;
                this.commonService.sendRequestToNode({ method: 'post', path: 'chart/save_wizard_report', postData: { TEMPLATE: JSON.stringify(this.filterObj), NAME: name,IS_FROM_TMSA : 1 } }).subscribe(result => {
                    if (result.status) {
                        this.get_list_of_report();
                        swal({
                            type: 'success',
                            title: result.message,
                            confirmButtonClass: "btn btn-success",
                            buttonsStyling: false,
                        })
                    } else {
                        swal({
                            type: 'warning',
                            title: result.message,
                            confirmButtonClass: "btn btn-success",
                            buttonsStyling: false,
                        })
                        alert(result.message);
                    }
                });
            }
            else {
                if (popup_responce.dismiss) {
                }
                else {
                    alert("Please Enter Name of Report");
                    this.saveReport();
                }
            }
        });
    }
   
    resetXAxisValue(){
        this.filterOberverCodeByAuditType();
        this.getXaxis();
        if(this.filterObj.audit_type == 2){
           this.filterObj.X_axis_max_item_selection = 9999;
        }
        else{
            this.filterObj.X_axis_max_item_selection = (this.filterObj.timespan && this.filterObj.consolidated_ship == 'false') ? 1 : 9999;
        }
        // alert(this.filterObj.X_axis_max_item_selection)
        this.filterObj.selectedValueForX_axis = null;
    }

    goForChart() {
        this.lineChartColors.length = 0;
        // if(this.filterObj.audit_type == 2){
          
            this.lineChartColors = [{
                    // green for low
                    backgroundColor: 'rgba(69,182,73,0.5)',
                    borderColor: '#45b649',
                    pointBackgroundColor: '#45b649',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#45b649'
                },
                {
                    // yellow for medium
                    backgroundColor: 'rgba(255,188,52,0.5)',
                    borderColor: '#ffbc34',
                    pointBackgroundColor: '#ffbc34',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#ffbc34'
                },
                {
                    // orange for high
                    backgroundColor: 'rgba(251,140,0,0.5)',
                    borderColor: '#fb8c00',
                    pointBackgroundColor: '#fb8c00',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#fb8c00'
                },
                {
                    // red for v.high
                    backgroundColor: 'rgba(255,0,0,0.5)',
                    borderColor: '#ff0000',
                    pointBackgroundColor: '#ff0000',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#ff0000'
                },
                {
                    // maroon
                    backgroundColor: 'rgba(128, 0, 0,0.5)',
                    borderColor: '#800000',
                    pointBackgroundColor: '#800000',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#800000'
                },
                {
                    // brown
                    backgroundColor: 'rgba(154, 99, 36,0.5)',
                    borderColor: '#9A6324',
                    pointBackgroundColor: '#9A6324',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#9A6324'
                }
                ,
                {
                    // Olive
                    backgroundColor: 'rgba(128, 128, 0,0.5)',
                    borderColor: '#808000',
                    pointBackgroundColor: '#808000',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#808000'
                },
                {
                    // purple
                    backgroundColor: 'rgba(145, 30, 180,0.5)',
                    borderColor: '#911eb4',
                    pointBackgroundColor: '#911eb4',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#911eb4'
                },
                {
                    // pink
                    backgroundColor: 'rgba(250, 190, 190,0.5)',
                    borderColor: '#fabebe',
                    pointBackgroundColor: '#fabebe',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#fabebe'
                },
                {
                    // Lime
                    backgroundColor: 'rgba(191, 239, 69,0.5)',
                    borderColor: '#bfef45',
                    pointBackgroundColor: '#bfef45',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#bfef45'
                }
            ];  
        // }
        // else{
        //     if(this.filterObj.audit_type == 1){
        //         this.lineChartColors = [
        //             {
        //                 // yellow for medium
        //                 backgroundColor: 'rgba(255,188,52,0.5)',
        //                 borderColor: '#ffbc34',
        //                 pointBackgroundColor: '#ffbc34',
        //                 pointBorderColor: '#fff',
        //                 pointHoverBackgroundColor: '#fff',
        //                 pointHoverBorderColor: '#ffbc34'
        //             }
        //         ];
        //     }
        //     else{
        //         this.lineChartColors = [
        //             {
        //                 // green for low
        //                 backgroundColor: 'rgba(69,182,73,0.5)',
        //                 borderColor: '#45b649',
        //                 pointBackgroundColor: '#45b649',
        //                 pointBorderColor: '#fff',
        //                 pointHoverBackgroundColor: '#fff',
        //                 pointHoverBorderColor: '#45b649'
        //             },
        //         ];
        //     }
            
    
        // }
        let from_time = new Date(this.filterObj.from_date).getTime();
        let to_time = new Date(this.filterObj.to_date).getTime();

        if(this.filterObj.audit_type == null){
            alert("Audit Type Can't Be Blank");
        }
        if(!this.filterObj.vessel || (typeof this.filterObj.vessel=='object' && this.filterObj.vessel.length == 0)){
            alert("please select Vessel");
        }
        else if(!this.filterObj.from_date){
            alert("From Date Can't Be Blank")
        }
        else if(!this.filterObj.to_date){
            alert("To Date Can't Be Blank");
        }
        else if(from_time > to_time){
            alert("From Date Can't Be Greater Than To Date")
        }
        else if (!this.filterObj.y_axis) {
            alert('please select Y axis');
        }
        else if (!this.filterObj.x_axis) {
            alert('please select X axis');
        }
        else if (!this.filterObj.selectedValueForY_axis && this.filterObj.y_axis != 'viq_ref_number') {
            alert('please select Y axis Value');
        }
        else if ( (  this.filterObj.y_axis != 'viq_ref_number' && !this.filterObj.selectedValueForX_axis && ( this.filterObj.selectedValueForY_axis && this.filterObj.selectedValueForY_axis.length > 0 && this.filterObj.x_axis != 'top_10_repeat' ) ) || ( this.filterObj.y_axis == 'chapter_number' && !this.filterObj.selectedValueForX_axis  && this.filterObj.x_axis != 'top_10_repeat' ) ) {
            alert('please select X axis Value');
        }
        else if(!this.filterObj.selectedValueForX_axis_compare && !this.filterObj.selectedValueForX_axis && this.filterObj.y_axis != 'viq_ref_number' && this.filterObj.audit_type == 2) {
            alert('please select X axis Value(External)');
        }
        else if((!this.filterObj.selectedValueForX_axis || (typeof this.filterObj.selectedValueForX_axis == 'object' && this.filterObj.selectedValueForX_axis.length==0 )) && this.filterObj.y_axis == 'viq_ref_number' && (this.filterObj.x_axis == 'question_number' || this.filterObj.x_axis == 'chapter_number'))
        { 
            alert('please select X axis Value');
        }
        else {
            this.getDataForDisplayChart();
        }
    }

    calculateTimeArray() {
        this.timeLineArr = [];
        this.timeLineLabelArr = [];
        var from_date_temp: any = new Date(this.filterObj.from_date);
        var to_date_temp: any = new Date(this.filterObj.to_date);
        var diff = Math.abs(to_date_temp.getTime() - from_date_temp.getTime());
        var diffDays = Math.ceil(diff / (1000 * 3600 * 24));
        var from_year = new Date(this.filterObj.from_date).getFullYear();
        var to_year = new Date(this.filterObj.to_date).getFullYear();
        var diff_year = to_year - from_year;
        var diff_month = this.monthDiff(to_date_temp, from_date_temp);
        let time_type = this.filterObj.timespan || this.filterObj.selectedValueForX_axis
        if (time_type == 'yearly') {
            for (let i = from_year; i <= to_year; i++) {
                this.timeLineArr.push(i.toString());
            }
        }
        else if (time_type == 'monthly') {
            this.timeLineArr.push(this.nameOfMonth[from_date_temp.getMonth()] + '-' + from_date_temp.getFullYear());
            for (let i = 0; i < diff_month; i++) {
                new Date(from_date_temp.setMonth(from_date_temp.getMonth() + 1));
                this.timeLineArr.push(this.nameOfMonth[from_date_temp.getMonth()] + '-' + from_date_temp.getFullYear());
            }
        }
        else if (time_type == 'quaterly') {
            let totalQuater = Math.ceil(diff_month / 3);
            let currentQuater = 0;
            let startDate;
            let endDate;
            for (let i = 1; i <= totalQuater; i++) {
                currentQuater = Math.ceil((from_date_temp.getMonth() + 1) / 3)
                if (currentQuater == 1) {
                    startDate = from_date_temp.getFullYear() + '-01-01';
                    endDate = from_date_temp.getFullYear() + '-03-31'
                }
                else if (currentQuater == 2) {
                    startDate = from_date_temp.getFullYear() + '-04-01';
                    endDate = from_date_temp.getFullYear() + '-06-30'
                }
                else if (currentQuater == 3) {
                    startDate = from_date_temp.getFullYear() + '-07-01';
                    endDate = from_date_temp.getFullYear() + '-09-30'
                }
                else {
                    startDate = from_date_temp.getFullYear() + '-10-01';
                    endDate = from_date_temp.getFullYear() + '-12-31'
                }
                if (i == 0) {
                    startDate = new Date(this.filterObj.from_date);
                }
                if (i == totalQuater) {
                    endDate = new Date(this.filterObj.to_date);// ('0'+ new Date(this.filterObj.to_date).getDate()).slice(-2) + '-' + ('0'+ new Date(this.filterObj.to_date).getMonth()).slice(-2) + '-' + to_date_temp.getFullYear()
                }
                let sDate = new Date(startDate);
                let eDate = new Date(endDate);
                this.timeLineLabelArr.push(sDate.getFullYear() + ' ' + this.sortNameOfMonth[sDate.getMonth()] + ' ' + sDate.getDate() + '-' + this.sortNameOfMonth[eDate.getMonth()] + ' ' + eDate.getDate());
                // this.timeLineLabelArr.push(startDate + ' TO '+ endDate);
                this.timeLineArr.push(currentQuater + '-' + from_date_temp.getFullYear());
                from_date_temp.setMonth(from_date_temp.getMonth() + 3)
            }
        }
        else if (time_type == 'weekly') {
            // let day = 7;
            let startDate;
            let oldstartDate;
            let endDate;
            let i = 0;
            let week = 0;
            while (from_date_temp.getTime() <= to_date_temp.getTime()) {
                let onejan: any = new Date(from_date_temp.getFullYear(), 0, 1);
                week = Math.ceil((((from_date_temp.getTime() - onejan.getTime()) / 86400000) + 1) / 7);
                this.timeLineArr.push(week + '-' + from_date_temp.getFullYear());
                let d = ((week - 1) * 7);
                if (startDate) {
                    oldstartDate = new Date(startDate);
                }
                startDate = new Date(from_date_temp.getFullYear(), 0, d);

                if (i == 0) {
                    startDate = new Date(this.filterObj.from_date);
                }
                endDate = new Date(startDate);
                endDate.setDate(endDate.getDate() - 1)

                if (i != 0) {
                    if (oldstartDate.getMonth() == endDate.getMonth()) {
                        this.timeLineLabelArr.push(oldstartDate.getFullYear() + '-' + this.sortNameOfMonth[oldstartDate.getMonth()] + ' ' + oldstartDate.getDate() + '-' + endDate.getDate());
                    } else {
                        this.timeLineLabelArr.push(oldstartDate.getFullYear() + '-' + this.sortNameOfMonth[oldstartDate.getMonth()] + ' ' + oldstartDate.getDate() + '-' + this.sortNameOfMonth[endDate.getMonth()] + ' ' + endDate.getDate());
                    }

                }
                from_date_temp.setDate(from_date_temp.getDate() - from_date_temp.getDay() + 8);//8 because we start week from monday
                i++;
            }

            if (startDate.getMonth() == new Date(this.filterObj.to_date).getMonth()) {
                this.timeLineLabelArr.push(startDate.getFullYear() + '-' + this.sortNameOfMonth[startDate.getMonth()] + ' ' + startDate.getDate() + '-' + new Date(this.filterObj.to_date).getDate());
            } else {
                this.timeLineLabelArr.push(startDate.getFullYear() + '-' + this.sortNameOfMonth[startDate.getMonth()] + ' ' + startDate.getDate() + '-' + this.sortNameOfMonth[new Date(this.filterObj.to_date).getMonth()] + ' ' + new Date(this.filterObj.to_date).getDate());
            }

        }
    }

    goReportTab(){
        this.tabs.select('step3');
    }
    generateReport(redirect = true) {
        let strX_axis = this.filterObj.x_axis; 
        this.filterVessel = [];
        this.filterSelectedXaxis =[];
        this.filterSelectedYaxis = [];
        let sortKey = Object.keys(this.sortFilter);
        let sortBy;
        let sortStatus ;

        if(sortKey.length && this.sortFilter[sortKey[0]]){
            sortBy = sortKey[0];
            sortStatus = this.sortFilter[sortKey[0]];
        }
        if(this.generate_report_id.length){
            this.commonService.sendRequestToNode({ method: 'post', path: 'tmsa-wizard/generateReportByIds', postData: { report_ids: this.generate_report_id, VESSEL_NAME:this.filterObj.VESSEL_NAME, Defciency_Descp:this.filterObj.Defciency_Descp,x_axis:strX_axis, selected_x_axis_value: this.filterObj.selected_x_axis_value, itemsPerPage:this.itemsPerPage,currentPage : this.currentPage-1,  sortBy : sortBy,sortStatus:sortStatus } }).subscribe(result => {
                if (result.status ) {
                    this.strSelectField = this.x_axis_label[strX_axis];
                        if( strX_axis ) {
                            this.strSelectField = this.x_axis_label[strX_axis];
                        }
                     this.filterObj.vessel.forEach((element, key) =>{
                        this.filterVessel[key] = JSON.parse( element ); 
                     })
                     if(   this.filterObj.selectedValueForX_axis ) {
                        this.filterObj.selectedValueForX_axis.forEach((element, key) =>{
                            this.filterSelectedXaxis[key] = this.commonService.isJson(element) ? JSON.parse( element ) : element; 
                         })
                     }
                     this.filterSelectedYaxis = this.commonService.isJson(this.filterObj.selectedValueForY_axis) ?  JSON.parse( this.filterObj.selectedValueForY_axis ) : this.filterObj.selectedValueForY_axis;
                     
                     this.totalItems = result.data[0].total_records;
                     this.declareGridVariable( this.strSelectField );
                     this.generateReportData = result.data;
                    //  this.itemsPerPage = result.data.length;
                    
                    if(redirect) {
                        this.tabs.select('step3');
                    }
                } else {
                    this.generateReportData = [];
                    alert(result.message);
                }
            });
        }
        else{
            this.generateReportData = [];
        }
        
    }
    getDataforcsv() {
        this.commonService.sendRequestToNode({ method: 'post', path: 'tmsa-wizard/generateReportCsv', postData: { report_ids: this.generate_report_id,x_axis: this.filterObj.x_axis} },{ responseType: 'blob' }).subscribe(result => {
            saveAs(result, `Seagraphsreport.xlsx`)
        })
    }
    getDataforPdf() {
        this.commonService.sendRequestToNode({ method: 'post', path: 'tmsa-wizard/generateReportPdf', postData: { report_ids: this.generate_report_id, x_axis_label:this.x_axis_label,y_axis_label:this.y_axis_label, filterObj :this.filterObj } },{ responseType: 'blob' }).subscribe(result => {
            saveAs(result, `Seagraphsreport.pdf`)
        })
        // window.location.href = this.commonService.getNodeApi() + '/tmsa-wizard/generateReportPdf?report_ids=' + JSON.stringify(this.generate_report_id);
    }
    
    getTimeLineInDropDown() {
        if (this.filterObj.from_date && this.filterObj.to_date) {
            this.range_dropdown = [];
            let from_time = new Date(this.filterObj.from_date);
            let to_time = new Date(this.filterObj.to_date);
            var diff = Math.abs(to_time.getTime() - from_time.getTime());
            var diffDays = Math.ceil(diff / (1000 * 3600 * 24));
            let month_to = ('0' + (to_time.getMonth() + 1)).slice(-2);
            let month_from = ('0' + (from_time.getMonth() + 1)).slice(-2);
            let diffMonth = parseInt(month_to) - parseInt(month_from);
            let year_to = to_time.getFullYear();
            let year_from = from_time.getFullYear();
            let diffYear = year_to - year_from;
           
            // Day Calulation
            if (diffDays >= 7) {
                this.range_dropdown.push({ ID: 'weekly', RANGE: "Week" });
            }
            // Month Calulation
            if (diffYear > 0) {
                this.range_dropdown.push({ ID: 'monthly', RANGE: "Month" });
            }
            else if (diffMonth > 0) {
                this.range_dropdown.push({ ID: 'monthly', RANGE: "Month" });
            }
            // Quarter Calulation and for original Quarter nothing
            if (diffYear > 0) {
                this.range_dropdown.push({ ID: 'quaterly', RANGE: "Quarter" });
            } else if (diffMonth >= 3) {
                this.range_dropdown.push({ ID: 'quaterly', RANGE: "Quarter" });
            }
            // Year Calulation
            if (diffYear > 0) {
                this.range_dropdown.push({ ID: 'yearly', RANGE: "Year" });
            }
        }
    }
    vesselDropdown(){
        if (this.vessel_dropdown.length <= 0) {
            // ACTIVE_FLAG : 1 
            this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-dropdown',queryParam : {with_non_tanker : true} }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    array.push({display : 'All Vessels',value : 'ALL'});
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.VESSEL_NAME })
                    });
                    this.vessel_dropdown = array;
                }
                else {
                    this.vessel_dropdown = [];
                }
            });
        }
    }
    changeChapterFilter(e,c){
        let arr = []
        this.filterObj.selectedValueForX_axis.forEach(ele=>{
            if(ele == 'ALL'){
            arr = this.chapter_dropdown.map(element=>{
                // if(element.value != 'ALL')
                return element.value;
            })
            arr = arr.filter(e=>{
                return !(e == 'ALL');
            })
            
            }
        });
        if(arr.length > 0){
            this.filterObj.selectedValueForX_axis = arr;
        }
    }
    changeYChapterFilter(e,c){
    }
    
    changeVesselFilter(e,c){
        let arr = []
        this.filterObj.vessel.forEach(ele=>{
            if(ele == 'ALL'){
            arr = this.vessel_dropdown.map(element=>{
                // if(element.value != 'ALL')
                return element.value;
            })
            arr = arr.filter(e=>{
                return !(e == 'ALL');
            })
            
            }
        });
        if(arr.length > 0){
            this.filterObj.vessel = arr;
        }
    }
    vesselGroupDropdown() {
        if (this.vesselGroup_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselGroup' }).subscribe(result => {
                if (result.status) {
                    let array = []
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify({ID : element.ID,TITLE : element.GROUP_NAME}), display: element.GROUP_NAME })
                    });
                    this.vesselGroup_dropdown = array;
                }
                else {
                    this.vesselGroup_dropdown = [];
                }
            });
        }
    }
    marineUsersDropdown() {
        if (this.marineUser_dropDown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown',queryParam:{type:'marine_superintendent'}}).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify({ID : element.ID,TITLE : element.FULL_NAME}), display: element.FULL_NAME })
                    });
                    this.marineUser_dropDown = array;
                }
                else {
                    this.marineUser_dropDown = [];
                }
            });
        }
    }
    userDropdown(){
        if (this.user_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown'}).subscribe(result => {
                if (result.status) {
                    this.user_dropdown = result.data;
                }
                else {
                    this.user_dropdown = [];
                }
            });
        }
    }
    technicalUsersDropdown() {
        if (this.techinalUser_dropDown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown',queryParam:{type:'technical_superintendent'}}).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify({ID : element.ID,TITLE : element.FULL_NAME}), display: element.FULL_NAME })
                    });
                    this.techinalUser_dropDown = array;
                }
                else {
                    this.techinalUser_dropDown = [];
                }
            });
        }
    }
    vesselFleetDropdown() {
        if (this.vesselFleet_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'fleet/fleet-dropdown' }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify({ID : element.ID,TITLE : element.FLEET_NAME}), display: element.FLEET_NAME })
                    });
                    this.vesselFleet_dropdown = array;
                }
                else {
                    this.vesselFleet_dropdown = [];
                }
            })
        }
    }
    public lineChartData: Array<any> = [
        // { data: [65, 39, 80, 15, 76, 35, 40], label: 'Series A' },
        {}
    ];
    public lineChartLabels: Array<any> = [
        // 'January',
        // 'February',
        // 'March',
        // 'April',
        // 'May',
        // 'June',
        // 'July'
    ];
    public lineChartOptions: any = {
        responsive: true,
        barThickness: 1,
        scales: {
            yAxes: [{
                ticks: {
                    beginAtZero: true
                },
            }],
            xAxes: [{
                barPercentage: 0.5,
                ticks: {
                    autoSkip : false,
                },
            }]
        }, 
        plugins: {
            labels: {
              // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
              render: 'value',
      
              // precision for percentage, default is 0
              precision: 0,
      
              // identifies whether or not labels of value 0 are displayed, default is false
            //   showZero: false,
      
              // font size, default is defaultFontSize
              fontSize: 10,
      
              // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
              fontColor: '#000',
      
              // font style, default is defaultFontStyle
              fontStyle: 'normal',
      
              // font family, default is defaultFontFamily
              fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",
      
              // draw text shadows under labels, default is false
            //   textShadow: true,
      
              // text shadow intensity, default is 6
            //   shadowBlur: 10,
      
              // text shadow X offset, default is 3
              shadowOffsetX: -5,
      
              // text shadow Y offset, default is 3
              shadowOffsetY: 5,
      
              // text shadow color, default is 'rgba(0,0,0,0.3)'
              shadowColor: 'rgba(255,0,0,0.75)',
      
              // position to draw label, available value is 'default', 'border' and 'outside'
              // bar chart ignores this
              // default is 'default'
              position: 'outside',
      
              // draw label even it's overlap, default is true
              // bar chart ignores this
              overlap: false,
      
              // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
              showActualPercentages: true,
      
              
      
              // add padding when position is `outside`
              // default is 2
              outsidePadding: 4,
      
              // add margin of text when position is `outside` or `border`
              // default is 2
              textMargin: 2
            }
          }
    };

    public lineChartLegend = true;
    public lineChartType = 'bar';
    getDataForDisplayChart() {
        this.generate_report_id = [];
            this.showLoader = true;
            this.commonService.sendRequestToNode({ method: 'post', path: 'tmsa-wizard/get-wizard-data-for-chart', 'postData': this.filterObj }).subscribe(result => {
                if (result.status) { 
                  
                    if((this.filterObj.consolidated_ship == 'false' && this.filterObj.audit_type == 2) || (this.filterObj.consolidated_ship == 'false' && !this.filterObj.timespan ) ){
                        this.makeChartThroughVesselData(result.data)
                    }
                    else if(this.filterObj.timespan){
                        this.makeChartThroughTimeLineFromData(result.data)
                    }
                    else{
                        this.makeChartFromData(result.data);
                    }
                    // }
                    this.showLoader = false;
                    this.tabs.select('step2');
                } else {
                    alert(result.message);
                }
            })
        // }
        
    }
    makeChartOfYear(data) {
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        this.timeLineArr.forEach((ele) => {
            this.lineChartLabels.push(ele)
        })


        data.forEach(element => {
            if (this.lineChartData.length > 0) {
                this.lineChartData[0].data.push(element.total_inspection)
            }
            else {
                if (this.filterObj.y_axis == "total_inspection") {
                    this.lineChartData.push({ data: [element.total_inspection], label: this.y_axis_label[this.filterObj.y_axis] });
                }

            }
        });
    }

    //filter key means key of filter object(use for label)
    // datakey means key of data of chart(use for display value)
    makeChartFromData(chartData ) {
       
        // let chartData = inChartData;
        let labelData = [];
        let temp = [];
        let tempdata = [];
        let tempdata1 = [];
        let toolTipLabelData = [];
        let dataArr = []; 
        if(this.filterObj.timespan || this.filterObj.x_axis == 'timespan'){
            this.calculateTimeArray();
        }
        if(this.filterObj.x_axis == "vessel_marine" || this.filterObj.x_axis == "vessel_technical"){
            this.lineChartOptions.tooltips = {
                mode: 'point',
                intersect: false,
                backgroundColor: 'rgb(95,22,21)',
                callbacks: {
                title: function() {
                    return '';
                },
                beforeLabel: function(tooltipItem, data) { 
                    //return formatted date
                    tooltipItem.xLabel = toolTipLabelData[tooltipItem.index]['FULL_NAME'] 
                    return tooltipItem.xLabel
                }
                }
            }
        }
        else{
            delete this.lineChartOptions.tooltips;
        }
       
        let ChartFinalArr = {}; //  this is for comparison ( legend add as per Selection)
        if (this.filterObj.x_axis == 'timespan') {
            if (this.filterObj.y_axis) {
                this.timeLineArr.forEach((element, key) => {
                    temp.push(element);
                    tempdata.push(0);
                    if (this.timeLineLabelArr.length > 0) {
                        labelData.push(this.timeLineLabelArr[key]);
                    } else {
                        labelData.push(element);
                    }

                })
            }
        } else {
            if(this.filterObj.selectedValueForX_axis){
                this.filterObj.selectedValueForX_axis.forEach(element => {
                    if(this.filterObj.audit_type != 2){
                        if(this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number"){
                            temp.push(element);
                            labelData.push(element);    
                            toolTipLabelData.push(element);
                        }
                        else{
                            temp.push(JSON.parse(element).ID);
                            labelData.push(JSON.parse(element).TITLE);
                            toolTipLabelData.push(JSON.parse(element));
                        }
                        tempdata.push(0);
                        tempdata1.push(0);
                    }
                    else{
                        // when comparison select in audit_type
                        let key_ID = (this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number") ? element : JSON.parse(element).ID ;
                        let label_title = (this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number") ? element : JSON.parse(element).TITLE; 
                       
                        if(!this.commonService.isJson(element) || (!JSON.parse(element).AUDIT_TYPE || JSON.parse(element).AUDIT_TYPE == 3)){
                            temp.push(key_ID+'_internal');
                            ChartFinalArr[key_ID+'_internal']={
                                label : `${label_title}(Internal)` 
                                ,data :[]
                            }

                            temp.push(key_ID+'_external');
                            ChartFinalArr[key_ID+'_external']={
                                label : `${label_title}(External)`,
                                data :[]
                            }
                        }
                        else if(JSON.parse(element).AUDIT_TYPE == 1){
                            temp.push(key_ID+'_internal');
                            ChartFinalArr[key_ID+'_internal']={
                                label : `${label_title}(Internal)`,data :[]
                            }
                        }
                        else if(JSON.parse(element).AUDIT_TYPE == 2){
                            
                            temp.push(key_ID+'_external');
                            ChartFinalArr[key_ID+'_external']={
                                label : `${label_title}(External)`,data :[]
                            }
                        }
                        
                    }
                    
                });
            }
            
        }
 
        if (chartData) { 
            if(this.filterObj.audit_type == 2){
                chartData.internalData.forEach(element => {
                    element.IDS.split(',').forEach(rId => {
                        if (rId && this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    
                    if(ChartFinalArr[element.X_ID+'_internal']){
                        ChartFinalArr[element.X_ID+'_internal'].data[0] = element.count
                    }
                     
                });
                chartData.externalData.forEach(element => {
                    element.IDS.split(',').forEach(rId => {
                        if (rId && this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    
                    if(ChartFinalArr[element.X_ID+'_external']) {
                        ChartFinalArr[element.X_ID+'_external'].data[0] = element.count;
                    }
                });
            }
            else{ 
                chartData.forEach(element => {
                    element.IDS.split(',').forEach(rId => {
                        if (rId && this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    if(this.filterObj.x_axis == "top_10_repeat"){
                        labelData.push(element.X_ID);    
                        tempdata.push(element.count)
                    }
                    else{
                        let tempI = temp.indexOf(element.X_ID);
                        tempdata[tempI] = element.count; 
                    }
                    
                });
            }
            
        }

        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        
        if(this.filterObj.audit_type == 2){
            if (Object.keys(ChartFinalArr).length > 0) {
                Object.keys(ChartFinalArr).forEach((ele) => {
                    this.lineChartData.push(ChartFinalArr[ele])
                })
            }
            labelData.push(this.x_axis_label[this.filterObj.x_axis])
            
        }
        else{
            let audit_type = (this.filterObj.audit_type == 1) ? 'External' : 'Internal';
            if(this.filterObj.y_axis == "viq_ref_number"){
                this.lineChartData.push({ data: tempdata, label: 'Total Count - '+ audit_type })
            }
            else{
                let selectedYAxis =  this.commonService.isJson( this.filterObj.selectedValueForY_axis ) ? JSON.parse(this.filterObj.selectedValueForY_axis).TITLE : this.filterObj.selectedValueForY_axis;
                this.lineChartData.push({ data: tempdata, label: selectedYAxis + ' - '+ audit_type })
            }
            
        }
        // this.lineChartData.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis]+'('+ JSON.parse(this.filterObj.selectedValueForY_axis).TITLE +')' })
        
        //this.lineChartData.push({data : tempdata,label:this.y_axis_label[this.filterObj.y_axis]});
        labelData.forEach((ele) => {
            this.lineChartLabels.push(ele)
        })
        this.generateReport(false); // get report 
    }

    makeChartThroughTimeLineFromData(chartData) {
       
        // let chartData =nC ihartData;
        let labelData = [];
        let temp = [];
        let tempdata = [];
        let tempdata1 = [];
        let toolTipLabelData = [];
        let dataArr = []; 
        this.calculateTimeArray();
        if(this.filterObj.x_axis == "vessel_marine" || this.filterObj.x_axis == "vessel_technical"){
            this.lineChartOptions.tooltips = {
                mode: 'point',
                intersect: false,
                backgroundColor: 'rgb(95,22,21)',
                callbacks: {
                title: function() {
                    return '';
                },
                beforeLabel: function(tooltipItem, data) { 
                    //return formatted date
                    tooltipItem.xLabel = toolTipLabelData[tooltipItem.index]['FULL_NAME'] 
                    return tooltipItem.xLabel
                }
                }
            }
        }
        else{
            delete this.lineChartOptions.tooltips;
        }

        this.timeLineArr.forEach((element, key) => {
            temp.push(element);
            tempdata.push(0);
            tempdata1.push(0);
            if (this.timeLineLabelArr.length > 0) {
                labelData.push(this.timeLineLabelArr[key]);
            } else {
                labelData.push(element);
            }

        })
        let ChartFinalArr = {};
        
        if(this.filterObj.consolidated_ship == 'false'){
            if(this.filterObj.vessel){
                this.filterObj.vessel.forEach(element => {
                    let key_ID = JSON.parse(element).ID; 

                    ChartFinalArr[key_ID]={
                        label : JSON.parse(element).VESSEL_NAME,data :[]
                    }
                });
            }
           chartData.forEach(element => {
                element.IDS.split(',').forEach(rId => {
                    if (rId && this.generate_report_id.indexOf(rId) == -1) {
                        this.generate_report_id.push(rId);
                    }
                });
                let tempI = temp.indexOf(element.timespan);
                ChartFinalArr[element.Ship_ID].data[tempI] = element.count;
            });
           
        }
        else{
            if(this.filterObj.audit_type == 2){

                this.filterObj.selectedValueForX_axis.forEach(element => {
                    let key_ID = (this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number") ? element : JSON.parse(element).ID;
                    let label_title = (this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number") ? element : JSON.parse(element).TITLE;
                     
                    if(!this.commonService.isJson(element) || !JSON.parse(element).AUDIT_TYPE || JSON.parse(element).AUDIT_TYPE == 3){
                        ChartFinalArr[key_ID+'_internal']={
                            label : `${label_title}(Internal)` 
                            ,data :[]
                        }

                        ChartFinalArr[key_ID+'_external']={
                            label : `${label_title}(External)`,
                            data :[]
                        }
                    }
                    else if(JSON.parse(element).AUDIT_TYPE == 1){
                       ChartFinalArr[key_ID+'_internal']={
                            label : `${label_title}(Internal)`,data :[]
                        }
                    }
                    else if(JSON.parse(element).AUDIT_TYPE == 2){
                        
                        ChartFinalArr[key_ID+'_external']={
                            label : `${label_title}(External)`,data :[]
                        }
                    }
                    
                });
                chartData.internalData.forEach(element => {
                    element.IDS.split(',').forEach(rId => {
                        if (rId && this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    let tempIndexOfTimeLineArr = this.timeLineArr.indexOf(element.timespan)

                    if(ChartFinalArr[element.X_ID+'_internal']){
                        ChartFinalArr[element.X_ID+'_internal'].data[tempIndexOfTimeLineArr] = element.count
                    }
                     
                });
                chartData.externalData.forEach(element => {
                    element.IDS.split(',').forEach(rId => {
                        if (rId && this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    let tempIndexOfTimeLineArr = this.timeLineArr.indexOf(element.timespan)

                    if(ChartFinalArr[element.X_ID+'_external']){
                        ChartFinalArr[element.X_ID+'_external'].data[tempIndexOfTimeLineArr] = element.count;
                    }
                });
                // chartData.internalData.forEach(element => {
                //     element.IDS.split(',').forEach(rId => {
                //         if (this.generate_report_id.indexOf(rId) == -1) {
                //             this.generate_report_id.push(rId);
                //         }
                //     });
                //     let tempI = temp.indexOf(element.timespan);
                //     if(tempI > -1){
                //         tempdata[tempI] = element.count;
                //     }
                     
                // });
                // chartData.externalData.forEach(element => {
                //     element.IDS.split(',').forEach(rId => {
                //         if (this.generate_report_id.indexOf(rId) == -1) {
                //             this.generate_report_id.push(rId);
                //         }
                //     });
                //     let tempI = temp.indexOf(element.timespan);
                //     if(tempI > -1){
                //         tempdata1[tempI] = element.count;
                //     }
                     
                // });
            }
            else{
                this.filterObj.selectedValueForX_axis.forEach(element => {
                    if(this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number"){
                        ChartFinalArr[element]={
                            label : element,data :[]
                        }
                    }
                    else{
                        ChartFinalArr[JSON.parse(element).ID]={
                            label : JSON.parse(element).TITLE,data :[]
                        }
                    }
                    
                });
                if (chartData.length > 0) {
                    chartData.forEach(element => {
                        let tempIndexOfTimeLineArr = this.timeLineArr.indexOf(element.timespan)
                        if ( tempIndexOfTimeLineArr > -1) {
                            if (element.IDS) {
                                element.IDS.split(',').forEach(rId => {
                                    if (rId && this.generate_report_id.indexOf(rId) == -1) {
                                        this.generate_report_id.push(rId);
                                    }
                                });
                            }
                            ChartFinalArr[element.X_ID].data[tempIndexOfTimeLineArr]= element.count // 
        
                        }
                    });
                }
            }
            
        }


        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        
        // if(this.filterObj.audit_type == 2){
        //     if (Object.keys(ChartFinalArr).length > 0) {
        //         Object.keys(ChartFinalArr).forEach((ele) => {
        //             this.lineChartData.push(ChartFinalArr[ele])
        //         })
        //     }
        //     labelData.push(this.x_axis_label[this.filterObj.x_axis])
        //     if(this.filterObj.y_axis == "viq_ref_number"){
        //         this.lineChartData.push({ data: tempdata, label: 'Total Count - Internal' })
        //         this.lineChartData.push({ data: tempdata1, label: 'Total Count - External' })
        //     }
        //     else{
        //         this.lineChartData.push({ data: tempdata, label: JSON.parse(this.filterObj.selectedValueForY_axis).TITLE + ' - Internal' })
        //         this.lineChartData.push({ data: tempdata1, label: JSON.parse(this.filterObj.selectedValueForY_axis).TITLE + ' - External' })
        //     }
            
        // }
        // else{
        //     if (Object.keys(ChartFinalArr).length > 0) {
        //         Object.keys(ChartFinalArr).forEach((ele) => {
        //             this.lineChartData.push(ChartFinalArr[ele])
        //         })
        //     }
        // }
        if (Object.keys(ChartFinalArr).length > 0) {
            Object.keys(ChartFinalArr).forEach((ele) => {
                this.lineChartData.push(ChartFinalArr[ele])
            })
        }
        labelData.forEach((ele) => {
            this.lineChartLabels.push(ele)
        })
        this.generateReport(false); // get report 
    }

    makeChartThroughVesselData(chartData) {
        
        // let chartData =nC ihartData;
        let labelData = [];
        let temp = [];
        let tempdata = [];
        let tempdata1 = [];
        let toolTipLabelData = [];
        let dataArr = []; 
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        if(this.filterObj.x_axis == "vessel_marine" || this.filterObj.x_axis == "vessel_technical"){
            this.lineChartOptions.tooltips = {
                mode: 'point',
                intersect: false,
                backgroundColor: 'rgb(95,22,21)',
                callbacks: {
                    title: function() {
                        return '';
                    },
                    beforeLabel: function(tooltipItem, data) { 
                        //return formatted date
                        tooltipItem.xLabel = toolTipLabelData[tooltipItem.index]['FULL_NAME'] 
                        return tooltipItem.xLabel
                    }
                }
            }
        }
        else{
            delete this.lineChartOptions.tooltips;
        }
       
        if(this.filterObj.audit_type == 2){
            this.filterObj.vessel.forEach((element, key) => {
                labelData.push(JSON.parse(element).VESSEL_NAME);
                temp.push(JSON.parse(element).ID);
            });
           
            let ChartFinalArr = {};
            this.filterObj.selectedValueForX_axis.forEach(element => {
                let key_ID = (this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number") ? element : JSON.parse(element).ID; 
                let label_title = (this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number") ? element : JSON.parse(element).TITLE; 
                if(!this.commonService.isJson(element) || !JSON.parse(element).AUDIT_TYPE || JSON.parse(element).AUDIT_TYPE == 3){
                    ChartFinalArr[key_ID+'_internal']={
                        label : `${label_title}(Internal)` 
                        ,data :[]
                    }

                    ChartFinalArr[key_ID+'_external']={
                        label : `${label_title}(External)`,
                        data :[]
                    }
                }
                else if(JSON.parse(element).AUDIT_TYPE == 1){
                   ChartFinalArr[key_ID+'_internal']={
                        label : `${label_title}(Internal)`,data :[]
                    }
                }
                else if(JSON.parse(element).AUDIT_TYPE == 2){
                    
                    ChartFinalArr[key_ID+'_external']={
                        label : `${label_title}(External)`,data :[]
                    }
                }
                
            });
            chartData.internalData.forEach(element => {
                element.IDS.split(',').forEach(rId => {
                    if (rId && this.generate_report_id.indexOf(rId) == -1) {
                        this.generate_report_id.push(rId);
                    }
                });
                let tempI = temp.indexOf(element.Ship_ID)

                if(ChartFinalArr[element.X_ID+'_internal']){
                    ChartFinalArr[element.X_ID+'_internal'].data[tempI] = element.count
                }
                 
            });
            chartData.externalData.forEach(element => {
                element.IDS.split(',').forEach(rId => {
                    if (rId && this.generate_report_id.indexOf(rId) == -1) {
                        this.generate_report_id.push(rId);
                    }
                });
                let tempI = temp.indexOf(element.Ship_ID)
                if(ChartFinalArr[element.X_ID+'_external']){
                    ChartFinalArr[element.X_ID+'_external'].data[tempI] = element.count;
                }
            });
             if (Object.keys(ChartFinalArr).length > 0) {
                Object.keys(ChartFinalArr).forEach((ele) => {
                    this.lineChartData.push(ChartFinalArr[ele])
                })
            }
            /**  this.filterObj.vessel.forEach((element, key) => {
                labelData.push(JSON.parse(element).VESSEL_NAME);
                temp.push(JSON.parse(element).ID);
                tempdata.push(0);
                tempdata1.push(0);
            });
            chartData.internalData.forEach(element => {
                element.IDS.split(',').forEach(rId => {
                    if (this.generate_report_id.indexOf(rId) == -1) {
                        this.generate_report_id.push(rId);
                    }
                });
                let tempI = temp.indexOf(element.Ship_ID);
                if(tempI > -1){
                    tempdata[tempI] = element.count;
                }
                 
            });
            chartData.externalData.forEach(element => {
                element.IDS.split(',').forEach(rId => {
                    if (this.generate_report_id.indexOf(rId) == -1) {
                        this.generate_report_id.push(rId);
                    }
                });
                let tempI = temp.indexOf(element.Ship_ID);
                if(tempI > -1){
                    tempdata1[tempI] = element.count;
                }
                 
            });
            if(this.filterObj.y_axis == "viq_ref_number"){
                this.lineChartData.push({ data: tempdata, label: 'Total Count - Internal' })
                this.lineChartData.push({ data: tempdata1, label: 'Total Count - External' })
            }
            else{
                this.lineChartData.push({ data: tempdata, label: JSON.parse(this.filterObj.selectedValueForY_axis).TITLE + ' - Internal' })
                this.lineChartData.push({ data: tempdata1, label: JSON.parse(this.filterObj.selectedValueForY_axis).TITLE + ' - External' })
            } */
        }
        else{
            if(this.filterObj.selectedValueForX_axis){
                this.filterObj.selectedValueForX_axis.forEach(element => {
                    if(this.filterObj.x_axis == "question_number" || this.filterObj.x_axis == "chapter_number"){
                        temp.push(element);
                        labelData.push(element);    
                        toolTipLabelData.push(element);
                    }
                    else{
                        temp.push(JSON.parse(element).ID);
                        labelData.push(JSON.parse(element).TITLE);
                        toolTipLabelData.push(JSON.parse(element));
                    }
                });
            }
            let ChartFinalArr = {};

            if(this.filterObj.vessel){
                this.filterObj.vessel.forEach(element => {
                    ChartFinalArr[JSON.parse(element).ID]={
                        label : JSON.parse(element).VESSEL_NAME,data :[]
                    }
                });
            }
            chartData.forEach(element => {
                element.IDS.split(',').forEach(rId => {
                    if (rId && this.generate_report_id.indexOf(rId) == -1) {
                        this.generate_report_id.push(rId);
                    }
                });
                let tempI = temp.indexOf(element.X_ID);
                ChartFinalArr[element.Ship_ID].data[tempI] = element.count;
            });
            if (Object.keys(ChartFinalArr).length > 0) {
                Object.keys(ChartFinalArr).forEach((ele) => {
                    this.lineChartData.push(ChartFinalArr[ele])
                })
            }
        }
        labelData.forEach((ele) => {
            this.lineChartLabels.push(ele)
        })
        this.generateReport(false); // get report 
    }

    makeChartForNumberOfObs(chartData) {
        let labelData = [];
        let dataArr = [];
        let j = 0;
        chartData.forEach(element => {
            if (element.total_obs - j > 0) {
                let length = element.total_obs - j;
                for (let i = 0; i < length; i++) {
                    labelData.push(j++);
                    dataArr.push(0);
                }
            }
            j = element.total_obs + 1;
            labelData.push(element.total_obs);
            if (this.filterObj.y_axis == 'total_inspection') {
                dataArr.push(element.TOTAL_INSPECTION);
            }
            else if (this.filterObj.y_axis == 'avg_risk') {
                if (this.isRiskCompany) {
                    dataArr.push(element.total_obs ? (element.company_total_risk / element.total_obs).toFixed(2) : 0);
                } else {
                    dataArr.push(element.total_obs ? (element.total_risk / element.total_obs).toFixed(2) : 0);
                }
            }
        });
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        labelData.forEach((ele) => {
            this.lineChartLabels.push(ele);
        })
        this.lineChartData.push({ data: dataArr, label: this.y_axis_label[this.filterObj.y_axis] })
    }
    getDataForDisplayOilMajorChart() {
        this.generate_report_id.length = 0;
        this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-wizard-data-for-oil-major-chart', 'postData': this.filterObj }).subscribe(result => {
            if (result.status) {
                let chartData = result.data;
                let dataArr = [];
                this.lineChartLabels.length = 0;
                this.lineChartData.length = 0;
                chartData.forEach(element => {
                    element.report_id.split(',').forEach(rId => {
                        if (rId && this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    this.lineChartLabels.push(element.INSPECTING_COMPANY);
                    dataArr.push(element.total_inspection);
                });
                this.lineChartData.push({ data: dataArr, label: this.y_axis_label[this.filterObj.y_axis] });
                this.tabs.select('step2');
            }
        })
    }
    openModelForShareReport(id,content) {
        let postData = {templateId : id};
        this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-share-wizard-report', 'postData': postData }).subscribe(result => {
            if(result.data.user_ids && result.data.user_ids !=null) {
                this.modalObj.users = result.data.user_ids.split(',').map(res => parseInt(res));
            } 
            else{
                this.modalObj.users = []
            }
            if(id){
                this.modalObj.templateId = id;
                this.modalRef = this.modalService.open(content, { size: 'sm' });
            }
        })
    }
    shareReport(){
        if(this.modalObj.templateId && this.modalObj.users.length > 0){
            this.commonService.sendRequestToNode({ method: 'post', path: 'chart/share-wizard-report',postData : this.modalObj }).subscribe(result => {
                if (result.status) {
                    this.modalRef.close();
                    swal({
                        title: 'Success',
                        text: 'Report Template Shared Successfully',
                        type: 'success',
                        confirmButtonClass: "btn btn-success",
                        buttonsStyling: false
                    })
                } else {
                    alert(result.message);
                }
            });
        }
    }

    show_wizard_report_from_list(obj) {
        if (obj) {
            let critical = this.filterObj.is_critical;
            this.filterObj = JSON.parse(obj);
            this.filterObj.is_critical = critical;
            this.getDropDownFrom_axis();
            this.getXaxis(1);
            this.goForChart();
        }
    }

    exportGraph(){
        // var canvas:any = document.getElementById("contentToConvert");
        // var image = canvas.toDataURL("image/png"); 
        // var link = document.createElement('a');
        //     link.download = this.filterObj.x_axis + '-'+ this.filterObj.y_axis +'.png';
        //     link.href = image;
        //     link.click();
        html2canvas(this.screen.nativeElement).then(canvas => {
            this.canvas.nativeElement.src = canvas.toDataURL();
            this.downloadLink.nativeElement.href = canvas.toDataURL('image/png');
            this.canvas.nativeElement.remove();
            // this.y_axis_label[filterObj.y_axis]
            let selectYaxis  = this.commonService.isJson( this.filterObj.selectedValueForY_axis) ? JSON.parse(this.filterObj.selectedValueForY_axis).TITLE : this.filterObj.selectedValueForY_axis;
            this.downloadLink.nativeElement.download = this.y_axis_label[this.filterObj.y_axis]+''+ ( this.filterObj.selectedValueForY_axis ? '('+ selectYaxis +')': '') +'_'+ this.x_axis_label[this.filterObj.x_axis] +'.png';
            this.downloadLink.nativeElement.click();
            
          });
    }

    resetFilter(){
        this.filterObj = {
            from_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))),
            to_date: this.commonService.formatDate(new Date()),
            x_axis: null,
            y_axis: null,
            timespan : null,
            consolidated_ship : 'true',
            selectedValueForX_axis: null,
            selectedValueForX_axis_compare : null,
            selectedValueForY_axis : null,
            audit_type : 0,
            vessel : null,
            X_axis_max_item_selection : 9999, // x-axis max item selection
            is_critical :  this.filterObj.is_critical,
            VESSEL_NAME: null,
            Defciency_Descp : null,
            selected_x_axis_value:null
        }
    }
}