import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';
//import { parse } from 'path';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';

@Component({
  templateUrl: './list.component.html',
  styleUrls: ['./list.component.scss']
})

export class ListComponent implements AfterViewInit,OnInit {
  //this is for filter 
  //public filterObj:any = {};
  test1:string;
  public headerInfo = {};
  sortFilter:any = {};
  //this is for timeout function break;
  time:any;
  is_critical_show : boolean = false;
  showFilter: boolean = false;
  public vesselForm:FormGroup;
  public modalRef:NgbModalRef;
  public config: PerfectScrollbarConfigInterface = {};
  public defectDamageForm: FormGroup;
  public expanded = [];
  public showhidefilter;
  public vessel_dropdown = [];
  public vessel_dropdown_export = [];
  public vessel_dropdown_obj = {} // get Name From Id
  public mainLoader = false;
  public defectType = 'pending';
  
  public showLoader = false;
  public defectDamageData = [];
  // public filterObj:any = {};
  public InspectionType = []; 
  public DeficiencyType = []; 
  public DeficiencyCause = []; 
  public Equipments = []; 
  public StatusCodes = [];
  public PSCRefNumbers = [];
  public AreaObservation = [];
  public ObserverCodes = []; 
  public Risk_Value = [];
  public PSC_Ref_ID = [];
  public Risk_Value_DropDown = [
    { id : 1 , display : 'Low Risk'},
    { id : 2 , display : 'Medium Risk'},
    { id : 3 , display : 'High Risk'},
    { id : 4 , display : 'Very High Risk'},
]
public Risk_Value_label = {
   1 : 'Low Risk',
   2 : 'Medium Risk',
   3 : 'High Risk',
   4 : 'Very High Risk',
  }
  public formSubmittedAttempt = false;
  public fileObj = ''; //use for importXls Data 
  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  
  public is_list_infoSharing = 0;
  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private formBuilder: FormBuilder,
    private router: Router,
    private route: ActivatedRoute
    ){
      this.is_list_infoSharing =  this.route.routeConfig.data.info_sharing || 0
      this.addForm();
      let filterObj = this.commonService.getRouteData('defect_damage_filter_data');
      if(filterObj) {
        this.defectDamageForm.patchValue(filterObj);
        // this.currentPage = filterObj.currentPage;
        this.commonService.clearRouteData('defect_damage_filter_data');
        this.currentPage = filterObj.currentPage;
      }
      this.getData();
      
  }
  @ViewChild('fileInput') fi:ElementRef;

  addForm() {
    this.defectDamageForm = this.formBuilder.group({
      C_Type: '',
      InfoSharing_Flag: this.is_list_infoSharing ? 'true' : 'false' ,
      InfoSharing_Flag_Change: false,
      Ship_ID: [''],
      Record_Date: [null],
      Inspection_Type_ID: [],
      Deficiency_Type_ID: [],
      Defciency_Descp: [],
      Deficiency_Cause: [],
      Equipments: [],
      Action_Taken: [],
      Target_Date: [null],
      Completion_Date: [null],
      Superident_Remarks: [],
      Status_ID: [],
      PSCRefNumbers: [],
      AreaObservation: [],
      Risk_Value: [],
      PSC_Ref_ID: [],
      Area_Observation_ID: [],
      Observeration_code: [],
      DryDock_Flag: false,
      Critical_Item_Flag: false,
      Complete_Flag: '0',
      start_date : null,
      end_date : null,
      is_filter_open : false
    });
    this.vesselForm = this.formBuilder.group({
      Vessel_ID: [null,[Validators.required]],
    });
    
  }
  get f(){
    return this.defectDamageForm.controls;
  }
  ngAfterViewInit(){
  }

  ngOnInit(){
    this.vessel();
    
    
    this.getInspectionType();
    this.getDeficiencyType();
    this.getDeficiencyCause();
    this.getStatusCodes();
    this.getEquipments();
    this.getPSCRefNumbers();
    this.getAreaObservations();
    this.getObserverCodes();
    this.configuration()
  }
  configuration(){
    this.commonService.sendRequestToNode({method :'get',path:'configuration/list'}).subscribe(result => {
      if(result.status){   
        if(result.data.length){
          this.is_critical_show = result.data[0].CRITICAL_DEFECT_SHOW;
          if(!this.is_critical_show){
            this.defectDamageForm.patchValue({
              Critical_Item_Flag : 0
            })
          }
        }
      }
    })
  }
  toggle(i){
    this.expanded[i] = !this.expanded[i];
  }
  showhideFilter(){
    this.defectDamageForm.patchValue({
      is_filter_open : !this.defectDamageForm.value.is_filter_open
    });
  }  
  getInspectionType(){
    this.commonService.sendRequestToNode({method :'get',path:'inspection-type-dropdown',queryParam : {ACTIVITY_TRAINING_FLAG : 0 }}).subscribe(result => {
      if(result.status){   
        this.InspectionType = result.data;
      }else{
        this.InspectionType = [];
        alert(result.message);
      }
    })
  }
  getDeficiencyType(){
    this.commonService.sendRequestToNode({method :'get',path:'typeof-defiency/data_list', queryParam:{sortBy:'TYPE_OF_DEFICIENCY',sortStatus: 'ASC'}}).subscribe(result => {
      if(result.status){   
        this.DeficiencyType = result.data;
      }else{
        this.DeficiencyType = [];
        alert(result.message);
      }
    })
  }
  getDeficiencyCause(){
    this.commonService.sendRequestToNode({method :'get',path:'deficiency-cause-dropdown'}).subscribe(result => {
      if(result.status){   
        this.DeficiencyCause = result.data;
      }else{
        this.DeficiencyCause = [];
        alert(result.message);
      }
    })
  }
  getStatusCodes(){
    this.commonService.sendRequestToNode({method :'get',path:'status-codes'}).subscribe(result => {
      if(result.status){   
        this.StatusCodes = result.data;
      }else{
        this.StatusCodes = [];
        alert(result.message);
      }
    })
  }
  getEquipments(){
    this.commonService.sendRequestToNode({method :'get',path:'equipment-codes'}).subscribe(result => {
      if(result.status){   
        this.Equipments = result.data;
        
      }else{
        this.Equipments = [];
        alert(result.message);
      }
    })
  }
  getPSCRefNumbers(){
    this.commonService.sendRequestToNode({method :'get',path:'psc-reference-numbers-dropdown'}).subscribe(result => {
      if(result.status){   
        this.PSCRefNumbers = result.data;
      }else{
        this.PSCRefNumbers = [];
        alert(result.message);
      }
    })
  }
  getAreaObservations(){
    this.commonService.sendRequestToNode({method :'get',path:'area-observation-dropdown'}).subscribe(result => {
      if(result.status){   
        this.AreaObservation = result.data;
      }else{
        this.AreaObservation = [];
        alert(result.message);
      }
    })
  }
  getObserverCodes(){
    this.commonService.sendRequestToNode({method :'get',path:'observer-codes'}).subscribe(result => {
      if(result.status){   
        this.ObserverCodes = result.data;
      }else{
        this.ObserverCodes = [];
        alert(result.message);
      }
    })
  }
  vessel(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vessel-dropdown-defect-damage-import-date',queryParam : {ACTIVE_FLAG : 1,with_non_tanker : true}}).subscribe(result => {
      if(result.status){
        
        this.vessel_dropdown = [{VESSEL_NAME : 'All Vessels',ID : 'ALL'},...result.data];
        this.vessel_dropdown_export = [...result.data];
        this.vessel_dropdown.forEach(ele => {
          this.vessel_dropdown_obj[ele.ID] = ele.VESSEL_NAME;
        })
        //console.log(this.vessel_dropdown);
      }
      else{
        this.vessel_dropdown = [];
        alert(result.message);
      }
    })
  }
  getData()
  {
    let filterParams:any = {}
    // alert('here')
    //search filter 
    // console.log(this.defectDamageForm);
    // filterParams = JSON.parse(JSON.stringify(this.defectDamageForm.value));
    filterParams = this.defectDamageForm.value;
    //search filter -end

    if((filterParams.Ship_ID && filterParams.Ship_ID.length) || this.is_list_infoSharing){
      // pagination
      // alert(this.currentPage);
      // alert(currentPage)
      filterParams.currentPage = this.currentPage-1;
      filterParams.itemsPerPage = this.itemsPerPage;
      // pagination - end

      //sorting 
      let sortKey = Object.keys(this.sortFilter);
      if(sortKey.length && this.sortFilter[sortKey[0]]){
        filterParams.sortBy = sortKey[0];
        filterParams.sortStatus = this.sortFilter[sortKey[0]];
      }
      
      //sorting - end
      this.showLoader = true;
      this.commonService.sendRequestToNode({method :'get',path:'defect-damage-compliance/list',queryParam:filterParams}).subscribe(result => {
        this.showLoader = false;        
        // alert('')
        if(result.status)
          {
            if(result.data.length > 0){
              this.totalItems = result.data[0].total_records;
              
              
              this.defectDamageData = result.data;
              result.data.forEach(element => {
                this.expanded.push(false)
              });
              // if(currentPage){
              //   setTimeout(()=>{
              //   alert('yes run')
              //     this.currentPage = currentPage;
              //   },2000)
                
              // }
            }else{
              this.totalItems = 0;
              this.defectDamageData = [];
            }
          }
          else{
            this.totalItems = 0;
            this.defectDamageData = [];
            alert(result.message);
          }
      })
    }
    else{
      this.totalItems = 0;
      this.defectDamageData = [];
    }
    
  }
  changeFlag_auditType(e){
    this.defectDamageForm.patchValue({
      // Complete_Flag : '',
      // DryDock_Flag: false,
      // Critical_Item_Flag: false,
      C_Type :e.target.value
    })
    // this.defectDamageForm.patchValue({
    //   C_Type : e.target.value 
    // })
    this.currentPage = 1;
    this.getData();
  }
  changeFlag_complete(e){
    // console.log(e.target.value);

    this.defectDamageForm.patchValue({
      Complete_Flag : e.target.value,
      // DryDock_Flag: false,
      // Critical_Item_Flag: false,
      // C_Type : ''
    })
    if( typeof e.target.value == 'string' && e.target.value == '' ) {
      this.defectType = 'both';
    } else if( typeof e.target.value == 'string' && e.target.value == '1') {
      this.defectType = 'completed';
    } else {
      this.defectType = 'pending';
    }
   
    this.currentPage = 1;
    this.getData();
  }
  changeFlag_DryDock(e){
    // console.log(e.target.value)
    // this.defectDamageForm.patchValue({
    //   // Complete_Flag : '',
    //   DryDock_Flag: e ? 1 : 0
    //   // Critical_Item_Flag: false,
    //   // C_Type : ''
    // })
    //console.log(e)
    this.defectDamageForm.patchValue({
      DryDock_Flag : e 
    })
    this.currentPage = 1;
    this.getData();
  }
  changeFlag_Critical_Item(e){
    //console.log(e)
    // this.defectDamageForm.patchValue({
    //   // Complete_Flag : '',
    //   // DryDock_Flag: false,
    //   Critical_Item_Flag: e ? 1 : 0,
    //   // C_Type : ''
    // })
    this.defectDamageForm.patchValue({
      Critical_Item_Flag : e 
    })
    this.currentPage = 1;
    this.getData();
  }
  changeFlag_infosharing_change(e,id){
    //console.log(e)
    this.showLoader = true;
    this.defectDamageForm.patchValue({
      InfoSharing_Flag_Change : e 
    })
    this.commonService.sendRequestToNode({method :'post',path:'defect-damage-compliance_update-infosharing',postData:{'infosharing':e,'id':id}}).subscribe(
      data => {
        this.currentPage = 1;
        // this.showLoader = false;
        this.getData();
        
        // var dialogueTitle = "Updated!"
        // swal({
        //   title: dialogueTitle,
        //   text: data.message,
        //   type: 'success',
        //   confirmButtonClass: "btn btn-success",
        //   buttonsStyling: false
        // })
      }
    )
     
  }
  edit(id){
    // alert(id)
    let filerObj = this.defectDamageForm.value;
    filerObj.currentPage = this.currentPage;
    this.commonService.setRouteData('defect_damage_filter_data',filerObj);
    this.router.navigate(['tmsa/defect_damage_compliance/edit/'+id])

  }

  add(id){
    // alert(id)
    let filerObj = this.defectDamageForm.value;
    filerObj.currentPage = this.currentPage;
    this.commonService.setRouteData('defect_damage_filter_data',filerObj);
    this.router.navigate(['tmsa/defect_damage_compliance/add'])

  }
  delete(id){
    
    if(id){
      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, delete it!',
         buttonsStyling: false
      }).then((result) => {
        if (result.value) {
          this.mainLoader = true;
          this.commonService.sendRequestToNode({method :'delete',path:'defect-damage-compliance/'+id}).subscribe(
          data => {
          if(data.status){
            this.mainLoader = false;
            var dialogueTitle = "Deleted!"
            if(this.defectDamageData.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
              if(this.currentPage>1){
                this.currentPage--;
              }
            }
            this.getData();
            swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
          }         
          
      })
         }
      })      
    }
  }
  changePage(page){
    this.currentPage = page;
    this.getData();
    window.scroll(0,0);
    // this.updateData.emit(page)
  }
  
  change_vessel(){
    let arr = []
    this.f.Ship_ID.value.forEach(ele=>{
      if(ele == 'ALL'){
        arr = this.vessel_dropdown.map(e=>{
          return e.ID;
        })
        arr = arr.filter(e=>{
          return !(e == 'ALL');
        })
       
      }
    })
    if(arr.length > 0){
      this.defectDamageForm.patchValue({
        Ship_ID : arr
      });
    }
    // console.log(arr);return false;
    
    this.filter()
  }

  //when filter
  filter(){
    this.currentPage = 1;
    this.getData();
  }

  exportSelect(content){
    this.vesselForm.patchValue({
      Vessel_ID: null,
    })
    this.modalRef = this.modalService.open(content,{size: 'sm'});
  }
  importOpenModal(content){
    // this.vesselForm.patchValue({
    //   Vessel_ID: null,
    // })
    this.modalRef = this.modalService.open(content,{size: 'sm'});
  }


  onFileChange(event) {
    if(event.target.files.length > 0) {
      this.fileObj = event.target.files[0];  
    }else{
      this.fileObj = '';
      this.fi ? this.fi.nativeElement.value = "" : '';
    }
  }
  
  submitImportFile(){
    if(this.fileObj){
      this.mainLoader = true;
      let formData = new FormData();
      formData.append('FILE',this.fileObj);
      
      this.commonService.sendRequestToNode({method :'post',path:'defect-damage-compliance/checkImportFileOlderOrNot',postData:formData}).subscribe(data =>{
        if(data.status){
          if(data.message == "confirmation_for_import"){
            this.mainLoader = false;
            swal({
              title: 'Are you sure?',
              text: "Last exported file name does not match the  file you are currently trying to import from , do you wish to continue ? . Data might get overwritten if you choose to proceed.",
              type: 'warning',
              showCancelButton: true,
              confirmButtonClass: 'btn btn-success',
              cancelButtonClass: 'btn btn-danger',
              confirmButtonText: 'Yes, Import it!',
               buttonsStyling: false
            }).then((result) => {
              if (result.value) {
                 this.importFile();
                }         
                
              })  
          }
          else{
            this.importFile();
          }
          
        }
      })  
    }  
    else{
      alert('Please Select File');
    }
  }

  importFile(){
    let formData = new FormData();
    formData.append('FILE',this.fileObj);
    this.mainLoader = true;
    this.commonService.sendRequestToNode({method :'post',path:'defect-damage-compliance/importXls',postData:formData}).subscribe(
      data =>{
      this.mainLoader = false;
        var dialogueTitle = "Imported!";
        if(data.status){
          swal({
            html: 'File Successfully imported',
            title: dialogueTitle,
            type: 'success',
            confirmButtonClass: "btn btn-success",
            buttonsStyling: false
          });
          this.getData();
          this.modalRef.close();
          this.fileObj = ''; // remove data from file Obj
          this.fi ? this.fi.nativeElement.value = "" : ''; // blank input file 
          
        }
        else{
          alert(data.message)
        }
      }); 
  }

  exportData(){
    this.formSubmittedAttempt = true;
    if(this.vesselForm.valid){
      let Vessel_ID = this.vesselForm.value.Vessel_ID;
      window.open(this.commonService.getNodeApi()+'/defect-damage-compliance/exportXls?Vessel_ID='+Vessel_ID+'&is_critical='+this.is_critical_show+'&VesselName='+this.vessel_dropdown_obj[Vessel_ID],'_blank')
      this.modalRef.close();
    }
    
  }

  sorting(header_title){
    
    if(!this.headerInfo[header_title]){
      this.headerInfo = {};
      this.headerInfo[header_title] = {
        sortStatus : undefined
      }
    }
    if(this.headerInfo[header_title].sortStatus == undefined){
      // alert('headerInfo')
      this.headerInfo[header_title].sortStatus = 'asc'
    }
    else if(this.headerInfo[header_title].sortStatus == 'asc'){
      this.headerInfo[header_title].sortStatus = 'desc'
    }
    else{
      this.headerInfo[header_title].sortStatus = undefined;
    }
    this.sortFilter = {[header_title] : this.headerInfo[header_title].sortStatus} 
    this.getData();
    // console.log(header)
  }

  exportReportData(type){
    let filterParams:any = {}
    // alert('here')
    //search filter 
    // console.log(this.defectDamageForm);
    filterParams = JSON.parse(JSON.stringify(this.defectDamageForm.value));
    //search filter -end

    // if(filterParams.Ship_ID){
      //sorting 
      let sortKey = Object.keys(this.sortFilter);
      if(sortKey.length && this.sortFilter[sortKey[0]]){
        filterParams.sortBy = sortKey[0];
        filterParams.sortStatus = this.sortFilter[sortKey[0]];
      }
      filterParams.all_records = 1;
      //sorting - end
      this.mainLoader = true;
      this.commonService.sendRequestToNode({method :'get',path:'defect-damage-compliance/list',queryParam:filterParams}).subscribe(result => {
        this.mainLoader = false;        
        // alert('')
        if(result.status)
          {
           let url = this.commonService.getNodeApi() + '/defect-damage-compliance/pdf';
            if(type=='xls'){
              url = this.commonService.getNodeApi() + '/defect-damage-compliance/csv';
            }
           
           var mapForm = document.createElement("form");
           mapForm.target = "_blank";
           mapForm.method = "POST"; // or "post" if appropriate
           mapForm.action = url;
       
           var mapInput = document.createElement("input");
           mapInput.type = "hidden";
           mapInput.name = "data";
           mapInput.value = JSON.stringify(result.data);
           mapForm.appendChild(mapInput);
       
           document.body.appendChild(mapForm);
       
          //  let map = window.open("", "Map", "status=0,title=0,height=600,width=800,scrollbars=1");
       
           if (mapForm) {
               mapForm.submit();
           } else {
               alert('You must allow popups for this map to work.');
           }
          }
          else{
            this.totalItems = 0;
            this.defectDamageData = [];
            alert(result.message);
          }
      });
    // }
    // else{
    //   this.totalItems = 0;
    //   this.defectDamageData = [];
    // }
  }

  
}

