import { Component, AfterViewInit, ViewEncapsulation, OnInit } from '@angular/core';
import { DragulaService } from 'ng2-dragula';
import { CommonService } from '../common-service.service';
import { Router, ActivatedRoute } from "@angular/router";
import swal from 'sweetalert2';

//for charts

import * as Chartist from 'chartist';
import { ChartType, ChartEvent } from 'ng-chartist/dist/chartist.component';

declare var require: any;
const data: any = require('./data.json');

export interface Chart {
  type: ChartType;
  data: Chartist.IChartistData;
  options?: any;
  responsiveOptions?: any;
  events?: ChartEvent;
}


@Component({
  templateUrl: './home.component.html',
  styleUrls: ['./home.component.scss']
})
export class HomeComponent implements AfterViewInit {

  //box 1 chart
  public lineChartData1: Array<any> = [];
  public lineChartLabels1: Array<any> = [];
  public lineChartColors1: Array<any> =  [
    {
      backgroundColor: 'rgb(246,196,41,.5)',
      borderColor: '#F6C429',
      pointBackgroundColor: '#F6C429',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#F6C429'
    }
  ];
  //box 2 chart
  public lineChartData2: Array<any> = [];
  public lineChartLabels2: Array<any> = [];
  public lineChartColors2: Array<any> = [
    {
      backgroundColor: 'rgb(255,127,173,.7)',
      borderColor: '#FF7FAD',
      pointBackgroundColor: '#FF7FAD',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#FF7FAD'
    }
  ];
  //box 3 chart
  public lineChartData3: Array<any> = [];
  public lineChartLabels3: Array<any> = [];
  public lineChartColors3: Array<any> = [
    {
      backgroundColor: 'rgb(127,231,233,.7)',
      borderColor: '#7FE9E7',
      pointBackgroundColor: '#7FE9E7',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#7FE9E7'
    }
  ];
  //box 4 chart
  public lineChartData4: Array<any> = [];
  public lineChartLabels4: Array<any> = [];
  public lineChartColors4: Array<any> = [
    {
      backgroundColor: 'rgb(127,194,255,.7)',
      borderColor: '#7FC2FF',
      pointBackgroundColor: '#7FC2FF',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#7FC2FF'
    }
  ];

  //box 5 chart
  public lineChartData5: Array<any> = [];
  public lineChartLabels5: Array<any> = [];
  public lineChartColors5: Array<any> = [
    {
      backgroundColor: 'rgb(241,127,255,.5)',
      borderColor: '#D67FFF',
      pointBackgroundColor: '#D67FFF',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#D67FFF'
    }
  ];

  //box 7 chart
  public lineChartData7: Array<any> = [];
  public lineChartLabels7: Array<any> = [];
  public lineChartColors7: Array<any> = [
    {
      backgroundColor: 'rgb(0,197,76,.7)',
      borderColor: '#00C54C',
      pointBackgroundColor: '#00C54C',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#00C54C'
    }
  ];

  //box 8 chart
  public lineChartData8: Array<any> = [];
  public lineChartLabels8: Array<any> = [];
  public lineChartColors8: Array<any> = [
    {
      backgroundColor: 'rgb(255,198,127,.7)',
      borderColor: '#FFC67F',
      pointBackgroundColor: '#FFC67F',
      pointBorderColor: '#fff',
      pointHoverBackgroundColor: '#fff',
      pointHoverBorderColor: '#FFC67F'
    }
  ];
  

  public lineChartOptions: any = {
    responsive: true,
    scales: {
      yAxes: [{
          ticks: {
              beginAtZero: true
          },
      }],
    }
  };
  public lineChartLegend = true;
  public lineChartType = 'line';
  public BarChartType = 'bar';

  constructor(private commonService: CommonService,private router: Router){
  }

  ngOnInit(){
    this.getData();
    this.upcomingInspection();
  }

  ngAfterViewInit(){	
  }

  // This is with the output example
  public dashboard_index: Array<number> = [1, 2, 3, 4, 5, 6, 7, 8, 9];
  public upcoming_Inspection;
  public total_obs;
  public total_inspection;

  getData()
  {
    this.commonService.sendRequestToNode({method :'get',path:'home/getDashboard'}).subscribe(result => {
        if(result.status)
        {
          this.dashboard_index = JSON.parse(result.data[0].DASHBOARD_INDEX);
          //console.log(this.dashboard_index);
        }
        else{
          alert(result.message)
        }
    })

    this.commonService.sendRequestToNode({method :'get',path:'home/getAllChartData'}).subscribe(result => {
      if(result.status)
      {
        
        // viq ref chart
        if(result.data.viqChapter && result.data.viqChapter.length > 0){
          let label = [];
          let data = [];
          result.data.viqChapter.forEach(ele => {
            label.push('CH-'+ele.chapter);
            data.push(ele.total_obs ? (ele.total_obs/ele.total_inspection).toFixed(2):0);
          });
          this.lineChartData1.push({ data: data, label: 'Avg. No. of Obs' })
          this.lineChartLabels1 =  label;
        }else{
          this.lineChartData1.push({ data: [], label: 'Avg. No. of Obs' })
          this.lineChartLabels1 =  [];
        }
        
        // Month chart
        if(result.data.monthChart && result.data.monthChart.length > 0){
          let label = [];
          let data = [];
          result.data.monthChart.forEach(ele => {
            label.push(ele.time);
            data.push(ele.total_obs ? (ele.total_obs/ele.total_inspection).toFixed(2):0);
          });
          this.lineChartData2.push({ data: data, label: 'Avg. No. of Obs' })
          this.lineChartLabels2 =  label;
        }else{
            this.lineChartData2.push({ data: [], label: 'Avg. No. of Obs' })
            this.lineChartLabels2 =  [];
        }
        
        // Year chart
        if(result.data.yearChart && result.data.yearChart.length > 0){
          let label = [];
          let data = [];
          result.data.yearChart.forEach(ele => {
            label.push(ele.time);
            data.push(ele.total_obs ? (ele.total_obs/ele.total_inspection).toFixed(2):0);
          });
          this.lineChartData3.push({ data: data, label: 'Avg. No. of Obs' })
          this.lineChartLabels3 =  label;
        }else{
            this.lineChartData3.push({ data: [], label: 'Avg. No. of Obs' })
            this.lineChartLabels3 =  [];
        }

        // oilMajor chart
        if(result.data.oilMajorChart && result.data.oilMajorChart.length > 0){
          let label = [];
          let data = [];
          result.data.oilMajorChart.forEach(ele => {
            label.push(ele.OFFICIAL_NAME);
            data.push(ele.PERCENT);
          });
          this.lineChartData4.push({ data: data, label: 'Avg. No. of Obs' })
          this.lineChartLabels4 =  label;
        }else{
            this.lineChartData4.push({ data: [], label: 'Avg. No. of Obs' })
            this.lineChartLabels4 =  [];
        }

        // vessel chart
        if(result.data.vesselChart && result.data.vesselChart.length > 0){
          let label = [];
          let data = [];
          let res = result.data.vesselChart.slice(0,6);
          res.forEach(ele => {
            label.push(ele.VESSEL_NAME);
            data.push(ele.total_risk ? (ele.total_risk/ele.total_obs).toFixed(2):0);
          });
          this.lineChartData5.push({ data: data, label: 'Avg. Risk Value' })
          this.lineChartLabels5 =  label;
        }else{
            this.lineChartData5.push({ data: [], label: 'Avg. Risk Value' })
            this.lineChartLabels5 =  [];
        }

        // fleet chart
        if(result.data.fleetChart && result.data.fleetChart.length > 0){
          let label = [];
          let data = [];
          result.data.fleetChart.forEach(ele => {
            label.push(ele.FLEET_NAME);
            data.push(ele.total_obs ? (ele.total_obs/ele.total_inspection).toFixed(2):0);
          });
          this.lineChartData8.push({ data: data, label: 'Avg. No. of Obs' })
          this.lineChartLabels8 =  label;
        }else{
            this.lineChartData8.push({ data: [], label: 'Avg. No. of Obs' })
            this.lineChartLabels8 =  [];
        }

        // group chart
        if(result.data.groupChart && result.data.groupChart.length > 0){
          let label = [];
          let data = [];
          result.data.groupChart.forEach(ele => {
            label.push(ele.GROUP_NAME);
            data.push(ele.total_obs ? (ele.total_obs/ele.total_inspection).toFixed(2):0);
          });
          this.lineChartData7.push({ data: data, label: 'Avg. No. of Obs' })
          this.lineChartLabels7 =  label;
        }else{
            this.lineChartData7.push({ data: [], label: 'Avg. No. of Obs' })
            this.lineChartLabels7 =  [];
        }

      }
      else{
        alert(result.message)
      }
  })
  }

  upcomingInspection()
  {
    this.commonService.sendRequestToNode({method :'get',path:'home/dashboardBoxInfo'}).subscribe(result => {
        if(result.status)
        {
          this.upcoming_Inspection = result.data[0].count;
          this.total_inspection = result.data1[0].total_inspection;
          this.total_obs = result.data1[0].total_obs;
        }
        else{
          alert(result.message)
        }
    })
  }

  getReportOftop() {
    this.router.navigate(["/inspectionPlanning"]);
  }

  onSubmit(){

    this.commonService.sendRequestToNode({method :'post',path:'home/addDashboard',postData:{DASHBOARD_INDEX:JSON.stringify(this.dashboard_index)}}).subscribe(
      data =>{
        var dialogueTitle = "Updated!";
        if(data.status){
          swal({
            title: dialogueTitle,
            text: data.message,
            type: 'success',
            confirmButtonClass: "btn btn-success",
            buttonsStyling: false
          })
          this.getData();
        }else{
          alert(data.message);
        }
    })

  }


  private hasClass(el: any, name: string): any {
    return new RegExp('(?:^|\\s+)' + name + '(?:\\s+|$)').test(el.className);
  }

  private addClass(el: any, name: string): void {
    if (!this.hasClass(el, name)) {
      el.className = el.className ? [el.className, name].join(' ') : name;
    }
  }

  private removeClass(el: any, name: string): void {
    if (this.hasClass(el, name)) {
      el.className = el.className.replace(
        new RegExp('(?:^|\\s+)' + name + '(?:\\s+|$)', 'g'),
        ''
      );
    }
  }

  private onDrag(args: any): void {
    const [e] = args;
    this.removeClass(e, 'ex-moved');
  }

  private onDrop(args: any): void {
    const [e] = args;
    this.addClass(e, 'ex-moved');
  }

  private onOver(args: any): void {
    const [el] = args;
    this.addClass(el, 'ex-over');
  }

  private onOut(args: any): void {
    const [el] = args;
    this.removeClass(el, 'ex-over');
  }

  private onDropModel(args: any): void {
    const [el, target, source] = args;
 
  }

  private onRemoveModel(args: any): void {
    const [el, source] = args;
   
  }



  // for charts....

  // Barchart
  barChart1: Chart = {
    type: 'Bar',
    data: data['Bar'],
    options: {
      seriesBarDistance: 15,
      axisX: {
        showGrid: false,
        offset: 70
      },
      axisY: {
        showGrid: true,
        offset: 50
      }
    },
    responsiveOptions: [
      [
        'screen and (min-width: 640px)',
        {
          axisX: {
            labelInterpolationFnc: function(
              value: number,
              index: number
            ): string {
              return index % 1 === 0 ? `${value}` : null;
            }
          }
        }
      ]
    ]
  };

  
  // Line chart 2
  lineChart2: Chart = {
    type: 'Line',
    data: data['Line'],
    options: {
      low: 0,
      showArea: true,
      fullWidth: true
    }
  };
  // Line chart 2
  lineChart3: Chart = {
    type: 'Line',
    data: data['Line2'],
    options: {
      low: 0,
      showArea: true,
      fullWidth: true
    }
  };
  // Scatter chart
  scatterChart1: Chart = {
    type: 'Line',
    data: data['Scatter'],
    options: {
      showLine: false,
      axisX: {
        labelInterpolationFnc: function(value: number, index: number): string {
          return index % 13 === 0 ? `W${value}` : null;
        }
      }
    },
    responsiveOptions: [
      [
        'screen and (min-width: 640px)',
        {
          axisX: {
            labelInterpolationFnc: function(
              value: number,
              index: number
            ): string {
              return index % 4 === 0 ? `W${value}` : null;
            }
          }
        }
      ]
    ]
  };
  // Pie chart
  pieChart1: Chart = {
    type: 'Pie',
    data: data['Pie'],
    options: {
      donut: true,
      donutWidth: 50,
      startAngle: 270,
      total: 200,
      showLabel: false
    }
  };
  donuteChart1: Chart = {
    type: 'Pie',
    data: data['Pie'],
    options: {
      donut: true,
      showLabel: false
    }
    // events: {
    //   draw(data: any): boolean {
    //     return data;
    //   }
    // }
  };
  // Bi Poller chart
  bipollarChart1: Chart = {
    type: 'Bar',
    data: data['Bi-PolarBar'],
    options: {
      high: 10,
      low: -10,
      axisX: {
        labelInterpolationFnc: function(value: number, index: number): number {
          return index % 2 === 0 ? value : null;
        }
      }
    }
  };




}
