// import { Component, AfterViewInit, ViewEncapsulation, OnInit } from '@angular/core';
// import { CommonService } from '../common-service.service';

// import {Router,ActivatedRoute} from "@angular/router";
// import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
// import swal from 'sweetalert2';

import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import swal from 'sweetalert2';
import { WindowService } from '@ng-select/ng-select/ng-select/window.service';

declare var require: any;

@Component({
  selector: 'inspectionPlanning',
  templateUrl: './inspectionPerOilMajor.component.html',
  styleUrls: ['./inspectionPerOilMajor.component.scss']
})
export class InspectionPerOilMajorComponent implements AfterViewInit,OnInit {

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  isDisabled = true;

  public expanded = [];
  public NEXT_DUE;
  public filterObj = {};
  public formData = {};
  public formDataOperatorDate = {};
  public vesselGroup_dropdown = [];
  public vesselFleet_dropdown = [];
  public vesselOwner_dropdown = [];
  public port_dropdown = [];
  public perCompanyObservation;
  public perCompanyRisk;
  public oilMajor_dropdown = [];
  public inspector_dropdown = [];
  public inspectionPerOilMajorData = [];
  public inspectionPerOilMajorDatacsv = [];
  public configData = [];
  public sortFilter:any = {};
  public current_template;
  public link_template;
  public questions_curr = [];
  public questions_prev = [];
  private fieldArray = {};
  private dataArray = {};
  public linkData = {};  

  
  // public VesselMasterForm:FormGroup;
  // public groupSireReportUpload:FormGroup;

  constructor(private modalService: NgbModal,
    private commonService: CommonService){      
  }

  ngOnInit(){
 
    this.getData();
    //this.getDataforcsv();   
    //console.log(this.formData);    
  
  }

  ngAfterViewInit(){	
  }

  changePage(page){
    this.currentPage = page;
    this.sendFilterObjectForUpdateData();
    window.scroll(0,0);
    // this.updateData.emit(page)
  }

  sendFilterObjectForUpdateData(){
    let makeFilterObj = {}
     Object.keys(this.filterObj).forEach((key) => {
       makeFilterObj[key] = this.filterObj[key].replace(/'/g, "\\\'").replace(/"/g, '\\\"')
     });
     let filter = {
       filter : makeFilterObj,
       page : this.currentPage,
       sort : this.sortFilter
     }
     this.getData();
   }

 
  // generatcsv(){
  //   console.log(this.inspectionPerOilMajorDatacsv);
  //   this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/exportObj',postData:this.inspectionPerOilMajorDatacsv}).subscribe(result => {
  //     window.location.href = this.commonService.getNodeApi()+'/inspectionPlanning/export';
  //   })
  // }

  generatePdf(){
    window.location.href = this.commonService.getNodeApi()+'/inspectionPlanning/generate-pdf';
  }


  getData(){ 
    let filterParams:any = {}
   //search filter 
   filterParams = JSON.parse(JSON.stringify(this.filterObj));
   //search filter -end

   // pagination
   filterParams.currentPage = this.currentPage-1;
   filterParams.itemsPerPage = this.itemsPerPage;

    this.commonService.sendRequestToNode({method :'get',path:'inspectionPerOilMajor/getData',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        if(result.data[0]){
          this.totalItems = result.data[0].total_records;
        }        

        this.inspectionPerOilMajorData = result.data[0];          
        
      }
      else{
        this.inspectionPerOilMajorData = [];
        alert(result.message);
      }
    })
  } 
  
  // navigate(name,id){
  //   //this.inspectionPerOilMajorData; 

  // }
  addMonths(month){
    let months = this.inspectionPerOilMajorData;
    for (let m of months) {

      var lastSireDate = new Date(m.LAST_INSPECTION_DATE);
      var dd = lastSireDate.getDate();
      var mm = lastSireDate.getMonth() + parseInt('1') + parseInt(month); 
      var yyyy;
      if(mm > 12){
        yyyy = lastSireDate.getFullYear() + 1; 
        mm = mm - 12;
      }else{
        yyyy = lastSireDate.getFullYear();
      }      
      
      
      m.NEXT_DUE_DATE = ('0' + (dd)).slice(-2) +'/'+('0' + (mm)).slice(-2)+'/'+yyyy;

      m.NEXT_DUE_DATE1 = yyyy +'/'+mm+'/'+dd;
      var today1 = new Date();
      
     

      let color;
      let dueDate = new Date(m.NEXT_DUE_DATE1);

      //this is for NEXT DUE TO Today date diff
      let isPrevFromNextdueDate = false;
      if(dueDate.getTime() - today1.getTime() > 0  ){
        var timeDiff = Math.abs(dueDate.getTime() - today1.getTime());
        var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
        // console.log(diffDays); 
      } 
      else{
        var timeDiff = Math.abs(dueDate.getTime() - today1.getTime());
        var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
        isPrevFromNextdueDate =  true;
        // console.log('-'+diffDays); 
      }

      //this is for Last Sire Date TO Today date diff
      let isPrevFromLastSireDate = false;
      if(lastSireDate.getTime() - today1.getTime() > 0  ){
        var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
        var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
      } 
      else{
        var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
        var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
        isPrevFromLastSireDate =  true;
      }
                         
      if(isPrevFromNextdueDate){ 
        m.BG_COLOR = 'bg-myred';        
      }else if(!isPrevFromNextdueDate && diffDays <= 30){
        m.BG_COLOR = 'bg-myorange';
      }else if(isPrevFromLastSireDate && diffDaysOFLastSire <= 30){
        m.BG_COLOR = 'bg-mygreen';
      }else{  
        m.BG_COLOR = 'bg-myyellow';
      }

      // let color ;
      // let dueDate = new Date(m.NEXT_DUE_DATE);             
      //   alert(dueDate.getTime());
      // if(today.getTime() > dueDate.getTime()){ 
      //   m.BG_COLOR = 'red';
      // }else{
      //   m.BG_COLOR = 'bg-orange';
      // }

      let mmm = parseInt(month);
      this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/addMonth/'+mmm}).subscribe(
        data =>{         
      })
    }
  }

  calculate(lastSireDate,currentDate) {
    var fromDate =lastSireDate;
    var toDate = currentDate;
  // console.log(fromDate);
  // console.log(toDate);
    try { //alert();
      // document.getElementById('result').innerHTML = '';
  
      var result = this.getDateDifference(new Date(fromDate), new Date(toDate));
      //console.log(result);
      if (result && !isNaN(result.years)) {
        // console.log(result);
        // document.getElementById('result').innerHTML =
        //   result.years + ' year' + (result.years == 1 ? ' ' : 's ') +
        //   result.months + ' month' + (result.months == 1 ? ' ' : 's ') + 'and ' +
        //   result.days + ' day' + (result.days == 1 ? '' : 's');

          return {'Year':result.years,'Month':result.months,'Day':result.days};
      }
    } catch (e) {
      console.error(e);
    }
  }
  
  getDateDifference(startDate, endDate) {
    //console.log(startDate);
    //console.log(endDate)
    if (startDate > endDate) {
  //    console.error('Start date must be before end date');
      return null;
    }
    var startYear = startDate.getFullYear();
    var startMonth = startDate.getMonth();
    var startDay = startDate.getDate();
  
    var endYear = endDate.getFullYear();
    var endMonth = endDate.getMonth();
    var endDay = endDate.getDate();
  
    // We calculate February based on end year as it might be a leep year which might influence the number of days.
    var february = (endYear % 4 == 0 && endYear % 100 != 0) || endYear % 400 == 0 ? 29 : 28;
    var daysOfMonth = [31, february, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  
    var startDateNotPassedInEndYear = (endMonth < startMonth) || endMonth == startMonth && endDay < startDay;
    var years = endYear - startYear - (startDateNotPassedInEndYear ? 1 : 0);
  
    var months = (12 + endMonth - startMonth - (endDay < startDay ? 1 : 0)) % 12;
  
    // (12 + ...) % 12 makes sure index is always between 0 and 11
    var days = startDay <= endDay ? endDay - startDay : daysOfMonth[(12 + endMonth - 1) % 12] - startDay + endDay;
  //console.log(years+':'+months+':'+days)
    return {
      years: years,
      months: months,
      days: days
    };
  }

  onSubmit(ID,data){    
       
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:data}).subscribe(
          data =>{
            var dialogueTitle = "Updated!";
           
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
             // this.getData();
             //this.getDataforcsv();
           
              //this.resetForm();
            }else{
              alert(data.message);
            }
        })   
  }

  resetForm(ID){       
    
    //this.formData[ID] = {};
   // this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';

   
      
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
      
      if (result.value) {
        
        this.formData[ID].PLAN_DATE='';
        this.formData[ID].PLAN_INSPECTOR_FK='';
        this.formData[ID].PLAN_OIL_MAJOR_FK='';
        this.formData[ID].PLAN_PORT_FK='';
        this.formData[ID].PLAN_REMARKS='';
        this.onSubmit(ID,this.formDataOperatorDate[ID]);
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:this.formData[ID]}).subscribe(
          data => {
            if(data.status){
              var dialogueTitle = "Reset!";              
              this.getData();
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
        })
      }
    })

    //this.formData[ID] = {};
    //this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';
   
  }
  resetDateForm(ID){
   
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
      
      if (result.value) { 
        this.formData[ID].PLAN_DATE='';
        this.formData[ID].PLAN_INSPECTOR_FK='';
        this.formData[ID].PLAN_OIL_MAJOR_FK='';
        this.formData[ID].PLAN_PORT_FK='';
        this.formData[ID].PLAN_REMARKS='';
        this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';
        this.onSubmit(ID,this.formDataOperatorDate[ID]);
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:this.formData[ID]}).subscribe(
          data => {
            if(data.status){
              var dialogueTitle = "Reset!";              
              this.getData();
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
        })
      }
    })

  }

  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    // this.getData();
  }

}
