import { Component, AfterViewInit,OnInit } from '@angular/core';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router} from "@angular/router";
import {FormGroup,FormBuilder} from '@angular/forms';
import swal from 'sweetalert2';

declare var require: any;

@Component({
  selector: 'inspectionPlanning',
  templateUrl: './inspectionPlanning.component.html',
  styleUrls: ['./inspectionPlanning.component.scss']
})
export class InspectionPlanningComponent implements AfterViewInit,OnInit {
  
  public modalRef:NgbModalRef;
  
  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  isDisabled = true;

  public expanded = [];
  public NEXT_DUE;
  public filterObj : any = {};
  public formData = {};
  public vessel_dropdown = [];
  public formDataOperatorDate = {};
  public vesselGroup_dropdown = [];
  public vesselFleet_dropdown = [];
  public vesselOwner_dropdown = [];
  public port_dropdown = [];
  public perCompanyObservation;
  public perCompanyRisk;
  public oilMajor_dropdown = [];
  public inspector_dropdown = [];
  public inspector_dropdown_name : any = {};
  public country_dropdown = [];// user in add port
  public inspectionPlanningData = [];
  public inspectionPlanningDatacsv = [];
  public configData = [];
  public sortFilter:any = {};
  public current_template;
  public link_template;
  public questions_curr = [];
  public questions_prev = [];
  private fieldArray = {};
  private dataArray = {};
  public linkData = {};  
  public result:any = {};
  //this is for inspector form
  public Groupinspector :FormGroup;
  public portForm :FormGroup;
  public isRiskCompany = false; // if true then risk get from company side
  public sortObj = {
    VESSEL_NAME : '',
    DELIVERY_DATE : '',
    LAST_INSPECTION_DATE : '',
    OPERATOR_RESPONSE_DUE_DATE : ''
  }

  public inspectorFormSubmittedAttempt = false;
  public portFormSubmittedAttempt = false;
  // public VesselMasterForm:FormGroup;
  // public groupSireReportUpload:FormGroup;
  
  //this is for Add Inspector or Port
  public planningIndex = 0;

  public disabled = true;
  public operator_response_due_start_date:any; 
  public operator_response_due_end_date:any;

  public showLoader = false;
  constructor(private modalService: NgbModal,
    private formBuilder: FormBuilder,
    private router: Router,
    private commonService: CommonService){
      let d = new Date();
      this.operator_response_due_start_date = d.getFullYear()+'-'+ ('0'+(d.getMonth()+1)).slice(-2) + '-'+('0'+d.getDate()).slice(-2); 
      let d1 =  new Date(d.getTime() + 13*24*60*60*1000);//increase 14 days
      this.operator_response_due_end_date = d1.getFullYear()+'-'+ ('0'+(d1.getMonth()+1)).slice(-2) + '-'+('0'+d1.getDate()).slice(-2); 
      // this.operator_response_due_end_date = ;
  }

  ngOnInit(){
    this.vesselGroup();
    this.vesselFleet();
    this.vesselOwner();
    this.countryDropDown();
    this.port();
    this.oilMajor();
    this.inspector();
    this.getData();
    this.vesselDropdown();
    
    //form for Inspector add 
    this.Groupinspector = this.formBuilder.group({
      OIL_MAJOR_MASTER_FK: [null,],
      FNAME: [null,],
      LNAME: [null,],
      INSPECTING_COMPANY: [null,],
      OFFICE_TELEPHONE: [null,],
      MOBILE_NO: [null,],
      EMAIL: [null,],
      COMMONLY_KNOWN: [null,],
      COMMENTS: [null,],
    }); 

    //form for port add 
    this.portForm = this.formBuilder.group({
      PORT_NAME: [null,],
      PORT_CODE: [null,],
      COUNTRY_MST_FK: [null,],
      LATITUDE : [null,],
      LONGITUDE : [null,]
    }); 
    //this.getDataforcsv();   
    //console.log(this.formData);    
  
  }

  ngAfterViewInit(){	
  }

  changePage(page){
    this.currentPage = page;
    window.scroll(0,0);
    this.getData();
  }

  toggle(id,inspectorId,index){
    this.expanded[id] = !this.expanded[id];
    if(this.expanded[id]){
      // console.log();
      if(this.inspectionPlanningData[index].PLAN_DATE && this.inspectionPlanningData[index].PLAN_DATE != "0000-00-00"){
        let pdate = new Date(this.inspectionPlanningData[index].PLAN_DATE);
        this.formData[id].PLAN_DATE = pdate.getFullYear()+'-'+('0' + (pdate.getMonth()+1)).slice(-2)+'-'+('0' + (pdate.getDate())).slice(-2);  
      }
      this.formData[id].PLAN_INSPECTOR_FK = this.inspectionPlanningData[index].PLAN_INSPECTOR_FK ? this.inspectionPlanningData[index].PLAN_INSPECTOR_FK : undefined;
      this.formData[id].PLAN_OIL_MAJOR_FK = this.inspectionPlanningData[index].PLAN_OIL_MAJOR_FK ? this.inspectionPlanningData[index].PLAN_OIL_MAJOR_FK : undefined;
      this.formData[id].PLAN_PORT_FK = this.inspectionPlanningData[index].PLAN_PORT_FK ? this.inspectionPlanningData[index].PLAN_PORT_FK : undefined;
      this.formData[id].PLAN_REMARKS = this.inspectionPlanningData[index].PLAN_REMARKS;
      // console.log(this.inspectionPlanningData[index]);
      this.getInspectorObservation(inspectorId,index);
    }  
  }

  getInspectorObservation(inspectorId,index){
    if(inspectorId){
      this.commonService.sendRequestToNode({method :'post',path:'get-local-observation-of-inspector',postData : {'INSPECTOR_FK' : inspectorId}}).subscribe(result => {
        if(result.status){
          
          this.inspectionPlanningData[index].AVG_INSPECTOR_OBSERVATION = result.data[inspectorId].AVG_OBSERVATION ? result.data[inspectorId].AVG_OBSERVATION.toFixed(2) : 0
          this.inspectionPlanningData[index].AVG_INSPECTOR_RISK_PROFILE = result.data[inspectorId].AVG_RISK_PROFILE ? result.data[inspectorId].AVG_RISK_PROFILE.toFixed(2) : 0   
        }
        else{
          alert(result.message);
        }
      })
    }
    else{
      this.inspectionPlanningData[index].AVG_INSPECTOR_OBSERVATION = 0;
      this.inspectionPlanningData[index].AVG_INSPECTOR_RISK_PROFILE = 0;  
    }
  }

  vesselGroup(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselGroup'}).subscribe(result => {
      if(result.status){
        this.vesselGroup_dropdown = result.data;
      }
      else{
        this.vesselGroup_dropdown = [];
        alert(result.message);
      }
    })
  }

  port(portId = 0,planningIndex = 0){
    this.commonService.sendRequestToNode({method :'get',path:'port-dropdown'}).subscribe(result => {
      if(result.status){
        this.port_dropdown = result.data;
        if(portId){
          this.formData[planningIndex].PLAN_PORT_FK = portId;  
        }
      }
      else{
        this.port_dropdown = [];
        alert(result.message);
      }
    })
  }

  oilMajor(){
    this.commonService.sendRequestToNode({method :'get',path:'inspectors/oliMajor-dropdown'}).subscribe(result => {
      if(result.status){
        this.oilMajor_dropdown = result.data;        
      }
      else{
        this.oilMajor_dropdown = [];
        alert(result.message);
      }
    })
  }

  inspector(inspectorId=0,planningIndex=0){
    this.commonService.sendRequestToNode({method :'get',path:'inspectors/inspector-dropDown'}).subscribe(result => {
      if(result.status){
        this.inspector_dropdown = result.data;
        result.data.forEach(element => {
          this.inspector_dropdown_name[element.ID] = element.FULLNAME;   
        }); 
        if(inspectorId){
          this.formData[planningIndex].PLAN_INSPECTOR_FK = inspectorId;  
        }
      }
      else{
        this.inspector_dropdown = [];
        alert(result.message);
      }
    })
  }

  vesselFleet(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselFleet'}).subscribe(result => {
      if(result.status){
        this.vesselFleet_dropdown = result.data;        
      }
      else{
        this.vesselFleet_dropdown = [];
        alert(result.message);
      }
    })
  }

  vesselOwner(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselOwner'}).subscribe(result => {
      if(result.status){
        this.vesselOwner_dropdown = result.data;           
      }
      else{
        this.vesselOwner_dropdown = [];
        alert(result.message);
      }
    })
  }

  countryDropDown(){
    this.commonService.sendRequestToNode({method :'get',path:'country/dropdown'}).subscribe(result => {
      if(result.status){
        this.country_dropdown = result.data;           
      }
      else{
        this.country_dropdown = [];
        alert(result.message);
      }
    })
  }

  generatcsv(){
    let postObj = {
      isRiskCompany : this.isRiskCompany,
      data : this.inspectionPlanningDatacsv
    }
    this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/exportObj',postData:postObj}).subscribe(result => {
      window.open(this.commonService.getNodeApi()+'/inspectionPlanning/export', '_blank' );
    })
  }

  generatePdf(){
    if(this.inspectionPlanningData.length){
      let postObj:any = this.filterObj;
      postObj.isCompanyRisk = this.isRiskCompany;
      // console.log(postObj);
      if(this.sortFilter && this.sortFilter.sortBy){
        postObj.sortBy = this.sortFilter.sortBy;
        postObj.sortStatus = this.sortFilter.sortStatus;
      }
     window.open(this.commonService.getNodeApi()+'/inspectionPlanning/generate-pdf?filter='+JSON.stringify(postObj),'_blank')
    }
  }

  getDataforcsv(){
    if(this.inspectionPlanningData.length){
      
      let postObj:any = this.filterObj;
      postObj.isCompanyRisk = this.isRiskCompany;
      // console.log(postObj);
      if(this.sortFilter && this.sortFilter.sortBy){
        postObj.sortBy = this.sortFilter.sortBy;
        postObj.sortStatus = this.sortFilter.sortStatus;
      }
      
      this.commonService.sendRequestToNode({method :'get',path:'inspectionPlanning/getDataforcsv',queryParam:postObj}).subscribe(result => {
        if(result.status){
          this.inspectionPlanningDatacsv = result.data; 
  
          let months = this.inspectionPlanningDatacsv;
          let today = new Date(); 
          let totalPlanningData = this.inspectionPlanningDatacsv.length;
          this.NEXT_DUE = result.data1[0]['INSPECTION_PLANNING_MONTH']; 
          // this.addMonths(this.NEXT_DUE);
  
          var i = 0;
          var incr = 0;
          let observation = 0;
          let risk = 0;
  
          for (let m of months) {

            m.SR_ID = incr+1;
  
            ///field color change OPERATOR RESPONSE DUE 
            if(m.OPERATOR_RESPONSE_DUE_DATE && m.OPERATOR_RESPONSE_DUE_DATE != '0000-00-00 00:00:00'){
              let operator_due_date = new Date(m.OPERATOR_RESPONSE_DUE_DATE);
              let today = new Date();
              operator_due_date.setHours(0,0,0,0);
              today.setHours(0,0,0,0);
              let isPrevFromDate = false;
              let timeDiff,diffDays;
              if(operator_due_date.getTime() - today.getTime() >= 0 ){
                timeDiff = Math.abs(operator_due_date.getTime() - today.getTime());
                diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
                // console.log(diffDays); 
              } 
              else{
                timeDiff = Math.abs(operator_due_date.getTime() - today.getTime());
                diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
                isPrevFromDate =  true;
                // console.log('-'+diffDays); 
              }
  
              let orddDate = new Date(m.OPERATOR_RESPONSE_DUE_DATE);
              m.OPERATOR_RESPONSE_DUE_DATE_FORMAT = ('0' + (orddDate.getDate())).slice(-2)+'/'+('0' + (orddDate.getMonth()+1)).slice(-2)+'/'+orddDate.getFullYear();
  
              if(isPrevFromDate){
                m.OPERATOR_RESPONSE_DUE_DATE_FORMAT = {value:m.OPERATOR_RESPONSE_DUE_DATE_FORMAT,color:'bg-myred'}; 
              }else if(diffDays <= 5){ 
                m.OPERATOR_RESPONSE_DUE_DATE_FORMAT = {value:m.OPERATOR_RESPONSE_DUE_DATE_FORMAT,color:'bg-myorange'}; 
              }else if(diffDays >= 10){
                m.OPERATOR_RESPONSE_DUE_DATE_FORMAT = {value:m.OPERATOR_RESPONSE_DUE_DATE_FORMAT,color:'bg-mygreen'}; 
              }else{  
                m.OPERATOR_RESPONSE_DUE_DATE_FORMAT = {value:m.OPERATOR_RESPONSE_DUE_DATE_FORMAT,color:'bg-myyellow'}; 
              }
            }
            else{
              m.OPERATOR_RESPONSE_DUE_DATE_FORMAT = {value:'',color:''}; 
            }
            
            // ################################## 
  
            if(m.PLAN_DATE && m.PLAN_DATE!='0000-00-00'){
              //console.log(m.PLAN_DATE);
              let planDate = new Date(m.PLAN_DATE);
              m.PLAN_DATE = ('0' + (planDate.getDate())).slice(-2)+'/'+('0' + (planDate.getMonth()+1)).slice(-2)+'/'+planDate.getFullYear();
            }else{
              m.PLAN_DATE = '';
            }
  
            if(m.LAST_INSPECTION_DATE && m.LAST_INSPECTION_DATE!='0000-00-00 00:00:00'){
              //console.log(m.LAST_INSPECTION_DATE);
              let liDate = new Date(m.LAST_INSPECTION_DATE);
              m.LAST_INSPECTION_DATE_FORMAT = ('0' + (liDate.getDate())).slice(-2)+'/'+('0' + (liDate.getMonth()+1)).slice(-2)+'/'+liDate.getFullYear();
            }else{
              m.LAST_INSPECTION_DATE_FORMAT = '';
            }
  
  
            // next duedate -----------------------------------------
            if(m.LAST_INSPECTION_DATE && m.LAST_INSPECTION_DATE != "0000-00-00 00:00:00"){
              var lastSireDate = new Date(m.LAST_INSPECTION_DATE);
              var dd = lastSireDate.getDate();
              var mm = lastSireDate.getMonth() + parseInt('1') + parseInt(this.NEXT_DUE); 
              var yyyy;
              if(mm > 12){
                yyyy = lastSireDate.getFullYear() + 1; 
                mm = mm - 12;
              }else{
                yyyy = lastSireDate.getFullYear();
              }      
              //var m2 = ('0' + (today.getMonth()+1)).slice(-2);   
              
              m.NEXT_DUE_DATE = ('0' + (dd)).slice(-2) +'/'+('0' + (mm)).slice(-2)+'/'+yyyy;
        
              m.NEXT_DUE_DATE1 = yyyy +'/'+mm+'/'+dd;  

              var today1 = new Date();
              today1.setHours(0,0,0,0);
           
      
              let color;
              let dueDate = new Date(m.NEXT_DUE_DATE1);
        
              //this is for NEXT DUE TO Today date diff
              let isPrevFromNextdueDate = false;
              if(dueDate.getTime() - today1.getTime() > 0  ){
                var timeDiff = Math.abs(dueDate.getTime() - today1.getTime());
                var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
                // console.log(diffDays); 
              } 
              else{
                var timeDiff = Math.abs(dueDate.getTime() - today1.getTime());
                var diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
                isPrevFromNextdueDate =  true;
                // console.log('-'+diffDays); 
              }
        
              //this is for Last Sire Date TO Today date diff
              let isPrevFromLastSireDate = false;
              if(lastSireDate.getTime() - today1.getTime() > 0  ){
                var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
                var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
              } 
              else{
                var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
                var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
                isPrevFromLastSireDate =  true;
              }
                var percDay = (diffDaysOFLastSire*100) / (parseInt(this.NEXT_DUE)*30);
                if(percDay >= 83.34){ 
                  m.NEXT_DUE_DATE = {value:m.NEXT_DUE_DATE ,color:'bg-myred'};      
                }else if(percDay >= 50.01){
                  m.NEXT_DUE_DATE = {value:m.NEXT_DUE_DATE ,color:'bg-myorange'};
                }else{  
                  m.NEXT_DUE_DATE = {value:m.NEXT_DUE_DATE ,color:'bg-mygreen'};
                }
            }
            else{
              m.NEXT_DUE_DATE = {value:'' ,color:' '};        
            }
           

            

                              
            
      
            // let color ;
            // let dueDate = new Date(m.NEXT_DUE_DATE);             
            //   alert(dueDate.getTime());
            // if(today.getTime() > dueDate.getTime()){ 
            //   m.BG_COLOR = 'red';
            // }else{
            //   m.BG_COLOR = 'bg-orange';
            // }
      
            // let mmm = parseInt(month);
            // this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/addMonth/'+mmm}).subscribe(
            //   data =>{         
            // })
  
            // ------------------------------------------------------
            
            // this.getInspectorObservation(m.PLAN_INSPECTOR_FK,i);
            observation = observation + m.TOTAL_OBSERVATION;
            risk = risk + m.TOTAL_RISK;
           
            var LastInsDate = (m.LAST_INSPECTION_DATE && m.LAST_INSPECTION_DATE != "0000-00-00 00:00:00") ?  new Date(m.LAST_INSPECTION_DATE) : null;
            m.DIFFERENCE = this.calculate(LastInsDate,today);
            console.log(m.DELIVERY_DATE);
            if(m.DELIVERY_DATE && m.DELIVERY_DATE != '0000-00-00 00:00:00'){
              var dDate = new Date(m.DELIVERY_DATE);
              m.DELIVERY_DATE = dDate.getFullYear();
              //this.inspectionPlanningDatacsv[i]['DELIVERY_DATE']  = dDate.getFullYear()+'-'+('0' + (dDate.getMonth()+1)).slice(-2)+'-'+('0' + (dDate.getDate())).slice(-2); 
            }else{
              this.inspectionPlanningData[i]['DELIVERY_DATE'] = '-';
            }
  
            if(!this.formDataOperatorDate[m.ID]){
              this.formDataOperatorDate[m.ID] = {};
            }  

            //this.formDataOperatorDate[m.ID]['OPERATOR_RESPONSE_DUE_DATE'] = m.OPERATOR_RESPONSE_DUE_DATE;
            let mdate = '';
            if(m.OPERATOR_RESPONSE_DUE_DATE && m.OPERATOR_RESPONSE_DUE_DATE !='01-01-1970'){
                let mdate = new Date(m.OPERATOR_RESPONSE_DUE_DATE);
                this.formDataOperatorDate[m.ID]['OPERATOR_RESPONSE_DUE_DATE'] = mdate.getFullYear()+'-'+('0' + (mdate.getMonth()+1)).slice(-2)+'-'+('0' + (mdate.getDate())).slice(-2); 
            }
            
            // this.inspectionPlanningDatacsv[i]['diff_days'] = claculateDate.Day;
            // this.inspectionPlanningDatacsv[i]['diff_months'] = claculateDate.Month;
            // this.inspectionPlanningDatacsv[i]['diff_years'] = claculateDate.Year;
            //console.log(claculateDate); 
  
            if(m.PLAN_INSPECTOR_FK){
              this.commonService.sendRequestToNode({method :'post',path:'get-local-observation-of-inspector',postData : {'INSPECTOR_FK' : m.PLAN_INSPECTOR_FK}}).subscribe(result => {
                if(result.status){
                  m.AVG_INSPECTOR_OBSERVATION = result.data[m.PLAN_INSPECTOR_FK].AVG_OBSERVATION ? result.data[m.PLAN_INSPECTOR_FK].AVG_OBSERVATION.toFixed(2) : 0;
                  m.AVG_INSPECTOR_RISK_PROFILE = result.data[m.PLAN_INSPECTOR_FK].AVG_RISK_PROFILE ? result.data[m.PLAN_INSPECTOR_FK].AVG_RISK_PROFILE.toFixed(2) : 0;  
                  if(months.length == i+1){
                    this.generatcsv();
                  }  
                }
                i++;
              })
            }
            else{
              m.AVG_INSPECTOR_OBSERVATION = 0;
              m.AVG_INSPECTOR_RISK_PROFILE = 0;
                  if(months.length == i+1){
                    this.generatcsv();
                  }    
              i++;
            }
  
            m.PER_COMPANY_OBS = this.perCompanyObservation;
            m.PER_COMPANY_RISK = this.perCompanyRisk;
            incr++;
            
          }  
        }
        else{
          this.inspectionPlanningData = [];
          alert(result.message);
        }
      })
    }
    
  }

  sorting(header){
    let sort = this.sortObj[header]; 
    this.sortObj = {
      VESSEL_NAME : '',
      DELIVERY_DATE : '',
      LAST_INSPECTION_DATE : '',
      OPERATOR_RESPONSE_DUE_DATE : ''
    }
    if(sort == ''){
      this.sortObj[header] = 'asc'
    }
    else if(sort == 'asc'){
      this.sortObj[header] = 'desc'
    }
    else{
      this.sortObj[header] = '';
    }
    if(this.sortObj[header]){
      this.sortFilter = {'sortBy' : header,'sortStatus' : this.sortObj[header]}
    }
    else{
      this.sortFilter = {};
    }
    
    this.getData();
    // console.log(header)
  }

  getData(){ 
    this.showLoader = true;
    let filterParams:any = {}
   //search filter 
   filterParams = JSON.parse(JSON.stringify(this.filterObj));
   //search filter -end

   // pagination
   filterParams.currentPage = this.currentPage-1;
   filterParams.itemsPerPage = this.itemsPerPage;
   if(this.sortFilter && this.sortFilter.sortBy){
      filterParams.sortBy = this.sortFilter.sortBy;
      filterParams.sortStatus = this.sortFilter.sortStatus;
   }
   
    // console.log( this.filterObj.VESSEL_FK )
  //  if( typeof this.filterObj.VESSEL_FK == 'object' && this.filterObj.VESSEL_FK.length > 0) {
  //   this.filterObj.VESSEL_FK.forEach((element, key) =>{
  //     this.filterObj[key] = JSON.parse( element ).ID; 
  //   })
  //  } else if( typeof this.filterObj.VESSEL_FK == 'json' ) {
  //     this.filterObj = JSON.parse( this.filterObj.VESSEL_FK ).ID; 
  //  }
  
//  filterParams.VESSEL_FK  =   this.filterObj.VESSEL_FK
    this.commonService.sendRequestToNode({method :'get',path:'inspectionPlanning/getData',queryParam:filterParams}).subscribe(result => {
      this.showLoader = false;
      if(result.status){
        //console.log(result);
        this.inspectionPlanningData = result.data;
        this.result = result
        this.calculateData();
      }  else {
        this.inspectionPlanningData = [];
        alert(result.message);
      }
    })
  } 

  calculateRisk(isCompanyRisk = false){
    this.isRiskCompany = isCompanyRisk;
    let total_observation = 0;
    let total_final_observation = 0;
    let total_risk = 0;
    let company_total_risk = 0;
    let total_inspection = 0
    if(this.result.avgObs && this.result.avgObs.length > 0){
      this.result.avgObs.forEach(element => {
        total_final_observation += element.TOTAL_FINAL_OBSERVATION;
        total_observation += element.TOTAL_OBSERVATION;
        total_risk += element.TOTAL_RISK;
        company_total_risk += element.COMPANY_TOTAL_RISK;
        total_inspection += element.TOTAL_INSPECTION; 
      });
      
    }
    if(total_observation != 0 && this.totalItems !=0){
      this.perCompanyObservation = total_observation/total_inspection;         
      this.perCompanyObservation = this.perCompanyObservation.toFixed(2);
    }else{
      this.perCompanyObservation=0;
    }
    
    if(total_risk != 0 && total_inspection !=0 && !this.isRiskCompany){
      this.perCompanyRisk = total_final_observation ? total_risk/total_final_observation : 0;
    }else if(company_total_risk != 0 && total_inspection !=0 && this.isRiskCompany){
      this.perCompanyRisk = total_final_observation ? company_total_risk/total_final_observation : 0;
    }
    else{
      this.perCompanyRisk=0;
    }
    this.perCompanyRisk = this.perCompanyRisk.toFixed(2);
  }

  calculateData(){
    // console.log(is)
    this.calculateRisk(this.isRiskCompany);
    if(this.result.data[0]){
      this.totalItems = this.result.data[0].total_records;
    }        
    // let total_observation = 0;
    // let total_risk = 0;
    // let company_total_risk = 0;
    // let total_inspection = 0
    // if(this.result.avgObs && this.result.avgObs.length > 0){
    //   this.result.avgObs.forEach(element => {
    //     total_observation = total_observation + element.TOTAL_OBSERVATION;
    //     total_risk = total_risk + element.TOTAL_RISK;
    //     company_total_risk = company_total_risk + element.COMPANY_TOTAL_RISK;
    //     total_inspection = total_inspection + element.TOTAL_INSPECTION; 
    //   });
      
    // }
    
         
    //console.log(this.inspectionPlanningData.length);
    let months = this.inspectionPlanningData;
    let today = new Date(); 
    let totalPlanningData = this.inspectionPlanningData.length;
     this.NEXT_DUE = this.result.data1[0]['INSPECTION_PLANNING_MONTH']; 
     this.addMonths(this.NEXT_DUE);
    var i = 0;
    
// console.log(months)
    for (let m of months) {
      
      m.AVG_OBSERVATION = m.AVG_OBSERVATION ? parseFloat(m.AVG_OBSERVATION).toFixed(2) : 0.00;
      m.AVG_RISK = m.AVG_RISK ? parseFloat(m.AVG_RISK).toFixed(2) : 0.00; 
      ///field color change OPERATOR RESPONSE DUE 
      if(m.OPERATOR_RESPONSE_DUE_DATE && m.OPERATOR_RESPONSE_DUE_DATE != '0000-00-00 00:00:00'){
        let operator_due_date = new Date(m.OPERATOR_RESPONSE_DUE_DATE);
        operator_due_date.setHours(0,0,0,0);
        let today = new Date();
        today.setHours(0,0,0,0);
        let isPrevFromDate = false;
        let timeDiff,diffDays;
        if(operator_due_date.getTime() - today.getTime() >= 0 ){
          timeDiff = Math.abs(operator_due_date.getTime() - today.getTime());
          diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
          // console.log(diffDays); 
        } 
        else{
          timeDiff = Math.abs(operator_due_date.getTime() - today.getTime());
          diffDays = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
          isPrevFromDate =  true;
          // console.log('-'+diffDays); 
        }
      //  console.log(isPrevFromDate + '---' +diffDays)
        if(isPrevFromDate){ 
          m.BG_COLOR_FOR_OPERATOR_DATE = 'bg-myred';        
        }else if(diffDays <= 5){
          m.BG_COLOR_FOR_OPERATOR_DATE = 'bg-myorange';
        }else if(diffDays >= 10){
          m.BG_COLOR_FOR_OPERATOR_DATE = 'bg-mygreen';
        }else{  
          m.BG_COLOR_FOR_OPERATOR_DATE = 'bg-myyellow';
        }
       
      }
      else{
        m.BG_COLOR_FOR_OPERATOR_DATE = "";  
      }
      
      // ##################################  
     
      var LastInsDate = (m.LAST_INSPECTION_DATE && m.LAST_INSPECTION_DATE != "0000-00-00 00:00:00") ?  new Date(m.LAST_INSPECTION_DATE) : null;;
      //this.inspectionPlanningData[i]['DIFFERENCE'] = this.calculate(LastInsDate,today);
      this.inspectionPlanningData[i]['DIFFERENCE'] = this.calculate(LastInsDate,today);
      if(m.DELIVERY_DATE && m.DELIVERY_DATE != '0000-00-00 00:00:00'){
        var dDate = new Date(m.DELIVERY_DATE);
        // this.inspectionPlanningData[i]['DELIVERY_DATE'] = ('0' + (dDate.getDate())).slice(-2)+'/'+('0' + (dDate.getMonth()+1)).slice(-2)+'/'+dDate.getFullYear();
        this.inspectionPlanningData[i]['DELIVERY_DATE'] = dDate.getFullYear();            
        //this.inspectionPlanningData[i]['DELIVERY_DATE']  = dDate.getFullYear()+'-'+('0' + (dDate.getMonth()+1)).slice(-2)+'-'+('0' + (dDate.getDate())).slice(-2); 
      }else{
        this.inspectionPlanningData[i]['DELIVERY_DATE'] = '-';
      }
    
      if(!this.formData[m.ID]){
        this.formData[m.ID] = {};
      }  
      if(!this.formDataOperatorDate[m.ID]){
        this.formDataOperatorDate[m.ID] = {};
      }    
      //console.log(m.PLAN_PORT_FK);
      this.formData[m.ID]['PLAN_PORT_FK'] = (m.PLAN_PORT_FK && m.PLAN_PORT_FK!=0) ? m.PLAN_PORT_FK :undefined;
      this.formData[m.ID]['PLAN_OIL_MAJOR_FK'] = (m.PLAN_OIL_MAJOR_FK && m.PLAN_OIL_MAJOR_FK!=0) ? m.PLAN_OIL_MAJOR_FK : undefined;

      if(m.PLAN_DATE && m.PLAN_DATE != "0000-00-00"){
        let pdate = new Date(m.PLAN_DATE);
        this.formData[m.ID]['PLAN_DATE'] = pdate.getFullYear()+'-'+('0' + (pdate.getMonth()+1)).slice(-2)+'-'+('0' + (pdate.getDate())).slice(-2); 
      }
      

      //this.formData[m.ID]['PLAN_DATE'] = new Date(m.PLAN_DATE);
      this.formData[m.ID]['PLAN_INSPECTOR_FK'] = (m.PLAN_INSPECTOR_FK && m.PLAN_INSPECTOR_FK!=0) ? m.PLAN_INSPECTOR_FK : undefined;
      this.formData[m.ID]['PLAN_REMARKS'] = m.PLAN_REMARKS;

      //this.formDataOperatorDate[m.ID]['OPERATOR_RESPONSE_DUE_DATE'] = m.OPERATOR_RESPONSE_DUE_DATE;
      let mdate = '';
      if(m.OPERATOR_RESPONSE_DUE_DATE && m.OPERATOR_RESPONSE_DUE_DATE !='01-01-1970'){
          let mdate = new Date(m.OPERATOR_RESPONSE_DUE_DATE);
          this.formDataOperatorDate[m.ID]['OPERATOR_RESPONSE_DUE_DATE'] = mdate.getFullYear()+'-'+('0' + (mdate.getMonth()+1)).slice(-2)+'-'+('0' + (mdate.getDate())).slice(-2); 
      }
      
      // this.inspectionPlanningData[i]['diff_days'] = claculateDate.Day;
      // this.inspectionPlanningData[i]['diff_months'] = claculateDate.Month;
      // this.inspectionPlanningData[i]['diff_years'] = claculateDate.Year;
      //console.log(claculateDate); 
      i++;
    }   
  }

  changeMonths(month){
    this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/addMonth/'+parseInt(month)}).subscribe(
      data =>{
        this.addMonths(month)  
      })
   
  }
  
  addMonths(month){
    let months = this.inspectionPlanningData;

    for (let m of months) {
      if(m.LAST_INSPECTION_DATE &&  m.LAST_INSPECTION_DATE != "0000-00-00 00:00:00")
      {
        var lastSireDate = new Date(m.LAST_INSPECTION_DATE);
        lastSireDate.setHours(0,0,0,0);
        let next_due_date = new Date(m.LAST_INSPECTION_DATE);
        var dd = lastSireDate.getDate();
        var mm = lastSireDate.getMonth() + parseInt(month); 
        
        
        var yyyy;
        next_due_date.setMonth(mm);
    
        let test_month= mm;
        if(mm >= 12){
          test_month = Math.abs(12 - mm);
        }
        if(next_due_date.getMonth() != test_month){
          if(mm < 12){
            next_due_date.setMonth(mm+1,0);
          }
          else{
            next_due_date.setMonth((mm - 12)+1 ,0);
          }
          
        }
        
        m.NEXT_DUE_DATE = ('0' + (next_due_date.getDate())).slice(-2) +'/'+('0' + (next_due_date.getMonth()+1)).slice(-2)+'/'+ next_due_date.getFullYear();

        // m.NEXT_DUE_DATE1 = yyyy +'/'+mm+'/'+dd;
        var today1 = new Date();
        today1.setHours(0,0,0,0);
        
        // this is for Last Sire Date TO Today date diff
        if(today1.getTime() - lastSireDate.getTime()  > 0  ){
         
          //day count (today to last sire Date)
          var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime()) ;
          var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24)); 
          
          //calculation of color coding
          //0-50% : Green / 50.1-83.33%: Orange / 83.34-100% and above : Red
          var percDay = (diffDaysOFLastSire*100) / (parseInt(month)*30)
        } 
                            
        if(percDay >= 83.34){ 
          m.BG_COLOR = 'bg-myred';        
        }else if(percDay >= 50.01){
          m.BG_COLOR = 'bg-myorange';
        }else{  
          m.BG_COLOR = 'bg-mygreen';
        }
      }
      
    }       
  }

  calculate(lastSireDate,currentDate) {
    if(lastSireDate && lastSireDate != "0000-00-00 00:00:00"){
      var fromDate =lastSireDate;
      var toDate = currentDate;
      // console.log(fromDate);
      // console.log(toDate);
        try { //alert();
          // document.getElementById('result').innerHTML = '';
      
          var result = this.getDateDifference(new Date(fromDate), new Date(toDate));
          //console.log(result);
          if (result && !isNaN(result.years)) {
            // console.log(result);
            // document.getElementById('result').innerHTML =
            //   result.years + ' year' + (result.years == 1 ? ' ' : 's ') +
            //   result.months + ' month' + (result.months == 1 ? ' ' : 's ') + 'and ' +
            //   result.days + ' day' + (result.days == 1 ? '' : 's');

              return {'Year':result.years,'Month':result.months,'Day':result.days};
          }
        } catch (e) {
          console.error(e);
        }
    }
    else{
      return null;
    }
    
  }
  
  getDateDifference(startDate, endDate) {
    //console.log(startDate);
    //console.log(endDate)
    if (startDate > endDate) {
  //    console.error('Start date must be before end date');
      return null;
    }
    var startYear = startDate.getFullYear();
    var startMonth = startDate.getMonth();
    var startDay = startDate.getDate();
  
    var endYear = endDate.getFullYear();
    var endMonth = endDate.getMonth();
    var endDay = endDate.getDate(); 

    

    var oneDay = 24*60*60*1000; // hours*minutes*seconds*milliseconds
   

    var diffDays = Math.round(Math.abs((startDate.getTime() - endDate.getTime())/(oneDay)));

  //console.log(Math.round(diffDays/30));

    // We calculate February based on end year as it might be a leep year which might influence the number of days.
    var february = (endYear % 4 == 0 && endYear % 100 != 0) || endYear % 400 == 0 ? 29 : 28;
    var daysOfMonth = [31, february, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  
    var startDateNotPassedInEndYear = (endMonth < startMonth) || endMonth == startMonth && endDay < startDay;
    var years = endYear - startYear - (startDateNotPassedInEndYear ? 1 : 0);
  
    var months = (12 + endMonth - startMonth - (endDay < startDay ? 1 : 0)) % 12;
  
    // (12 + ...) % 12 makes sure index is always between 0 and 11
    var days = startDay <= endDay ? endDay - startDay : daysOfMonth[(12 + endMonth - 1) % 12] - startDay + endDay;
  //console.log(years+':'+months+':'+days)
  // let d:number = ;
    return {
      years: years,
      months: months,
     // days: days,
     days :(diffDays/30).toFixed(1)
    };
  }

  onSubmit(ID,data,refreshData=0,index = -1){ 
    data.OPERATOR_RESPONSE_DUE_DATE = data.OPERATOR_RESPONSE_DUE_DATE ? data.OPERATOR_RESPONSE_DUE_DATE : null
    // return false;
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:data}).subscribe(
          data =>{
            var dialogueTitle = "Saved!";
           
            if(data.status){
              if(index >= 0){
                this.inspectionPlanningData[index].PLAN_DATE = this.formData[ID].PLAN_DATE ;
                this.inspectionPlanningData[index].PLAN_INSPECTOR_FK = this.formData[ID].PLAN_INSPECTOR_FK;
                this.inspectionPlanningData[index].PLAN_OIL_MAJOR_FK = this.formData[ID].PLAN_OIL_MAJOR_FK;
                this.inspectionPlanningData[index].PLAN_PORT_FK = this.formData[ID].PLAN_PORT_FK; 
                this.inspectionPlanningData[index].PLAN_REMARKS = this.formData[ID].PLAN_REMARKS;
              }
              
              if(refreshData){
                  this.getData();
              }
                
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              
             //this.getDataforcsv();
           
              //this.resetForm();
            }else{
              alert(data.message);
            }
        })   
  }

  resetForm(ID){       
  
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
      if (result.value) {
        
        this.formData[ID].PLAN_DATE=null;
        this.formData[ID].PLAN_INSPECTOR_FK=null;
        this.formData[ID].PLAN_OIL_MAJOR_FK=null;
        this.formData[ID].PLAN_PORT_FK=null;
        this.formData[ID].PLAN_REMARKS=null;
        this.onSubmit(ID,this.formData[ID]);
        this.getData();
        // this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:this.formData[ID]}).subscribe(
        //   data => {
        //     if(data.status){
        //       var dialogueTitle = "Reset!";              
        //       this.getData();
        //       swal({
        //         title: dialogueTitle,
        //         text: data.message,
        //         type: 'success',
        //         confirmButtonClass: "btn btn-success",
        //         buttonsStyling: false
        //       })
        //     }         
        // })
      }
    })

  }

  resetDateForm(ID){
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      input: 'checkbox',
      inputPlaceholder:'Is second response due?',
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
  
      if (result.hasOwnProperty('value')) { 

        this.formData[ID].SECOND_RESPONSE_DUE=result.value;  
      this.formData[ID].PLAN_DATE='';
        this.formData[ID].PLAN_INSPECTOR_FK='';
        this.formData[ID].PLAN_OIL_MAJOR_FK='';
        this.formData[ID].PLAN_PORT_FK='';
        this.formData[ID].PLAN_REMARKS='';
        this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';
        this.onSubmit(ID,this.formDataOperatorDate[ID]);
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:this.formData[ID]}).subscribe(
          data => {
            if(data.status){
              var dialogueTitle = "Reset!";              
              this.getData();
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
        })
      }
    })

  }

  clearSecondRes(ID){
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revertIs second response this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
      if (result.value) { 
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData: { 'SECOND_RESPONSE_DUE' : 0 }}).subscribe(
          data => {
            if(data.status){
              var dialogueTitle = "Reset!";              
              this.getData();
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
        })
      }
    })

  }

  openModel(content,planningIndex) {
    this.planningIndex = planningIndex;
    this.modalRef = this.modalService.open(content,{size: 'lg'});
  }

  onSubmitInspector(){
    //console.log(this.edit_id);
    this.inspectorFormSubmittedAttempt = true;
    if(this.Groupinspector.valid){
      //console.log(this.Groupinspector.value);
      this.commonService.sendRequestToNode({method :'post',path:'inspector/add',postData:this.Groupinspector.value}).subscribe(
        data =>{
          var dialogueTitle = "Inserted!";
          if(data.status){
            swal({
              title: dialogueTitle,
              text: data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            }).then(()=>{
              this.modalRef.close();
              this.inspector(data.insertId,this.planningIndex);
              this.resetInspectorForm();
            })
            // this.modal.close()
          }else{
            alert(data.message);
          }
      })
    }  
  }

  resetInspectorForm(){
    this.inspectorFormSubmittedAttempt = false;
    this.Groupinspector.patchValue({
      OIL_MAJOR_MASTER_FK: null,
      FNAME: null,
      LNAME: null,
      INSPECTING_COMPANY: null,
      OFFICE_TELEPHONE: null,
      MOBILE_NO: null,
      EMAIL: null,
      COMMONLY_KNOWN: null,
      COMMENTS: null, 
    })
  }

  onSubmitPort(){ 
    this.portFormSubmittedAttempt = true;
    if(this.portForm.valid){
     
        this.commonService.sendRequestToNode({method :'post',path:'port',postData:this.portForm.value}).subscribe(
          data =>{
          var dialogueTitle = "Inserted!";
          if(data.status){
            this.modalRef.close();
            swal({
              title: dialogueTitle,
              text: data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            })
            
            this.port(data.insertId,this.planningIndex);
            this.resetPortForm(); //after edit form is reset
          }else{
            alert(data.message);
          }
        })
      }
     
  } 

  resetPortForm(){
    this.portFormSubmittedAttempt = false;
    this.portForm.patchValue({
      PORT_NAME : null,
      PORT_CODE : null,
      COUNTRY_MST_FK :null,
      LATITUDE : null,
      LONGITUDE : null,                     
    })
  }
  clickOnInspector(id){
    if(id && this.formData[id].PLAN_INSPECTOR_FK){
      let type = '';
    if (this.isRiskCompany) {
      type = 'com';
    }
    else {
      type = 'glob';
    }
    let inspector_name = this.inspector_dropdown_name[this.formData[id].PLAN_INSPECTOR_FK];
    this.router.navigate(["/pastObservationForInspector/", { inspector: this.formData[id].PLAN_INSPECTOR_FK, fullname: inspector_name, type: type }]);
    }
    
  }
  clickOnVessel(id){


    if(id){
      let type = '';
      if (this.isRiskCompany) {
        type = 'com';
      }
      else {
        type = 'glob';
      }
      this.router.navigate(["/vessel-report/"+id, { type: type }]);
    }
    
  }

  vesselDropdown(){
    if (this.vessel_dropdown.length <= 0) {
        this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-dropdown',queryParam : {ACTIVE_FLAG : 1,with_non_tanker : true} }).subscribe(result => {
            if (result.status) {
                let array = [];
                array.push({display : 'All Vessels',value : 'ALL'});
                result.data.forEach(element => {
                    array.push({ value: JSON.stringify(element), display: element.VESSEL_NAME })
                });
                this.vessel_dropdown = array;
            }
            else {
                this.vessel_dropdown = [];
            }
        });
    }
}

changeVesselFilter(e){
  //  alert( e )
  let arr = []
  this.filterObj.VESSEL_FK.forEach(ele=>{
      if(ele == 'ALL'){
        arr = this.vessel_dropdown.map(element=>{
            return element.value;
        })
        arr = arr.filter( e => {
            return !( e == 'ALL');
        })
      }
  });
  if( arr.length > 0 ) {
      this.filterObj.VESSEL_FK = arr;
  }
  this.getData();
}
}
