// import { Component, AfterViewInit, ViewEncapsulation, OnInit } from '@angular/core';
// import { CommonService } from '../common-service.service';

// import {Router,ActivatedRoute} from "@angular/router";
// import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
// import swal from 'sweetalert2';

import { Component, AfterViewInit, OnInit, createPlatformFactory, ElementRef, ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import { Router, ActivatedRoute } from "@angular/router";
import { FormGroup, FormBuilder, Validators, FormControl } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import swal from 'sweetalert2';
import { WindowService } from '@ng-select/ng-select/ng-select/window.service';

declare var require: any;

@Component({
  selector: 'inspectionRisk',
  templateUrl: './inspectionRisk.component.html',
  styleUrls: ['./inspectionRisk.component.scss']
})
export class inspectionRiskComponent implements AfterViewInit, OnInit {

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  isDisabled = true;
  public showLoader:boolean = false
  public expanded = [];
  public NEXT_DUE;
  public filterObj = {};
  public formData = {};
  public formDataOperatorDate = {};
  public vesselGroup_dropdown = [];
  public vesselFleet_dropdown = [];
  public vesselOwner_dropdown = [];
  public port_dropdown = [];
  public perCompanyObservation;
  public perCompanyRisk;
  public oilMajor_dropdown = [];
  public inspector_dropdown = [];
  public sireHighRiskObservationData = [];
  public sireHighRiskObservationDatacsv = [];
  public configData = [];
  public sortFilter: any = {};
  public current_template;
  public link_template;
  public forData;
  public vessel;

  public questions_curr = [];
  public questions_prev = [];
  private fieldArray = {};
  private dataArray = {};
  public linkData = {};
  //for grid 
  public headerInformation;
  public actionButtons;
  public title;

  public pdfLogo;
  public withoutPaginationData = [];

  // public VesselMasterForm:FormGroup;
  // public groupSireReportUpload:FormGroup;

  constructor(private modalService: NgbModal,
    private commonService: CommonService, private route: ActivatedRoute) {
    this.route.params.subscribe(params => {
      this.forData = params['type'];
      this.vessel = params['vessel'];
    });
    this.declareGridVariable();
    this.title = 'Number Of Inspection Report';
  }

  ngOnInit() {
    this.pdfLogo = location.origin+location.pathname+'assets/images';
    this.route.params.subscribe(params => {
      this.forData = params['type'];
      this.vessel = params['vessel'];
    });
    this.getData();
    this.getDataWithoutPagination();


  }

  ngAfterViewInit() {
  }

  changePage(page) {
    this.currentPage = page;
    this.sendFilterObjectForUpdateData();
    window.scroll(0, 0);
  }

  sendFilterObjectForUpdateData() {
    let makeFilterObj = {}
    Object.keys(this.filterObj).forEach((key) => {
      makeFilterObj[key] = this.filterObj[key].replace(/'/g, "\\\'").replace(/"/g, '\\\"')
    });
    let filter = {
      filter: makeFilterObj,
      page: this.currentPage,
      sort: this.sortFilter
    }
    this.getData();
  }


  getData() {
    let filterParams: any = {}
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    filterParams.currentPage = this.currentPage - 1;
    filterParams.itemsPerPage = this.itemsPerPage;
    filterParams.vessel = this.vessel;
    filterParams.type =  this.forData;


    if (Object.keys(this.sortFilter).length > 0) {
      filterParams.sortBy = Object.keys(this.sortFilter)[0];
      filterParams.sortStatus = this.sortFilter[Object.keys(this.sortFilter)[0]]
    }

    this.commonService.sendRequestToNode({ method: 'get', path: 'chart/getPieChart_2_inspection_data', queryParam: filterParams }).subscribe(result => {
      if (result.status) {
        if (result.data[0]) {
          this.totalItems = result.data[0].total_records;
        }
        var index = 0;
        var finalData = [];
        var dataGlob = result.data;
        var dataCom = result.dataCom;

        if (dataGlob && this.forData == 'glob') {
          this.sireHighRiskObservationData = dataGlob;
        }
        if (dataCom && this.forData == 'com') {
          this.sireHighRiskObservationData = dataCom;
        }
        
      }
      else {
        this.sireHighRiskObservationData = [];
        alert(result.message);
      }
    })
  }

  // navigate(name,id){
    //   //this.sireHighRiskObservationData; 

    // }
    addMonths(month) {
    }

    calculate(lastSireDate, currentDate) {
    }

    getDateDifference(startDate, endDate) {
    }

    onSubmit(ID, data) {
    }

    resetForm(ID) {

      //this.formData[ID] = {};
      // this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';


      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, Reset it!',
        buttonsStyling: false
      }).then((result) => {

        if (result.value) {


        }
      })

      //this.formData[ID] = {};
      //this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';

    }
    resetDateForm(ID) {

    }

    filter($event) {
      let obj = $event;
      this.currentPage = obj.page;
      this.filterObj = obj.filter;
      this.sortFilter = obj.sort
      this.getData();
    }

    declareGridVariable() {

      this.headerInformation = [
      {
        title: 'Date',// show title table header
        isDate: 'yes',
        name: 'DATE_OF_INSPECTION',// name of column in data source
        width: '10%',// width of column in table
        isSortable: true,// sort by column false or true
        // isFilter:{ // filter 
          //   type : 'text',
          //   placeholder : 'Filter By Date'
          // }
      },
      {
        title: 'Vessel',// show title table header
        //nameIcon : true,// show icon of First letter
        highlight: true,
        name: 'VESSEL_NAME',// name of column in data source
        width: '12%',// width of column in table
        isSortable: true,// sort by column false or true,
        isFilter: { // filter 
          type: 'text',
          placeholder: 'Filter By Vessel'
        }
      },
      {
        title: 'Risk',// show title table header
        //nameIcon : true,// show icon of First letter
        name: (this.forData == 'glob')? 'INITIAL_RISK_PROFILE' : 'FINAL_RISK_PROFILE',// name of column in data source
        width: '12%',// width of column in table
        display_value: { '1': 'Low', '2': 'Medium', '3': 'High Risk', '4': 'Very High Risk' },
        isFilter: { // filter 
          type: 'select',
          placeholder: 'Filter By Vessel',
          options_value:  [1,2,3, 4],
          options_display:  ['Low','Medium','High Risk', 'Very High Risk']
        }

      },

      {
        title: 'VIQ Ref No.',// show title table header
        name: 'QUESTION_NUMBER',// name of column in data source
        width: '15%',// width of column in table
        isSortable: true,// sort by column false or true
        isFilter: { // filter 
          type: 'text',
          placeholder: 'Filter By VIQ Ref No'
        }

      },
      {
        title: 'VIQ Questions',// show title table header
        name: 'QUESTION_DESCRIPTION',// name of column in data source
        width: '25%',// width of column in table
        isSortable: true,// sort by column false or true
        isFilter: { // filter 
          type: 'text',
          placeholder: 'Filter By VIQ Questions'
        }

      },
      { 
        title: 'Inspector Observation',
        name: 'COMMENTS',
        width: '5%',
        isFilter: {
          type: 'text',
          placeholder: 'Filter By Port Of Inspection'
        } 
      },
      {
        title: 'Port Of Inspection',
        name: 'PORT_OF_INSPECTION',
        width: '5%',
        isFilter: { // filter 
          type: 'text',
          placeholder: 'Filter By Port Of Inspection'
        }
      },
      {
        title: 'Vessel Type', name: 'VESSEL_TYPE', width: '15%',
      }
      ];

    }


      getDataWithoutPagination() {
        let filterParams: any = {}
        filterParams = JSON.parse(JSON.stringify(this.filterObj));
        filterParams.vessel = this.vessel;
        filterParams.type =  this.forData;
    
    
        if (Object.keys(this.sortFilter).length > 0) {
          filterParams.sortBy = Object.keys(this.sortFilter)[0];
          filterParams.sortStatus = this.sortFilter[Object.keys(this.sortFilter)[0]]
        }
    
        this.commonService.sendRequestToNode({ method: 'get', path: 'chart/getPieChart_2_inspection_data', queryParam: filterParams }).subscribe(result => {
          if (result.status) {
            if (result.data[0]) {
              this.totalItems = result.data[0].total_records;
            }
            var index = 0;
            var finalData = [];
            var dataGlob = result.data;
            var dataCom = result.dataCom;
    
            if (dataGlob && this.forData == 'glob') {
              this.withoutPaginationData = dataGlob;
            }
            if (dataCom && this.forData == 'com') {
              this.withoutPaginationData = dataCom;
            }
            
          }
          else {
            this.withoutPaginationData = [];
            alert(result.message);
          }
        })
      }

      getDataforcsv() {
        this.generatcsv();
      }
    
      generatcsv(){
        let postObj = {
          data : this.withoutPaginationData
        }
        this.commonService.sendRequestToNode({method :'post',path:'numberOfInspectionReport/generateCSVData',postData:postObj}).subscribe(result => {
          if(result.status){
            window.open(this.commonService.getNodeApi()+'/numberOfInspectionReport/exportCSV', '_blank' );
          } 
        })
      }

      generatePdf(){
        var data = document.getElementById('htmlToString').innerHTML;
        // console.log(JSON.stringify(data));
        // console.log(data);
        var htmlData = {'data':data};
        this.commonService.sendRequestToNode({ method: 'post', path: 'numberOfInspectionReport/generatePDFData',postData:htmlData }).subscribe(result => {
          if(result.status){
            window.location.href = this.commonService.getNodeApi()+'/numberOfInspectionReport/exportPDF';
          }
        })
      }

    }
