import { Component, AfterViewInit,OnInit,ElementRef,ViewChild } from '@angular/core';
import { CommonService } from '../common-service.service';
//import { parse } from 'path';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';

@Component({
  templateUrl: './inspector_search.component.html',
  styleUrls: ['./inspector_search.component.scss']
})
export class InspectorComponent implements AfterViewInit,OnInit {

  public config: PerfectScrollbarConfigInterface = {};
  public dataList = [];
  public showLoader = false;
  public grid_subtitle = '';
  //for grid 
  public filterObj:any = {};
  public sortFilter:any = {};
  public headerInformation;
  public actionButtons;

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  
  constructor(
    private commonService: CommonService
    ){
      this.declareGridVariable()
  }
  
  ngAfterViewInit(){
   
  }

  ngOnInit(){
    this.getData();
   }

  
  getData()
  {
    this.showLoader = true; 
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    // pagination
    filterParams.currentPage = this.currentPage-1;
    filterParams.itemsPerPage = this.itemsPerPage;
    // pagination - end

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end

    this.showLoader = true;

    this.commonService.sendRequestToNode({method :'get',path:'inspectors/inspector-search-report',queryParam:filterParams}).subscribe(result => {
    this.showLoader = false;      
      if(result.status)
        {
          let search_remains_count = 0;
          let searched_count = 0;
          this.showLoader = false;
          if(result.countData && result.countData.data.length > 0){
            result.countData.data.forEach(element => {
              searched_count += element.SEARCHED_INSPECTOR_COUNT;
              search_remains_count += element.NUMBER_OF_INSPECTOR_CHECKED - element.SEARCHED_INSPECTOR_COUNT;
            });
          }
          this.grid_subtitle = '<span>Total Searched :</span><label class="label label-danger">'+(searched_count)+'</label>';
          this.grid_subtitle += '<span>Search Remains :</span><label class="label label-success">'+(search_remains_count)+'</label>';
          if(result.data.length > 0){
            this.totalItems = result.data[0].total_records;
            this.dataList = result.data;
          }else{
            this.dataList = [];
          }
        }
        else{
          this.dataList = [];
          alert(result.message);
        }
    })
  }

 //part of grid
  //when change filter ,change page no . etc, 
  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getData();
  }
  // part of grid
  declareGridVariable(){
    this.headerInformation = [
      {
        title : 'User Name',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'USER_NAME',// name of column in data source
        width : '17%',// width of column in table
        highlight:true, // name highlight
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By User Name'
        }
      },
      {
        title : 'Inspector Name',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'INSPECTOR_NAME',// name of column in data source
        width : '17%',// width of column in table
        //highlight:true, // name highlight
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Inspector Name'
        }
      },
      {
        title : 'How Many Time Search',
        name:'count',
        width : '66%'
      }
    ];
    
  }

}
