import { Component, AfterViewInit,OnInit, createPlatformFactory,ViewChild,ElementRef } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';

@Component({
  templateUrl: './office-audit.component.html',
  styleUrls: ['./office-audit.component.scss']
})
export class OfficeAuditComponent implements AfterViewInit,OnInit {

  public config: PerfectScrollbarConfigInterface = {};
  public docPath = this.commonService.getImagePath()+'/office-audit';
  public officeLocationForm:FormGroup; 
  public officeLocationFormSubmittedAttempt = false;
  
  public officeAuditData = [];
  public officeAuditForm:FormGroup;  
  public edit_id;
  public formSubmittedAttempt = false;
  public openRightSidebar = false;
  //public filterObj:any = {};
  public filterObj:any = {year : new Date().getFullYear(),type : []};
  public sortFilter:any = {};
  modalRef: NgbModalRef;

  public officceLoaction_dropdown = [];
  public viewData = false;
  public officeAudit_view:any = {};
  public showSideBarLoader = false;
  public showLoader = false;
  public monthArr = [0,1,2,3,4,5,6,7,8,9,10,11];
  public sortNameOfMonth = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'July', 'Aug', 'Sept', 'Oct', 'Nov', 'Dec'];;

  public pdfLogo;
  public file_upload;
  public auditor = 'internal_auditor';
  //for grid 
  public headerInformation;
  public actionButtons;

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  
  @ViewChild('autofocus') el:any;
  @ViewChild('fileInput') fi:ElementRef;

  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private router: Router,
    private formBuilder: FormBuilder,
    private route: ActivatedRoute){
  }


  ngAfterViewInit(){
   
  }

  ngOnInit(){
    this.pdfLogo = location.origin+location.pathname+'assets/images';    
    this.getData();
    this.addForm();
    this.officeLocationDropDown();
  }

  officeLocationDropDown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'office-location-dropDown'}).subscribe(result => {
      if(result.status){
        this.officceLoaction_dropdown = result.data;
        if(id){
          this.officeAuditForm.patchValue({
            OFFICE_LOCATION_FK : id 
          })
        }
      }
      else{
        this.officceLoaction_dropdown = [];
        alert(result.message);
      }
    })
  }
  
  getData()
  {
    
    this.officeAuditData = [];
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    this.showLoader = true;
    let data = {};
    this.commonService.sendRequestToNode({method :'get',path:'office-audit',queryParam:filterParams}).subscribe(
      result => {
      this.showLoader = false;              
        if(result.status)
        {
          if(result.data.length > 0){
            this.totalItems = result.data[0].total_records;
            result.data.forEach(element => {

            var target_date = new Date(element.TARGET_DATE);
            var target_month =  target_date.getMonth();
            var target_date_format = this.commonService.formatDate(target_date,'d-m-y') 
            var completion_month;
            if(element.COMPLETION_DATE){
              var completion_date = new Date(element.COMPLETION_DATE);
              completion_month = completion_date.getMonth();
              var complete_date_format = this.commonService.formatDate(completion_date,'d-m-y') 
            }
            
            if(data[element.OFFICE_LOCATION_FK]){

              if( (this.filterObj.year== target_date.getFullYear())){
                data[element.OFFICE_LOCATION_FK].targetMonthWise[target_month] = {
                  'color' : (completion_month >=0) ? 'bg-danger' : 'bg-orange',
                  'pdfcolor' : (completion_month >=0) ? '#ef6e6e' : '#fb8c00',
                  'TARGET_MONTH' : target_month,
                  'target_date' : target_date_format,
                  'complete_date' : complete_date_format,
                  'COMPLETION_MONTH' : completion_month,
                  'id' : element.ID
                }
              }
              if( (this.filterObj.year == completion_date.getFullYear())){
                data[element.OFFICE_LOCATION_FK].completeMonthWise[completion_month] = {
                  'color' : 'bg-success',
                  'pdfcolor' : '#45b649',
                  'target_date' : target_date_format,
                  'complete_date' : complete_date_format,
                  'TARGET_MONTH' : (target_month != completion_month || target_date.getFullYear() != this.filterObj.year) ? target_month : -1,
                  'TARGET_YEAR' : (target_date.getFullYear() != this.filterObj.year) ? ('-'+target_date.getFullYear()) : '',
                  'COMPLETION_MONTH' : completion_month,                  
                  'id' : element.ID
                }
              }
            }else{
              data[element.OFFICE_LOCATION_FK] = {
                targetMonthWise : {},
                completeMonthWise : {},
                Id : element.Id, 
                OFFICE_LOCATION : element.OFFICE_LOCATION
              }
              if( (this.filterObj.year == completion_date.getFullYear())){
                data[element.OFFICE_LOCATION_FK].completeMonthWise[completion_month] = {
                  'color' : 'bg-success',
                  'pdfcolor' : '#45b649',
                  // 'TARGET_MONTH' : target_month,
                  'TARGET_MONTH' : (target_month != completion_month || target_date.getFullYear() != this.filterObj.year) ? target_month : -1,
                  'target_date' : target_date_format,
                  'complete_date' : complete_date_format,
                  'COMPLETION_MONTH' : completion_month,
                  'TARGET_YEAR' : (target_date.getFullYear() != this.filterObj.year) ? ('-'+target_date.getFullYear()) : '',
                  'id' : element.ID
                }
              }
              if( (this.filterObj.year == target_date.getFullYear())){
                data[element.OFFICE_LOCATION_FK].targetMonthWise[target_month] = {
                  'color' : (completion_month >=0)  ? 'bg-danger' : 'bg-orange',
                  'pdfcolor' : (completion_month >=0) ? '#ef6e6e' : '#fb8c00',                  
                  'TARGET_MONTH' : target_month,
                  'COMPLETION_MONTH' : completion_month,
                  'id' : element.ID,
                  'target_date' : target_date_format,
                  'complete_date' : complete_date_format,
                }
              }
            }  
            });
          
            //console.log(data);
            Object.keys(data).forEach(key=>{
              this.officeAuditData.push(data[key]);  
            })


          }else{
            this.officeAuditData = [];
          }
        }
        else{
          this.officeAuditData = [];
          alert(result.message);
        }
    })
  }

  onFileChange(event) {
    if(event.target.files.length > 0) {
      let file = event.target.files[0];
       this.officeAuditForm.get('FILE').setValue(file);
    }
    else{
      this.fi ? this.fi.nativeElement.value = "" : '';
    }
  }

  addForm(){
    this.officeAuditForm = this.formBuilder.group({
      OFFICE_LOCATION_FK: [null,Validators.required],
      TARGET_DATE: ['',Validators.required],
      COMPLETION_DATE: [''],
      AUDITOR_NAME : [''],
      NCN : [''],
      OBSERVATION : [''],
      FILE : [''],
    });
    
    this.officeLocationForm = this.formBuilder.group({
      TITLE: [''],
      ADDRESS: [''],
      CITY: ['']
    });
  }

  resetForm(){
    this.formSubmittedAttempt = false;
    this.openRightSidebar = false;
    this.edit_id = '';
    this.file_upload = "";
    this.viewData = false;
    this.fi ? this.fi.nativeElement.value = "" : '';
    this.officeAuditForm.patchValue({
      OFFICE_LOCATION_FK: null,
      TARGET_DATE: '',
      COMPLETION_DATE: '',
      AUDITOR_NAME : '',
      NCN : '',
      OBSERVATION : '',
      FILE : '',
    })
  }

  edit(data,data1){
    // console.log(data);
    let id = data ? data.id : (data1 ? data1.id : ''); 
    // console.log(data1);return false;
    this.openRightSidebar = true;
    this.showSideBarLoader = true;
    // .focus();
    this.el.nativeElement.focus();
    // console.log(``)
    this.commonService.sendRequestToNode({method :'get',path:'office-audit/'+id}).subscribe(
      data => {
        this.officeAuditForm.patchValue({
          OFFICE_LOCATION_FK : data.data.OFFICE_LOCATION_FK,
          AUDITOR_NAME : data.data.AUDITOR_NAME,
          NCN : data.data.NCN,
          OBSERVATION : data.data.OBSERVATION,
          TARGET_DATE : (data.data.TARGET_DATE && data.data.TARGET_DATE != '00/00/0000') ? this.commonService.formatDate(new Date(data.data.TARGET_DATE)) : null,
          COMPLETION_DATE : (data.data.COMPLETION_DATE && data.data.COMPLETION_DATE != '00/00/0000') ? this.commonService.formatDate(new Date(data.data.COMPLETION_DATE)) : null,    
        });
        this.showSideBarLoader = false;
        this.edit_id = id;
        this.file_upload = data.data.FILE;
    })
  }

  delete(data,data1){
    let id = data ? data.id : (data1 ? data1.id : ''); 
    if(id){
      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, delete it!',
         buttonsStyling: false
      }).then((result) => {
        if (result.value) {
          this.commonService.sendRequestToNode({method :'delete',path:'office-audit/'+id}).subscribe(
          data => {
          if(data.status){
            var dialogueTitle = "Deleted!"
            if(this.officeAuditData.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
              if(this.currentPage>1){
                this.currentPage--;
              }
            }
            this.getData();
            swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
          }         
          
      })
         }
      })      
    }
  }

  onSubmit(){ 
    this.formSubmittedAttempt = true;
    if(this.officeAuditForm.valid){
      this.showSideBarLoader = true;
      
      let formData = new FormData();

      formData.append('OFFICE_LOCATION_FK',this.officeAuditForm.get('OFFICE_LOCATION_FK').value );
      formData.append('TARGET_DATE',this.officeAuditForm.get('TARGET_DATE').value );
      formData.append('COMPLETION_DATE',this.officeAuditForm.get('COMPLETION_DATE').value );
      formData.append('AUDITOR_NAME',this.officeAuditForm.get('AUDITOR_NAME').value );
      formData.append('NCN',this.officeAuditForm.get('NCN').value );
      formData.append('OBSERVATION', this.officeAuditForm.get('OBSERVATION').value);
      formData.append('FILE', this.officeAuditForm.get('FILE').value);
      
      
      if(this.edit_id){    
        this.commonService.sendRequestToNode({method :'put',path:'office-audit/'+this.edit_id,postData:formData}).subscribe(
          data =>{
            var dialogueTitle = "Updated!";
            this.showSideBarLoader = false;
            if(data.status){
              swal({
                  title: dialogueTitle,
                  text: data.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                })
              this.getData();
              this.resetForm(); //after edit form is reset
            }
            else{
              alert(data.message);
            }
        })
      }else{
        this.commonService.sendRequestToNode({method :'post',path:'office-audit',postData:formData}).subscribe(
          data =>{
            var dialogueTitle = "Inserted!";
            this.showSideBarLoader = false;
            if(data.status){
              swal({
                  title: dialogueTitle,
                  text: data.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                })
              this.getData();
              this.resetForm(); //after edit form is reset

            }
            else{
              alert(data.message);
            }
        })
      }
    }
      
  }


  view(data,data1){
    let id = data ? data.id : (data1 ? data1.id : ''); 

    this.viewData = true;
    this.showSideBarLoader = true;
    this.openRightSidebar = true; 
    //console.log(id);
    this.commonService.sendRequestToNode({method :'get',path:'office-audit/'+id}).subscribe(result => {      
      this.showSideBarLoader = false;
      if(result.status)
        {
          this.officeAudit_view = result.data;
          this.file_upload = result.data.FILE
        }
        else{
          alert(result.message)
        }
    })
  }

    //part of grid
    funOpenRightSidebar(){
      // this.el.focus();
      this.el.nativeElement.focus();
      this.openRightSidebar = true; 
    }

    changeYear(i){
      this.filterObj.year = this.filterObj.year + (i)
      this.getData() 
    }


    addOfficeLocation(content){
      this.modalRef = this.modalService.open(content,{size: 'sm'});
    }

    resetOfficeLocationForm(){
      this.officeLocationFormSubmittedAttempt = false;
      this.officeLocationForm.patchValue({
        TITLE: '',
        ADDRESS: '',
        CITY: ''
      })
    }

    onSubmitOfficeLocation(){
      //console.log(this.edit_id);
      this.officeLocationFormSubmittedAttempt = true;
      if(this.officeLocationForm.valid){
        //console.log(this.Groupinspector.value);
        this.commonService.sendRequestToNode({method :'post',path:'office-location',postData:this.officeLocationForm.value}).subscribe(
          data =>{
            var dialogueTitle = "Inserted!";
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              }).then(()=>{
                this.modalRef.close();
                this.officeLocationDropDown(data.insertId);
                this.resetOfficeLocationForm();
              })
              // this.modal.close()
            }else{
              alert(data.message);
            }
        })
      }  
    }


  generatePdf(){
    var data = document.getElementById('htmlToString').innerHTML;
    // console.log(JSON.stringify(data));
    // console.log(data);
    var htmlData = {'data':data};
    this.commonService.sendRequestToNode({ method: 'post', path: 'office-audit/generatePDFData',postData:htmlData }).subscribe(result => {
      if(result.status){  
        window.location.href = this.commonService.getNodeApi()+'/office-audit-exportPDF';
      }  
    })
  }
  
  removeFile(id,fileName){
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, remove it!',
       buttonsStyling: false
    }).then((result) => {
      if(result){
        this.commonService.sendRequestToNode({method :'post',path:'office-audit/deleteFile/'+id,postData:{fileName:fileName}}).subscribe(result => {
          if(result.status){
            var dialogueTitle = "Removed!";
            swal({
              title: dialogueTitle,
              text: result.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            })
            this.file_upload = '';
          }else{
            alert(result.message)
          }
      })
      }
    });
    
  }

}

