import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { CommonService } from '../common-service.service';
import {ActivatedRoute} from "@angular/router";
import swal from 'sweetalert2';

@Component({
  selector: 'pastObservationForInspector',
  templateUrl: './pastObservationForInspector.component.html',
  styleUrls: ['./pastObservationForInspector.component.scss']
})

export class PastObservationForInspectorComponent implements AfterViewInit,OnInit {

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  isDisabled = true;

  public expanded = [];
  public NEXT_DUE;
  public filterObj = {};
  public formData = {};
  public formDataOperatorDate = {};
  public vesselGroup_dropdown = [];
  public vesselFleet_dropdown = [];
  public vesselOwner_dropdown = [];
  public port_dropdown = [];
  public perCompanyObservation;
  public perCompanyRisk;
  public oilMajor_dropdown = [];
  public inspector_dropdown = [];
  public pastObservationForInspectorData = [];
  public pastObservationForInspectorDatacsv = [];
  public configData = [];
  public sortFilter:any = {};
  public current_template;
  public link_template;
  public forData;
  public fromData;
  public INSPECTOR;
  public INSPECTOR_NAME = '';
  public questions_curr = [];
  public questions_prev = [];
  public linkData = {};  
  public headerInformation;
  public actionButtons;
  public pdfLogo;
  public withoutPaginationData = [];
  public showLoader = false;
  public isCompanyObs:any = false;


  constructor(
    private commonService: CommonService,private route: ActivatedRoute){   
      this.declareGridVariable();
  }

  ngOnInit(){
    //console.log(location);
    this.pdfLogo = location.origin+location.pathname+'assets/images';    
      this.route.params.subscribe(params => {
        this.fromData = params['fromData'];
        this.INSPECTOR = params['inspector']; 
        this.forData = params['type'];     
        this.isCompanyObs =  params['isCompanyObs'];
        this.INSPECTOR_NAME = (params['fullname'] && params['fullname'] != 'undefined') ? params['fullname'] : '';
    });
    this.getData();
    this.getDataWithoutPagination();   
    //console.log(this.formData);    
  
  }

  ngAfterViewInit(){	
  }

  changePage(page){
    this.currentPage = page;
    this.sendFilterObjectForUpdateData();
    window.scroll(0,0);
    this.getData();
    // this.updateData.emit(page)
  }

  sendFilterObjectForUpdateData(){
    let makeFilterObj = {}
     Object.keys(this.filterObj).forEach((key) => {
       makeFilterObj[key] = this.filterObj[key].replace(/'/g, "\\\'").replace(/"/g, '\\\"')
     });

     this.getData();
   }

 
  // generatcsv(){
  //   console.log(this.pastObservationForInspectorDatacsv);
  //   this.commonService.sendRequestToNode({method :'post',path:'pastObservationForInspector/exportObj',postData:this.pastObservationForInspectorDatacsv}).subscribe(result => {
  //     window.location.href = this.commonService.getNodeApi()+'/pastObservationForInspector/export';
  //   })
  // }

  // generatePdf(){
  //   window.location.href = this.commonService.getNodeApi()+'/pastObservationForInspector/generate-pdf';
  // }


  getData(){ 
    this.showLoader = true;

    let filterParams:any = {}
   //search filter 
   filterParams = JSON.parse(JSON.stringify(this.filterObj));
   //search filter -end

   // pagination
   filterParams.currentPage = this.currentPage - 1;
   filterParams.itemsPerPage = this.itemsPerPage;
   if(this.INSPECTOR && this.INSPECTOR != 'undefined'){
    filterParams.INSPECTOR_FK = this.INSPECTOR;
   }
   if(this.fromData){
    filterParams.fromData = this.fromData;
   }
   if( this.isCompanyObs ||(  typeof this.isCompanyObs == 'string' && this.isCompanyObs  == 'true' )  ) {
    filterParams.isCompanyObs =  this.isCompanyObs;
    this.declareGridVariable();
   }
   
   if(Object.keys(this.sortFilter).length > 0) { 
    filterParams.sortBy = Object.keys(this.sortFilter)[0]; 
    filterParams.sortStatus = this.sortFilter[Object.keys(this.sortFilter)[0]]
  }
   

    this.commonService.sendRequestToNode({method :'get',path:'pastObservationForInspector/getData',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        this.showLoader = false;
          
        var dataGlob = result.data;
        var dataCom = result.dataCom;
       
        // alert(this.forData);
        //this is for global observation
        if(this.fromData == 'global' && result.data.length > 0){
          this.pastObservationForInspectorData = result.data;
          this.totalItems = result.data[0].total_records;
          this.INSPECTOR_NAME = result.data[0].INSPECTOR_NAME
        }
        else if (dataGlob && this.forData == 'glob') {
          this.pastObservationForInspectorData = dataGlob;
          this.totalItems = dataGlob[0].total_records;
        }
        else if (dataCom && this.forData == 'com') {
          this.pastObservationForInspectorData = dataCom;
          this.totalItems = dataCom[0].total_records;
        }
        else{
          this.pastObservationForInspectorData = [];  
          this.totalItems = 0;
        }
        // this.pastObservationForInspectorData = result.data;
      }
      else{
        this.pastObservationForInspectorData = [];
        alert(result.message);
      }
    })
  } 
  
  // navigate(name,id){
  //   //this.pastObservationForInspectorData; 

  // }
  

  

  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getData();
    this.getDataWithoutPagination();
  }

  declareGridVariable(){
     console.log( this.isCompanyObs )
     console.log( typeof this.isCompanyObs )


    if( ( this.isCompanyObs && this.isCompanyObs == true ) || ( typeof this.isCompanyObs == 'string' && this.isCompanyObs == 'true')  ) {

      this.headerInformation = [
            {
          title : 'VIQ Ref No.',// show title table header
          highlight:true,
          //nameIcon : true,// show icon of First letter
          name:'QUESTION_NUMBER',// name of column in data source
          width : '25%',// width of column in table
          // isSortable : true,// sort by column false or true
          // isFilter:{ // filter 
          //   type : 'text',
          //   placeholder : 'Filter By VIQ Ref No'
          // }
        },
        {
          title : 'Date',// show title table header
          isDate:'yes',
          name:'INSPECTION_DATE',// name of column in data source
          width : '25%',// width of column in table
          // isSortable : true,// sort by column false or true
          // isFilter:{ // filter 
          //   type : 'text',
          //   placeholder : 'Filter By Date'
          // }
        },
        
        {
          title : 'Inspector Name',// show title table header
          //nameIcon : true,// show icon of First letter
          // highlight:true,
          name:'INSPECTOR_NAME',// name of column in data source
          width : '25%',// width of column in table
        //  isSortable : true,// sort by column false or true
          // isFilter:{ // filter 
          //   type : 'text',
          //   placeholder : 'Filter By Inspector Name'
          // }
        },
        {title : 'Inspector Observation',name:'INSPECTION_OBSERVATION',width : '25%',},
          ];
    } else  {
      this.headerInformation = [
        {
       title : 'VIQ Ref No.',// show title table header
       highlight:true,
       //nameIcon : true,// show icon of First letter
       name:'QUESTION_NUMBER',// name of column in data source
       width : '5%',// width of column in table
       // isSortable : true,// sort by column false or true
       // isFilter:{ // filter 
       //   type : 'text',
       //   placeholder : 'Filter By VIQ Ref No'
       // }
     },
     {
       title : 'Date',// show title table header
       isDate:'yes',
       name:'INSPECTION_DATE',// name of column in data source
       width : '10%',// width of column in table
       // isSortable : true,// sort by column false or true
       // isFilter:{ // filter 
       //   type : 'text',
       //   placeholder : 'Filter By Date'
       // }
     },
    
     {
       title : 'Inspector Name',// show title table header
       //nameIcon : true,// show icon of First letter
      // highlight:true,
       name:'INSPECTOR_NAME',// name of column in data source
       width : '10%',// width of column in table
     //  isSortable : true,// sort by column false or true
       // isFilter:{ // filter 
       //   type : 'text',
       //   placeholder : 'Filter By Inspector Name'
       // }
     },
    //    {
    //    title : 'Vessel',// show title table header
    //    //nameIcon : true,// show icon of First letter
    //    highlight:true,
    //    name:'VESSEL_NAME',// name of column in data source
    //    width : '10%',// width of column in table
    //    isSortable : true,// sort by column false or true
    //    isFilter:{ // filter 
    //      type : 'text',
    //      placeholder : 'Filter By Vessel'
    //    }
    //  },
     {
       title : 'Risk',// show title table header
       //nameIcon : true,// show icon of First letter
       name:'RISK_PROFILE',// name of column in data source
       width : '10%',// width of column in table
       
       display_value : {'1': 'Low','2': 'Medium','3': 'High Risk','4':'Very High Risk'},
       isFilter:{ // filter 
         type : 'select',
         placeholder : 'Filter By Vessel',
         options_value : [1,2,3,4],
         options_display : ['Low','Medium','High Risk','Very High Risk']
       }
     },
   
     
     {
       title : 'VIQ Questions',// show title table header
       //nameIcon : true,// show icon of First letter
       name:'QUESTION_DESCRIPTION',// name of column in data source
       width : '20%',// width of column in table
       isSortable : true,// sort by column false or true
       isFilter:{ // filter 
         type : 'text',
         placeholder : 'Filter By VIQ Questions'
       }
     },
     {title : 'Inspector Observation',name:'INSPECTION_OBSERVATION',width : '25%',},
     {title : 'Port Of Inspection',name:'PORT_OF_INSPECTION',width : '10%',
     isFilter:{ // filter 
       type : 'text',
       placeholder : 'Filter By Port Of Inspection'
     }
   },
     {title : 'Oil Major',name:'OIL_MAJOR',width : '10%',isFilter:{ // filter 
       type : 'text',
       placeholder : 'Filter By Oil Major'
     }}
      ];
    }
  }

  getDataWithoutPagination() { 
    let filterParams:any = {}
   //search filter 
   filterParams = JSON.parse(JSON.stringify(this.filterObj));
   //search filter -end

   if(this.INSPECTOR && this.INSPECTOR != 'undefined'){
    filterParams.INSPECTOR_FK = this.INSPECTOR;
   }
   if(Object.keys(this.sortFilter).length > 0){ 
    filterParams.sortBy = Object.keys(this.sortFilter)[0]; 
    filterParams.sortStatus = this.sortFilter[Object.keys(this.sortFilter)[0]]
  }

  if(this.fromData){
    filterParams.fromData = this.fromData;
  }
  if( this.isCompanyObs ) {
    filterParams.isCompanyObs =  this.isCompanyObs;
     this.declareGridVariable();
 }

    this.commonService.sendRequestToNode({method :'get',path:'pastObservationForInspector/getData',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        var dataGlob = result.data;
        var dataCom = result.dataCom;
        // alert(this.forData);

        //this is for global observation
        if(this.fromData == 'global'){
          this.withoutPaginationData = result.data;
          this.totalItems = result.data[0].total_records;
        }
        // alert(this.forData);
        if (dataGlob && this.forData == 'glob') {
          this.withoutPaginationData = dataGlob;
          this.totalItems = dataGlob[0].total_records;
        }
        if (dataCom && this.forData == 'com') {
          this.withoutPaginationData = dataCom;
          this.totalItems = dataCom[0].total_records;
        }

        // this.withoutPaginationData = result.data;
       
        
        
      }
      else{
        this.withoutPaginationData = [];
        alert(result.message);
      }
    })
  }

  getDataforcsv() {
    this.generatcsv();
  }

  generatcsv(){
    let postObj = {
      data : this.withoutPaginationData
    }
    this.commonService.sendRequestToNode({method :'post',path:'pastObservationForInspector/generateCSVData',postData:postObj}).subscribe(result => {
      if(result.status){ 
        window.open(this.commonService.getNodeApi()+'/pastObservationForInspector/exportCSV', '_blank' );
      }  
    })
  }

  generatePdf(){
    var data = document.getElementById('htmlToString').innerHTML;
    // console.log(JSON.stringify(data));
    // console.log(data);
    var htmlData = {'data':data};
    this.commonService.sendRequestToNode({ method: 'post', path: 'pastObservationForInspector/generatePDFData',postData:htmlData }).subscribe(result => {
      if(result.status){  
        window.location.href = this.commonService.getNodeApi()+'/pastObservationForInspector/exportPDF';
      }  
    })
  }

  // getkey(obj){
  //   if(obj.RISK_PROFILE == 1){
  //     obj.RISK_PROFILE = 'Low';
  //   }else if(obj.RISK_PROFILE == 2){
  //     obj.RISK_PROFILE = 'Medium';
  //   }else if(obj.RISK_PROFILE == 3){
  //     obj.RISK_PROFILE = 'High Risk';
  //   }else if(obj.RISK_PROFILE == 4){
  //     obj.RISK_PROFILE = 'Very High Risk';
  //   }
  //   return Object.keys(obj);
  // }

}
