// import { NgModule } from '@angular/core';
// import { CommonModule } from '@angular/common';
// import { FormsModule } from '@angular/forms';
// import { Routes, RouterModule } from '@angular/router';

// import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

// import { PastObservationForInspectorComponent } from './PastObservationForInspector.component';
// import { NgSelectModule } from '@ng-select/ng-select';

import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule,ReactiveFormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

import { PastObservationForInspectorComponent } from './pastObservationForInspector.component';

// import { GridViewComponent } from '../grid-view/grid-view.component';

import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { GridViewModule} from '../shared/grid-view/grid-view.module';
import { NgSelectModule } from '@ng-select/ng-select';

const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};
const routes: Routes = [
  {
    path: '',
    data: {
      title: 'Past Observations For Inspector',
      urls: [
        { title: 'Home', url: '/home' },
        { title: 'Analytics Dashboard', url: '/dashboard-demo' },
        { title: 'Past Observations For Inspector' }
      ]
    },
    component: PastObservationForInspectorComponent
  }
];

// @NgModule({
//   imports: [FormsModule, CommonModule, RouterModule.forChild(routes),NgbModule,NgSelectModule],
//   declarations: [PastObservationForInspectorComponent]
// })
@NgModule({
  imports: [
    FormsModule,
    CommonModule,
    RouterModule.forChild(routes),
    NgbModule,
    ReactiveFormsModule,
    PerfectScrollbarModule,
    GridViewModule,
    NgSelectModule
  ],
  declarations: [
    PastObservationForInspectorComponent
  ],
  providers: [
    {
      provide: PERFECT_SCROLLBAR_CONFIG,
      useValue: DEFAULT_PERFECT_SCROLLBAR_CONFIG
    },
  ]
})
export class PastObservationForInspectorModule {}
