import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef, ChangeDetectionStrategy, ViewChild, TemplateRef, EventEmitter  } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';
import html2canvas from 'html2canvas';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { element } from 'protractor';
import { json } from 'd3';

import {
  startOfDay,
  endOfDay,
  subDays,
  addDays,
  endOfMonth,
  isSameDay,
  isSameMonth,
  addHours
} from 'date-fns';
import { Subject } from 'rxjs';
import {
  CalendarEvent,
  CalendarEventAction,
  CalendarEventTimesChangedEvent,
  CalendarView
} from 'angular-calendar';

import { data } from '../table/smart-table/smart-data-table';
const colors: any = {
  0: {
    primary: '#FF0000',
    secondary: '#FAE3E3'
  },
  1: {
    primary: '#00FF00',
    secondary: '#D1E8FF'
  },
  2: {
    primary: '#0000FF',
    secondary: '#FDF1BA'
  },
  3: {
    primary: '#FFFF00',
    secondary: '#FDF1BA'
  },
  4: {
    primary: '#00FFFF',
    secondary: '#FDF1BA'
  },
  5: {
    primary: '#FF00FF',
    secondary: '#FDF1BA'
  },
  6: {
    primary: '#800000',
    secondary: '#FDF1BA'
  },
  7: {
    primary: '#808000',
    secondary: '#FDF1BA'
  },
  8: {
    primary: '#008000',
    secondary: '#FDF1BA'
  },
  9: {
    primary: '#800080',
    secondary: '#FDF1BA'
  }
};



@Component({
  //selector: 'mwl-demo-component',
  //changeDetection: ChangeDetectionStrategy.OnPush,
  templateUrl: './ship-training.component.html',
  styleUrls: ['./ship-training.component.scss']
})
export class ShipTrainingComponent implements OnInit {
  public modalRef:NgbModalRef;

  public trainingTypeForm:FormGroup;
  public trainingTypeFormSubmittedAttempt = false;


  public config: PerfectScrollbarConfigInterface = {};
  public uploadPath = this.commonService.getDocumentPath(); 
  public trainingData = [];
  public trainingListPerMonth = [];
  public trainingForm:FormGroup; 
  public edit_id;
  public editData;
  public formSubmittedAttempt = false;
  public openRightSidebar = false;
  public filterObj:any = {year : new Date().getFullYear(),type : []};
  public sortFilter:any = {};
  public viewData = false;
  public showSideBarLoader = false;
  public OLD_USER:any //this is for edit
  public rank_dropdown = [];
  public trainingtype_dropdown = [];
  public trainingtype_dropdown_name = [];
  
  public training_viewData;
  public attachmentDisplayData:any = [];
  public showMainLoader = false;
  public showModalLoader = false;
  public showLoader = false;;
  public monthArr = ['01','02','03','04','05','06','07','08','09','10','11','12'];
  //this is for file select object 
  public ObjPerFile:any = {}

  public pdfLogo;
  public txt = '';

  //this is for store ids when click on box
  public dataForIds :any = {};

  //for grid 
  public headerInformation;
  public actionButtons;
  public plan_complete = [{'name':'Plan'},{'name':'Completed'}];
  public caldata: any = [];
  public withoutPaginationData = [];

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;

  @ViewChild('content') content: ElementRef;
  @ViewChild('fileInput') fi:ElementRef;
  @ViewChild('autofocus') el:ElementRef;
  @ViewChild('modalContent') modalContent: TemplateRef<any>;

  @ViewChild('screen') screen: ElementRef;
  @ViewChild('canvas') canvas: ElementRef;
  @ViewChild('downloadLink') downloadLink: ElementRef;
  
  @ViewChild('training_list') training_list: TemplateRef<any>;
  view: CalendarView = CalendarView.Month;

  CalendarView = CalendarView;

  viewDate: Date = new Date();

  modalData: {
    action: string;
    event: CalendarEvent;
  };

  actions: CalendarEventAction[] = [
    {
      label: '<button>Edit</button>',
      onClick: ({ event }: { event: CalendarEvent }): void => {
        this.edit(event.id)
        //console.log(event.id)
       // this.handleEvent('Edited', event);
      }
    },
    {
      label: '&nbsp;<button>Delete</button>',
      onClick: ({ event }: { event: CalendarEvent }): void => {
        //alert(event.id)
        this.delete(event.id)
        //this.events = this.events.filter(iEvent => iEvent !== event);
        //this.handleEvent('Deleted', event);
      }
    }
  ];
  //actions: CalendarEventAction[] = [];
  events: CalendarEvent[] = [];
  /*events: CalendarEvent[] = [
    {
      
      start: subDays(startOfDay(new Date()), 1),
      end: addDays(new Date(), 1),
      title: 'A 3 day event',
      color: colors.red,
      actions: this.actions,
      allDay: true,
      resizable: {
        beforeStart: true,
        afterEnd: true
      },
      draggable: true
    },
    {
      start: startOfDay(new Date()),
      title: 'An event with no end date',
      color: colors.yellow,
      actions: this.actions
    },
    {
      start: subDays(endOfMonth(new Date()), 3),
      end: addDays(endOfMonth(new Date()), 3),
      title: 'A long event that spans 2 months',
      color: colors.blue,
      allDay: true
    },
    {
      start: addHours(startOfDay(new Date()), 2),
      end: new Date(),
      title: 'A draggable and resizable event',
      color: colors.yellow,
      actions: this.actions,
      resizable: {
        beforeStart: true,
        afterEnd: true
      },
      draggable: true
    }
  ];*/

  activeDayIsOpen: boolean = false;

  constructor(private modal: NgbModal,private modalService: NgbModal,
    private commonService: CommonService,
    private router: Router,
    private formBuilder: FormBuilder,
    private route: ActivatedRoute) {}

  dayClicked({ date, events }: { date: Date; events: CalendarEvent[] }): void {
    //alert('here')
    if (isSameMonth(date, this.viewDate)) {
      this.viewDate = date;
      if (
        (isSameDay(this.viewDate, date) && this.activeDayIsOpen === true) ||
        events.length === 0
      ) {
        this.activeDayIsOpen = false;
      } else {
        this.activeDayIsOpen = true;
        
      }
    }
  }

  eventTimesChanged({
    event,
    newStart,
    newEnd
  }: CalendarEventTimesChangedEvent): void {
    this.events = this.events.map(iEvent => {
      if (iEvent === event) {
        return {
          ...event,
          start: newStart,
          end: newEnd
        };
      }
      return iEvent;
    });
    this.handleEvent('Dropped or resized', event);
  }

  handleEvent(action: string, event: CalendarEvent): void {
    //console.log(action);
    let data = {Ids  : [event.id]}
    this.openModelForTrainingList(this.training_list,data)
    // this.modalData = { event, action };
    // this.modal.open(this.modalContent, { size: 'lg' });
  }

  addEvent(): void {
    this.events = [
      ...this.events,
      {
        title: 'New event',
        start: startOfDay(new Date()),
        end: endOfDay(new Date()),
        color: colors.red,
        draggable: true,
        resizable: {
          beforeStart: true,
          afterEnd: true
        }
      }
    ];
  }

  deleteEvent(eventToDelete: CalendarEvent) {
    this.events = this.events.filter(event => event !== eventToDelete);
  }

  setView(view: CalendarView) {
    this.view = view;
  }

  closeOpenMonthViewDay() {
    this.activeDayIsOpen = false;
  }

  ngOnInit(){
    this.pdfLogo = location.origin+location.pathname+'assets/images';
    this.getData();
    this.addForm();
    this.rankDropDown();
    this.trainingTypeDropDown();
  }
  rankDropDown(){
    this.commonService.sendRequestToNode({method :'get',path:'rank-dropdown'}).subscribe(result => {
      if(result.status){
        this.rank_dropdown = result.data;
      }
      else{
        this.rank_dropdown = [];
        alert(result.message);
      }
    })
  }

  trainingTypeDropDown(id=0){
    let filterParams:any = {
      type : 'ship'
    }
    this.commonService.sendRequestToNode({method :'get',path:'trainingtype-dropDown',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        this.trainingtype_dropdown = result.data;
        this.trainingtype_dropdown.forEach(ele=>{
          this.trainingtype_dropdown_name[ele.ID] = ele.TRAINING_TYPE;
        })
        if(id){
          this.trainingForm.patchValue({
            TRAINING_TYPE_FK : id 
          })
        }
      }
      else{
        this.trainingtype_dropdown = [];
        alert(result.message);
      }
    })
  }
  getData()
  {
    //console.log('here');
    //return;
    this.getDataWithoutPagination();
    this.showLoader = true;
    let filterParams:any = {}
    let i=0;
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //alert(filterParams)
    let data = {};
    let color_val = '#';
    this.trainingData = [];
    this.caldata = [];
    let letters = "0123456789ABCDEF"; 
    let color = '#'; 
    this.commonService.sendRequestToNode({method :'get',path:'ship-training-cal',queryParam:filterParams}).subscribe(
      result => {
        if(result.status)
        {
          this.showLoader = false;
          //alert(result.data)
          if(result.data.length > 0){
            // this.totalItems = result.data[0].total_records;
            //console.log("ressss"+JSON.stringify(result));
            
            result.data.forEach(element => {
              
              if(i>9){
                for (var j = 0; j < 6; j++) 
                  color_val += letters[(Math.floor(Math.random() * 16))]; 
              }else{
                color_val = colors[i]
              }
              let obj = {
                id: element.ID,
                start: startOfDay(element.TRAINING_START_DATE),
                end: endOfDay(element.TRAINING_END_DATE),
                title: '<label class="cus_title">Trainer:</label> '+element.TRAINER_NAME+' <label class="cus_title">User:</label> '+element.USER,
                color: color_val,

                actions: this.actions
                
              }
              i++;
              this.caldata.push(obj);
              //alert(JSON.stringify(obj))
              
              // if(data[element.RANK_FK]){
              //   data[element.RANK_FK].monthWise[element.month] = {
              //     'totalTraining' : element.total_training,
              //     'Ids' : element.Ids
              //   }
              //   data[element.RANK_FK].Ids += ','+element.Ids 
              // }    
              // else{
              //   data[element.RANK_FK] = {
              //     monthWise : {
              //       [element.month]: {
              //         'totalTraining' : element.total_training,
              //         'Ids' : element.Ids
              //       }
              //     },
              //     Ids : element.Ids, 
              //     USER : element.USER,
              //     RANK : element.RANK,
              //     title : element.RANK,
              //     startdate : element.TRAINING_START_DATE,
              //     enddate : element.TRAINING_END_DATE
              //   }
              //   console.log("ressss"+JSON.stringify(data));
                
              // }
            });
            this.events = this.caldata;
            Object.keys(data).forEach(key=>{
              this.trainingData.push(data[key]);  
              
            })
            //console.log("aaa"+this.trainingData)
          }else{
            this.events = [];
            this.trainingData = [];
          }
        }
        else{
          this.events = [];
          this.trainingData = [];
          alert(result.message);
        }
    })
  }
  getDataWithoutPagination()
  {
    this.showLoader = true;
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //alert(filterParams.user)

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end
    let data = {};
    this.trainingData = [];
    this.commonService.sendRequestToNode({method :'get',path:'get-ship-staff-training-report',queryParam:filterParams}).subscribe(result => {
      this.showLoader = false;  
      if(result.status)
        {
          if(result.data.length > 0){
            this.totalItems = result.data[0].total_records;
            this.withoutPaginationData = result.data;
            //console.log(this.withoutPaginationData);
          }else{
            this.withoutPaginationData = [];
          }
        }
        else{
          this.withoutPaginationData = [];
          alert(result.message);
        }
    })
  } 
  getDataforcsv() {
    this.generatcsv();
  }

  
  generatcsv(){
    //console.log('aa'+this.withoutPaginationData);
    //search filter 
    let filterParams:any = {}
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //alert(filterParams)
    let postObj = {
      data : this.withoutPaginationData
    }
    //var data = document.getElementById('htmlToString').innerHTML;
    this.commonService.sendRequestToNode({method :'post',path:'ship-training/generateCSVData',queryParam:filterParams, postData:postObj}).subscribe(result => {
      if(result.status){
        window.open(this.commonService.getNodeApi()+'/ship-training/exportCSV', '_blank' );
      } 
    })
  }
  addForm(){

    this.trainingForm = this.formBuilder.group({
      TRAINER_NAME: ['',[Validators.required]],
      USER : [null,[Validators.required]],
      TRAINING_TYPE_FK: null,
      NEXT_DONE_MONTH: 0,
      NEXT_DONE_YEAR: 0,
      TRAINING_START_DATE: ['',[Validators.required]],
      TRAINING_END_DATE: ['',[Validators.required]],
      LOCATION: '',
      REMARKS: '',
      FLAG: 'ship',
      RANK_FK: ['',[Validators.required]],
    });
    
    this.trainingTypeForm = this.formBuilder.group({
      TRAINING_TYPE: [''],
      FLAG: ['ship'],
    }); 

  }

  resetForm(){
    this.formSubmittedAttempt = false;
    this.openRightSidebar = false;
    this.viewData = false;
    this.edit_id = '';
    this.trainingForm.patchValue({
      TRAINER_NAME : '',
      USER : '',
      TRAINING_TYPE_FK: null,
      NEXT_DONE_MONTH: 0,
      NEXT_DONE_YEAR: 0,
      TRAINING_START_DATE: '',
      TRAINING_END_DATE: '',
      LOCATION: '',
      REMARKS: '',
      FLAG: 'ship',
      RANK_FK: '',
    })
  }

  edit(id){
    this.openRightSidebar = true;
    this.el.nativeElement.focus();
    this.commonService.sendRequestToNode({method :'get',path:'ship-training/'+id}).subscribe(
      data => {
        this.editData = data.data;  
        data.data.USER = data.data.USER
        data.data.RANK_FK = data.data.RANK_FK
        data.data.TRAINING_END_DATE = this.commonService.formatDate(new Date(data.data.TRAINING_END_DATE))
        data.data.TRAINING_START_DATE = this.commonService.formatDate(new Date(data.data.TRAINING_START_DATE)) 
        this.trainingForm.patchValue(data.data)
        this.edit_id = id;
      })
    }


  view_(id){
    this.viewData = true;
    this.openRightSidebar = true;
    this.showSideBarLoader = true;
    //console.log(id);
    this.commonService.sendRequestToNode({method :'get',path:'ship-training/'+id}).subscribe(result => {
    this.showSideBarLoader = false;      
      if(result.status)
        {
          this.training_viewData = result.data;
        }
        else{
          alert(result.message)
        }
    })
  }

  
  

    delete(id){
      if(id){
       // console.log('here')
        swal({
          title: 'Are you sure?',
          text: "You won't be able to revert this!",
          type: 'warning',
          showCancelButton: true,
          confirmButtonClass: 'btn btn-success',
          cancelButtonClass: 'btn btn-danger',
          confirmButtonText: 'Yes, delete it!',
          buttonsStyling: false
        }).then((result) => {
          if (result.value) {
            this.commonService.sendRequestToNode({method :'delete',path:'ship-training/'+id}).subscribe(
            data => {
            if(data.status){
              var dialogueTitle = "Deleted!"
              if(this.trainingData.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
                if(this.currentPage>1){
                  this.currentPage--;
                }
              }
              this.getData();
              //update list
              let idArr = this.dataForIds.Ids.split(',');
              idArr.splice(idArr.indexOf(id),1);
              if(idArr.length == 0){
                this.modalRef.close();
              }
              else{
                this.dataForIds.Ids = idArr.join(); 
                // console.log();
                this.getTrainingList(this.dataForIds);  
              }
              swal({
                  title: dialogueTitle,
                  text: data.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                })
            }         
            
        })
          }
        })      
      }
    }

    onSubmit(){ 
      this.formSubmittedAttempt = true;
      if(this.trainingForm.valid){
      let postData = this.trainingForm.value;
      
        if(postData.TRAINING_START_DATE <= postData.TRAINING_END_DATE){
          if(this.edit_id){  
            this.showSideBarLoader = true;
            postData.OLD_USER = this.OLD_USER;
            
            this.commonService.sendRequestToNode({method :'put',path:'ship-training/'+this.edit_id,postData:postData}).subscribe(
              data =>{
                var dialogueTitle = "Updated!";
                this.showSideBarLoader = false;
                if(data.status){
                  swal({
                      title: dialogueTitle,
                      text: data.message,
                      type: 'success',
                      confirmButtonClass: "btn btn-success",
                      buttonsStyling: false
                    })
                  this.getData();
                  this.resetForm(); //after edit form is reset
                }
                else{
                  alert(data.message);
                }
              })
          }else{
                this.commonService.sendRequestToNode({method :'post',path:'ship-training',postData:this.trainingForm.value}).subscribe(
                data =>{
                  var dialogueTitle = "Inserted!";
                  this.showSideBarLoader = false;
                  if(data.status){
                    swal({
                        title: dialogueTitle,
                        text: data.message,
                        type: 'success',
                        confirmButtonClass: "btn btn-success",
                        buttonsStyling: false
                      })
                    this.getData();
                    this.resetForm(); //after edit form is reset
      
                  }
                  else{
                    alert(data.message);
                  }
              })
            }   
        }
        else{
          alert('End Date Should Be Greater Than Start Date')
        }
      }
        
    } 

  
    
    //part of grid
    funOpenRightSidebar(opt){
      this.el.nativeElement.focus();
      this.openRightSidebar = true; 
      //this.trainingForm.get('FLAG').value=opt;
      this.trainingForm.patchValue({
        FLAG : opt 
      })
      if(opt=="Completed")
        this.txt = "Training";
      else 
        this.txt = "Plan";
      document.getElementById("lbl_training").innerHTML = this.txt;
    }

    onFileChange(event,id) {
      let file = [];
      if(event.target.files.length > 0 && event.target.files.length <= 1) {
        this.ObjPerFile[id] = event.target.files[0];
      }else{
        this.ObjPerFile[id] = '';
        this.fi ? this.fi.nativeElement.value = "" : '';
      }
    }
  
    onSubmitAttachment(){
      this.showModalLoader = true;
      let formData = new FormData();
      Object.keys(this.ObjPerFile).forEach((ele)=>{
        if(this.ObjPerFile[ele]){
          formData.append('ID',ele );
          formData.append('FILE',this.ObjPerFile[ele] );
        }
      })
  
      this.commonService.sendRequestToNode({method :'post',path:'ship-training/upload-attachment',postData:formData}).subscribe(
        data =>{
          var dialogueTitle = "Uploaded!";
          this.showModalLoader = false;
          if(data.status){
            this.ObjPerFile = {};
            swal({
              title: dialogueTitle,
              text : data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            })
            // this.getTrainingList(this.dataForIds)
            this.modalRef.close();
            // this.getData();
            // this.openRightSidebar = false;
            // this.resetForm();
          }
          else{
            alert(data.message)
          }
          
        })
      
    }

    removeUploadedFile(id,fileName){
      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, remove it!',
        buttonsStyling: false
      }).then((result) => {
        if (result.value) {
          this.commonService.sendRequestToNode({method :'post',path:'ship-training/remove-ship-attachment/'+id,postData:{file:fileName}}).subscribe(
            result =>{
              this.getTrainingList(this.dataForIds);
              var dialogueTitle = "Success!";
              swal({
                title: dialogueTitle,
                text : result.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            })
        }
      })
      
    }
    getTrainingList(data){
      this.showMainLoader = true;
      this.commonService.sendRequestToNode({method :'get',path:'get-ship-training-list',queryParam : {Ids : data.Ids}}).subscribe(result => {
         if(result.status)
          {
            this.showMainLoader = false;
            this.showModalLoader = false;
            this.trainingListPerMonth = result.data;
          }
          else{
            alert(result.message)
          }
        })
    }
    openModelForTrainingList(content,data) {
      this.dataForIds = data;
      this.getTrainingList(data);
      this.showModalLoader = true;
      this.modalRef = this.modalService.open(content,{size:'lg'});
      
      //console.log(id);
      
    }
    changeYear(i){
      this.filterObj.year = this.filterObj.year + (i)
      this.getData() 
    }

    addTrainingType(content){
      this.modalRef = this.modalService.open(content,{size: 'sm'});
    }

    resetTrainingTypeForm(){
      this.trainingTypeFormSubmittedAttempt = false;
      this.trainingTypeForm.patchValue({
        TRAINING_TYPE: null,
      })
    }

    onSubmitTrainingType(){
      //console.log(this.edit_id);
      this.trainingTypeFormSubmittedAttempt = true;
      if(this.trainingTypeForm.valid){
        //console.log(this.Groupinspector.value);
        this.commonService.sendRequestToNode({method :'post',path:'training-type',postData:this.trainingTypeForm.value}).subscribe(
          data =>{
            var dialogueTitle = "Inserted!";
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              }).then(()=>{
                this.modalRef.close();
                this.trainingTypeDropDown(data.insertId);
                this.resetTrainingTypeForm();
              })
              // this.modal.close()
            }else{
              alert(data.message);
            }
        })
      }  
    }


    generatePdf(){
      var data = document.getElementById('htmlToString').innerHTML;
      // console.log(JSON.stringify(data));
      // console.log(data);
      var htmlData = {'data':data};
      this.commonService.sendRequestToNode({ method: 'post', path: 'training/generatePDFData',postData:htmlData }).subscribe(result => {
        if(result.status){  
          window.location.href = this.commonService.getNodeApi()+'/training-exportPDF';
        }  
      })
    }
    downloadImage(){
      html2canvas(this.screen.nativeElement).then(canvas => {
        this.canvas.nativeElement.src = canvas.toDataURL();
        this.downloadLink.nativeElement.href = canvas.toDataURL('image/png');
        this.canvas.nativeElement.remove();
        this.downloadLink.nativeElement.download = 'Ship-Staff-Training.png';
        this.downloadLink.nativeElement.click();
        
      });
    }
    changeFlag(e){
      //console.log(e)
      this.filterObj.flag = e;
      this.getData();
    }
}