import { NgModule } from '@angular/core'; 
import { BrowserAnimationsModule } from '@angular/platform-browser/animations'; 
import { CalendarModule, DateAdapter } from 'angular-calendar'; 
import { adapterFactory } from 'angular-calendar/date-adapters/date-fns';

import { CommonModule } from '@angular/common';
import { FormsModule,ReactiveFormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import { UiSwitchModule } from 'ngx-toggle-switch';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

import { ShipTrainingComponent } from './ship-training.component';

import { GridViewModule} from '../shared/grid-view/grid-view.module';
import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { NgSelectModule } from '@ng-select/ng-select';

import { FlatpickrModule } from 'angularx-flatpickr';
import { NgbModalModule } from '@ng-bootstrap/ng-bootstrap';

const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};
const routes: Routes = [
  {
    path: '',
    data: {
      title: 'Ship Staff Training',
      urls: [
        { title: 'Dashboard', url: '/dashboard' },
        { title: 'Training' }
      ]
    },
    component: ShipTrainingComponent
  }
];
@NgModule({ 
  imports: [ 
    //BrowserAnimationsModule, 
    CalendarModule.forRoot({ 
      provide: DateAdapter, 
      useFactory: adapterFactory 
    }),
    FormsModule,
    NgbModalModule,
    CommonModule,
    RouterModule.forChild(routes),
    FlatpickrModule.forRoot(),
    NgbModule,
    ReactiveFormsModule,
    PerfectScrollbarModule,
    GridViewModule,
    NgSelectModule,
    UiSwitchModule,
  ],
  declarations: [ShipTrainingComponent],
  exports: [ShipTrainingComponent]
}) 
export class ShipTrainingModule {} 