import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule,ReactiveFormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

import { ShoreStaffTrainingReportComponent } from './shore-staff-training-report.component';
import { ChartsModule } from 'ng2-charts';
import { GridViewModule} from '../shared/grid-view/grid-view.module';
import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { NgSelectModule } from '@ng-select/ng-select';
import { UiSwitchModule } from 'ngx-toggle-switch';
import { TagInputModule } from 'ngx-chips';

const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};

const routes: Routes = [
  {
    path: '',
    data: {
      title: 'Shore Staff Training Report',
      urls: [
        { title: 'Dashboard', url: '/dashboard' },
        { title: 'Shore Staff Training', url: '/tmsa/training' },
        { title: 'Report' }
      ]
    },
    component: ShoreStaffTrainingReportComponent
  }
];

@NgModule({
  imports: [
    FormsModule,
    CommonModule,
    RouterModule.forChild(routes),
    NgbModule,
    ReactiveFormsModule,
    PerfectScrollbarModule,
    GridViewModule,
    NgSelectModule,
    UiSwitchModule
  ],
  declarations: [
    ShoreStaffTrainingReportComponent
  ],
  providers: [
    {
      provide: PERFECT_SCROLLBAR_CONFIG,
      useValue: DEFAULT_PERFECT_SCROLLBAR_CONFIG
    },
  ]
})
export class ShoreStaffTrainingReportModule {}

