import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { NgbTabset, NgbModal, NgbModalRef, ModalDismissReasons, NgbActiveModal } from '@ng-bootstrap/ng-bootstrap';

import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';

//import { parse } from 'path';
declare var $: any;

import { PerfectScrollbarConfigInterface,PerfectScrollbarDirective } from 'ngx-perfect-scrollbar';
import { json } from 'd3';

@Component({
  templateUrl: './sire_report.component.html',
  styleUrls: ['./sire_report.component.scss']
})
export class sireReportComponent implements AfterViewInit,OnInit {

  public config: PerfectScrollbarConfigInterface = {};
  public modalRef:NgbModalRef;

  tabStatus = 'justified';

  @ViewChild(PerfectScrollbarDirective) directiveRef?: PerfectScrollbarDirective;
  @ViewChild('tabs')
  private tabs:NgbTabset;

  public groupSireReportUpload:FormGroup;
  public groupSireReportManual:FormGroup;
  public Groupinspector:FormGroup;
  public sires = [];
  public sires_view;
  public inspector_dropdown = [];
  public edit_id;
  public formSubmittedAttempt = false;
  public sireManualformSubmittedAttempt = false;
  public inspectorFormSubmittedAttempt = false;
  public openRightSidebar = false;
  public viewData = false;
  public filterObj:any = {};
  public sortFilter:any = {};

  public oliMajor_dropdown = [];
  public vessel_dropdown = [];
  public vessel_flag_dropdown = [];
  public vessel_type_dropdown = [];
  public society_dropdown = [];
  public port_dropdown = [];
  public sire_dropdown = [];
  
  public old_vessel_fk = 0;//hold vessel_fk for edit
  public OLD_REPORT_NUMBER = 0;//hold vessel_fk for edit

  public modalOpenFor // this variable for know modal open from which form 
  //for grid 
  public headerInformation;
  public actionButtons;

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;

  closeResult: string;
  

  public showSideBarLoader = false;
  public showLoader = false;

  public pdfLogo;
  public withoutPaginationData = [];

  public editViewData;


  @ViewChild('fileInput') fi:ElementRef;

  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private router: Router,
    private formBuilder: FormBuilder,
    public modal: NgbActiveModal) {
      let filterObj = this.commonService.getRouteData('sire_report_filter_data');
      if(filterObj) {
        this.filterObj = filterObj;
        this.commonService.clearRouteData('sire_report_filter_data')
      }
      this.declareGridVariable()
  }

  ngAfterViewInit(){
   
  }

  ngOnInit(){
    //console.log(location);
    this.pdfLogo = location.origin+location.pathname+'assets/images';
    this.getData();
    
    this.addForm();
    this.getAllDropDownValue();
    
    // this.oilMajor();
    $(document).on('change','#checkAll',function(){
      if ($(this).is(':checked')) {
        $('input.upload-confirm').attr('checked',true);
        // this.checked = !sure;
      }
      else{
        $('input.upload-confirm').removeAttr('checked');
      }
    })
  }
  getAllDropDownValue(){
    this.inspectorsData();
    this.oilMajor();
    this.vesselDropdown();
    this.vesselFlagDropdown();
    this.vesselTypeDropdown();
    this.societyDropdown();
    this.portDropdown();
    this.sireDropdown();

  }

  addForm(){
    this.groupSireReportUpload = this.formBuilder.group({
      FILE: ['',[Validators.required]],
      INSPECTOR_FK:null 
    });   
        
    this.groupSireReportManual = this.formBuilder.group({
      VESSEL_FK:[null],
      INSPECTOR_FK:[null],
      SIRE_FK : [null],
      REPORT_NUMBER : [null,[Validators.required]],
      TEMPLATE_FK : [null],
      DATE_OF_INSPECTION:[null],
      FLAG_FK : [null],
      PORT_FK :[null],
      OIL_MAJOR_FK : [null],
      DEADWEIGHT : [null],
      VESSEL_DELIVERY_DATE : [null],
      VESSEL_OPERATION : [null],
      VESSEL_TYPE_FK : [null],
      SOCIETY_CLASSIFICATION_FK : [null]
    });

    this.Groupinspector = this.formBuilder.group({
      OIL_MAJOR_MASTER_FK: [null,],
      FNAME: [null,],
      LNAME: [null,],
      INSPECTING_COMPANY: [null,],
      OFFICE_TELEPHONE: [null,],
      MOBILE_NO: [null,],
      EMAIL: [null,],
      COMMONLY_KNOWN: [null,],
      COMMENTS: [null,],
    }); 

    let filterObj = this.commonService.getRouteData('sire_report_filter_data');
    if(filterObj){
      this.filterObj = filterObj;
      this.commonService.clearRouteData('sire_report_filter_data')
    }
  }

  // onFileChange(event) {
  //   // console.log(event.target);
  //   // console.log(event.target.files.FileList);
  //   let file = [];
  //   if(event.target.files.length > 0) {
  //     for (var i = 0; i < event.target.files.length; i++) { 
  //       file.push(event.target.files[i]);
  //     }
  //    console.log(file);
  //     this.groupSireReportUpload.get('FILE').setValue(file);
  //   }
  // }

  onFileChange(event) {
    let file = [];
    if(event.target.files.length > 0 && event.target.files.length <= 20) {
      for (var i = 0; i < event.target.files.length; i++) { 
        file.push(event.target.files[i]);
      }
      this.groupSireReportUpload.get('FILE').setValue(file);
    }else{
      alert('You can only upload upto 20 files');
      this.fi ? this.fi.nativeElement.value = "" : '';
    }
  }
 
  onSubmit(){
    if(this.tabs.activeId == 'manual' ){
      this.submitManualReportForm();return false;
    }
    //console.log(this.edit_id);
    this.formSubmittedAttempt = true;
    
    if(this.groupSireReportUpload.valid){
      this.showSideBarLoader = true;
      let formData = new FormData();//this.oilMajorForm.value
      for (var i = 0; i < this.groupSireReportUpload.get('FILE').value.length; i++) { 
        formData.append("FILE", this.groupSireReportUpload.get('FILE').value[i]);
      }
      // formData.append('FILE',this.groupSireReportUpload.get('FILE').value );
      formData.append('INSPECTOR_FK',this.groupSireReportUpload.get('INSPECTOR_FK').value );
      this.commonService.sendRequestToNode({method :'post',path:'upload-sire-report',postData:formData}).subscribe(
        data =>{
          this.getAllDropDownValue();
          var dialogueTitle = "Uploaded!";
          if(!data.status){
            var dialogueTitle = "Error";
          }
  
          let errorStr = "<div>"+ data.message +"</div><br>";
          let inputBox = "";
          if(data.errObj && data.errObj.length>0){
            // errorStr += "<div>title</div>"
            
            data.errObj.forEach((element,key) => {
              if(element.status == "confirm"){
                if(!inputBox){
                  inputBox += "<div class='uploadrow_title'>These Reports Already Exist(Do You Want To Replace?)</div>"
                  inputBox += "<div class='uploadrow_title'  style='color:black;font-size:14px'>Check All <input type='checkbox' id='checkAll' name='one'></div>"
                }
                inputBox += "<div class='uploadrow_checkbox'><span>"+ element.fileName + " </span>: <input class='upload-confirm' type='checkbox' filePath = '"+ element.filePath +"' name='confirm'></div>"
              }
              else{
                errorStr += "<div class='uploadrow'><span>"+ element.fileName + "</span><div class='uploadrow_error'>"+ element.message + "</div></div>"
              }
            });
            errorStr += inputBox;
          }
          if(inputBox){
            swal({
              title: dialogueTitle,
              showCloseButton: true,
              showCancelButton: true,
              type: data.status ? 'success':'error',
              confirmButtonText: "submit",
              confirmButtonClass: "btn btn-success",
              cancelButtonClass: "btn btn-danger",
              buttonsStyling: false,
              html:errorStr,
             
              preConfirm: function () {
                var obj = [];
                $('input.upload-confirm:checked').each(function(index) {
                  obj.push($(this).attr('filePath'));
                });
                return new Promise(function (resolve) {
                  resolve(obj) 
                })
              },
              onOpen: function () {
                $('#swal-input1').focus();
              }
            }).then((result) => {
              if(result.value && result.value.length > 0){
                this.resubmitXmlFile(result.value);
              }
              else{
                this.showSideBarLoader = false;
              }
            }).catch(swal.noop)
          }
          else{
            this.showSideBarLoader = false;
            if(data.status){
              swal({
                html:errorStr,
                title: dialogueTitle,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }else{
              swal({
                html:errorStr,
                title: dialogueTitle,
                type: 'error',
                confirmButtonClass: "btn btn-danger",
                buttonsStyling: false
              })
            }
          }
          
        
      })
    }  
  }
  resubmitXmlFile(files){
    let postData = {
      filePath : files,
      forceFullyUpdateForXml : true,
      INSPECTOR_FK: this.groupSireReportUpload.get('INSPECTOR_FK').value
    }
    this.commonService.sendRequestToNode({method :'post',path:'upload-sire-report',postData:postData}).subscribe(data =>{
      var dialogueTitle = "Uploaded!";
      if(data.status){
        this.getAllDropDownValue();
        swal({
          title: dialogueTitle,
          text: data.message,
          type: 'success',
          confirmButtonClass: "btn btn-success",
          buttonsStyling: false
        }).then(()=>{
          this.showSideBarLoader = false;
        })
        this.getData();
        this.openRightSidebar = false;
        this.resetForm();
      }
    })
  }
  submitManualReportForm(){
    
    this.sireManualformSubmittedAttempt = true;
     if(this.groupSireReportManual.valid){
      this.showSideBarLoader = true;
       if(this.edit_id){
        let postObj = this.groupSireReportManual.value;
        postObj.OLD_VESSEL_FK = this.old_vessel_fk;
        postObj.OLD_REPORT_NUMBER = this.OLD_REPORT_NUMBER;
        this.commonService.sendRequestToNode({method :'post',path:'sire-report/'+this.edit_id,postData:postObj}).subscribe(
          data =>{
            this.showSideBarLoader = false;
            var dialogueTitle = "Updated!";
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }else{
              alert(data.message);
            }
        })
       }
       else{
        this.commonService.sendRequestToNode({method :'post',path:'sire-report/add',postData:this.groupSireReportManual.value}).subscribe(
          data =>{
            this.showSideBarLoader = false;
            var dialogueTitle = "Inserted!";
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }else{
              alert(data.message);
            }
        })
       }
      
    } 
  }

  onSubmitInspector(){
    //console.log(this.edit_id);
    this.inspectorFormSubmittedAttempt = true;
    if(this.Groupinspector.valid){
      //console.log(this.Groupinspector.value);
      this.commonService.sendRequestToNode({method :'post',path:'inspector/add',postData:this.Groupinspector.value}).subscribe(
        data =>{
          var dialogueTitle = "Inserted!";
          if(data.status){
            swal({
              title: dialogueTitle,
              text: data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            }).then(()=>{
              this.modalRef.close();
              this.inspectorsData(data.insertId,this.modalOpenFor);
              this.resetInspectorForm();
            })
            // this.modal.close()
          }else{
            alert(data.message);
          }
      })
    }  
  }

  getData()
  {

    this.showLoader = true;
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end


  
    // pagination
    filterParams.currentPage = this.currentPage-1;
    filterParams.itemsPerPage = this.itemsPerPage;
    // pagination - end

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end
    this.getDataWithoutPagination();
    this.commonService.sendRequestToNode({method :'get',path:'get-sire-report',queryParam:filterParams}).subscribe(result => {
      this.showLoader = false;  
      if(result.status)
        {
          if(result.data.length > 0){

            result.data.forEach((ele)=>{
              ele.OBSERVATION_COUNT_class = (ele.OBSERVATION_COUNT >= 9.50) ? ('bg-myred') :( (ele.OBSERVATION_COUNT >= 7.51) ? ('bg-myorange') : (ele.OBSERVATION_COUNT >= 4.51) ? 'bg-myyellow' : 'bg-mygreen'); 
              ele.INITIAL_RISK_PROFILE_class = (ele.INITIAL_RISK_PROFILE >= 35) ? ('bg-myred') :( (ele.INITIAL_RISK_PROFILE >= 21) ? ('bg-myorange') : 'bg-mygreen'); 
            })
            this.totalItems = result.data[0].total_records;
            this.sires = result.data;
          }else{
            this.sires = [];
          }
        }
        else{
          this.sires = [];
          alert(result.message);
        }
    })
  }

  delete(Obj){
    if (Obj.ID) {
      
      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, delete it!',
        buttonsStyling: false
        
        }).then((result) => {
          if (result.value) {   
            this.commonService.sendRequestToNode({method :'get',path:'sire-report/delete/'+Obj.ID,queryParam : {VESSEL_FK : Obj.VESSEL_FK}}).subscribe(result => {
              if(result.status){
                var dialogueTitle = "Deleted!"
                if(this.sires.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
                  if(this.currentPage>1){
                    this.currentPage--;
                  }
                }
                this.getData();
                swal({
                    title: dialogueTitle,
                    text: result.message,
                    type: 'success',
                    confirmButtonClass: "btn btn-success",
                    buttonsStyling: false
                  })
              }
            })
          }
        })
    }
  }

  observationManage(id){
    this.commonService.setRouteData('sire_report_filter_data',this.filterObj);
    this.router.navigate(["/observation/"+id]);    
  }
  edit(id) {

    this.directiveRef.scrollToTop();
    this.openRightSidebar = true;
    this.showSideBarLoader = true;
    this.commonService.sendRequestToNode({method :'get',path:'get-sire-report/'+id}).subscribe(result => {
      this.showSideBarLoader = false;
      if(result.status)
      {
        
        this.edit_id = id;
        if(result.data){

          this.editViewData = result.data;

          //this.totalItems = result.data[0].total_records;
          if(this.tabs) {
            this.tabs.select('manual');
          } 
          this.old_vessel_fk = result.data.VESSEL_FK;
          this.OLD_REPORT_NUMBER = result.data.REPORT_NUMBER;
          let DATE_OF_INSPECTION = new Date(result.data.DATE_OF_INSPECTION);
          
          result.data.DATE_OF_INSPECTION = DATE_OF_INSPECTION.getFullYear()+'-'+("0" + (DATE_OF_INSPECTION.getMonth() + 1)).slice(-2)+'-'+("0" + DATE_OF_INSPECTION.getDate()).slice(-2) 
        
          let date = new Date(result.data.VESSEL_DELIVERY_DATE);
       
          result.data.VESSEL_DELIVERY_DATE = date.getFullYear()+'-'+("0" + (date.getMonth() + 1)).slice(-2)+'-'+("0" + date.getDate()).slice(-2) 

        // console.log(result.data)
          //patch value in edit time
          this.groupSireReportManual.patchValue(result.data);
         
          this.oliMajor_dropdown.forEach(ele => {
            if(result.data.OIL_MAJOR_FK == ele.ID){  
              this.groupSireReportManual.patchValue({
                OIL_MAJOR_FK : ele.value ? ele.value : null
              })
            } 
          });
          this.vessel_dropdown.forEach((i) => {
            if(result.data.VESSEL_FK == i.ID){  
              this.groupSireReportManual.patchValue({
                VESSEL_FK : i.value ? i.value :null
              })
            }
          });
         
          this.vessel_flag_dropdown.forEach((i) => {
            if(result.data.FLAG_FK == i.ID){  
              this.groupSireReportManual.patchValue({
                FLAG_FK : i.value ? i.value : null
              })
            }
          });
          this.vessel_type_dropdown.forEach((i) => {
            if(result.data.VESSEL_TYPE_FK == i.ID){  
              this.groupSireReportManual.patchValue({
                VESSEL_TYPE_FK : i.value ? i.value : null
              })
            }
          });
          this.society_dropdown.forEach((i) => {
            if(result.data.SOCIETY_CLASSIFICATION_FK == i.ID){  
              this.groupSireReportManual.patchValue({
                SOCIETY_CLASSIFICATION_FK : i.value ? i.value : null
              })
            }
          });

          this.port_dropdown.forEach((i) => {
            if(result.data.PORT_FK == i.ID){  
              this.groupSireReportManual.patchValue({
                PORT_FK : i.value ? i.value : null
              })
            }
          });

          this.sire_dropdown.forEach((i) => {
            if(result.data.SIRE_FK == i.ID){  
              this.groupSireReportManual.patchValue({
                SIRE_FK : i.value ? i.value : null
              })
            }
          });
          
          // this.oilMajor();
          // this.vesselDropdown();
          // this.vesselFlagDropdown();
          // this.vesselTypeDropdown();
          // this.societyDropdown();
          // this.portDropdown();
          // this.sireDropdown(); 
          this.openRightSidebar = true;
          // Object.keys(this.loader).forEach(ele => {
          //   this.loader[ele] = true; 
          // });
        }
      }
      else{
        alert('Data Not Found')
      }
  })
    // alert(id);
    // this.router.navigate(["/sireLinking/"+id]);
  }

  view(id){
    this.openRightSidebar = true;
    this.showSideBarLoader = true;
    this.directiveRef.scrollToTop();
    this.commonService.sendRequestToNode({method :'get',path:'get-sire-report/'+id}).subscribe(result => {
      this.showSideBarLoader = false;
      if(result.status)
      { 
        if(result.data){
          let DATE_OF_INSPECTION = new Date(result.data.DATE_OF_INSPECTION);
          
          result.data.DATE_OF_INSPECTION = DATE_OF_INSPECTION.getFullYear()+'-'+("0" + (DATE_OF_INSPECTION.getMonth() + 1)).slice(-2)+'-'+("0" + DATE_OF_INSPECTION.getDate()).slice(-2) 
        
          let date = new Date(result.data.VESSEL_DELIVERY_DATE);
       
          result.data.VESSEL_DELIVERY_DATE = date.getFullYear()+'-'+("0" + (date.getMonth() + 1)).slice(-2)+'-'+("0" + date.getDate()).slice(-2) 
          this.viewData = result.data;

          //console.log(this.sires);
        }
      }
      else{
        alert('Data Not Found')
      }
  })
    // alert(id);
    // this.router.navigate(["/sireLinking/"+id]);
  }

  inspectorsData(id=0,fromUploadForm = '')
  {
    this.commonService.sendRequestToNode({method :'get',path:'inspectors/inspector-dropDown'}).subscribe(result => {
      if(result.status){
        this.inspector_dropdown = result.data;
        if(id){
      
          if(fromUploadForm == "uploadForm"){
            this.groupSireReportUpload.patchValue({
              INSPECTOR_FK : id 
            })
          }else if(fromUploadForm == "manualForm"){
            this.groupSireReportManual.patchValue({
              INSPECTOR_FK : id 
            })
          }
        }
        //console.log(this.inspector_dropdown);
      }
      else{
        this.inspector_dropdown = [];
        alert(result.message);
      }
    })
  }

  resetForm(){
    this.formSubmittedAttempt = false;
    this.sireManualformSubmittedAttempt = false;
    this.openRightSidebar = false;
    this.viewData = false;
    this.edit_id = '';
    this.fi ? this.fi.nativeElement.value = "" : '';
    this.groupSireReportUpload.patchValue({
      FILE: null,
      INSPECTOR_FK: null 
    });
    this.groupSireReportManual.patchValue({
      VESSEL_FK:null,
      INSPECTOR_FK:null,
      SIRE_FK : null,
      REPORT_NUMBER : null,
      TEMPLATE_FK : null,
      DATE_OF_INSPECTION:null,
      FLAG_FK : null,
      PORT_FK :null,
      OIL_MAJOR_FK : null,
      DEADWEIGHT : null,
      VESSEL_DELIVERY_DATE : null,
      VESSEL_OPERATION : null,
      VESSEL_TYPE_FK : null,
      SOCIETY_CLASSIFICATION_FK : null
    });
  }

  resetInspectorForm(){
    this.inspectorFormSubmittedAttempt = false;
    this.Groupinspector.patchValue({
      OIL_MAJOR_MASTER_FK: null,
      FNAME: null,
      LNAME: null,
      INSPECTING_COMPANY: null,
      OFFICE_TELEPHONE: null,
      MOBILE_NO: null,
      EMAIL: null,
      COMMONLY_KNOWN: null,
      COMMENTS: null, 
    })
  }
 
  // part of grid
  declareGridVariable(){
    this.headerInformation = [
      {
        title : 'Date',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'DATE_OF_INSPECTION',// name of column in data source
        width : '10%',// width of column in table
        isSortable : true,// sort by column false or true
        // isFilter:{ // filter 
        //   type : 'text',
        //   placeholder : 'Filter By Date'
        // }
      },
      {
        title : 'Oil Major',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'INSPECTING_COMPANY',// name of column in data source
        width : '13%',// width of column in table
        isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Oil Major'
        }
      },
      {
        title : 'Vessel',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'VESSEL_NAME',// name of column in data source
        width : '12%',// width of column in table
        isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Vessel'
        }
      },
    
      {
        title : 'Inspector Name',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'INSPECTOR_NAME',// name of column in data source
        width : '15%',// width of column in table
        isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Inspector Name'
        }
      },
      {
        title : 'Port',// show title table header
        //nameIcon : true,// show icon of First letter
        name:'PORT_OF_INSPECTION',// name of column in data source
        width : '25%',// width of column in table
        isSortable : true,// sort by column false or true
        isFilter:{ // filter 
          type : 'text',
          placeholder : 'Filter By Port'
        }
      },
      {title : 'Obs',highlight:true,name:'OBSERVATION_COUNT',width : '5%',},
      {title : 'Risk',highlight:true,name:'INITIAL_RISK_PROFILE',width : '5%'},
      {title : 'Action',name:'action',width : '15%'}
    ];
    this.actionButtons = [
      {title:'Observation',class : "fas fa-file-alt"},
      {title:'Edit',class : "far fa-edit"},
      {title:'View',class : "fas fa-eye"},
      {title:'Delete',class : "far fa-trash-alt"},
    ]
  }

  //part of grid
  clickOnAction(actionObj){
    if(actionObj.actionName == 'Observation'){
      this.observationManage(actionObj.object.ID);
    }else if(actionObj.actionName == 'Edit'){
      this.edit(actionObj.object.ID);
    }else if(actionObj.actionName == 'View'){
      this.view(actionObj.object.ID);
    }else if(actionObj.actionName == 'Delete'){
      this.delete(actionObj.object);
    }

  }


  //part of grid
  //when change filter ,change page no . etc, 
  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getData();
  }

  //part of grid
  funOpenRightSidebar(){
    this.commonService.setRouteData('sire_report_filter_data',this.filterObj);
    this.tabs.select('upload');
    this.openRightSidebar = true;
    this.directiveRef.scrollToTop();
  }

  open2(content,openModalFromUpload = true) {
    this.modalRef = this.modalService.open(content,{size: 'lg'});
    if(openModalFromUpload){
      this.modalOpenFor = 'uploadForm'
    }
    else{
      this.modalOpenFor = 'manualForm'
    }
    // this.modalRef.result.then(
    //   result => {
    //     this.closeResult = `Closed with: ${result}`;
    //   },
    //   reason => {
    //     this.closeResult = `Dismissed`;
    //   }
    // );
  }

  oilMajor(id = 0){
    this.commonService.sendRequestToNode({method :'get',path:'inspectors/oliMajor-dropdown'}).subscribe(result => {
      if(result.status){
        this.oliMajor_dropdown = result.data;
        this.oliMajor_dropdown.map((i) => { 
          i.value = JSON.stringify({
            ID:i.ID,
            COMPANY_NAME : i.COMPANY_NAME,
            OFFICIAL_NAME : i.OFFICIAL_NAME
          }); 
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              OIL_MAJOR_FK : i.value
            })
          } 
          return i; 
        });
        // this.loader.oilMajor = true;
      }
      else{
        this.oliMajor_dropdown = [];
        alert(result.message);
      }
    })
  }
  vesselDropdown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vessel-dropdown'}).subscribe(result => {
      if(result.status){
        this.vessel_dropdown = result.data;

        this.vessel_dropdown.map((i) => {
          
          i.value = JSON.stringify({
            ID:i.ID,
            VESSEL_NAME : i.VESSEL_NAME,
            IMO_NO : i.IMO_NO
          }); 
          
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              VESSEL_FK : i.value
            })
          }
          return i; 
        });
      }
      else{
        this.vessel_dropdown = [];
        alert(result.message);
      }
    })
  }
  vesselFlagDropdown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselFlag'}).subscribe(result => {
      if(result.status){
        this.vessel_flag_dropdown = result.data;
        this.vessel_flag_dropdown.map((i) => { 
          i.value = JSON.stringify({
            ID:i.ID,
            VESSEL_FLAG_NAME : i.VESSEL_FLAG_NAME
          }); 
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              FLAG_FK : i.value
            })
          }
          return i; 
        });
      }
      else{
        this.vessel_flag_dropdown = [];
        alert(result.message);
      }
    })
  }
  vesselTypeDropdown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselType'}).subscribe(result => {
      if(result.status){
        this.vessel_type_dropdown = result.data;
        this.vessel_type_dropdown.map((i) => { 
          i.value = JSON.stringify({
            ID:i.ID,
            VESSEL_TYPE : i.VESSEL_TYPE
          }); 
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              VESSEL_TYPE_FK : i.value
            })
          }
          return i; 
        });
      }
      else{
        this.vessel_type_dropdown = [];
        alert(result.message);
      }
    })
  }
  societyDropdown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'society-dropdown'}).subscribe(result => {
      if(result.status){
        this.society_dropdown = result.data;
        this.society_dropdown.map((i) => { 
          i.value = JSON.stringify({
            ID:i.ID,
            NAME : i.NAME
          }); 
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              SOCIETY_CLASSIFICATION_FK : i.value
            })
          }
          return i; 
        });
      }
      else{
        this.society_dropdown = [];
        alert(result.message);
      }
    })
  }
  portDropdown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'port-dropdown'}).subscribe(result => {
      if(result.status){
        this.port_dropdown = result.data;
        this.port_dropdown.map((i) => { 
          i.value = JSON.stringify({
            ID:i.ID,
            NAME : i.PORT_NAME
          }); 
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              PORT_FK : i.value
            })
          }
          return i; 
        });
      }
      else{
        this.port_dropdown = [];
        alert(result.message);
      }
    })
  }
  sireDropdown(id=0){
    this.commonService.sendRequestToNode({method :'get',path:'sire-dropdown'}).subscribe(result => {
      if(result.status){
        this.sire_dropdown = result.data;
        this.sire_dropdown.map((i) => { 
          i.value = JSON.stringify({
            ID:i.ID,
            VERSION : i.VERSION,
            TEMPLATE_FK : i.TEMPLATE_FK,
            TEMPLATE_NAME : i.TEMPLATE_NAME
          }); 
          if(id == i.ID){  
            this.groupSireReportManual.patchValue({
              SIRE_FK : i.value
            });
          }
          return i; 
        });
      }
      else{
        this.sire_dropdown = [];
        alert(result.message);
      }
    })
  }

  getDataWithoutPagination()
  {
    this.showLoader = true;
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end

    this.commonService.sendRequestToNode({method :'get',path:'get-sire-report',queryParam:filterParams}).subscribe(result => {
      this.showLoader = false;  
      if(result.status)
        {
          if(result.data.length > 0){
            this.totalItems = result.data[0].total_records;
            this.withoutPaginationData = result.data;
          }else{
            this.withoutPaginationData = [];
          }
        }
        else{
          this.withoutPaginationData = [];
          alert(result.message);
        }
    })
  } 

  getDataforcsv() {
    this.generatcsv();
  }

  generatcsv(){
    let postObj = {
      data : this.withoutPaginationData
    }
    this.commonService.sendRequestToNode({method :'post',path:'sireReport/generateCSVData',postData:postObj}).subscribe(result => {
      if(result.status){
        window.open(this.commonService.getNodeApi()+'/sireReport/exportCSV', '_blank' );
      } 
    })
  }

  generatePdf(){
    var data = document.getElementById('htmlToString').innerHTML;
    // console.log(JSON.stringify(data));
    // console.log(data);
    var htmlData = {'data':data};
    this.commonService.sendRequestToNode({ method: 'post', path: 'sireReport/generatePDFData',postData:htmlData }).subscribe(result => {
      if(result.status){
          window.location.href = this.commonService.getNodeApi()+'/sireReport/exportPDF';
      }
    })
}

  

}
