import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { CommonModule } from '@angular/common';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import { JsonpModule } from '@angular/http';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { NgSelectModule } from '@ng-select/ng-select';


import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { GridViewModule} from '../shared/grid-view/grid-view.module';


import { TmsaRoutes } from './tmsa.routing';
import { CargoAuditComponent } from './cargo_audit/cargo_audit.component';
import { DefectDamageComponent } from './defect_damage/defect_damage.component';
import { EngineeringAuditComponent } from './engineering_audit/engineering_audit.component';
import { ExternalAuditComponent } from './external_audit/external_audit.component';
import { FlagStateInspectionComponent } from './flag_state_inspection/flag_state_inspection.component';
import { InPortNavigationVerificationComponent } from './in_port_navigation_verification/in_port_navigation_verification.component';
import { InternalAuditComponent } from './internal_audit/internal_audit.component';
import { MlcAuditComponent } from './mlc_audit/mlc_audit.component';
import { MooringAuditComponent } from './mooring_audit/mooring_audit.component';
import { NonSireComponent } from './non_sire/non_sire.component';
import { OtherMiscAuditAndInspectionComponent } from './other_misc_audit_and_inspection/other_misc_audit_and_inspection.component';
import { PscComponent } from './psc/psc.component';
import { SailingNavigationAuditComponent } from './sailing_navigation_audit/sailing_navigation_audit.component';
import { SupritendentInspectionComponent } from './supritendent_inspection/supritendent_inspection.component';
import { TerminalInspectionComponent } from './terminal_inspection/terminal_inspection.component';
import { ThirdPartyInspectionComponent } from './thirdParty_inspection/thirdParty_inspection.component';


const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};

@NgModule({
  imports: [
    CommonModule,
    RouterModule.forChild(TmsaRoutes),
    FormsModule,
    ReactiveFormsModule,
    JsonpModule,
    NgbModule,
    NgSelectModule,
    PerfectScrollbarModule,
    GridViewModule
  ],
  declarations: [
    CargoAuditComponent,
    DefectDamageComponent,
    EngineeringAuditComponent,
    ExternalAuditComponent,
    FlagStateInspectionComponent,
    InPortNavigationVerificationComponent,
    InternalAuditComponent,
    MlcAuditComponent,
    MooringAuditComponent,
    NonSireComponent,
    OtherMiscAuditAndInspectionComponent,
    PscComponent,
    SailingNavigationAuditComponent,
    SupritendentInspectionComponent,
    TerminalInspectionComponent,
    ThirdPartyInspectionComponent
  ],
  providers: [
    {
      provide: PERFECT_SCROLLBAR_CONFIG,
      useValue: DEFAULT_PERFECT_SCROLLBAR_CONFIG
    },
  ]
})
export class TmsaModule {}
