import { Routes } from '@angular/router';

import { CargoAuditComponent } from './cargo_audit/cargo_audit.component';
import { DefectDamageComponent } from './defect_damage/defect_damage.component';
import { EngineeringAuditComponent } from './engineering_audit/engineering_audit.component';
import { ExternalAuditComponent } from './external_audit/external_audit.component';
import { FlagStateInspectionComponent } from './flag_state_inspection/flag_state_inspection.component';
import { InPortNavigationVerificationComponent } from './in_port_navigation_verification/in_port_navigation_verification.component';
import { InternalAuditComponent } from './internal_audit/internal_audit.component';
import { MlcAuditComponent } from './mlc_audit/mlc_audit.component';
import { MooringAuditComponent } from './mooring_audit/mooring_audit.component';
import { NonSireComponent } from './non_sire/non_sire.component';
import { OtherMiscAuditAndInspectionComponent } from './other_misc_audit_and_inspection/other_misc_audit_and_inspection.component';
import { PscComponent } from './psc/psc.component';
import { SailingNavigationAuditComponent } from './sailing_navigation_audit/sailing_navigation_audit.component';
import { SupritendentInspectionComponent } from './supritendent_inspection/supritendent_inspection.component';
import { TerminalInspectionComponent } from './terminal_inspection/terminal_inspection.component';
import { ThirdPartyInspectionComponent } from './thirdParty_inspection/thirdParty_inspection.component';

import { AuthGuard } from '../auth-guard.service';

export const TmsaRoutes: Routes = [
  {
    path: '',
    children: [
      {
        canActivate: [AuthGuard],
        path: 'cargo_audit',
        component: CargoAuditComponent,
        data: {
          module:'cargo_audit',
          title: 'Cargo Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Cargo Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'defect_damage',
        component: DefectDamageComponent,
        data: {
          module:'defect_damage',
          title: 'Defect Damage',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Defect Damage' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'engineering_audit',
        component: EngineeringAuditComponent,
        data: {
          module:'engineering_audit',
          title: 'Engineering Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Engineering Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'external_audit',
        component: ExternalAuditComponent,
        data: {
          module:'external_audit',
          title: 'External Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'External Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'flag_state_inspection',
        component: FlagStateInspectionComponent,
        data: {
          module:'flag_state_inspection',
          title: 'Flag State Inspection',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Flag State Inspection' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'in_port_navigation_verification',
        component: InPortNavigationVerificationComponent,
        data: {
          module:'in_port_navigation_verification',
          title: 'In Port Navigation Verification',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'In Port Navigation Verification' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'internal_audit',
        component: InternalAuditComponent,
        data: {
          module:'internal_audit',
          title: 'Internal Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Internal Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'mlc_audit',
        component: MlcAuditComponent,
        data: {
          module:'mlc_audit',
          title: 'MLC Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'MLC Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'mooring_audit',
        component: MooringAuditComponent,
        data: {
          module:'mooring_audit',
          title: 'Mooring Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Mooring Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'non_sire',
        component: NonSireComponent,
        data: {
          module:'non_sire',
          title: 'Non SIRE',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Non SIRE' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'other_misc_audit_and_inspection',
        component: OtherMiscAuditAndInspectionComponent,
        data: {
          module:'other_misc_audit_and_inspection',
          title: 'Other Misc Audit And Inspection',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Other Misc Audit And Inspection' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'psc',
        component: PscComponent,
        data: {
          module:'psc',
          title: 'PSC',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'PSC' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'sailing_navigation_audit',
        component: SailingNavigationAuditComponent,
        data: {
          module:'sailing_navigation_audit',
          title: 'Sailing Navigation Audit',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Sailing Navigation Audit' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'supritendent_inspection',
        component: SupritendentInspectionComponent,
        data: {
          module:'supritendent_inspection',
          title: 'Supritendent Inspection',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Supritendent Inspection' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'terminal_inspection',
        component: TerminalInspectionComponent,
        data: {
          module:'terminal_inspection',
          title: 'Terminal Inspection',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Terminal Inspection' }
          ]
        }
      },
      {
        canActivate: [AuthGuard],
        path: 'thirdParty_inspection',
        component: ThirdPartyInspectionComponent,
        data: {
          module:'thirdParty_inspection',
          title: 'Third Party Inspection',
          urls: [
            { title: 'Dashboard', url: '/dashboard' },
            { title: 'Third Party Inspection' }
          ]
        }
      },
    ]
  }
];
