// import { Component, AfterViewInit, ViewEncapsulation, OnInit } from '@angular/core';
// import { CommonService } from '../common-service.service';

// import {Router,ActivatedRoute} from "@angular/router";
// import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
// import swal from 'sweetalert2';

import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import swal from 'sweetalert2';
import { WindowService } from '@ng-select/ng-select/ng-select/window.service';

declare var require: any;

@Component({
  selector: 'inspectionPlanning',
  templateUrl: './topTwentyObservation.component.html',
  styleUrls: ['./topTwentyObservation.component.scss']
})
export class TopTwentyObservationComponent implements AfterViewInit,OnInit {

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  isDisabled = true;

  public expanded = [];
  public NEXT_DUE;
  public filterObj = {};
  public modalRef: NgbModalRef;
  public formData = {};
  public formDataOperatorDate = {};
  public vesselGroup_dropdown = [];
  public vesselFleet_dropdown = [];
  public vesselOwner_dropdown = [];
  public port_dropdown = [];
  public perCompanyObservation;
  public perCompanyRisk;
  public oilMajor_dropdown = [];
  public inspector_dropdown = [];
  public topTwentyObservationData = [];
  public topTwentyObservationDatacsv = [];
  public configData = [];
  public sortFilter:any = {};
  public current_template;
  public link_template;
  public questions_curr = [];
  public questions_prev = [];
  private fieldArray = {};
  private dataArray = {};
  public linkData = {};
  public pdfLogo;
  public topTwentyObservationCsvData;
  public filterObjObsChart: any = { start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))), end_date: this.commonService.formatDate(new Date()) };

  
  // public VesselMasterForm:FormGroup;
  // public groupSireReportUpload:FormGroup;

  constructor(private modalService: NgbModal,
    private commonService: CommonService){      
  }

  ngOnInit(){
 
    this.getData( this.filterObjObsChart );
    //console.log(location);
    this.pdfLogo = location.origin+location.pathname+'assets/images';
    //this.getDataforcsv();   
    //console.log(this.formData);    
  
  }

  ngAfterViewInit(){	
  }

  changePage(page){
    this.currentPage = page;
    this.sendFilterObjectForUpdateData();
    window.scroll(0,0);
    // this.updateData.emit(page)
  }

  sendFilterObjectForUpdateData(){
    let makeFilterObj = {}
     Object.keys(this.filterObj).forEach((key) => {
       makeFilterObj[key] = this.filterObj[key].replace(/'/g, "\\\'").replace(/"/g, '\\\"')
     });
     let filter = {
       filter : makeFilterObj,
       page : this.currentPage,
       sort : this.sortFilter
     }
     this.getData(  this.filterObjObsChart );
   }
   openModel(content) {
    this.modalRef = this.modalService.open(content, { size: 'sm' });
  }
  getData(filter: any = {}){ 
    let filterParams:any = {}
   //search filter 
   filterParams = JSON.parse(JSON.stringify(this.filterObj));
   //search filter -end

   // pagination
   filterParams.currentPage = this.currentPage-1;
   filterParams.itemsPerPage = this.itemsPerPage;
   filterParams.start_date  = filter.start_date;
   filterParams.end_date    = filter.end_date;

    this.commonService.sendRequestToNode({method :'get',path:'topTwentyObservation/getData',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        if(result.data[0]){
          this.totalItems = result.data[0].total_records;
        }        
        var data = [];
        // this.topTwentyObservationData = result.data[0];     
        for(var i=0; i < result.data.length;i++){
          if(!data[i]){
            data[i] = {detail:[]};
            
          }
          data[i]['QUESTION_DESCRIPTION'] = result.data[i].QUESTION_DESCRIPTION;
          data[i]['QUESTION_NUMBER'] = result.data[i].QUESTION_NUMBER;
          data[i]['QUESTION_REPEAT_COUNT'] = result.data[i].QUESTION_REPEAT_COUNT;
          var ins_date = result.data[i].INSPECTION_DATE ? result.data[i].INSPECTION_DATE.split(',') : '';
          var ins_obr = result.data[i].INSPECTION_OBSERVATION ? result.data[i].INSPECTION_OBSERVATION.split('||') : '';
          var ins_vsl = result.data[i].VESSEL_NAME ? result.data[i].VESSEL_NAME.split('||') : '';
          var ins_port = result.data[i].PORT_OF_INSPECTION ? result.data[i].PORT_OF_INSPECTION.split('||') : '';
          var ins_oil_major = result.data[i].OIL_MAJOR ? result.data[i].OIL_MAJOR.split('||') : '';
          for(var n = 0; n < ins_date.length;n++){
            data[i]['detail'][n] = [];
            data[i]['detail'][n]['INSPECTION_DATE'] = ins_date[n];
            data[i]['detail'][n]['INSPECTION_OBSERVATION'] = ins_obr[n];
            data[i]['detail'][n]['VESSEL_NAME'] = ins_vsl[n];
            data[i]['detail'][n]['PORT_OF_INSPECTION'] = ins_port[n];
            data[i]['detail'][n]['OIL_MAJOR'] = ins_oil_major[n];
            
          }
          
        }
        this.topTwentyObservationData = data;        
        
      }
      else{
        this.topTwentyObservationData = [];
        alert(result.message);
      }
    })
  } 
  
  // navigate(name,id){
  //   //this.topTwentyObservationData; 

  // }


  calculate(lastSireDate,currentDate) {
    var fromDate =lastSireDate;
    var toDate = currentDate;
  // console.log(fromDate);
  // console.log(toDate);
    try { //alert();
      // document.getElementById('result').innerHTML = '';
  
      var result = this.getDateDifference(new Date(fromDate), new Date(toDate));
      //console.log(result);
      if (result && !isNaN(result.years)) {
        // console.log(result);
        // document.getElementById('result').innerHTML =
        //   result.years + ' year' + (result.years == 1 ? ' ' : 's ') +
        //   result.months + ' month' + (result.months == 1 ? ' ' : 's ') + 'and ' +
        //   result.days + ' day' + (result.days == 1 ? '' : 's');

          return {'Year':result.years,'Month':result.months,'Day':result.days};
      }
    } catch (e) {
      console.error(e);
    }
  }
  
  getDateDifference(startDate, endDate) {
    //console.log(startDate);
    //console.log(endDate)
    if (startDate > endDate) {
  //    console.error('Start date must be before end date');
      return null;
    }
    var startYear = startDate.getFullYear();
    var startMonth = startDate.getMonth();
    var startDay = startDate.getDate();
  
    var endYear = endDate.getFullYear();
    var endMonth = endDate.getMonth();
    var endDay = endDate.getDate();
  
    // We calculate February based on end year as it might be a leep year which might influence the number of days.
    var february = (endYear % 4 == 0 && endYear % 100 != 0) || endYear % 400 == 0 ? 29 : 28;
    var daysOfMonth = [31, february, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
  
    var startDateNotPassedInEndYear = (endMonth < startMonth) || endMonth == startMonth && endDay < startDay;
    var years = endYear - startYear - (startDateNotPassedInEndYear ? 1 : 0);
  
    var months = (12 + endMonth - startMonth - (endDay < startDay ? 1 : 0)) % 12;
  
    // (12 + ...) % 12 makes sure index is always between 0 and 11
    var days = startDay <= endDay ? endDay - startDay : daysOfMonth[(12 + endMonth - 1) % 12] - startDay + endDay;
  //console.log(years+':'+months+':'+days)
    return {
      years: years,
      months: months,
      days: days
    };
  }

  onSubmit(ID,data){    
       
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:data}).subscribe(
          data =>{
            var dialogueTitle = "Updated!";
           
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
           
            }else{
              alert(data.message);
            }
        })   
  }

  resetForm(ID){       
    
    //this.formData[ID] = {};
   // this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';

   
      
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
      
      if (result.value) {
        
        this.formData[ID].PLAN_DATE='';
        this.formData[ID].PLAN_INSPECTOR_FK='';
        this.formData[ID].PLAN_OIL_MAJOR_FK='';
        this.formData[ID].PLAN_PORT_FK='';
        this.formData[ID].PLAN_REMARKS='';
        this.onSubmit(ID,this.formDataOperatorDate[ID]);
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:this.formData[ID]}).subscribe(
          data => {
            if(data.status){
              var dialogueTitle = "Reset!";              
              this.getData(  this.filterObjObsChart );
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
        })
      }
    })

    //this.formData[ID] = {};
    //this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';
   
  }
  resetDateForm(ID){
   
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, Reset it!',
       buttonsStyling: false
    }).then((result) => {
      
      if (result.value) { 
        this.formData[ID].PLAN_DATE='';
        this.formData[ID].PLAN_INSPECTOR_FK='';
        this.formData[ID].PLAN_OIL_MAJOR_FK='';
        this.formData[ID].PLAN_PORT_FK='';
        this.formData[ID].PLAN_REMARKS='';
        this.formDataOperatorDate[ID].OPERATOR_RESPONSE_DUE_DATE = '';
        this.onSubmit(ID,this.formDataOperatorDate[ID]);
        this.commonService.sendRequestToNode({method :'post',path:'inspectionPlanning/edit/'+ID,postData:this.formData[ID]}).subscribe(
          data => {
            if(data.status){
              var dialogueTitle = "Reset!";              
              this.getData(  this.filterObjObsChart);
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
        })
      }
    })

  }

  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
  }

  generatePDFNik() {
    var data = document.getElementById('contentToConvert').innerHTML;
    // console.log(JSON.stringify(data));
    // console.log(data);
    var htmlData = {'data':data};
    this.commonService.sendRequestToNode({ method: 'post', path: 'topTwentyObservation/generateInvoice',postData:htmlData }).subscribe(result => {
      if(result.status){
        window.location.href = this.commonService.getNodeApi()+'/topTwentyObservation/exportPDF';
      }
    })
  }

  getDataforcsv(filter:any ={}){
    let filterParams:any = {}
   //search filter 
   filterParams = JSON.parse(JSON.stringify(this.filterObj));
   //search filter -end

   // pagination
   filterParams.currentPage = this.currentPage-1;
   filterParams.itemsPerPage = this.itemsPerPage;
   filterParams.start_date   = filter.start_date;
    filterParams.end_date     = filter.end_date;

    this.commonService.sendRequestToNode({method :'get',path:'topTwentyObservation/getData',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        this.topTwentyObservationCsvData = result;
        if(this.topTwentyObservationCsvData.data[0]){
          this.totalItems = this.topTwentyObservationCsvData.data[0].total_records;
        }        
        var data = [];
        // this.topTwentyObservationData = this.topTwentyObservationCsvData.data[0];     
        for(var i=0; i < this.topTwentyObservationCsvData.data.length;i++){
          if(!data[i]){
            data[i] = {detail:[]};
            
          }
          data[i]['QUESTION_DESCRIPTION'] = this.topTwentyObservationCsvData.data[i].QUESTION_DESCRIPTION;
          data[i]['QUESTION_NUMBER'] = this.topTwentyObservationCsvData.data[i].QUESTION_NUMBER;
          data[i]['QUESTION_REPEAT_COUNT'] = this.topTwentyObservationCsvData.data[i].QUESTION_REPEAT_COUNT;
          var ins_date = this.topTwentyObservationCsvData.data[i].INSPECTION_DATE ? this.topTwentyObservationCsvData.data[i].INSPECTION_DATE.split(',') : '';
          var ins_obr = this.topTwentyObservationCsvData.data[i].INSPECTION_OBSERVATION ? this.topTwentyObservationCsvData.data[i].INSPECTION_OBSERVATION.split('||') : '';
          var ins_vsl = this.topTwentyObservationCsvData.data[i].VESSEL_NAME ? this.topTwentyObservationCsvData.data[i].VESSEL_NAME.split('||') : '';
          var ins_port = this.topTwentyObservationCsvData.data[i].PORT_OF_INSPECTION ? this.topTwentyObservationCsvData.data[i].PORT_OF_INSPECTION.split('||') : '';
          var ins_oil_major = this.topTwentyObservationCsvData.data[i].OIL_MAJOR ? this.topTwentyObservationCsvData.data[i].OIL_MAJOR.split('||') : '';
          for(var n = 0; n < ins_date.length;n++){
            data[i]['detail'][n] = [];
            data[i]['detail'][n]['INSPECTION_DATE'] = ins_date[n];
            data[i]['detail'][n]['INSPECTION_OBSERVATION'] = ins_obr[n];
            data[i]['detail'][n]['VESSEL_NAME'] = ins_vsl[n];
            data[i]['detail'][n]['PORT_OF_INSPECTION'] = ins_port[n];
            data[i]['detail'][n]['OIL_MAJOR'] = ins_oil_major[n];
            
          }
          
        }
        this.topTwentyObservationData = data;
        this.generatcsv();        
        
      }
      else{
        this.topTwentyObservationData = [];
        alert(this.topTwentyObservationCsvData.message);
      }
    })
  } 

  generatcsv(){
    let postObj = {
      data : this.topTwentyObservationCsvData.data
    }
    this.commonService.sendRequestToNode({method :'post',path:'topTwentyObservation/exportObj',postData:postObj}).subscribe(result => {
      if(result.status){
        window.open(this.commonService.getNodeApi()+'/topTwentyObservation/export', '_blank' );
      } 
    })
  }

   applyFilterForObservationChart() {
    if(this.filterObjObsChart.start_date > this.filterObjObsChart.end_date){
      alert('Please Enter Valid Date');
    } else {
      this.getData( this.filterObjObsChart );
      this.modalRef.close();
    }
   }

}
