import { Component, OnInit, ViewChild,ElementRef, ɵConsole } from '@angular/core';
import { CommonService } from '../common-service.service';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
// import swal from 'sweetalert2';
import { NgbTabset } from '@ng-bootstrap/ng-bootstrap';
// import html2canvas from 'html2canvas';
import { saveAs } from 'file-saver';
// //this is define because some issue in retention page(when load this page and go)
// import * as pluginAnnotations from 'chartjs-plugin-annotation';
// import 'chartjs-plugin-labels';
// //import { GoogleChartComponent } from 'angular-google-charts';

@Component({
  selector: 'training-planning-reports',
  templateUrl: './training-planning-reports.component.html',
  styleUrls: ['./training-planning-reports.component.css']
})
export class TrainingPlanningReportsComponent implements OnInit {

  ngOnInit() {
     this.vesselFleetDropdown();
     this.vesselOwnerDropdown();
     this.getVesselData();
     this.vesselGroupDropdown();
     this.yearDropdown();
  }

    tabStatus = 'justified';
    public saved_reports = [
      { ID: 'home_page', ITEM: "SUPERINTENDENT VISIT PLANNING" },
      { ID: 'vessel_history', ITEM: "VESSEL ACTIVITY REPORT" },
      { ID: 'consolidated_vessel_plan', ITEM: "CONSOLIDATED PLANNING FOR VESSEL" },
      { ID: 'planner_or_completed_one_year', ITEM: "COMPLETED / PLANNING FOR 1 YEAR" },
      { ID: 'planner_or_completed_three_year', ITEM: "CONSOLIDATED 3 YEAR REPORT ( 2 YEAR COMPLETED AND 1 YEAR PLANNING )" },
  ];

    public isRiskCompany = false;
    public Selected_Template = 'home_page';
    public expanded = [];
    public totalItems;
    public activitiesData;
    public vesselFleet_dropdown = [];
    public vesselOwner_dropdown = [];
    public ColorCodingClass =  "";
    public VesselData = [];
    public vessel_dropdown_obj = {} // get Name From Id
    public vesselGroup_dropdown = [];
    public vesselGroup_dropdown_obj = [];
    public vesselOwner_dropdown_obj = [];
    public vesselFleet_dropdown_obj = [];
    public UserDetailData = [];
    public InspectionType = [];
    public selected = '';
    public tempReportData = [];
    public vessel_dropdown_export = [];
    public generateOneYeatPlannedReport = [];
    public generateDataForFuturePlan = [];
    public yearData = new Date().getFullYear() - 6;
    public yearRange = [];
    public ActiveElementFlag = false;
    public filterYear:any = {year : new Date().getFullYear(),type : []};
    public defectDamageData = [];
    public VesselDataObj =[];
    public NEXT_DUE;
    public nextPortDateData = [];
    public remarkData = [];
    public validMark = false;

// public generate_report_id = [];
    public generateReportData  = [];
    public generateReportData1 = [];
// public lineChartColors: Array<any> = [];
    public filterObj = {
        from_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))),
        to_date: this.commonService.formatDate(new Date()),
        fleet: [],
        owner: [],
        group: [],
        VESSEL_FK: [],
        threeYearPlan : false,
        USER_TYPE : null,
        yearCompleted: null,
        yearPlanned: null
    }

 
//public modalObj:any = {};
public modalRef: NgbModalRef;

constructor( private commonService: CommonService, private modalService: NgbModal, public tabset: NgbTabset ) {
            
}
//     @ViewChild('screen') screen: ElementRef;
//     @ViewChild('canvas') canvas: ElementRef;
//     @ViewChild('downloadLink') downloadLink: ElementRef;
    @ViewChild('tabs')
    private tabs: NgbTabset;

vesselFleetDropdown() {
  // if (this.vesselFleet_dropdown.length <= 0) {
   let filterParams = JSON.parse(JSON.stringify(this.filterObj));

    this.commonService.sendRequestToNode({ method: 'get', path: 'fleet/fleet-dropdown' , queryParam:filterParams}).subscribe(result => {
      if (result.status) {
        this.vesselFleet_dropdown = result.data;
        this.vesselFleet_dropdown.forEach(ele => {
          this.vesselFleet_dropdown_obj[ele.ID] = ele.FLEET_NAME;
        })
      }
      else {
        this.vesselFleet_dropdown = [];
      }
    })
  // }
}

vesselOwnerDropdown() {
  // if (this.vesselOwner_dropdown.length <= 0) {
   let filterParams = JSON.parse(JSON.stringify(this.filterObj));
    this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselOwner',queryParam: filterParams }).subscribe(result => {
      if (result.status) {
        this.vesselOwner_dropdown = result.data;
        this.vesselOwner_dropdown.forEach(ele => {
          this.vesselOwner_dropdown_obj[ele.ID] = ele.COMPANY_NAME;
        })
      }
      else {
        this.vesselOwner_dropdown = [];
      }
    });
  // }
}

getVesselData(selected_template = null ) {
  let filterParams = JSON.parse(JSON.stringify(this.filterObj));
  filterParams.ACTIVE_FLAG = 1;
  this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-dropdown',queryParam:filterParams }).subscribe(result => {
    if(result.status) {
      if( selected_template && selected_template == 'vessel_history' ) {
        this.VesselData = result.data;
      } else {
        if(result.data.length > 0 ) {
          this.VesselData = [{VESSEL_NAME : 'All Vessels',ID : 'ALL'},...result.data];
        }
        this.vessel_dropdown_export = [...result.data];
        this.VesselData.forEach(ele => {
          this.vessel_dropdown_obj[ele.ID] = ele.VESSEL_NAME;
        })
      }
        

    } else {
      this.VesselData = [];
      alert(result.message);
    }
  })
}

yearDropdown() {
   var range = [];
   range.push( this.yearData );
   for (var i = 1; i < 20; i++) {
      range.push(this.yearData + i);
   }
   this.yearRange = range;
}

vesselGroupDropdown() {
  // if (this.vesselGroup_dropdown.length <= 0) {
    let filterParams = JSON.parse(JSON.stringify(this.filterObj));
    this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselGroup',queryParam:filterParams}).subscribe(result => {
      if (result.status) {
        this.vesselGroup_dropdown = result.data;
        this.vesselGroup_dropdown.forEach(ele => {
          this.vesselGroup_dropdown_obj[ele.ID] = ele.GROUP_NAME;
        })
      } else {
        this.vesselGroup_dropdown = [];
      }
    });
  // }
}

toggle(i) {
  this.expanded[i] = !this.expanded[i];
}

getDataforPdf() {
  // vessel_dropdown_obj:this.vessel_dropdown_obj, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj
  this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateReportPdf', postData: {generateReportData: this.generateReportData,filterObj :this.filterObj,vessel_dropdown_obj:this.vessel_dropdown_obj, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj }},{ responseType: 'blob' }).subscribe(result => {
      saveAs(result, `VesselActivitiesReport.pdf`)
  })
}

getDataforcsv() {
  this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateReportCsv', postData: this.generateReportData },{ responseType: 'blob' }).subscribe(result => {
      saveAs(result, `Seagraphsreport.xlsx`)
  })
}

resetFilterObj() {
    this.filterObj.from_date = this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1)));
    this.filterObj.to_date = this.commonService.formatDate(new Date());
    this.filterObj.fleet = [];
    this.filterObj.owner= [];
    this.filterObj.group= [];
    this.filterObj.VESSEL_FK= [];
    this.filterObj.threeYearPlan = false;
    this.filterObj.USER_TYPE = null;
    this.filterObj.yearCompleted = null;
    this.filterObj.yearPlanned= null;
}

select_template( e ) {
  this.resetFilterObj();
  this.selected = "selected";
  this.Selected_Template = e;
  this.getVesselData(e);
  if( e == 'vessel_history' ) {
    this.ActiveElementFlag = false;
   } else if( e == 'consolidated_vessel_plan' ) {
    this.ActiveElementFlag = true;
   } else if( e == 'planner_or_completed_one_year' ) {
        this.ActiveElementFlag = true;
   } else if( e == 'planner_or_completed_three_year') {
        this.ActiveElementFlag = true;
   } else if( e == 'home_page') {
    //  this.filterObj.USER_TYPE = 1;
     this.ActiveElementFlag = false;
   }
}

selectedTemplated( e ) {
   this.filterVesselName();
    
     if( e == 'vessel_history' ) {
        if(this.filterObj.from_date > this.filterObj.to_date ){
          alert('Please Enter Valid Date');
        } else if(  this.filterObj.VESSEL_FK &&  typeof this.filterObj.VESSEL_FK == 'number'  && this.filterObj.VESSEL_FK != null ) {
              this.generateReport();
        } else  {
            alert('Vessel is required.');
        }
     } else if( e == 'consolidated_vessel_plan' ) {
          this.ActiveElementFlag = true;
          if( this.filterObj.yearCompleted &&  this.filterObj.VESSEL_FK && this.filterObj.VESSEL_FK.length > 0 ) {
            this.consolidatedPlanningForMulitpleVesselReport();
          } else {
            alert('Year and Vessel is Required.')
          }
          
     } else if( e == 'planner_or_completed_one_year' ) {
          this.ActiveElementFlag = true;
          if( this.filterObj.yearCompleted  && this.filterObj.VESSEL_FK && this.filterObj.VESSEL_FK.length > 0 ) {
            this.plannedCompletedOneYearReport();
          } else {
            alert('Year and Vessel is Required.');
          }
     } else if( e == 'planner_or_completed_three_year') {
          this.ActiveElementFlag = true;
          if( this.filterObj.yearCompleted && this.filterObj.yearPlanned && this.filterObj.VESSEL_FK && this.filterObj.VESSEL_FK.length > 0 ) {
            this.consolidatedPlanningForThreeYear();
          } else {
            alert('Year and Vessel is Required.');
          }
     } else if( e == 'home_page') {
          if(  this.filterObj.USER_TYPE && this.filterObj.VESSEL_FK && this.filterObj.VESSEL_FK.length > 0) {
            this.generateHomePage();
          } else {
            alert('Type and Vessel is Required.')
          }
      // this.filterObj.USER_TYPE = 1;
          
     }
}

filterVesselName() {
  this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-name',queryParam:{VESSEL_FK: this.filterObj.VESSEL_FK} }).subscribe(result => {
    if(result.status) {
       this.VesselDataObj = result.data;

    } else {
      this.VesselDataObj = [];
      alert(result.message);
    }
  
  
  });

 }

generateHomePage() {
  this.nextPortDateData = [];
  this.remarkData = [];
  this.tabs.select('step2');
  // if( this.filterObj.VESSEL_FK || this.filterObj.VESSEL_FK.length > 0  ) {

    this.commonService.sendRequestToNode({ method: 'get', path: 'configuration/list' }).subscribe(res => {
      if( res.status ) {
        if( res.data.length ) {
          if (2 == this.filterObj.USER_TYPE ) {
            this.NEXT_DUE = res.data[0].TRAINING_PLANNING_MONTH_FOR_MARINE;
          } else if (3 == this.filterObj.USER_TYPE ) {
            this.NEXT_DUE = res.data[0].TRAINING_PLANNING_MONTH_FOR_ONBOARD;
          } else {
            this.NEXT_DUE = res.data[0].TRAINING_PLANNING_MONTH_FOR_TECHNICAL;
          }
          
              this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/list', queryParam: this.filterObj }).subscribe(result => {
                // this.showLoader = false;
                if( result.status ) {
                  if (result.data.length > 0) {
                    this.totalItems = result.data[0].total_records;
                    result.data.forEach((element, k) => {
                      this.expanded.push( false );

                      if(2 == this.filterObj.USER_TYPE ) {
                        var Newdate = element.LAST_VISITED_MARINE_DATE;
                      } else if(3 == this.filterObj.USER_TYPE ) {
                        var Newdate = element.LAST_VISITED_ONBOARD_DATE;
                      } else {
                        var Newdate = element.LAST_VISITED_TECHNICAL_DATE;
                      }
                      if( Newdate ) {
                        this.getDateUserVise( this.NEXT_DUE, Newdate, element );
                        
                      }

                      if( element.NEXT_PORT_INFO ) {
                        var tempObjectNextPort = (this.commonService.isJson( element.NEXT_PORT_INFO )) ? JSON.parse( element.NEXT_PORT_INFO ) : '';
                        var strNextInfo = '';
                        var strSuperitendent = [];
                        var strRemark = '';
                        var strNextInfoPdf ='';
                        var tempRemark = [];
                        var tempNextPort = [];
                        if( tempObjectNextPort ) {
                          tempObjectNextPort.forEach( e => {
                            strNextInfoPdf += e.PORT_NAME + " - " + e.DATE + "\n";
                            strNextInfo = e.PORT_NAME + " - " + e.DATE + "\n";
                            strSuperitendent.push( e.USER_FK );
                            strRemark += e.REMARK + "\n";
                            tempRemark.push( e.REMARK );
                            tempNextPort.push( strNextInfo )
                            this.nextPortDateData.push( { 'vessel_id': element.VESSEL_FK , 'nextport_date' : strNextInfo} );
                            this.remarkData.push( { 'vessel_id': element.VESSEL_FK , 'pdfRemark' : e.REMARK} );
                          });
                        }
                         result.data[k].NEXT_PORT_INFO_PDF = strNextInfoPdf;
                        result.data[k].NEXT_PORT_INFO = tempNextPort;
                        result.data[k].SUPERINTENDENT = ( strSuperitendent.length > 0 ) ? true : false;
                        result.data[k].RECORDED_REMARK_PDF = strRemark;
                        result.data[k].RECORDED_REMARK = tempRemark;
                        
                      }
                    });
                    this.defectDamageData = result.data;
                  } else {
                    this.totalItems = 0;
                    this.defectDamageData = [];
                  }
                }
                else {
                  this.totalItems = 0;
                  this.defectDamageData = [];
                  alert(result.message);
                }
              })

            }
          }
        })
  // }
}

getDateUserVise(month, LastDate, m) {
  if (LastDate && LastDate != "0000-00-00 00:00:00") {
    var lastSireDate = new Date(LastDate);
    lastSireDate.setHours(0, 0, 0, 0);
    let next_due_date = new Date(LastDate);
    var mm = lastSireDate.getMonth() + parseInt(month);
    next_due_date.setMonth(mm);
    let test_month = mm;
    if (mm >= 12) {
      test_month = Math.abs(12 - mm);
    }
    if (next_due_date.getMonth() != test_month) {
      if( mm < 12 ) {
        next_due_date.setMonth(mm + 1, 0);
      } else {
        next_due_date.setMonth((mm - 12) + 1, 0);
      }
    }
    m.NEXT_DUE_DATE = ('0' + (next_due_date.getDate())).slice(-2) + '/' + ('0' + (next_due_date.getMonth() + 1)).slice(-2) + '/' + next_due_date.getFullYear();
    var today1 = new Date();
    today1.setHours(0, 0, 0, 0);

    // this is for Last Sire Date TO Today date diff
    if (today1.getTime() - lastSireDate.getTime() > 0) {

      //day count (today to last sire Date)
      var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
      var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24));
      //calculation of color coding
      var percDay = (diffDaysOFLastSire * 100) / (parseInt(month) * 30)

    }

    if (percDay >= 83.34) {
      m.BG_COLOR = 'bg-myred';
    } else if (percDay >= 50.01) {
      m.BG_COLOR = 'bg-myorange';
    } else {
      m.BG_COLOR = 'bg-mygreen';
    }
    m.NEXT_DUE_DATE = {value:m.NEXT_DUE_DATE,color:m.BG_COLOR}; 

  }
}

generateReport() {
  let from_time = new Date(this.filterObj.from_date).getTime();
  let to_time = new Date(this.filterObj.to_date).getTime();
 
  this.tabs.select('step2');
    if( this.filterObj.VESSEL_FK || this.filterObj.VESSEL_FK.length > 0  ) {
       this.filterObj.USER_TYPE = null;
        this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateReport', postData:{ filter: this.filterObj }}).subscribe(result => {
            if( result.status ) {
             
        //       this.totalItems = result.data[0].total_records;
                result.data.forEach(( element, k) => {
                  var tempActivitiesOfHistory = [];
                  this.expanded.push( false )
                   this.commonService.sendRequestToNode({method :'get',path:'get-single-training-history/'+ element.ID }).subscribe(res => {
                     result.data[k].ACTIVITIES = res.activityDetailArr
                     
                     res.activityDetailArr.forEach((e1, k1 ) =>{

                          let filterParams: any = {}
                          filterParams.inspection_id  = e1.ID;
                          filterParams.vessel_id      = this.filterObj.VESSEL_FK;
                          filterParams.start_date     = e1.START_DATE;
                          filterParams.end_date       = e1.END_DATE;
                        this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/activity_wise_no_of_oberservation', queryParam: filterParams }).subscribe(result1 => {
                          if( result1.data.length > 0  ) {
                            result.data[k].ACTIVITIES[k1].NO_OF_OBSERVATION  = result1.data[0].no_of_obs;
                            result.data[k].ACTIVITIES[k1].NO_OF_OPEN_OBSERVATION = result1.data[0].open_obs;
                            result.data[k].ACTIVITIES[k1].NO_OF_CLOSE_OBSERVATION = result1.data[0].close_obs;
                          }
                        });
                     });
                   });
                });
                this.generateReportData = result.data;
             
                //         if( redirect ) {
                //             this.tabs.select('step2');
                //         }
            } else {
                this.generateReportData = [];
                alert(result.message);
            }
        });
    } else {
        this.generateReportData = [];
         alert( 'Select Vessel Name');
    }
}

consolidatedPlanningForMulitpleVesselReport() {
  this.tempReportData = [];
  this.generateReportData1 = [];
  
      this.tabs.select('step2');
      this.getInspectionType();
      if( this.filterObj.VESSEL_FK || this.filterObj.VESSEL_FK.length > 0  ) {
        this.filterObj.USER_TYPE = null;
          this.commonService.sendRequestToNode({method :'get', path:'training-plan',queryParam : this.filterObj }).subscribe(
            result => {
              if(result.status)  { 
                      if( result.data.length > 0 ) {
                        var planningReportData = result.data;
                        this.filterObj.VESSEL_FK.forEach( (ele_new) => {
                            planningReportData.forEach( ( ele1, key1 ) => {
                                if( ele_new == ele1.VESSEL_FK ) {
                                      if( this.tempReportData.length <= 0 ) {
                                        let arrPlanData1 = { 'vessel_fk': ele1.VESSEL_FK , 'vessel_name' : ele1.VESSEL_NAME };
                                        this.tempReportData.push( arrPlanData1 );
                                        } else {
                                          this.tempReportData.forEach(( e, k)=>{
                                            if(this.tempReportData.some(person => person.vessel_fk == ele1.VESSEL_FK)){
                                                console.log("Object found inside the array.");
                                            } else {
                                                let arrPlanData1 = { 'vessel_fk': ele1.VESSEL_FK , 'vessel_name' : ele1.VESSEL_NAME };
                                                this.tempReportData.push( arrPlanData1 );
                                            }
                                          })
                                        }
                                } else {
                                      if( this.tempReportData.length <= 0 ) {
                                        let arrPlanData1 = { 'vessel_fk': ele_new , 'vessel_name' : this.vessel_dropdown_obj[ele_new] };
                                        this.tempReportData.push( arrPlanData1 );
                                      } else {
                                        this.tempReportData.forEach(( e, k)=>{
                                          if(this.tempReportData.some(person => person.vessel_fk == ele_new)){
                                              console.log("Object found inside the array.");
                                          } else {
                                              let arrPlanData1 = { 'vessel_fk': ele_new , 'vessel_name' : this.vessel_dropdown_obj[ele_new] };
                                              this.tempReportData.push( arrPlanData1 );
                                          }
                                        })

                                      }
                                }
                                  
                            });
                        } );
                          //  planningReportData.forEach( ( ele1, key1 ) => {
                          //      if( this.tempReportData.length <= 0 ) {
                          //       let arrPlanData1 = { 'vessel_fk': ele1.VESSEL_FK , 'vessel_name' : ele1.VESSEL_NAME };
                          //       this.tempReportData.push( arrPlanData1 );
                          //      } else {
                          //         this.tempReportData.forEach(( e, k)=>{
                          //           if(this.tempReportData.some(person => person.vessel_fk == ele1.VESSEL_FK)){
                          //               console.log("Object found inside the array.");
                          //           } else {
                          //               let arrPlanData1 = { 'vessel_fk': ele1.VESSEL_FK , 'vessel_name' : ele1.VESSEL_NAME };
                          //               this.tempReportData.push( arrPlanData1 );
                          //           }
                          //         })
                          //      }
                          //   });

                        this.generateReportData1 = result.data;
                      }
              } else {
                    this.tempReportData = [];
                //     alert(result.message);
                  }
          })
      } else {
          this.generateReportData1 = [];
           alert( 'Select Vessel Name');
      }

}

getInspectionType() {
  this.commonService.sendRequestToNode({method :'get',path:'inspection-type-dropdown',queryParam:{ACTIVITY_TRAINING_FLAG:1}}).subscribe(result1 => {
    if(result1.status){   
      this.InspectionType = result1.data;
    }else{
      this.InspectionType = [];
      alert(result1.message);
    }
  })
}

getDataForPlanPdf() {
    this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generatePlanReportPdf', postData:{ tempReportData : this.tempReportData, generateReportData1: this.generateReportData1 ,filterObj: this.filterObj, InspectionType :this.InspectionType, vessel_dropdown_obj:this.vessel_dropdown_obj, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj } },{ responseType: 'blob' }).subscribe( result => {
      saveAs(result, `ConsolidatedPlanningReport.pdf`)
    })
}

getGeneralData() {
   if( this.NEXT_DUE <= 0 ) {
    this.NEXT_DUE = '0';
   }
  this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateDataReportPdf', postData:{ generateReportData : this.defectDamageData, filterObj: this.filterObj, NEXT_DUE : this.NEXT_DUE, vessel_dropdown_obj:this.vessel_dropdown_obj, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj, nextPortDateData: this.nextPortDateData, remarkData:this.remarkData } },{ responseType: 'blob' }).subscribe( result => {
    saveAs(result, `SuperintendentVisitPlanningReport.pdf`)
  })
}
 
plannedCompletedOneYearReport() {
   this.validMark =false;
      this.tabs.select('step2');
       if( this.filterObj.VESSEL_FK || this.filterObj.VESSEL_FK.length > 0 ) {
          this.filterObj.USER_TYPE = null;
          this.commonService.sendRequestToNode({method :'get',path:'user', queryParam: { ACTIVE_FLAG: 1}}).subscribe( res1 => { 
           if( res1.status ) {
              if( res1.data.length > 0 ) {
                 this.UserDetailData = res1.data; 
              } else {
                 this.UserDetailData = [];
              }
           }
         });
          this.commonService.sendRequestToNode({method :'get', path:'training-history-for-all-vessel',queryParam :  this.filterObj }).subscribe(
            result => {
              if( result.status ) { 
                      this.commonService.sendRequestToNode({method :'get', path:'training-plan',queryParam : this.filterObj }).subscribe(
                      res => {
                            this.generateDataForFuturePlan = res.data;
                      });
                     
                      if( result.data.length > 0 ) {
                            // ----------------------------------------------------------
                              // var  PdfTempArr = result.data;
                              // var monthwiseArray = [];

                            // ---------------------------------------------------------
                            var tempDataArr = result.data;
                            var VesselArr   = [];
                            var historyIds;
                            this.VesselDataObj.forEach((e, k  )=> {
                            // this.filterObj.VESSEL_FK.forEach( ( e ) => {
                              //  VesselArr[e] = [];
                              VesselArr[e.ID] = [];

                              historyIds = [];
                                tempDataArr.forEach( ( element, key ) => {
                                    if( e.ID == element.VESSEL_FK ) {
                                            if( element.USER_TYPE == 'marine_superintendent' ) {
                                                if( element.IS_DRY_DOCK == 1 ) {
                                                  element.ColorCodingClass = 'on_board_port';
                                                } else if( element.PORT_FROM_ID == element.PORT_TO_ID ) {
                                                  element.ColorCodingClass = 'es-ms-visit-layuo-dd';
                                                } else {          
                                                  element.ColorCodingClass = 'on_board-sailing';     
                                                }
                                            } else if( element.USER_TYPE == 'technical_superintendent' ) {      
                                                if( element.IS_DRY_DOCK == 1 ) {               
                                                  element.ColorCodingClass = 'ia-napa-obt-ms-visit';
                                                } else if( element.PORT_FROM_ID == element.PORT_TO_ID ) {
                                                  element.ColorCodingClass = 'es-visit-in-port';
                                                } else {
                                                  element.ColorCodingClass = 'es-visit-sailing';
                                                }    
                                            } else if( element.ON_BOARD_TRAINING_FLAG == 1 ) {
                                                if( element.IS_DRY_DOCK == 1 ) {
                                                  element.ColorCodingClass = 'technical_sailing';
                                                } else if( element.PORT_FROM_ID == element.PORT_TO_ID ) {
                                                  element.ColorCodingClass = 'on_board_dry_dock';
                                                } else {
                                                  element.ColorCodingClass = 'technical_port';
                                                }
                                            }
                                       VesselArr[e.ID].push( element );
                                       this.validMark = true;
                                    }
                                    historyIds.push( element.ID );
                                });
                            });

                            //  if( historyIds && historyIds.length > 0 ) {
                              this.commonService.sendRequestToNode({method :'post', path:'training-activities-by-history_ids',postData : {'historyIds': historyIds } }).subscribe(
                                result1 => {
                                  this.activitiesData = result1.data;
                              });
                            //  }

                          // VesselArr.sort((a,b) => a.VESSEL_NAME.sort(b.VESSEL_NAME));
                          this.generateOneYeatPlannedReport = VesselArr;
                          console.log( this.validMark );
                          this.generateOneYeatPlannedReport.forEach((e, k) => {
                              Object.keys(k).forEach(element => {
                              });
                          });
                      }
              } else {
              
              }
          });
      } else {
          this.generateReportData1 = [];
           alert( 'Select Vessel Name');
      }
}

getPlannedCompletedOneYearReportPdf() {
  this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generatePlannedCompletedOneYearReportPdf', postData: { generateDataForFuturePlan : this.generateDataForFuturePlan, activitiesData :this.activitiesData, generateOneYeatPlannedReport: this.generateOneYeatPlannedReport , filterObj :this.filterObj,vessel_dropdown_obj:this.vessel_dropdown_obj, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj, UserDetailData: this.UserDetailData } },{ responseType: 'blob' }).subscribe(result => {
      saveAs(result, `CompletedPlannedReportForOneYear.pdf`);
  });
}

getPlannedCompletedThreeYearReportPdf() {
  this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generatePlannedCompletedThreeYearReportPdf', postData: { generateDataForFuturePlan : this.generateDataForFuturePlan, activitiesData :this.activitiesData, generateOneYeatPlannedReport: this.generateOneYeatPlannedReport , filterObj :this.filterObj,vessel_dropdown_obj:this.vessel_dropdown_obj, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj, UserDetailData: this.UserDetailData } },{ responseType: 'blob' }).subscribe(result => {
      saveAs(result, `CompletedPlannedReportForThreeYear.pdf`);
  });
}

consolidatedPlanningForThreeYear() {
  this.filterObj.threeYearPlan = true;
  this.plannedCompletedOneYearReport();       
}

changeYear(i) {
  this.filterYear.year = this.filterYear.year + (i);
  this.consolidatedPlanningForThreeYear();
}

change_vessel() {
  let arr = []
  this.filterObj.VESSEL_FK.forEach(ele=>{
    if(ele == 'ALL'){
      arr = this.VesselData.map(e=>{
        return e.ID;
      })
      arr = arr.filter(e=>{
        return !(e == 'ALL');
      })
     
    }
  })
  if(arr.length > 0){
    this.filterObj.VESSEL_FK = arr;
  }
  
  // this.filter()
}

dateCheck() {
  if(this.filterObj.from_date > this.filterObj.to_date ){
    alert('Please Enter Valid Date');
  } 
}

filterLogic(SelectedDropdown) {

  this.vesselOwnerDropdown();
  this.vesselGroupDropdown();
  this.vesselFleetDropdown();
  this.getVesselData( this.Selected_Template );

}
}