import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';
import html2canvas from 'html2canvas';
//import {ExcelService} from './services/excel.service';
//import * as jspdf from 'jspdf';

declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { element } from 'protractor';
import { json } from 'd3';

@Component({
  templateUrl: './training.component.html',
  styleUrls: ['./training.component.scss']
})
export class TrainingComponent implements OnInit {

  public modalRef:NgbModalRef;

  public trainingTypeForm:FormGroup;
  public trainingTypeFormSubmittedAttempt = false;

  public config: PerfectScrollbarConfigInterface = {};
  public uploadPath = this.commonService.getDocumentPath(); 
  public trainingData = [];
  public trainingListPerMonth = [];
  public trainingForm:FormGroup; 
  public edit_id;
  public editData;
  public formSubmittedAttempt = false;
  public openRightSidebar = false;
  public filterObj:any = {year : new Date().getFullYear(),type : []};
  public sortFilter:any = {};
  public viewData = false;
  public showSideBarLoader = false;
  public OLD_USER_FK:any //this is for edit
  public user_dropdown = [];
  public trainingtype_dropdown = [];
  public trainingtype_dropdown_name = [];
  
  public training_viewData;
  public attachmentDisplayData:any = [];
  public showMainLoader = false;
  public showModalLoader = false;
  public showLoader = false;;
  public monthArr = ['01','02','03','04','05','06','07','08','09','10','11','12'];
  //this is for file select object 
  public ObjPerFile:any = {}
  public withoutPaginationData = [];
  public pdfLogo;

  //this is for store ids when click on box
  public dataForIds :any = {};

  //for grid 
  public headerInformation;
  public actionButtons;
  public plan_complete = [{'name':'Plan'},{'name':'Completed'}]
  public txt = '';

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;

  @ViewChild('content') content: ElementRef;
  @ViewChild('fileInput') fi:ElementRef;
  @ViewChild('autofocus') el:ElementRef;

  @ViewChild('screen') screen: ElementRef;
  @ViewChild('canvas') canvas: ElementRef;
  @ViewChild('downloadLink') downloadLink: ElementRef;

  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private router: Router,
    private formBuilder: FormBuilder,
    private route: ActivatedRoute){
      // this.declareGridVariable();
  }


  ngOnInit(){
    this.pdfLogo = location.origin+location.pathname+'assets/images';
    this.getData();
    this.addForm();
    // this.getDataWithoutPagination();
    this.userDropDown();
    this.trainingTypeDropDown();
  }

  userDropDown(){
    
    this.commonService.sendRequestToNode({method :'get',path:'user-dropdown',queryParam:{'allusers':true}}).subscribe(result => {
      if(result.status){
        this.user_dropdown = result.data;
      }
      else{
        this.user_dropdown = [];
        alert(result.message);
      }
    })
  }

  trainingTypeDropDown(id=0){
    let filterParams:any = {
      type : 'shore'
    }
    
    this.commonService.sendRequestToNode({method :'get',path:'trainingtype-dropDown',queryParam:filterParams}).subscribe(result => {
      if(result.status){
        this.trainingtype_dropdown = result.data;
        this.trainingtype_dropdown.forEach(ele=>{
          this.trainingtype_dropdown_name[ele.ID] = ele.TRAINING_TYPE;
        })
        if(id){
          this.trainingForm.patchValue({
            TRAINING_TYPE_FK : id 
          })
        }
      }
      else{
        this.trainingtype_dropdown = [];
        alert(result.message);
      }
    })
  }

    getData()
  {
    this.getDataWithoutPagination();
    this.showLoader = true;
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //alert(filterParams)
    let data = {};
    this.trainingData = [];
    this.commonService.sendRequestToNode({method :'get',path:'training',queryParam:filterParams}).subscribe(
      result => {
        if(result.status)
        {
          this.trainingData = [];
          this.showLoader = false;
          if(result.data.length > 0){
            // this.totalItems = result.data[0].total_records;
            //console.log(result.data);
            result.data.forEach(element => {
              if(data[element.USER_FK]){
                data[element.USER_FK].monthWise[element.month] = {
                  'totalTraining' : element.total_training,
                  'Ids' : element.Ids
                }
                data[element.USER_FK].Ids += ','+element.Ids 
              }    
              else{
                data[element.USER_FK] = {
                  monthWise : {
                    [element.month]: {
                      'totalTraining' : element.total_training,
                      'Ids' : element.Ids
                    }
                  },
                  Ids : element.Ids, 
                  FULL_NAME : element.FULL_NAME
                }
              }
            });
            
            Object.keys(data).forEach(key=>{
              this.trainingData.push(data[key]);  
            })
            
          }else{
            this.trainingData = [];
          }
        }
        else{
          this.trainingData = [];
          alert(result.message);
        }
    })
  }
  getDataWithoutPagination()
  {
    this.showLoader = true;
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //alert(filterParams.user)

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end
    let data = {};
    this.trainingData = [];
    this.commonService.sendRequestToNode({method :'get',path:'get-shore-staff-training-report',queryParam:filterParams}).subscribe(result => {
      this.showLoader = false;  
      if(result.status)
        {
          if(result.data.length > 0){
            this.totalItems = result.data[0].total_records;
            this.withoutPaginationData = result.data;
          }else{
            this.withoutPaginationData = [];
          }
        }
        else{
          this.withoutPaginationData = [];
          alert(result.message);
        }
    })
  } 
  getDataforcsv() {
    this.generatcsv();
  }

  
  generatcsv(){
    //console.log(this.withoutPaginationData);
    //search filter 
    let filterParams:any = {}
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //alert(filterParams)
    let postObj = {
      data : this.withoutPaginationData
    }
    //var data = document.getElementById('htmlToString').innerHTML;
    this.commonService.sendRequestToNode({method :'post',path:'training/generateCSVData',queryParam:filterParams, postData:postObj}).subscribe(result => {
      if(result.status){
        window.open(this.commonService.getNodeApi()+'/training/exportCSV', '_blank' );
      } 
    })
  }
  addForm(){

    this.trainingForm = this.formBuilder.group({
      TRAINER_NAME: ['',[Validators.required]],
      USER_FK : [null,[Validators.required]],
      TRAINING_TYPE_FK: null,
      NEXT_DONE_MONTH: 0,
      NEXT_DONE_YEAR: 0,
      TRAINING_START_DATE: ['',[Validators.required]],
      TRAINING_END_DATE: ['',[Validators.required]],
      LOCATION: '',
      REMARKS: '',
      FLAG: '',
    });
    
    this.trainingTypeForm = this.formBuilder.group({
      TRAINING_TYPE: [''],
      FLAG: ['shore'],
    }); 

  }

  resetForm(){
    this.formSubmittedAttempt = false;
    this.openRightSidebar = false;
    this.viewData = false;
    this.edit_id = '';
    this.trainingForm.patchValue({
      TRAINER_NAME : '',
      USER_FK : '',
      TRAINING_TYPE_FK: null,
      NEXT_DONE_MONTH: 0,
      NEXT_DONE_YEAR: 0,
      TRAINING_START_DATE: '',
      TRAINING_END_DATE: '',
      LOCATION: '',
      REMARKS: '',
      FLAG: '',
    })
  }

  edit(id){
    this.openRightSidebar = true;
    this.el.nativeElement.focus();
    this.commonService.sendRequestToNode({method :'get',path:'training/'+id}).subscribe(
      data => {
        this.editData = data.data;  
        data.data.USER_FK = data.data.USER_FK
        data.data.TRAINING_END_DATE = this.commonService.formatDate(new Date(data.data.TRAINING_END_DATE))
        data.data.TRAINING_START_DATE = this.commonService.formatDate(new Date(data.data.TRAINING_START_DATE)) 
        this.trainingForm.patchValue(data.data)
        this.edit_id = id;
      })
    }


  view(id){
    this.viewData = true;
    this.openRightSidebar = true;
    this.showSideBarLoader = true;
    //console.log(id);
    this.commonService.sendRequestToNode({method :'get',path:'training/'+id}).subscribe(result => {
    this.showSideBarLoader = false;      
      if(result.status)
        {
          this.training_viewData = result.data;
        }
        else{
          alert(result.message)
        }
    })
  }

  
  

    delete(id){
      if(id){
        swal({
          title: 'Are you sure?',
          text: "You won't be able to revert this!",
          type: 'warning',
          showCancelButton: true,
          confirmButtonClass: 'btn btn-success',
          cancelButtonClass: 'btn btn-danger',
          confirmButtonText: 'Yes, delete it!',
          buttonsStyling: false
        }).then((result) => {
          if (result.value) {
            this.commonService.sendRequestToNode({method :'delete',path:'training/'+id}).subscribe(
            data => {
            if(data.status){
              var dialogueTitle = "Deleted!"
              if(this.trainingData.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
                if(this.currentPage>1){
                  this.currentPage--;
                }
              }
              this.getData();
              
              //update list
              let idArr = this.dataForIds.Ids.split(',');
              idArr.splice(idArr.indexOf(id),1);
              if(idArr.length == 0){
                this.modalRef.close();
              }
              else{
                this.dataForIds.Ids = idArr.join(); 
                // console.log();
                this.getTrainingList(this.dataForIds);  
              }
              swal({
                  title: dialogueTitle,
                  text: data.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                })
            }         
            
        })
          }
        })      
      }
    }

    onSubmit(){ 
      this.formSubmittedAttempt = true;
      if(this.trainingForm.valid){
      let postData = this.trainingForm.value;
      
        if(postData.TRAINING_START_DATE <= postData.TRAINING_END_DATE){
          this.showSideBarLoader = true;
          if(this.edit_id){  
            postData.OLD_USER_FK = this.OLD_USER_FK;
            
            this.commonService.sendRequestToNode({method :'put',path:'training/'+this.edit_id,postData:postData}).subscribe(
              data =>{
                var dialogueTitle = "Updated!";
                this.showSideBarLoader = false;
                if(data.status){
                  swal({
                      title: dialogueTitle,
                      text: data.message,
                      type: 'success',
                      confirmButtonClass: "btn btn-success",
                      buttonsStyling: false
                    })
                  this.getData();
                  this.resetForm(); //after edit form is reset
                }
                else{
                  alert(data.message);
                }
              })
          }else{
                this.commonService.sendRequestToNode({method :'post',path:'training',postData:this.trainingForm.value}).subscribe(
                data =>{
                  var dialogueTitle = "Inserted!";
                  this.showSideBarLoader = false;
                  if(data.status){
                    swal({
                        title: dialogueTitle,
                        text: data.message,
                        type: 'success',
                        confirmButtonClass: "btn btn-success",
                        buttonsStyling: false
                      })
                    this.getData();
                    this.resetForm(); //after edit form is reset
      
                  }
                  else{
                    alert(data.message);
                  }
              })
            }   
        }
        else{
          alert('End Date Should Be Greater Than Start Date')
        }
      }
        
    } 

  
    
    //part of grid
    funOpenRightSidebar(opt){
      this.el.nativeElement.focus();
      this.openRightSidebar = true; 
      //this.trainingForm.get('FLAG').value=opt;
      this.trainingForm.patchValue({
        FLAG : opt 
      })
      if(opt=="Completed")
        this.txt = "Training";
      else 
        this.txt = "Plan";
      document.getElementById("lbl_training").innerHTML = this.txt;
    }

    onFileChange(event,id) {
      let file = [];
      if(event.target.files.length > 0 && event.target.files.length <= 1) {
        this.ObjPerFile[id] = event.target.files[0];
      }else{
        this.ObjPerFile[id] = '';
        this.fi ? this.fi.nativeElement.value = "" : '';
      }
    }
  
    onSubmitAttachment(){
      this.showModalLoader = true;
      let formData = new FormData();
      Object.keys(this.ObjPerFile).forEach((ele)=>{
        if(this.ObjPerFile[ele]){
          formData.append('ID',ele );
          formData.append('FILE',this.ObjPerFile[ele] );
        }
      })
  
      this.commonService.sendRequestToNode({method :'post',path:'training/upload-attachment',postData:formData}).subscribe(
        data =>{
          var dialogueTitle = "Uploaded!";
          this.showModalLoader = false;
          if(data.status){
            this.ObjPerFile = {};
            swal({
              title: dialogueTitle,
              text : data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            })
            // this.getTrainingList(this.dataForIds)
            this.modalRef.close();
            // this.getData();
            // this.openRightSidebar = false;
            // this.resetForm();
          }
          else{
            alert(data.message)
          }
          
        })
      
    }

    removeUploadedFile(id,fileName){
      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, remove it!',
        buttonsStyling: false
      }).then((result) => {
        if (result.value) {
          this.commonService.sendRequestToNode({method :'post',path:'training/remove-attachment/'+id,postData:{file:fileName}}).subscribe(
            result =>{
              this.getTrainingList(this.dataForIds);
              var dialogueTitle = "Success!";
              swal({
                title: dialogueTitle,
                text : result.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            })
        }
      })
      
    }
    getTrainingList(data){
      this.showMainLoader = true;
      this.commonService.sendRequestToNode({method :'get',path:'get-training-list',queryParam : {Ids : data.Ids}}).subscribe(result => {
         if(result.status)
          {
            this.showMainLoader = false;
            this.showModalLoader = false;
            this.trainingListPerMonth = result.data;
          }
          else{
            alert(result.message)
          }
        })
    }
    openModelForTrainingList(content,data) {
      if(data){
        this.dataForIds = data;
        this.getTrainingList(data);
        this.showModalLoader = true;
        this.modalRef = this.modalService.open(content,{size:'lg'});
      }
      
      
      //console.log(id);
      
    }
    changeYear(i){
      this.filterObj.year = this.filterObj.year + (i)
      this.getData() 
    }

    addTrainingType(content){
      this.modalRef = this.modalService.open(content,{size: 'sm'});
    }

    resetTrainingTypeForm(){
      this.trainingTypeFormSubmittedAttempt = false;
      this.trainingTypeForm.patchValue({
        TRAINING_TYPE: null,
      })
    }

    onSubmitTrainingType(){
      //console.log(this.edit_id);
      this.trainingTypeFormSubmittedAttempt = true;
      if(this.trainingTypeForm.valid){
        //console.log(this.Groupinspector.value);
        this.commonService.sendRequestToNode({method :'post',path:'training-type',postData:this.trainingTypeForm.value}).subscribe(
          data =>{
            var dialogueTitle = "Inserted!";
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              }).then(()=>{
                this.modalRef.close();
                this.trainingTypeDropDown(data.insertId);
                this.resetTrainingTypeForm();
              })
              // this.modal.close()
            }else{
              alert(data.message);
            }
        })
      }  
    }

    
    
    generatePdf(){
      var data = document.getElementById('htmlToString').innerHTML;
      // console.log(JSON.stringify(data));
      // console.log(data);
      var htmlData = {'data':data};
      this.commonService.sendRequestToNode({ method: 'post', path: 'training/generatePDFData',postData:htmlData }).subscribe(result => {
        if(result.status){  
          window.location.href = this.commonService.getNodeApi()+'/training-exportPDF';
        }  
      })
    }
    downloadImage(){
      html2canvas(this.screen.nativeElement).then(canvas => {
        this.canvas.nativeElement.src = canvas.toDataURL();
        this.downloadLink.nativeElement.href = canvas.toDataURL('image/png');
        this.canvas.nativeElement.remove();
        this.downloadLink.nativeElement.download = 'Shore-Staff-Training.png';
        this.downloadLink.nativeElement.click();
        
      });
    }
    changeFlag(e){
      //console.log(e)
      this.filterObj.flag = e;
      this.getData();
    }

}

