import { Component, AfterViewInit, OnInit, ElementRef, ViewChild } from '@angular/core';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import { Router } from "@angular/router";
import { FormGroup, FormBuilder, Validators } from '@angular/forms';
import swal from 'sweetalert2';
import { element } from 'protractor';
import { elementStart } from '@angular/core/src/render3/instructions';
import { stringify } from 'querystring';
import { saveAs } from 'file-saver';
import { forEach } from '@angular/router/src/utils/collection';

declare var require: any;

@Component({
  selector: 'trainingReport',
  templateUrl: './trainingReport.component.html',
  styleUrls: ['./trainingReport.component.scss']
})
export class TrainingReportComponent implements OnInit {
  expand: boolean = false;
  public expanded = [];
  public PortDropdown = [];
  public NEXT_DUE;
  public vesselGroup_dropdown = [];
  public defectDamageData = [];
  public country_dropdown = [];
  public vesselGroup_dropdown_obj = [];
  public vesselOwner_dropdown_obj = [];
  public vesselFleet_dropdown_obj = [];
  public InspectionType = [];
  public previousExpanded ;
  public vesselOwner_dropdown = [];
  public vesselFleet_dropdown = [];
  public showSideBarLoader = false;
  public formSubmittedAttempt = false;
  public tempArrObjActivity = [];
  public tempArrObjNextPort = [];
  public vesselHistoryData = [];
  public userData = [];
  public isAuditSave = true;
  public addTrainingHistotyForm: FormGroup;
  public addActivityForm: FormGroup;
  public FilterForm: FormGroup;
  public addPortForm: FormGroup;
  public PRIORITY_FLAG =true;
  public isActivityEnable = true;
  public addNextPortForm: FormGroup;
  public trainingVesselReport: FormGroup;
  public VesselID = null;
  public user_type_id = 1;
  currentPage: number = 1;
  public filterObj : any =  {}
  public vessel_dropdown_name = [];
  public nextPortDateData = [];
  public remarkData = [];

  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  public docPath = this.commonService.getDocumentPath() + '/TrainingActivity';

  totalItems: number;
  isRiskCompany: any = '';
  showLoader = false;
  public copy_date = false;
  public tempDate = new Date();
  public todayDate = new Date();


  public modalRef: NgbModalRef;

  public VesselData = [];
  @ViewChild('fileInput') fi: ElementRef;
 @ViewChild('nextPortFormcontent') nextPortFormcontent
 @ViewChild('portFormcontent') portFormcontent
  constructor(private modalService: NgbModal,
    private formBuilder: FormBuilder,
    private router: Router,
    private commonService: CommonService) {
    this.addForm();
  }

  ngOnInit() {
    this.getData('1');
    this.getPortDropdown();
    this.countryDropDown();
    this.getInspectionType();
    this.userDropDown();
    this.vesselOwnerDropdown();
    this.getVesselData();
    this.vesselFleetDropdown();
    this.vesselGroupDropdown();
  }

  changeMonths(month) {
    this.commonService.sendRequestToNode({ method: 'post', path: 'training-vessel-report/addMonth/' + parseInt(month), postData: { 'user_type': this.user_type_id } }).subscribe(
      data => {
        this.addMonths(month)
      })
  }

  addMonths(month) {
    let months = this.defectDamageData;
    for (let m of months) {
      if (1 == this.user_type_id && m.LAST_VISITED_TECHNICAL_DATE && m.LAST_VISITED_TECHNICAL_DATE != "0000-00-00 00:00:00") {
        this.getDateUserVise(month, m.LAST_VISITED_TECHNICAL_DATE, m);
      } else if (2 == this.user_type_id && m.LAST_VISITED_MARINE_DATE && m.LAST_VISITED_MARINE_DATE != "0000-00-00 00:00:00") {
        this.getDateUserVise(month, m.LAST_VISITED_MARINE_DATE, m);
      } else if (3 == this.user_type_id && m.LAST_VISITED_ONBOARD_DATE && m.LAST_VISITED_ONBOARD_DATE != "0000-00-00 00:00:00") {
        this.getDateUserVise(month, m.LAST_VISITED_ONBOARD_DATE, m);
      }
    }
  }

  getDateUserVise(month, LastDate, m) {
    if (LastDate && LastDate != "0000-00-00 00:00:00") {
      var lastSireDate = new Date(LastDate);
      lastSireDate.setHours(0, 0, 0, 0);
      let next_due_date = new Date(LastDate);
      var mm = lastSireDate.getMonth() + parseInt(month);
      next_due_date.setMonth(mm);
      let test_month = mm;
      if (mm >= 12) {
        test_month = Math.abs(12 - mm);
      }
      if (next_due_date.getMonth() != test_month) {
        if( mm < 12 ) {
          next_due_date.setMonth(mm + 1, 0);
        } else {
          next_due_date.setMonth((mm - 12) + 1, 0);
        }
      }
      m.NEXT_DUE_DATE = ('0' + (next_due_date.getDate())).slice(-2) + '/' + ('0' + (next_due_date.getMonth() + 1)).slice(-2) + '/' + next_due_date.getFullYear();
      
      var today1 = new Date();
      today1.setHours(0, 0, 0, 0);

      // this is for Last Sire Date TO Today date diff
      if (today1.getTime() - lastSireDate.getTime() > 0) {

        //day count (today to last sire Date)
        var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
        var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24));
        //calculation of color coding
        var percDay = (diffDaysOFLastSire * 100) / (parseInt(month) * 30)

      }

      if ( percDay >= 83.34 ) {
        m.BG_COLOR = 'bg-myred';
      } else if ( percDay >= 50.01 ) {
        m.BG_COLOR = 'bg-myorange';
      } else {
        m.BG_COLOR = 'bg-mygreen';
      }
      m.NEXT_DUE_DATE = {value:m.NEXT_DUE_DATE,color:m.BG_COLOR}; 
    }
  }

  getFrequencyActivityVise( LastDate, m, InspectionType) {
    if (LastDate && LastDate != "0000-00-00 00:00:00") {
      var lastSireDate = new Date(LastDate);
      // lastSireDate.setHours(0, 0, 0, 0);
      let next_due_date = new Date(LastDate);
      // var mm = lastSireDate.getMonth() + parseInt(month);
      var mm = lastSireDate.getMonth();

     
      next_due_date.setMonth(mm);

      let test_month = mm;
      if (mm >= 12) {
        test_month = Math.abs(12 - mm);
      }
      if (next_due_date.getMonth() != test_month) {
        if( mm < 12 ) {
          next_due_date.setMonth( mm + 1, 0 );
        } else {
          next_due_date.setMonth( ( mm - 12 ) + 1, 0 );
        }
      }
      InspectionType.forEach((element, k) => {
        
      });

      
   
      // m.NEXT_DUE_DATE = ('0' + (next_due_date.getDate())).slice(-2) + '/' + ('0' + (next_due_date.getMonth() + 1)).slice(-2) + '/' + next_due_date.getFullYear();
      var today1 = new Date();
      today1.setHours(0, 0, 0, 0);

      // this is for Last Sire Date TO Today date diff
      if (today1.getTime() - lastSireDate.getTime() > 0 ) {

        //day count (today to last sire Date)
        var timeDiff = Math.abs(lastSireDate.getTime() - today1.getTime());
        var diffDaysOFLastSire = Math.ceil(timeDiff / (1000 * 3600 * 24));
        //calculation of color coding
        var percDay = (diffDaysOFLastSire * 100) / ( 30);

      }
      if (percDay >= 83.34) {
        m.BG_COLOR_ACT = 'bg-myred';
      } else if (percDay >= 50.01) {
        m.BG_COLOR_ACT = 'bg-myorange';
      } else {
        m.BG_COLOR_ACT = 'bg-mygreen';
      }
    }
  }

  generatePdf() {
    this.filterObj.USER_TYPE = this.filterObj.user_type;
    this.getData( this.filterObj.USER_TYPE, true );
    // this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateDataReportPdf', postData:{ generateReportData : this.defectDamageData, filterObj: this.filterObj, NEXT_DUE:  this.NEXT_DUE  } },{ responseType: 'blob' }).subscribe( result => {
    //   saveAs(result, `GeneralReportData.pdf`)
    // })
}

  getDataforcsv() {
    this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateDataReportCsv', postData:{ generateReportData : this.defectDamageData, filterObj: this.filterObj, NEXT_DUE:  this.NEXT_DUE  } },{ responseType: 'blob' }).subscribe(result => {
        saveAs(result, `SuperintendentVisitPlanningReport.xlsx`)
    })
  }

  toggle(i) {
    
     if( i == this.previousExpanded && this.expanded[i] == true ) {
      this.expanded[this.previousExpanded] = true;
     } else {
      this.expanded[this.previousExpanded] = false;
     }
    
    this.expanded[i] = !this.expanded[i];
    this.previousExpanded = i;


    this.resetForm();
    this.addTrainingHistotyForm = this.formBuilder.group({
      VESSEL_FK: [null],
      USER_FK: [null, Validators.required],
      TRAINNING_ON: false,
      START_DATE: [  this.commonService.formatDate( this.tempDate )],
      END_DATE: [ this.commonService.formatDate(new Date())],
      PORT_FROM: [null, Validators.required],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });

  }

  addForm() {
    this.tempDate.setDate(this.tempDate.getDate() - 1);
    this.addActivityForm = this.formBuilder.group({
      ACTIVITY_ID: [null, Validators.required],
      START_DATE: [null, Validators.required],
      END_DATE: [null, Validators.required],
      RPT_CRT_NO: [null],
      NO_OF_OBSERVATION: [null],
      NO_OF_NCN_OBSERVATION: [null],
      NO_OF_NCN_OPEN_OBSERVATION:[null],
      NO_OF_OPEN_OBSERVATION:[null],
      REMARKS: [null],
      ACTIVITY_NAME: [null],
      ATTACHMENT: ['']
    });

    this.addTrainingHistotyForm = this.formBuilder.group({
      VESSEL_FK: [null],
      USER_FK: [null, Validators.required],
      TRAINNING_ON: false,
      START_DATE: [  this.commonService.formatDate( this.tempDate )],
      END_DATE: [ this.commonService.formatDate(new Date())],
      PORT_FROM: [null, Validators.required],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });

    this.FilterForm = this.formBuilder.group({
      GROUP_NAME: [null],
      FLEET_NAME: [null],
      COMPANY_NAME: [null],
      VESSEL_FK: [null],
      USER_TYPE: '1',
      NEXT_DUE: this.NEXT_DUE,
    });

    this.addPortForm = this.formBuilder.group({
      PORT_NAME: [null, Validators.required],
      PORT_CODE: [null, Validators.required],
      COUNTRY_MST_FK: [null,],
      LATITUDE: [null,],
      LONGITUDE: [null,]
    });

    this.addNextPortForm = this.formBuilder.group({
      REMARK: [null],
      PORT_ID: [null],
      USER_FK: [null],
      USER_NAME: [null],
      PORT_NAME: [null, Validators.required],
      DATE: [null, Validators.required]
    });

    this.trainingVesselReport = this.formBuilder.group({
      VESSEL_FK: [null],
      TRAINNING_HISTORY_FK: [null],
      LAST_VISITED_MARINE_DATE: [null],
      LAST_VISITED_MARINE_FK: [null],
      LAST_VISITED_MARINE_NAME: [null],
      LAST_2_VISITED_MARINE_DATE: [null],
      LAST_2_VISITED_MARINE_FK: [null],
      LAST_2_VISITED_MARINE_NAME: [null],
      LAST_VISITED_TECHNICAL_DATE: [null],
      LAST_VISITED_TECHNICAL_FK: [null],
      LAST_VISITED_TECHNICAL_NAME: [null],
      LAST_2_VISITED_TECHNICAL_DATE: [null],
      LAST_2_VISITED_TECHNICAL_FK: [null],
      LAST_2_VISITED_TECHNICAL_NAME: [null],
      LAST_VISITED_ONBOARD_DATE: [null],
      LAST_VISITED_ONBOARD_FK: [null],
      LAST_VISITED_ONBOARD_NAME: [null],
      LAST_2_VISITED_ONBOARD_DATE: [null],
      LAST_2_VISITED_ONBOARD_FK: [null],
      LAST_2_VISITED_ONBOARD_NAME: [null],
      PRIORITY_FLAG: false,
      NEXT_PORT_INFO: '',

    });

  }

  changePage(page) {
    this.currentPage = page;
    window.scroll(0, 0);
    this.getData();
  }

  getData(user_type: any = null, isPdf:any = false) {
    this.nextPortDateData = [];
    this.remarkData = [];
    this.filterObj.group      = ( this.FilterForm.value.GROUP_NAME && this.FilterForm.value.GROUP_NAME.length > 0) ? this.FilterForm.value.GROUP_NAME: null;
    this.filterObj.fleet      = ( this.FilterForm.value.FLEET_NAME && this.FilterForm.value.FLEET_NAME.length > 0) ? this.FilterForm.value.FLEET_NAME: null;
    this.filterObj.owner      = ( this.FilterForm.value.COMPANY_NAME && this.FilterForm.value.COMPANY_NAME.length > 0) ? this.FilterForm.value.COMPANY_NAME: null;
    this.filterObj.VESSEL_FK  = ( this.FilterForm.value.VESSEL_FK && this.FilterForm.value.VESSEL_FK.length > 0) ? this.FilterForm.value.VESSEL_FK: null;
    
    // pagination
    this.filterObj.currentPage  = this.currentPage - 1;
    this.filterObj.itemsPerPage = this.itemsPerPage;
    // pagination - end
    this.filterObj.user_type = (user_type) ? user_type : '';
    this.filterObj.USER_TYPE = (user_type) ? user_type : '';
    this.filterObj.isPdf     = ( isPdf )   ? isPdf     : false;

    //sorting - end
    this.showLoader = true;

    this.commonService.sendRequestToNode({ method: 'get', path: 'configuration/list' }).subscribe(res => {
      if( res.status ) {
        if( res.data.length ) {
          if( 1 == this.user_type_id ) {
            this.NEXT_DUE = res.data[0].TRAINING_PLANNING_MONTH_FOR_TECHNICAL;
          } else if( 2 == this.user_type_id) {
            this.NEXT_DUE = res.data[0].TRAINING_PLANNING_MONTH_FOR_MARINE;
          } else if( 3 == this.user_type_id) {
            this.NEXT_DUE = res.data[0].TRAINING_PLANNING_MONTH_FOR_ONBOARD;
          }
          this.FilterForm.patchValue({
            NEXT_DUE: this.NEXT_DUE
          })
          //....
          this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/list', queryParam: this.filterObj }).subscribe(result => {
            this.showLoader = false;
            if( result.status ) {
              if (result.data.length > 0) {
                this.totalItems = result.data[0].total_records;
                result.data.forEach((element, k) => {
                  this.expanded.push( false )
                  this.getActivityStatus( element.ID, element )
                  if( 1 == this.user_type_id ) {
                    var Newdate = element.LAST_VISITED_TECHNICAL_DATE;
                  } else if(2 == this.user_type_id) {
                    var Newdate = element.LAST_VISITED_MARINE_DATE;
                  } else if(3 == this.user_type_id) {
                    var Newdate = element.LAST_VISITED_ONBOARD_DATE;
                  } 
                  if( Newdate ) {
                    // this.getFrequencyActivityVise( Newdate, element, this.InspectionType );
                    this.getDateUserVise( this.NEXT_DUE, Newdate, element );
                  }
                  if( element.NEXT_PORT_INFO ) {
                    var tempObjectNextPort = (this.commonService.isJson( element.NEXT_PORT_INFO )) ? JSON.parse( element.NEXT_PORT_INFO ) : '';
                    var strNextInfo = '';
                    var strRemark = '';
                    var strNextInfoPdf ='';
                    var strSuperitendent = [];
                    var tempRemark = [];
                    var tempNextPort = [];

                    if( tempObjectNextPort ) {
                      tempObjectNextPort.forEach(e => {
                        strNextInfoPdf += e.PORT_NAME + ' - ' + e.DATE + '\n';
                        strNextInfo = e.PORT_NAME + ' - ' + e.DATE + '\n';
                        strRemark += e.REMARK + "\n";
                        strSuperitendent.push( e.USER_FK );
                        tempRemark.push( e.REMARK );
                        tempNextPort.push( strNextInfo )
                         this.nextPortDateData.push( { 'vessel_id': element.VESSEL_FK , 'nextport_date' : strNextInfo} );
                         this.remarkData.push( { 'vessel_id': element.VESSEL_FK , 'pdfRemark' : e.REMARK} );
                      });
                    }
                    result.data[k].NEXT_PORT_INFO = tempNextPort;
                    result.data[k].NEXT_PORT_INFO_PDF = strNextInfoPdf;
                    result.data[k].SUPERINTENDENT = (strSuperitendent.length > 0) ? true : false;
                    result.data[k].RECORDED_REMARK = tempRemark;
                    result.data[k].RECORDED_REMARK_PDF = strRemark;

                  }
                  
                  
                });
                // this.getData( this.filterObj.user_type );
                this.defectDamageData = result.data;
                if(isPdf && isPdf == true ) { 
                  this.generatePdfReport( this.defectDamageData );
                }

              } else {
                this.totalItems = 0;
                this.defectDamageData = [];
              }
            }
            else {
              this.totalItems = 0;
              this.defectDamageData = [];
              alert(result.message);
            }
          })
          //....end

        }
      }
    })
  }
  generatePdfReport( data ) {
    this.commonService.sendRequestToNode({ method: 'post', path: 'training-planning-reports/generateDataReportPdf', postData:{ generateReportData : data, filterObj: this.filterObj, NEXT_DUE:  this.NEXT_DUE , vessel_dropdown_obj:this.vessel_dropdown_name, vesselGroup_dropdown_obj: this.vesselGroup_dropdown_obj,vesselFleet_dropdown_obj: this.vesselFleet_dropdown_obj,vesselOwner_dropdown_obj:this.vesselOwner_dropdown_obj, nextPortDateData: this.nextPortDateData, remarkData:this.remarkData } },{ responseType: 'blob' }).subscribe( result => {
      saveAs(result, `GeneralReportData.pdf`)
    })
  }

  changeFlagUserType(e) {
    this.user_type_id = e;
    this.getData(e);
    this.userDropDown();
  }

  openModel(content, data: any = null, trueFlag = false, isgetActivity = false) {
    this.VesselID = (data) ? data : null;
    this.isActivityEnable = true;

    if (this.VesselID && trueFlag) {
      this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/vessel_record/' + this.VesselID }).subscribe(result => {
        if (result.status) {
          if (result.data.length > 0) {
            this.tempArrObjNextPort = (this.commonService.isJson(result.data[0].NEXT_PORT_INFO)) ? JSON.parse(result.data[0].NEXT_PORT_INFO) : '';
          }
        } else {
          alert(result.message);
        }
      });
    }
    if (this.VesselID && isgetActivity ) {
      this.getActivityStatus(this.VesselID );
    }
    this.modalRef = this.modalService.open(content, { size: 'lg' });
  }

  getPortDropdown() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/port-dropdown' }).subscribe(result => {
      if (result.status) {
        this.PortDropdown = result.data;
      } else {
        this.PortDropdown = [];
        alert(result.message);
      }
    })
  }

  countryDropDown() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'country/dropdown' }).subscribe(result => {
      if (result.status) {
        this.country_dropdown = result.data;
      }
      else {
        this.country_dropdown = [];
        alert(result.message);
      }
    })
  }

  resetForm() {
    this.formSubmittedAttempt = false;
    this.showSideBarLoader = false;

    this.addPortForm.patchValue({
      PORT_NAME: null,
      PORT_CODE: null,
      COUNTRY_MST_FK: null,
      LATITUDE: null,
      LONGITUDE: null,
    });

    this.addTrainingHistotyForm.patchValue({
      VESSEL_FK: [null],
      USER_FK: [null],
      TRAINNING_ON: false,
      START_DATE: [null],
      END_DATE: [null],
      PORT_FROM: [null],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });

    this.trainingVesselReport.patchValue({
      VESSEL_FK: [null],
      TRAINNING_HISTORY_FK: [null],
      LAST_VISITED_MARINE_DATE: [null],
      LAST_VISITED_MARINE_FK: [null],
      LAST_VISITED_MARINE_NAME: [null],
      LAST_2_VISITED_MARINE_DATE: [null],
      LAST_2_VISITED_MARINE_FK: [null],
      LAST_2_VISITED_MARINE_NAME: [null],
      LAST_VISITED_TECHNICAL_DATE: [null],
      LAST_VISITED_TECHNICAL_FK: [null],
      LAST_VISITED_TECHNICAL_NAME: [null],
      LAST_2_VISITED_TECHNICAL_DATE: [null],
      LAST_2_VISITED_TECHNICAL_FK: [null],
      LAST_2_VISITED_TECHNICAL_NAME: [null],
      LAST_VISITED_ONBOARD_DATE: [null],
      LAST_VISITED_ONBOARD_FK: [null],
      LAST_VISITED_ONBOARD_NAME: [null],
      LAST_2_VISITED_ONBOARD_DATE: [null],
      LAST_2_VISITED_ONBOARD_FK: [null],
      LAST_2_VISITED_ONBOARD_NAME: [null],
      PRIORITY_FLAG: false,
      NEXT_PORT_INFO: '',

    });
    this.tempArrObjActivity = [];
     this.copy_date =  false;

  }

  addPort() {
    this.formSubmittedAttempt = true;
    if (this.addPortForm.valid) { 
      this.showSideBarLoader = true;
      this.commonService.sendRequestToNode({ method: 'post', path: 'training-vessel-report/port', postData: this.addPortForm.value }).subscribe(
        data => {
          var dialogueTitle = "Inserted!";
          this.showSideBarLoader = false;
          if (data.status) {
            swal({
              title: dialogueTitle,
              text: data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            })
            this.addPortForm = this.formBuilder.group({
              PORT_NAME: [null, Validators.required],
              PORT_CODE: [null, Validators.required],
              COUNTRY_MST_FK: [null,],
              LATITUDE: [null,],
              LONGITUDE: [null,]
            });
            this.portFormcontent.hide();
            this.getPortDropdown();
          } else {
            alert(data.message);
          }
        });
    }
  }

  getInspectionType() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'inspection-type-dropdown',queryParam : {ACTIVITY_TRAINING_FLAG : 1 } }).subscribe(result => {
      if (result.status) {
        this.InspectionType = result.data;
      } else {
        this.InspectionType = [];
        alert(result.message);
      }
    })
  }

  onFileChange(event) {
    let notAllowedCount = 0;
    let sizeNotAllowedCount = 0;
    let file = [];
    var re = /(?:\.([^.]+))?$/;

    if (event.target.files.length > 0  && event.target.files.length <= 20 ) {
      for (var i = 0; i < event.target.files.length; i++) { 
        let tempFilename = event.target.files[i];
        let tempFileSize = event.target.files[i].size;
        let tempFileSizeInKB =  Math.round(tempFileSize / 1024)
        let FileExtension = re.exec(tempFilename.name)[1];
        if( event.target.files[i].type != "application/pdf" && FileExtension != 'xlsx' && FileExtension != 'xlsm' && FileExtension != 'xltx' && FileExtension != 'xltm' && FileExtension != 'xla' && FileExtension != 'xlam') {
            notAllowedCount++; 
        } 
        if( tempFileSizeInKB > 5000) {
          sizeNotAllowedCount++;
        }
      }
      if( notAllowedCount > 0 ) {
        alert('Only Pdf or Excel File Allowed, Skiping ' + notAllowedCount + ' file(s). ');
      } 
      if( sizeNotAllowedCount > 0 ) {
        alert(' ' + sizeNotAllowedCount + ' file(s) size more than 5KB, So Skiping those file(s).');
      }
      for (var i = 0; i < event.target.files.length; i++) {
        let tempFilename = event.target.files[i];
        let FileExtension = re.exec(tempFilename.name)[1];
        let tempFileSize = event.target.files[i].size;
        let tempFileSizeInKB =  Math.round(tempFileSize / 1024);
        if( ( event.target.files[i].type == "application/pdf" || FileExtension == 'xlsx' || FileExtension == 'xlsm' || FileExtension == 'xltx' || FileExtension == 'xltm' || FileExtension == 'xla' || FileExtension == 'xlam' ) && tempFileSizeInKB < 5000) {
          file.push(event.target.files[i]);
             this.addActivityForm.get('ATTACHMENT').setValue(file);
        } 
      }
    } else {
      alert('You can only upload upto 20 files');
      this.fi ? this.fi.nativeElement.value = "" : '';
    }
  }

  SaveActivity() {
    this.isActivityEnable = false;
    this.formSubmittedAttempt = true;
    let filterParams: any = {}
    if (this.addActivityForm.valid ) {
      if( this.addActivityForm.value.START_DATE > this.addActivityForm.value.END_DATE ) {
        this.isActivityEnable = true;
        alert('Please Enter Valid Date');
      } else {
                var activity_id = this.addActivityForm.value.ACTIVITY_ID;
              if (this.tempArrObjActivity && this.tempArrObjActivity.length > 0) {
                var found = this.tempArrObjActivity.filter(function (ele) {
                  return ele.ACTIVITY_ID === activity_id;
                });
              } else {
                this.tempArrObjActivity = [];
              }

              if (!found || found.length <= 0) {
              filterParams.inspection_id = this.addActivityForm.value.ACTIVITY_ID;
              filterParams.vessel_id = this.VesselID;
              filterParams.start_date = this.addActivityForm.value.START_DATE;
              filterParams.end_date = this.addActivityForm.value.END_DATE;
              this.commonService.sendRequestToNode({ method: 'get', path: 'inspection-type/' + this.addActivityForm.value.ACTIVITY_ID }).subscribe(
                data => {
                  this.addActivityForm.patchValue({
                    ACTIVITY_NAME: data.data.TITLE,
                  });
                  this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/activity_wise_no_of_oberservation', queryParam: filterParams }).subscribe(result => {
                    this.addActivityForm.patchValue({
                      NO_OF_OBSERVATION: result.data[0].no_of_obs,
                      NO_OF_NCN_OBSERVATION: result.data[0].ncn_obs,
                      NO_OF_NCN_OPEN_OBSERVATION: result.data[0].ncn_open_obs,
                      NO_OF_OPEN_OBSERVATION: result.data[0].open_obs,
                    });
                    this.tempArrObjActivity.push(this.addActivityForm.value);
                    this.formSubmittedAttempt = false;

                    this.addActivityForm = this.formBuilder.group({
                      ACTIVITY_ID: [null, Validators.required],
                      START_DATE: [null, Validators.required],
                      END_DATE: [null, Validators.required],
                      RPT_CRT_NO: [null],
                      NO_OF_OBSERVATION: [null],
                      NO_OF_NCN_OBSERVATION: [null],
                      NO_OF_NCN_OPEN_OBSERVATION:[null],
                      NO_OF_OPEN_OBSERVATION:[null],
                      REMARKS: [null],
                      ACTIVITY_NAME: [null],
                      TRAINING_HISTORY_FK: [null],
                      ATTACHMENT: ['']
                    });
                    this.isActivityEnable = true;
                    this.modalRef.close();
                  });
                });
              } else {
                this.isActivityEnable = true;
                alert("Activity is already Exist");
              }
      }
    } else {
      this.isActivityEnable = true;
    }
  }

  removeFile(index, fileIndex ) {
    this.tempArrObjActivity.forEach((element, key) => {
      if (key == index) {
        element.ATTACHMENT.forEach( (ele, fIndex)=> {
          if( fIndex == fileIndex) {
            this.tempArrObjActivity[key].ATTACHMENT[fIndex] = [''];
          }
        });
      }
    })
  }

  SavePortAndActivity(vessel_fk: any) {
     this.isAuditSave = false;
    this.formSubmittedAttempt = true;
    if (this.addTrainingHistotyForm.valid ) {
      if( this.addTrainingHistotyForm.value.START_DATE > this.addTrainingHistotyForm.value.END_DATE ) {
        this.isAuditSave = true;
        alert('Please Enter Valid Date');
      } else {
        if( this.addTrainingHistotyForm.value.TRAINNING_ON  && ( this.addTrainingHistotyForm.value.PORT_TO == null || this.addTrainingHistotyForm.value.PORT_FROM == null )) {
          this.isAuditSave = true;
          alert(' Please Select Port')
        } else {
          if ( !this.addTrainingHistotyForm.value.TRAINNING_ON ) {
            this.addTrainingHistotyForm.patchValue({
              PORT_TO: this.addTrainingHistotyForm.value.PORT_FROM
            });
          }
          this.addTrainingHistotyForm.patchValue({
            VESSEL_FK: vessel_fk
          });

          this.showSideBarLoader = true;
          this.commonService.sendRequestToNode({ method: 'post', path: 'training-vessel-report/port_activity', postData: this.addTrainingHistotyForm.value }).subscribe(
            data => {
              var dialogueTitle = "Inserted!";
              this.showSideBarLoader = false;
              if (data.status) {
                var trainingHistoryId = data.data;
                // insert acivities
                this.tempArrObjActivity.forEach((element, key) => {
                  let formData = new FormData();
                  formData.append('TRAINING_HISTORY_FK', trainingHistoryId);
                  formData.append('ACTIVITY_ID', element.ACTIVITY_ID);
                  formData.append('START_DATE', element.START_DATE);
                  formData.append('END_DATE', element.END_DATE);
                  formData.append('RPT_CRT_NO', element.RPT_CRT_NO);
                  formData.append('REMARKS', element.REMARKS);
                  for( var i = 0; i < element.ATTACHMENT.length; i++ ) { 
                    formData.append('ATTACHMENT', element.ATTACHMENT[i]);
                  }
                  this.commonService.sendRequestToNode({ method: 'post', path: 'training-vessel-report/activity_history_details', postData: formData }).subscribe(
                    res => {
                      if (res.status) {
                        console.log('sucess');
                      }
                      else {
                        console.log('fail')
                      }
                    });
                });
                swal({
                  title: dialogueTitle,
                  text: data.message,
                  type: 'success',
                  confirmButtonClass: "btn btn-success",
                  buttonsStyling: false
                });
                this.resetForm();
                this.addTrainingHistotyForm = this.formBuilder.group({
                  VESSEL_FK: [null],
                  USER_FK: [null, Validators.required],
                  TRAINNING_ON: false,
                  START_DATE: [  this.commonService.formatDate( this.tempDate )],
                  END_DATE: [ this.commonService.formatDate(new Date())],
                  PORT_FROM: [null, Validators.required],
                  PORT_TO: [null],
                  IS_DRY_DOCK: false,
                });
               this.isAuditSave = true;

                this.getData();
                this.getPortDropdown();
              } else {
                alert(data.message);
              }
            })

        }
      }
    } else {
       this.isAuditSave =true;
    }
  }

  userDropDown() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown', queryParam: { 'allusers': 1, 'USER_TYPE_FILTER': '1', user_type_id: this.user_type_id } }).subscribe(result => {
      if (result.status) {
        this.userData = result.data;
      } else {
        this.userData = [];
        alert(result.message);
      }
    });
  }

  getVesselData() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-dropdown',queryParam:{ACTIVE_FLAG:1} }).subscribe(result => {
      if (result.status) {
       
        this.VesselData = [{VESSEL_NAME : 'All Vessels',ID : 'ALL'},...result.data];
        result.data.forEach((val) => {
          this.vessel_dropdown_name[val.ID] = val.VESSEL_NAME;
        });
        
      } else {
        this.VesselData = [];
        alert(result.message);
      }
    })
  }

  resetNextPortForm() {
    this.formSubmittedAttempt = true;
    if (this.addNextPortForm.valid) {

      var port_id = this.addNextPortForm.value.PORT_NAME;
      if (this.tempArrObjNextPort && this.tempArrObjNextPort.length > 0) {
        var found = this.tempArrObjNextPort.filter(function (ele) {
          return ele.PORT_ID === port_id;
        });
      } else {
        this.tempArrObjNextPort = [];
      }

      if (!found || found.length <= 0) {
        this.commonService.sendRequestToNode({ method: 'get', path: 'port/' + port_id, queryParam: { 'user_id': this.addNextPortForm.value.USER_FK } }).subscribe(result => {
          if (result.data) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user/' + this.addNextPortForm.value.USER_FK }).subscribe(
              data => {
                if (data.data) {
                  this.addNextPortForm.patchValue({
                    PORT_ID: port_id,
                    PORT_NAME: result.data.PORT_NAME,
                    USER_NAME: data.data.FULL_NAME
                  });
                  this.tempArrObjNextPort.push(this.addNextPortForm.value);
                  this.addNextPortForm = this.formBuilder.group({
                    PORT_ID: [null],
                    PORT_NAME: [null],
                    DATE: [null],
                    USER_FK: [null],
                    USER_NAME: [null],
                    REMARK:[null]
                  });
                }
              });
          }
        });
      } else {
        alert("Port is already Exist");
      }
    }
  }

  RemoveNextPort(ID) {
    this.tempArrObjNextPort.forEach((element, key) => {
      if (ID == element.PORT_ID) {
        this.tempArrObjNextPort.splice(key, 1);
      }
    });

  }

  UpdatePriority( vessel_id, Priority) {

    if( vessel_id && Priority ) {
      this.commonService.sendRequestToNode({ method: 'get', path: 'training-vessel-report/vessel_record/' + vessel_id }).subscribe(result => {
        if (result.status) {
            if (result.data.length > 0 ) {
                  if( result.data[0].PRIORITY_FLAG) {
                    this.PRIORITY_FLAG = false;
                  } else {
                    this.PRIORITY_FLAG = true;
                  }
                  this.addNextPort( vessel_id, Priority, this.PRIORITY_FLAG );
            } else { 
                  this.addNextPort( vessel_id, Priority, true );
            }
        } else {
          this.addNextPort( vessel_id, Priority, true );
          alert(result.message);
        }
      });
    }
  }

  addNextPort(vessel_id: any = null, Priority: any = false, PRIORITY_FLAG: any = false) {
    if (vessel_id) {
      this.VesselID = vessel_id;
    }
    var strRemark = '';

    if ( this.tempArrObjNextPort && this.tempArrObjNextPort.length > 0 || Priority) {
      if (this.tempArrObjNextPort.length > 0) {
        strRemark = this.tempArrObjNextPort[0].REMARK;
      }
      this.commonService.sendRequestToNode({ method: 'post', path: 'training-vessel-report/update_nextport/' + this.VesselID, postData: { 'Next_Port': this.tempArrObjNextPort, 'priority': Priority,'PRIORITY_FLAG':PRIORITY_FLAG, 'temp_vessel_id': vessel_id,'Remark': strRemark } }).subscribe(
        data => {
          var dialogueTitle = "Updated!";
          this.showSideBarLoader = false;
          if (data.status) {
            swal({
              title: dialogueTitle,
              text: data.message,
              type: 'success',
              confirmButtonClass: "btn btn-success",
              buttonsStyling: false
            });
            
            this.getData();
            if( !Priority && !PRIORITY_FLAG && vessel_id == null ) {
                this.modalRef.close();
                this.nextPortFormcontent.hide();
                this.portFormcontent.hide();
            }
          } else {
            alert( data.message );
          }
        })
    } else {
      alert('Enter Atleast one Port Detail');
    }

  }

  vesselOwnerDropdown() {
    if (this.vesselOwner_dropdown.length <= 0) {
      this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselOwner' }).subscribe(result => {
        if (result.status) {
          this.vesselOwner_dropdown = result.data;
          this.vesselOwner_dropdown.forEach(ele => {
            this.vesselOwner_dropdown_obj[ele.ID] = ele.COMPANY_NAME;
          })
        }
        else {
          this.vesselOwner_dropdown = [];
        }
      });
    }
  }

  vesselFleetDropdown() {
    if (this.vesselFleet_dropdown.length <= 0) {
      this.commonService.sendRequestToNode({ method: 'get', path: 'fleet/fleet-dropdown' }).subscribe(result => {
        if (result.status) {
          this.vesselFleet_dropdown = result.data;
          this.vesselFleet_dropdown.forEach(ele => {
            this.vesselFleet_dropdown_obj[ele.ID] = ele.FLEET_NAME;
          })
        }
        else {
          this.vesselFleet_dropdown = [];
        }
      })
    }
  }

  vesselGroupDropdown() {
    if (this.vesselGroup_dropdown.length <= 0) {
      this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselGroup' }).subscribe(result => {
        if (result.status) {
          this.vesselGroup_dropdown = result.data;
          this.vesselGroup_dropdown.forEach(ele => {
            this.vesselGroup_dropdown_obj[ele.ID] = ele.GROUP_NAME;
          })
        } else {
          this.vesselGroup_dropdown = [];
        }
      });
    }
  }

  RemoveTempActivity(id) {
    this.tempArrObjActivity.forEach((element, key) => {
      if (element.ACTIVITY_ID == id) {
        this.tempArrObjActivity.splice(key, 1);
      }
    });
  }

  copyDate() {
    if( this.addTrainingHistotyForm.value.START_DATE &&  this.addTrainingHistotyForm.value.END_DATE ) {
      this.copy_date = true;
      this.addActivityForm.patchValue({
        START_DATE: this.addTrainingHistotyForm.value.START_DATE,
        END_DATE: this.addTrainingHistotyForm.value.END_DATE,
      })
      
      this.addNextPortForm.patchValue({
        DATE : this.addTrainingHistotyForm.value.END_DATE
      })
    } else {
      this.copy_date = false;
      alert( "Please select Start/End Date both")
    }
  }

  refreshWholeForm() {
     this.resetForm();
    this.addTrainingHistotyForm.patchValue({
      VESSEL_FK: [null],
      USER_FK: [null],
      TRAINNING_ON: false,
      START_DATE: [null],
      END_DATE: [null],
      PORT_FROM: [null],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });

    this.addActivityForm.patchValue({
      TRAINING_HISTORY_FK: [null],
      ACTIVITY_ID: [null],
      START_DATE: [null],
      END_DATE: [null],
      NO_OF_OBSERVATION: null,
      NO_OF_NCN_OBSERVATION: null,
      NO_OF_NCN_OPEN_OBSERVATION: null,
      NO_OF_OPEN_OBSERVATION: null,
      RPT_CRT_NO: [null],
      REMARKS: [null],
      ACTIVITY_NAME: [null],
      ATTACHMENT: [''],
    });
    this.addNextPortForm.patchValue({
      DATE : [null]
    })
    this.tempArrObjActivity = [];
    this.addTrainingHistotyForm = this.formBuilder.group({
      VESSEL_FK: [null],
      USER_FK: [null, Validators.required],
      TRAINNING_ON: false,
      START_DATE: [  this.commonService.formatDate( this.tempDate )],
      END_DATE: [ this.commonService.formatDate(new Date())],
      PORT_FROM: [null, Validators.required],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });
  }

  resetPlanDate( id ) {
    this.commonService.sendRequestToNode({method :'delete',path:'training-plan/' + id}).subscribe(
      data => {
      if(data.status){
        var dialogueTitle = "Resert to next planned date!"
       
        this.getData();
        swal({
            title: dialogueTitle,
            text: data.message,
            type: 'success',
            confirmButtonClass: "btn btn-success",
            buttonsStyling: false
          })
      }         
      
  })
  }

  change_vessel() {
    let arr = [];
     if( this.FilterForm.value.VESSEL_FK.length > 0 ) {
      // alert( this.FilterForm.value.VESSEL_FK)
      this.FilterForm.value.VESSEL_FK.forEach(ele=>{
        if(ele == 'ALL'){
          arr = this.VesselData.map(e=>{
            return e.ID;
          })
          arr = arr.filter(e=>{
            return !(e == 'ALL');
          })
         
        }
      })
     } else {
      this.FilterForm.patchValue({
        VESSEL_FK:null
      })
     }
    
    if( arr.length > 0 ) {
       this.FilterForm.patchValue({
         VESSEL_FK:arr
       })
    }
    this.filterData();
  }

  filterData() {
      this.getData(this.FilterForm.value.USER_FK);
  }

  getActivityStatus(vessel_id, elementObj:any = {} ) {
    this.commonService.sendRequestToNode({method :'get',path:'training-history/activity_status/' + vessel_id}).subscribe(
      data => { 
        if(data.data){
          let countRed    = 0;
          let countOrange = 0;
          let countGreen  = 0;
          let RemainingCount = 0;

          this.vesselHistoryData = data.data;
          this.vesselHistoryData.forEach((element, k) => {
            if( element.LAST_DATE ) {
              this.getDateUserVise( element.FREQUENCY, element.LAST_DATE, element );
            }
          });
          this.vesselHistoryData.forEach((ele,key)=>{
            if(ele.BG_COLOR && ele.BG_COLOR == 'bg-myred' ) {
              countRed = countRed + 1;
            } else  if(ele.BG_COLOR && ele.BG_COLOR == 'bg-myorange' ) {
              countOrange= countOrange +1;
            } else if(ele.BG_COLOR && ele.BG_COLOR == 'bg-mygreen' ) {
              countGreen = countGreen +1;
            } else {
              RemainingCount = RemainingCount +1;
            }
          });
           
          if(countGreen >= countOrange &&  countGreen >= countRed  &&  countGreen != 0 && countGreen >=  RemainingCount ) {
            elementObj.pendingActivityColor = 'bg-mygreen';
            elementObj.pendingActivityCount = countGreen;
          } else  if( countOrange >= countGreen &&  countOrange >= countRed && countOrange != 0 && countOrange >= RemainingCount ) {
            elementObj.pendingActivityColor = 'bg-myorange';
            elementObj.pendingActivityCount = countOrange;
          } else {
            elementObj.pendingActivityColor = 'bg-myred';
            elementObj.pendingActivityCount = countRed + RemainingCount;
          } 
        } else{
            this.vesselHistoryData = [];
        }
        
      })
  }
}
  

