import { Component, AfterViewInit,OnInit,ViewChild, ElementRef } from '@angular/core';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators} from '@angular/forms';
import swal from 'sweetalert2';
import { BsModalRef } from 'ngx-bootstrap';

declare var require: any;

@Component({
  selector: 'trainingReportHistory',
  templateUrl: './trainingReportHistory.component.html',
  styleUrls: ['./trainingReportHistory.component.scss']
})
export class TrainingReportHistoryComponent implements AfterViewInit,OnInit {
  @ViewChild('Formcontent') Formcontent : ElementRef
  @ViewChild('FormEditcontent') FormEditcontent : ElementRef

  expand : boolean = false;
  vesselInfo : any = {};
  vesselHistoryData = [];
  vesselGroup_dropdown = [];
   public country_dropdown = [];
  showLoader = false;
  @ViewChild('fileInput') fi:ElementRef;
  
  public PortDropdown = [] ;
  public userData = [];
  public attachmentsObj =[];
  public file_upload;
  public modalRef:NgbModalRef;
  public addTrainingHistotyForm: FormGroup;
  public viewTrainingHistotyForm: FormGroup;
  public filterUserForm: FormGroup;
  public addPortForm : FormGroup;
  public addActivityForm : FormGroup;
  public vesselFk = '';
  public user_type_id =  null;
  public historyId = null;
  //for grid 
  public headerInformation;
  public actionButtons;
  public filterObj:any = {};
  public sortFilter:any = {};
  public filterUserObj = {
    USER_TYPE : 1,
  }

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  public docPath = this.commonService.getDocumentPath()+'/TrainingActivity';
  totalItems: number;
  currentPage: number = 1;
  //---

  formSubmittedAttempt = false;
  tempArrObjActivity = [];
  InspectionType = [];
  constructor(private modalService: NgbModal,
    private formBuilder: FormBuilder,
    private router: Router,
    private route: ActivatedRoute,
    private commonService: CommonService ) {
        
        this.route.params.subscribe(data=>{
          this.filterUserForm = this.formBuilder.group({
            USER_Type: "1",
            start_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))),
            end_date: this.commonService.formatDate(new Date())
          });
          this.vesselFk = data.vesselId;
          this.vesselDataById();
          this.getHistoryData()
        })
  }

  ngOnInit(){
    this.declareGridVariable();
    this.buildForm();
    this.getInspectionType();
    this.userDropDown();
    this.getPortDropdown();
    this.countryDropDown();
  }

  ngAfterViewInit(){	
  }
  buildForm(){
    // this.filterUserForm = this.formBuilder.group({
    //   USER_Type: 1,
    // });
    this.addActivityForm = this.formBuilder.group({
      
      ACTIVITY_ID: [null,Validators.required],
      START_DATE: [null, Validators.required],
      END_DATE : [null,Validators.required],
      RPT_CRT_NO : [null],
      NO_OF_OBSERVATION : [null],
      REMARKS  :[null],
      ACTIVITY_NAME : [null],
      ATTACHMENT : ['']
    });

    this.addTrainingHistotyForm = this.formBuilder.group({
      
      VESSEL_FK: [this.vesselFk],
      USER_FK: [null],
      TRAINNING_ON : false,
      START_DATE : [null],
      END_DATE  :[null],
      PORT_FROM : [null],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });

    this.viewTrainingHistotyForm = this.formBuilder.group({
      
      VESSEL_FK: [this.vesselFk],
      USER_FK: [null],
      TRAINNING_ON : false,
      START_DATE : [null],
      END_DATE  :[null],
      PORT_FROM : [null],
      PORT_TO: [null],
      IS_DRY_DOCK: false,
    });

    this.addPortForm = this.formBuilder.group({
      PORT_NAME: [null,Validators.required],
      PORT_CODE: [null,Validators.required],
      COUNTRY_MST_FK: [null,],
      LATITUDE : [null,],
      LONGITUDE : [null,]
    });

    
  }
  // part of grid
  declareGridVariable(){
    this.headerInformation = [
    {
      title : 'Type',// show title table header
      name:'TRAINNING_ON',// name of column in data source
      width : '15%',// width of column in table
      isSortable : true,// sort by column false or true
      display_value : {
        '0' : 'Port',
        '1' : 'Sailing' 
      },
      highlight:true, // name highlight
      isFilter:{ // filter 
        type : 'select',
        placeholder : 'Filter',
        options_value : [1,0],
        options_display : ['Sail','Port']
      }
    },
    {
      title : 'Port From',// show title table header
      name:'PORT_NAME_from',// name of column in data source
      width : '15%',// width of column in table
      isSortable : true,// sort by column false or true
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By Port'
      }
    },
    {
      title : 'Port To',// show title table header
      name:'PORT_NAME_to',// name of column in data source
      width : '15%',// width of column in table
      isSortable : true,// sort by column false or true
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By Port'
      }
    },
    {
      title : 'From Date',
      name:'START_DATE',
      width : '15%',
      isSortable : true,
      isDate : 'yes'
    },
    {
      title : 'To Date',
      name:'END_DATE',
      width : '15%',
      isSortable : true,
      isDate : 'yes'
    },
    
    {title : 'Action',name:'action',width : '15%'}
    ];
    this.actionButtons = [
    {title:'View',class : "fas fa-eye"},
    {title:'Edit',class : "far fa-edit"},
    ]
  }

   //part of grid
   clickOnAction(actionObj){
    if(actionObj.actionName == 'View') {
      this.openModelFullScreen();
      this.getHistoryDetailById(actionObj.object.ID);
    }else if(actionObj.actionName == 'Edit'){ 
      this.openModelFullEditScreen(actionObj.object.ID);
      this.getHistoryDetailById(actionObj.object.ID);
    }else if(actionObj.actionName == 'Delete'){
      // this.delete(actionObj.object.ID);
    }else if(actionObj.actionName == 'Status'){
      // this.statusChange(actionObj.object.ID,actionObj.object)
    }
  }

  //part of grid
  //when change filter ,change page no . etc, 
  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getHistoryData();
  }


  changeFlagUserType( e ) {
   
          this.filterUserForm.patchValue({
            USER_Type : e
          })
          this.user_type_id =  e;
          this.getHistoryData( );
          
       
  }
  getHistoryData() {
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    // pagination
    filterParams.currentPage  = this.currentPage-1;
    filterParams.itemsPerPage = this.itemsPerPage;
    filterParams.start_date   = this.filterUserForm.value.start_date;
    filterParams.end_date     = this.filterUserForm.value.end_date;
     if( this.user_type_id ) {
      filterParams.user_type_id  = this.user_type_id;
     } else {
       filterParams.user_type_id  = 1;
     }
    // pagination - end

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end

    this.showLoader = true;
    this.commonService.sendRequestToNode({method :'get',path:'training-history/'+this.vesselFk,queryParam: filterParams}).subscribe(
      data => { 
        if(data.data){
          this.showLoader = false; 
          this.vesselHistoryData = data.data;
          this.totalItems = data.data[0].total_records;
        }
        else{

        }
        
      })
  }
  vesselDataById(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/getById/'+this.vesselFk}).subscribe(
      data => { 
        this.vesselInfo = data.data;
      })
  }
  sorting(column_name){

  }

  openModelFullScreen() {
    this.modalRef = this.modalService.open(this.Formcontent,{size: 'lg',windowClass : 'fullscreen'});
  }

  openModelFullEditScreen(id) {
    this.historyId = id;
    this.modalRef = this.modalService.open(this.FormEditcontent,{size: 'lg',windowClass : 'fullscreen'});
  }

  openModel(content) {
    this.modalRef = this.modalService.open(content,{size: 'lg'});
  }

  getInspectionType() {
    this.commonService.sendRequestToNode({method :'get',path:'inspection-type-dropdown',queryParam : {ACTIVITY_TRAINING_FLAG : 1}}).subscribe(result => {
      if(result.status){   
        this.InspectionType = result.data;
      }else{
        this.InspectionType = [];
        alert(result.message);
      }
    })
  }

  SaveActivity() {
    this.formSubmittedAttempt = true;
    let filterParams:any = {}
    let Temp_ACTIVITY_ID = this.addActivityForm.value.ACTIVITY_ID;
    var found = [];
   
    if(this.addActivityForm.valid ) {
        if( this.tempArrObjActivity.length > 0 ) {
          found = this.tempArrObjActivity.filter(function(ele) {
            return ele.ACTIVITY_ID === Temp_ACTIVITY_ID;
          });
        }

      if( found && found.length <= 0  ) { 
        filterParams.inspection_id  =  this.addActivityForm.value.ACTIVITY_ID;
        filterParams.vessel_id      = this.vesselFk;
        filterParams.start_date     = this.addActivityForm.value.START_DATE;
        filterParams.end_date       = this.addActivityForm.value.END_DATE;

        this.commonService.sendRequestToNode({ method :'get',path:'inspection-type/'+ this.addActivityForm.value.ACTIVITY_ID }).subscribe(
          data => {     
            this.addActivityForm.patchValue({
              ACTIVITY_NAME : data.data.TITLE ,
            });
            this.commonService.sendRequestToNode({ method :'get',path:'training-vessel-report/activity_wise_no_of_oberservation',queryParam:filterParams}).subscribe(result => {
                this.addActivityForm.patchValue({
                  NO_OF_OBSERVATION : result.data[0].count ,
                });
                this.tempArrObjActivity.push( this.addActivityForm.value );
                this.formSubmittedAttempt = false;
                this.addActivityForm.patchValue({
                  TRAINING_HISTORY_FK: [null],
                  ACTIVITY_ID: [null],
                  START_DATE: [null],
                  END_DATE : [null],
                  NO_OF_OBSERVATION: null,
                  RPT_CRT_NO : [null],
                  REMARKS  :[null],
                  ACTIVITY_NAME : [null],
                  ATTACHMENT:[''],
                });
                this.modalRef.close();
            });
        });
      } else {
        alert( 'Activity already Exist');
      }

    }
   
  }

  getHistoryDetailById(id) {
    this.commonService.sendRequestToNode({method :'get',path:'get-single-training-history/'+id}).subscribe(result => {
      if(result.status){   
        let historyObj = result.data[0];
        
        historyObj.START_DATE = this.commonService.formatDate(historyObj.START_DATE);
        historyObj.END_DATE   = this.commonService.formatDate(historyObj.END_DATE)
        this.addTrainingHistotyForm.patchValue( historyObj );
        this.viewTrainingHistotyForm.patchValue( historyObj );
        this.tempArrObjActivity = result.activityDetailArr;
        if( this.tempArrObjActivity.length > 0 ) {
          this.tempArrObjActivity.forEach( (ele, index)=> {
            this.commonService.sendRequestToNode({method :'get',path:'get-training-history-attachments/'+ ele.ID}).subscribe(result1 => {
              // if( result1.length > 0 ) {
                this.tempArrObjActivity[index].ATTACHMENT = result1.data;
              // }
            });
          });
       }
      } else {
        alert(result.message);
      }
    })
  }

resetForm() {
  this.formSubmittedAttempt = false;
  // this.showSideBarLoader = false;
  // this.edit_id = '';
  this.addPortForm.patchValue({
    PORT_NAME: [null],
    PORT_CODE: [null],
    COUNTRY_MST_FK: [null,],
    LATITUDE : [null,],
    LONGITUDE : [null,]
  });

  this.addActivityForm.patchValue({
      TRAINING_HISTORY_FK: [null],
      ACTIVITY_ID: [null],
      START_DATE: [null],
      END_DATE : [null],
      RPT_CRT_NO : [null],
      NO_OF_OBSERVATION : [null],
      REMARKS  :[null],
      ACTIVITY_NAME : [null],
      ATTACHMENT : ['']
  });
  this.tempArrObjActivity = [];

  this.addTrainingHistotyForm = this.formBuilder.group({
    VESSEL_FK: [this.vesselFk],
    USER_FK: [null],
    TRAINNING_ON : false,
    START_DATE : [null],
    END_DATE  :[null],
    PORT_FROM : [null],
    PORT_TO: [null],
    IS_DRY_DOCK: false,
  });
}

getPortDropdown(){
  this.commonService.sendRequestToNode({method :'get',path:'training-vessel-report/port-dropdown'}).subscribe(result => {
    if(result.status){   
      this.PortDropdown = result.data;
    } else {
      this.PortDropdown = [];
      alert(result.message);
    }
  })
}

userDropDown() {
  this.commonService.sendRequestToNode({method :'get',path:'user-dropdown'}).subscribe(result => {
    if(result.status){
      this.userData = result.data;
    } else {
      this.userData = [];
      alert(result.message);
    }
  })
}

funOpenRightSidebar(){
  
}

addPort() {
  this.formSubmittedAttempt = true;
  if(this.addPortForm.valid){
    // this.showSideBarLoader = true;
    this.commonService.sendRequestToNode({method :'post',path:'training-vessel-report/port',postData:this.addPortForm.value}).subscribe(
      data =>{ 
      var dialogueTitle = "Inserted!";
      // this.showSideBarLoader = false;
      if(data.status){
        swal({
          title: dialogueTitle,
          text: data.message,
          type: 'success',
          confirmButtonClass: "btn btn-success",
          buttonsStyling: false
        })
        this.addPortForm = this.formBuilder.group({
          PORT_NAME: [null, Validators.required],
          PORT_CODE: [null, Validators.required],
          COUNTRY_MST_FK: [null,],
          LATITUDE: [null,],
          LONGITUDE: [null,]
        });
        this.modalRef.close();
        this.getPortDropdown();
        // this.resetForm();
      } else {
        alert(data.message);
      }
    })
}
}

countryDropDown() {
  this.commonService.sendRequestToNode({method :'get',path:'country/dropdown'}).subscribe(result => {
    if(result.status){
      this.country_dropdown = result.data;           
    }
    else{
      this.country_dropdown = [];
      alert(result.message);
    }
  })
}

SavePortAndActivity(id) {
  this.formSubmittedAttempt = true;
  if(this.addTrainingHistotyForm.valid){ 
    if( !this.addTrainingHistotyForm.value.TRAINNING_ON ) {
      this.addTrainingHistotyForm.patchValue({
        PORT_TO: this.addTrainingHistotyForm.value.PORT_FROM
      });
    }
    // this.showSideBarLoader = true;
    this.commonService.sendRequestToNode({method :'post',path:'training-vessel-report/update_activity/'+ id,postData:this.addTrainingHistotyForm.value}).subscribe(
      data =>{ 
      var dialogueTitle = "Inserted!";
      // this.showSideBarLoader = false;
      if(data.status) {
        var trainingHistoryId = id;
                // insert acivities
                    this.tempArrObjActivity.forEach((element,key) => {
                      if( !element.ID ) {
                            let formData = new FormData();
                            formData.append('TRAINING_HISTORY_FK', trainingHistoryId );
                            formData.append('ACTIVITY_ID', element.ACTIVITY_ID );
                            formData.append('START_DATE',element.START_DATE );
                            formData.append('END_DATE',element.END_DATE );
                            formData.append('RPT_CRT_NO',element.RPT_CRT_NO );
                            formData.append('REMARKS', element.REMARKS );
                            // formData.append('ATTACHMENT', element.ATTACHMENT );
                            for( var i = 0; i < element.ATTACHMENT.length; i++ ) { 
                              formData.append('ATTACHMENT', element.ATTACHMENT[i]);
                            }
                            this.commonService.sendRequestToNode({method :'post',path:'training-vessel-report/activity_history_details',postData:formData}).subscribe(
                            res =>{ 
                              if(res.status) {
                                console.log('sucess')
                              } else {
                                console.log('fail')
                              }
                            });
                      }
                  });
        swal({
          title: dialogueTitle,
          text: data.message,
          type: 'success',
          confirmButtonClass: "btn btn-success",
          buttonsStyling: false
        })
        this.modalRef.close();
        this.getPortDropdown();
        this.resetForm();
      } else {
        alert(data.message);
      }
    })
}
}

RemoveActivity(activity_id, id ) {
  if(id && activity_id){
    swal({
      title: 'Are you sure?',
      text: "You won't be able to revert this!",
      type: 'warning',
      showCancelButton: true,
      confirmButtonClass: 'btn btn-success',
      cancelButtonClass: 'btn btn-danger',
      confirmButtonText: 'Yes, delete it!',
       buttonsStyling: false
    }).then((result) => {
      if( result.value ) {
        this.commonService.sendRequestToNode({method :'delete',path:'training-vessel-report/delete/'+id}).subscribe(
          data => {
            if( data.status ) {
              var dialogueTitle = "Deleted!"
              this.tempArrObjActivity.forEach( (element , key ) => {
                if( element.ID == id ) {
                  this.tempArrObjActivity.splice(key, 1); 
                }
              });
              this.getHistoryDetailById(id);
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }         
          })
        }
      })
  } else if( activity_id ){
    if( this.tempArrObjActivity.length > 0 ) {
      this.tempArrObjActivity.forEach( (element , key ) => {
        if( element.ACTIVITY_ID == activity_id ) {
          this.tempArrObjActivity.splice(key, 1); 
        }
      });
    }
  }
}

  onFileChange(event) { 
    let file = [];
    var re = /(?:\.([^.]+))?$/;
    
    if (event.target.files.length > 0  && event.target.files.length <= 20 ) {
      // let file = event.target.files[0];
      for (var i = 0; i < event.target.files.length; i++) { 
        let tempFilename = event.target.files[i];
        let FileExtension = re.exec(tempFilename.name)[1];
        if( event.target.files[i].type == "application/pdf" || FileExtension == 'xlsx' || FileExtension == 'xlsm' || FileExtension == 'xltx' || FileExtension == 'xltm' || FileExtension == 'xla' || FileExtension == 'xlam') {
          file.push(event.target.files[i]);
             this.addActivityForm.get('ATTACHMENT').setValue(file);
        } else {
          alert('You can only upload upto 20 files');
        }
      }
    } else {
      alert('Only Pdf or Excel File Allowed');
      this.fi ? this.fi.nativeElement.value = "" : '';
    }
  }

  removeFile(index, attachmentIndex) {
    this.tempArrObjActivity.forEach((element,key) => {
        if( key == index ) {
         var tempObj = element.ATTACHMENT;
         tempObj.forEach( (e, i )=> {
           if(i ==  attachmentIndex) {
            this.tempArrObjActivity[key].ATTACHMENT[i] = [''];
           }
         })
        }
    })
  }

  applyFilterForObservationChart() {
    if(this.filterUserForm.value.start_date > this.filterUserForm.value.end_date){
      alert('Please Enter Valid Date');
    } else {
      this.getHistoryData( );
    }
   }
}

