import { Component, OnInit } from '@angular/core';
import {Injectable,Inject} from '@angular/core';
import { FormArray, FormBuilder, FormGroup,Validators } from '@angular/forms';
import { CommonService } from '../../common-service.service';
import {Router,ActivatedRoute,Params} from "@angular/router";
import { DOCUMENT } from "@angular/common";

declare var $: any;
var classThis;
@Component({
    selector: 'app-login',
    templateUrl: './login.component.html',
    styleUrls: ['./login.component.scss']
})

export class LoginComponent implements OnInit {
    //displayLoginForm = true;
    displayForgetForm = false;
    forgotForm: FormGroup;

    loginForm: FormGroup;
    public formSubmittedAttempt = false;
    public resetToken;
    
    constructor(
        private activatedRoute: ActivatedRoute,
        private formBuilder: FormBuilder,
        private commonService: CommonService,
        private router: Router,
        private route: ActivatedRoute,
        @Inject(DOCUMENT) private document: any) 
        {
        this.createForm();
    }

    // showRecoverForm() {
    //   this.displayLoginForm = !this.displayLoginForm;
    //   this.displayForgetForm = !this.displayForgetForm;
    // }  
    showRecoverForm() {
        this.displayForgetForm = !this.displayForgetForm;
    }  

    createForm(){
      this.loginForm = this.formBuilder.group({
        email: ['',[Validators.required,Validators.pattern("^[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,4}$")]],
        password: ['',[Validators.required]]
      });    
      this.forgotForm = this.formBuilder.group({
        email: ['',[Validators.required,Validators.pattern("^[a-z0-9._%+-]+@[a-z0-9.-]+\.[a-z]{2,4}$")]]        
      }); 
    }
  
    ngOnInit() {
        // this.route.params.subscribe(params => {
        //     console.log()
        //     this.resetToken = params['token'];
        //  });
    }
    
    
    //krunal

    submitLoginForm(){
        this.formSubmittedAttempt = true;
        if(this.loginForm.valid)
        {
         
            this.commonService.sendRequestToNode({method :'post',path:'login',postData:this.loginForm.value}).subscribe(data => {
                if(data.status == true)
                {
                    // alert(data.message);

                    
                    localStorage.setItem(this.commonService.prefix+'userData', JSON.stringify(data.userData));
                    localStorage.setItem(this.commonService.prefix+'authentic_token', data.token);
                    
                    this.router.navigate(['/home']);
                    
                }
                else{
                    alert(data.message)
                }
            })
        
        }
    }

    submitForgotpasswordForm(){ 
        
        if(this.forgotForm.valid)
        {   
             
          
            
            // this.forgotForm.token = this.resetToken;
            //this.commonService.sendRequestToNode({method :'post',path:'forgotpassword',url:'http://localhost:8042',postData:this.loginForm.value}).subscribe(data => {
            
            this.commonService.sendRequestToNode({method :'post',path:'forgotpassword',postData:this.forgotForm.value}).subscribe(data => {
                
                if(data.status == true)
                {
                    alert(data.message);
                    localStorage.clear();
                       this.router.navigate(['/login'])
                }
                else{
                    alert(data.message)
                }
              })
        
        }
        }
}