import { Component, OnInit } from '@angular/core';
import {Injectable,Inject} from '@angular/core';
import { FormArray, FormBuilder, FormGroup,Validators } from '@angular/forms';
import { CommonService } from '../../common-service.service';
import {Router,ActivatedRoute,Params} from "@angular/router";
import { DOCUMENT } from "@angular/common";

declare var $: any;
var classThis;
@Component({    
    templateUrl: './recover.component.html',
    styleUrls: ['./recover.component.scss']
})

export class RecoverComponent implements OnInit {
    displayForm = 'recover';
    public PASSWORD = false;
    recoverForm: FormGroup;
    public formSubmittedAttempt = false;
    public resetToken;
    
    constructor(
        private activatedRoute: ActivatedRoute,
        private formBuilder: FormBuilder,
        private commonService: CommonService,
        private router: Router,
        private route: ActivatedRoute,
        @Inject(DOCUMENT) private document: any) 
        {
            this.addForm();
    }

  
  
    ngOnInit() { 
         this.route.params.subscribe(params => {            
            this.resetToken = params['token'];
         });   
        this.addForm();    
        //this.getLinkDetail();
        this.checkToken();
    }
    

    checkToken(){
        //alert(this.resetToken);
        this.commonService.sendRequestToNode({method :'get',path:'checkToken/'+this.resetToken}).subscribe(result => {     
            if(!result.status){
                alert(result.message);
                this.router.navigate(['/login']);
            }
        })

    }

    // getLinkDetail(){
    //     var data = {'PASSWORD_RESET_TOKEN':JSON.stringify(this.resetToken)};
        
    //     this.commonService.sendRequestToNode({method :'post',path:'getLinkDetail',postData:data}).subscribe(data => {
                
    //         if(data.status == true)
    //         {               
                
    //         }
    //         else{
    //             alert(data.message)
    //             this.router.navigate(['/login'])
    //         }
    //       })
    // }

    addForm(){
        this.recoverForm = this.formBuilder.group({
            PASSWORD : [,[Validators.required]]
        });   
    }

    submitRecoverForm(){
        this.formSubmittedAttempt = true;
        if(this.recoverForm.valid){     
            var postData = {};
            postData = this.recoverForm.value;
            postData['token'] = this.resetToken;

            this.commonService.sendRequestToNode({method :'post',path:'resetPassword',postData:postData}).subscribe(data => {
                    
                if(data.status == true)
                {
                    alert(data.message);
                    localStorage.clear();
                       this.router.navigate(['/login'])
                }
                else{
                    alert(data.message)
                }
            })
        }
    }
      
   
}