import { Component, AfterViewInit, OnInit, createPlatformFactory, ElementRef, ViewChild } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import { Router, ActivatedRoute } from "@angular/router";
import { FormGroup, FormBuilder, Validators, FormControl } from '@angular/forms';
import swal from 'sweetalert2';
//import { parse } from 'path';
import { saveAs } from 'file-saver';


declare var $: any;
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';

@Component({
  // templateUrl: './departments.component.html',
  // styleUrls: ['./departments.component.css']
  // selector: 'app-vessal-pc-software-report',
  templateUrl: './vessal-pc-software-history-report.component.html',
  styleUrls: ['./vessal-pc-software-history-report.component.css']
})
export class VessalPcSoftwareHistoryReportComponent implements AfterViewInit, OnInit {
  public config: PerfectScrollbarConfigInterface = {};

  public modalRef: NgbModalRef;
  public vesselForm: FormGroup;


  public vessel_dropdown_name = [];
  public vesselOwner_data = [];
  public formSubmittedAttempt = false;
  public showLoader = false;
  public filterObj: any = {};
  public sortFilter: any = {};

  //for grid
  public headerInformation;
  public actionButtons;
  public PC_VALUE_DATA = [];
  public PC_ID_Data = [];
  public OFFICE_VALUE_DATA = [];
  public OFFICE_ID_DATA = [];
  public Software_id_data = [];
  public Software_value_data = [];
  public Current_Version_value = []
  public Current_Version_id = []
  public Latest_Version_value = []
  public Latest_Version_id = []
  public vessel_office_id = [];
  public vessel_office_value = []
  public colorFilterdata = '';

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;

  @ViewChild('content') content: ElementRef;
  @ViewChild('autofocus') el: ElementRef;
  @ViewChild('fileInput') fi: ElementRef;

  constructor(
    private commonService: CommonService,) {
    this.getFilterDetails();
    this.declareGridVariable()
  }

  ngAfterViewInit() {
  }

  ngOnInit() {
    this.getData();
  }

  getData() {

    //console.log(this.colorFilterdata);

    let filterParams: any = {}

    this.filterObj = {
      ...this.filterObj,
      color: this.colorFilterdata
    }

    //search filter
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    // pagination
    filterParams.currentPage = this.currentPage - 1;
    filterParams.itemsPerPage = this.itemsPerPage;
    // pagination - end

    //sorting
    let sortKey = Object.keys(this.sortFilter);
    if (sortKey.length && this.sortFilter[sortKey[0]]) {
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end

    this.showLoader = true;
    console.log(filterParams)
    this.commonService.sendRequestToNode({ method: 'get', path: 'vessal-pc-software-history-report/data_list', queryParam: filterParams }).subscribe(result => {
      this.showLoader = false;
      if (result.status) {
        if (result.data.length > 0) {
          this.totalItems = result.data[0].total_records;
          this.vesselOwner_data = result.data;
          console.log(this.vesselOwner_data);
          for (let ele of this.vesselOwner_data) {
            // console.log(ele.CURRENT_VESRION);
            // console.log(ele.LATEST_VERSION_ID);

            console.log(ele.REPORT_DATE)

            // if (ele.LATEST_VERSION_ID == null || ele.CURRENT_VESRION == null) {
            //   ele.COLOR = '#ccefc8';
            // }
            // if (ele.LATEST_VERSION_ID >= ele.CURRENT_VESRION) {
            //   ele.COLOR = '#f7c3c3';
            // }
            // if (ele.LATEST_VERSION_ID == ele.CURRENT_VESRION) {
            //   ele.COLOR = '#ccefc8';
            // }


            if (this.Current_Version_id.length > 0) {
              var found = this.Current_Version_id.filter(function (data) {
                return (data === ele.SELECTED_CURRENT_ID) ? true : false;
              });
            }
            if (!found || found.length <= 0) {
              this.Current_Version_id.push(ele.SELECTED_CURRENT_ID)
              this.Current_Version_value.push(ele.SELECTED_CURRENT_VERSION)
            }
            // vessel  dropdown
            if (this.vessel_office_id.length > 0) {
              var found = this.vessel_office_id.filter(function (data) {
                return (data === ele.VESSEL_NAME_ID) ? true : false;
              });
            }
            if (!found || found.length <= 0) {
              this.vessel_office_id.push(ele.VESSEL_NAME_ID)
              this.vessel_office_value.push(ele.VESSEL_NAME)
            }
          }
          // this.vessel_office_id.forEach( ( x ,i) =>  {
          //   if( typeof x == 'object') {
          //     this.vessel_office_id[i] = 'office'
          //   }
          // });

          console.log(this.vesselOwner_data);

        } else {
          this.vesselOwner_data = [];
        }
      }
      else {
        this.vesselOwner_data = [];
        alert(result.message);
      }
    });
  }


  // part of grid
  declareGridVariable() {
    this.headerInformation = [
      {
        title: 'Vessel/Office',
        name: 'VESSEL_NAME',
        width: '20%',
        // isSortable : true,
        //highlight:true,
        isFilter: { // filter
          type: 'select',
          placeholder: 'Filter By PC',
          options_display: this.vessel_office_value,
          options_value: this.vessel_office_id
        }

      },
      {
        title: ' PC Name',
        name: 'PC',
        width: '10%',

        isFilter: { // filter
          type: 'select',
          placeholder: 'Filter By PC',
          options_display: this.PC_VALUE_DATA,
          options_value: this.PC_ID_Data
        }
      },
      {
        title: ' PC Location ',
        name: 'SELECTED_LOCATION',
        width: '20%',
        isFilter: { // filter
          type: 'select',
          placeholder: 'Filter By Vessel',
          options_display: this.OFFICE_VALUE_DATA,
          options_value: this.OFFICE_ID_DATA

        }
        // isFilter:{ // filter
        //   type : 'text',
        //   placeholder : 'Filter By PC Location',
        // }
      },
      {
        title: 'Software',
        name: 'SOFTWARE_TITLE',
        width: '15%',

        isFilter: { // filter
          type: 'select',
          placeholder: 'Filter By Software',
          options_display: this.Software_value_data,
          options_value: this.Software_id_data
        }
      },
      {
        title: 'Current Version',
        name: 'SELECTED_CURRENT_VERSION',
        width: '10%',
        isFilter: { // filter
          type: 'select',
          placeholder: 'Filter By Current Version',
          options_display: this.Current_Version_value,
          options_value: this.Current_Version_id

        }
      },
      {
        title: 'Latest Version',
        name: 'LATEST_VERSION',
        width: '10%',
        isFilter: { // filter
          type: 'select',
          placeholder: 'Filter By Latest Version',
          options_display: this.Latest_Version_value,
          options_value: this.Latest_Version_id
        }
      },
      {
        title: 'Report Date',
        name: 'REPORT_DATE',
        width: '10%',
        isDate: 'yes'
        // isFilter: { // filter
        //   type: 'select',
        //   placeholder: 'Filter By Current Version',
        //   options_display: this.Current_Version_value,
        //   options_value: this.Current_Version_id
        // }
      },
    ];
  }

  getFilterDetails() {
    this.commonService.sendRequestToNode({ method: 'get', path: 'pc-master' }).subscribe(result => {
      if (result.status) {
        if (result.data.length > 0) {
          result.data.forEach((ele) => {
            this.PC_ID_Data.push(ele.ID)
            this.PC_VALUE_DATA.push(ele.NAME)
          })
        }
      } else {
        alert(result.message);
      }
    })

    this.commonService.sendRequestToNode({ method: 'get', path: 'office-location-dropDown' }).subscribe(result => {
      if (result.status) {
        if (result.data.length > 0) {
          result.data.forEach((ele) => {
            this.OFFICE_ID_DATA.push(ele.ID)
            this.OFFICE_VALUE_DATA.push(ele.TITLE)
          })
        }
      }
      else {
        alert(result.message);
      }
    })

    this.commonService.sendRequestToNode({ method: 'get', path: 'softwaredropdown' }).subscribe(result => {
      if (result.status) {
        if (result.data.length > 0) {
          result.data.forEach((ele) => {
            this.Software_id_data.push(ele.ID);
            this.Software_value_data.push(ele.SOFTWARE_TITLE);
          })
        }
      } else {
        alert(result.message);
      }
    })

    this.commonService.sendRequestToNode({ method: 'get', path: 'software-data' }).subscribe(result => {
      if (result.status) {
        if (result.data.length > 0) {
          result.data.forEach((ele) => {
            if (ele.IS_LATEST == 1) {
              this.Latest_Version_id.push(ele.ID);
              this.Latest_Version_value.push(ele.VERSION);
            }
          })
        }
      }
      else {
        alert(result.message);
      }
    })

  }

  //part of grid
  //when change filter ,change page no . etc,
  filter($event) {
    let obj = $event;
    console.log(obj.filter)
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getData();
  }

  // exportData() {
  //   this.formSubmittedAttempt = true;
  //   if (this.vesselForm.valid) {

  //     let Vessel_ID = this.vesselForm.value.Vessel_ID;
  //     Vessel_ID.forEach(element => {
  //       window.open(this.commonService.getNodeApi() + '/vessal-pc-software-report/exportXls?Vessel_ID=' + element + '&VesselName=' + this.vessel_dropdown_name[element], '_blank')
  //     })
  //     this.modalRef.close();

  //   }

  // }

  getDataforcsv() {
    this.commonService.sendRequestToNode({ method: 'post', path: 'vessal-pc-software-report-csv/generateReportCsv', postData: { vesselOwner_data: this.vesselOwner_data } }, { responseType: 'blob' }).subscribe(result => {
      saveAs(result, `SoftwareReport.xlsx`)
    })
  }

  getDataforPdf() {
    this.commonService.sendRequestToNode({ method: 'post', path: 'vessal-pc-software-report-pdf/generateReportPdf', postData: { vesselOwner_data: this.vesselOwner_data } }, { responseType: 'blob' }).subscribe(result => {
      saveAs(result, `SoftwareReport.pdf`)
    })
  }

}
