import { Component, AfterViewInit,OnInit, createPlatformFactory,ElementRef,ViewChild,ViewContainerRef } from '@angular/core';
import { NgbPaginationConfig, NgbModal, NgbModalRef, ModalDismissReasons,NgbTabset } from '@ng-bootstrap/ng-bootstrap';
import { CommonService } from '../common-service.service';
import {Router,ActivatedRoute} from "@angular/router";
import {FormGroup,FormBuilder,Validators,FormControl} from '@angular/forms';
import swal from 'sweetalert2';
//import { parse } from 'path';

declare var $: any;
import { PerfectScrollbarConfigInterface,PerfectScrollbarDirective } from 'ngx-perfect-scrollbar';

@Component({
  templateUrl: './vessel-master.component.html',
  styleUrls: ['./vessel-master.component.scss']
})
export class VesselMasterComponent implements AfterViewInit,OnInit {

  public config: PerfectScrollbarConfigInterface = {};
  public modalRef:NgbModalRef;

  tabStatus = 'justified';

  @ViewChild(PerfectScrollbarDirective) directiveRef?: PerfectScrollbarDirective;
  @ViewChild('fileInput') fi:ElementRef;
  // @ViewChild('vesselNameInput',{read: ViewContainerRef}) vesselNameInput:ElementRef;
  private vesselNameInputRef:ElementRef;
@ViewChild('vesselNameInput') set vesselNameInput(elRef: ElementRef) {
    this.vesselNameInputRef = elRef;
}
  @ViewChild('tabs')
  public tabs:NgbTabset;
  public VesselMasterForm:FormGroup;
  public groupSireReportUpload:FormGroup;
  public vesselMaster_data = [];
  public vesselType_dropdown = [];
  public template_type_dropdown = [];
  public vesselClass_dropdown = [];
  public vesselFlag_dropdown = [];
  public vesselOwner_dropdown = [];
  public fleetManager_dropdown = [];
  public vesselGroup_dropdown = [];
  public vesselFleet_dropdown = [];
  public OLD_VESSEL_NAME = null// for store old vessel-Name
  public OLD_VESSEL_OWNER_FK = null// for store old vessel-owner
  public OLD_VESSEL_FLEET_FK = null// for store old vessel-GROUP
  public OLD_VESSEL_GROUP_FK = null// for store old vessel-fleet
  public OLD_MARINE_SUPERINTENDENT_FK = null// for store old marine supreintendent
  public OLD_TECHNICIAN_SUPERINTENDENT_FK = null// for store old marine supreintendent
  public vesselMaster_view;
  public edit_id;
  public formSubmittedAttempt = false;
  public openRightSidebar = false;
  public showSideBarLoader = false;
  public showLoader = false;
  public viewData = false;
  public filterObj:any = {};
  public sortFilter:any = {};
  public technical_user_dropdown = [];
  public user_dropdown = [];
  public marine_user_dropdown = [];
  
  //for grid 
  public headerInformation;
  public actionButtons;

  //for pagination
  itemsPerPage: number = this.commonService.DefaultItemsPerPage;
  totalItems: number;
  currentPage: number = 1;
  
  @ViewChild('autofocus') el:ElementRef;

  constructor(private modalService: NgbModal,
    private commonService: CommonService,
    private router: Router,
    private formBuilder: FormBuilder,
    private route: ActivatedRoute){
    this.declareGridVariable()
  }

  // part of grid
  declareGridVariable(){
    this.headerInformation = [
    {
      title : 'Vessel Name',// show title table header
      name:'VESSEL_NAME',// name of column in data source
      width : '15%',// width of column in table
      isSortable : true,// sort by column false or true
      highlight:true, // name highlight
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By Vessel Name'
      }
    },
    {
      title : 'IMO No.',// show title table header
      name:'IMO_NO',// name of column in data source
      width : '15%',// width of column in table
      isSortable : true,// sort by column false or true
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By IMO No.'
      }
    },
    {
      title : 'OCIMF ID',// show title table header
      name:'OCIMF_ID',// name of column in data source
      width : '15%',// width of column in table
      isSortable : true,// sort by column false or true
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By OCIMF ID'
      }
    },
    {
      title : 'Vessel Flag',
      name:'VESSEL_FLAG_NAME',
      width : '15%',
      isSortable : true,
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By Vessel Flag'
      }
    },
    {
      title : 'Fleet Manager',
      name:'FULLNAME',
      width : '15%',
      isSortable : true,
      isFilter:{ // filter 
        type : 'text',
        placeholder : 'Filter By Fleet Manager'
      }
    },
    { 
      title : 'Status',
      name:'ACTIVE_FLAG',
      display_value: {1:'Active',0:'Inactive'},
      width : '10%',
      isFilter:{ // filter 
        type : 'select',
        placeholder : 'Filter By Status',
        options_value : [1,0],
        options_display : ['Active','Inactive']
      }
    },
    {title : 'Action',name:'action',width : '15%'}
    ];
    this.actionButtons = [
    {title:'View',class : "fas fa-eye"},
    {title:'Edit',class : "far fa-edit",'redColor':'FIELD_REMAIN','note':'Some fields are remaining to be filled'},
    {title:'Delete',class : "far fa-trash-alt"}
    ]
  }
  
  ngAfterViewInit(){

  }

  ngOnInit(){
  //   $('body').keypress(function(e){
  //     alert(e.which);
  //     if(e.which == 27){
  //         // Close my modal window
  //     }
  // });
    this.getData();
    this.addForm();
  }

  vesselType(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselType'}).subscribe(result => {
      if(result.status){
        this.vesselType_dropdown = result.data;
        //console.log(this.vesselType_dropdown);
      }
      else{
        this.vesselType_dropdown = [];
        alert(result.message);
      }
    })
  }
  templateTypeDropdown(id) {
    //sire-dropdown
    this.commonService.sendRequestToNode({ method: 'get', path: 'template-type-dropdown' }).subscribe(result => {
        if (result.status) {
            this.template_type_dropdown = result.data;
            if(id){
              this.VesselMasterForm.patchValue({
                TEMPLATE_TYPE_FK : id 
              })
            }
        }
        else {
            this.template_type_dropdown = [];
        }
    });
}
  vesselClass(){
    this.commonService.sendRequestToNode({method :'get',path:'society-dropdown'}).subscribe(result => {
      if(result.status){
        this.vesselClass_dropdown = result.data;
      }
      else{
        this.vesselClass_dropdown = [];
        alert(result.message);
      }
    })
  }

  vesselFlag(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselFlag'}).subscribe(result => {
      if(result.status){
        this.vesselFlag_dropdown = result.data;
        //console.log(this.vesselFlag_dropdown);
      }
      else{
        this.vesselFlag_dropdown = [];
        alert(result.message);
      }
    })
  }

  vesselOwner(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselOwner'}).subscribe(result => {
      if(result.status){
        this.vesselOwner_dropdown = result.data;
        //console.log(this.vesselOwner_dropdown);
      }
      else{
        this.vesselOwner_dropdown = [];
        alert(result.message);
      }
    })
  }
  
  getUserData(){
    this.commonService.sendRequestToNode({method :'get',path:'user-dropdown',queryParam:{allusers : true} }).subscribe(result => {
      if(result.status){
        this.user_dropdown = result.data;
        //console.log(this.technical_user_dropdown);
      }
      else{
        this.user_dropdown = [];
        alert(result.message);
      }
    })
  }

  getTechnicalUserData(){
    this.commonService.sendRequestToNode({method :'get',path:'user-dropdown',queryParam:{type:'technical_superintendent',allusers : true}}).subscribe(result => {
      if(result.status){
        this.technical_user_dropdown = result.data;
        //console.log(this.technical_user_dropdown);
      }
      else{
        this.technical_user_dropdown = [];
        alert(result.message);
      }
    })
  }

  getMarineUserData(){
    this.commonService.sendRequestToNode({method :'get',path:'user-dropdown',queryParam:{type:'marine_superintendent',allusers : true}}).subscribe(result => {
      if(result.status){
        this.marine_user_dropdown = result.data;
        //console.log(this.marine_user_dropdown);
      }
      else{
        this.marine_user_dropdown = [];
        alert(result.message);
      }
    })
  }
  
  vesselGroup(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselGroup'}).subscribe(result => {
      if(result.status){
        this.vesselGroup_dropdown = result.data;
        //console.log(this.vesselGroup_dropdown);
      }
      else{
        this.vesselGroup_dropdown = [];
        alert(result.message);
      }
    })
  }

  vesselFleet(){
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/vesselFleet'}).subscribe(result => {
      if(result.status){
        this.vesselFleet_dropdown = result.data;
        //console.log(this.vesselFleet_dropdown);
      }
      else{
        this.vesselFleet_dropdown = [];
        alert(result.message);
      }
    })
  }

  // onFileChange(event) {
  //   if(event.target.files.length > 0) {
  //     let file = event.target.files[0];
  //     this.groupSireReportUpload.get('FILE').setValue(file);
  //   }
  // }
  onFileChange(event) {
    let file = [];
    if(event.target.files.length > 0 && event.target.files.length <= 20) {
      for (var i = 0; i < event.target.files.length; i++) { 
        file.push(event.target.files[i]);
      }
      this.groupSireReportUpload.get('FILE').setValue(file);
    }else{
      alert('You can only upload upto 20 files');
      this.fi ? this.fi.nativeElement.value = "" : '';
    }
  }

  addForm(){

    this.groupSireReportUpload = this.formBuilder.group({
      FILE: ['',[Validators.required]],
      VESSEL_OWNER_FK:null 
    });   
    
    this.VesselMasterForm = this.formBuilder.group({
      VESSEL_TYPE_FK: [null,],
      TEMPLATE_TYPE_FK : [null],
      VESSEL_CLASS_FK: [null,],
      VESSEL_FLAG_FK: [null,],
      VESSEL_OWNER_FK: [null,],
      VESSEL_FLEET_FK: [null,],
      VESSEL_GROUP_FK: [null,],
      VESSEL_NAME: [null,],
      IMO_NO: [null,],
      OCIMF_ID: [null,],
      FLEET_MANAGER_FK: [null,],
      HVPQ_REF_NUMBER: [null,],
      DEADWEIGHT: [null,],
      MARINE_SUPERINTENDENT_FK: [null,],
      TECHNICIAN_SUPERINTENDENT_FK: [null,],
      // SHIP_BUILT_DATE: [null,],
      DELIVERY_DATE: [null,],
      ACTIVE_FLAG: [''],
    });   
  }

  edit(id){
    this.directiveRef.scrollToTop();
    this.vesselType();
    
    this.vesselClass();
    this.vesselFlag();
    this.vesselOwner();
    this.getTechnicalUserData();
    this.getUserData();
    this.getMarineUserData();
    this.vesselGroup();
    this.vesselFleet();

    this.openRightSidebar = true;
    // this.el.nativeElement.focus();
    this.showSideBarLoader = true;
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/getById/'+id}).subscribe(
      data => { 
        this.edit_id = id;

        if(this.tabs) {
          this.tabs.select('manual');
            setTimeout(()=> {
              this.vesselNameInputRef.nativeElement.focus()
          });
        } 
        
        this.OLD_VESSEL_NAME = data.data.VESSEL_NAME;
        this.OLD_VESSEL_OWNER_FK = data.data.VESSEL_OWNER_FK;
        this.OLD_VESSEL_FLEET_FK = data.data.VESSEL_FLEET_FK;
        this.OLD_VESSEL_GROUP_FK = data.data.VESSEL_GROUP_FK;
        this.OLD_MARINE_SUPERINTENDENT_FK = data.data.MARINE_SUPERINTENDENT_FK;
        this.OLD_TECHNICIAN_SUPERINTENDENT_FK = data.data.TECHNICIAN_SUPERINTENDENT_FK;
        //console.log(data.data.EXPIRY_DATE);
        let date = new Date(data.data.DELIVERY_DATE);
        //console.log(date);
        //  = date.getFullYear()+'-'+(date.getMonth()+1)+'-'+date.getDate(); 
        data.data.DELIVERY_DATE = date.getFullYear()+'-'+('0' + (date.getMonth()+1)).slice(-2)+'-'+('0' + (date.getDate())).slice(-2); 
        //console.log(data.data.EXPIRY_DATE);
        let fleetFk = [];
        if(data.data.VESSEL_FLEET_FK){
          fleetFk = data.data.VESSEL_FLEET_FK.split(',').map(function (value) {
            return parseInt(value)
          });
        }

        let groupFk = [];
        if(data.data.VESSEL_GROUP_FK){
          groupFk = data.data.VESSEL_GROUP_FK.split(',').map(function (value) {
            return parseInt(value)
          });
        }
        this.templateTypeDropdown(data.data.TEMPLATE_TYPE_FK);
        this.VesselMasterForm.patchValue({
          VESSEL_TYPE_FK : (data.data.VESSEL_TYPE_FK != null || data.data.VESSEL_TYPE_FK != '') ? data.data.VESSEL_TYPE_FK : null,
          TEMPLATE_TYPE_FK : data.data.TEMPLATE_TYPE_FK ? data.data.TEMPLATE_TYPE_FK : null,
          VESSEL_CLASS_FK : data.data.VESSEL_CLASS_FK ? data.data.VESSEL_CLASS_FK : null,
          VESSEL_FLAG_FK : data.data.VESSEL_FLAG_FK ? data.data.VESSEL_FLAG_FK : null,
          VESSEL_OWNER_FK : data.data.VESSEL_OWNER_FK ? data.data.VESSEL_OWNER_FK : null,
          VESSEL_FLEET_FK : fleetFk,
          VESSEL_GROUP_FK : groupFk,
          VESSEL_NAME : data.data.VESSEL_NAME,
          IMO_NO : data.data.IMO_NO,
          OCIMF_ID : data.data.OCIMF_ID,
          FLEET_MANAGER_FK : data.data.FLEET_MANAGER_FK ? data.data.FLEET_MANAGER_FK : null,
          HVPQ_REF_NUMBER : data.data.HVPQ_REF_NUMBER,
          DEADWEIGHT : data.data.DEADWEIGHT,
          MARINE_SUPERINTENDENT_FK : data.data.MARINE_SUPERINTENDENT_FK ? data.data.MARINE_SUPERINTENDENT_FK : null,
          TECHNICIAN_SUPERINTENDENT_FK : data.data.TECHNICIAN_SUPERINTENDENT_FK ? data.data.TECHNICIAN_SUPERINTENDENT_FK : null,
          // SHIP_BUILT_DATE : data.data.SHIP_BUILT_DATE,
          DELIVERY_DATE : data.data.DELIVERY_DATE,
          ACTIVE_FLAG : data.data.ACTIVE_FLAG.toString(),
        });
        this.showSideBarLoader = false;
      })
  }

  onSubmit(){

    if(this.tabs.activeId == 'manual'){
      this.submitManualReportForm();return false;
    }
    else{
      if(this.groupSireReportUpload.valid){
        this.showSideBarLoader = true;
        let formData = new FormData();//this.oilMajorForm.value
        for (var i = 0; i < this.groupSireReportUpload.get('FILE').value.length; i++) { 
          formData.append('FILE',this.groupSireReportUpload.get('FILE').value[i] );
        }
        
        formData.append('VESSEL_OWNER_FK',this.groupSireReportUpload.get('VESSEL_OWNER_FK').value );
        this.commonService.sendRequestToNode({method :'post',path:'upload-vessel-master',postData:formData}).subscribe(
          data =>{
            var dialogueTitle = "Uploaded!";
            
            let errorStr = "<div>"+ data.message +"</div><br>";
            if(data.errObj && data.errObj.length>0){
              data.errObj.forEach((element) => {
                errorStr += "<div class='uploadrow'><span>"+ element.imoNo + "</span><div class='uploadrow_error'>"+ element.message + "</div></div>"
              });
            }
            this.showSideBarLoader = false;
            if(data.status){
              swal({
                title: dialogueTitle,
                html:errorStr,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }
            else{
              var dialogueTitle = "Fail!";
              swal({
                title: dialogueTitle,
                html:errorStr,
                type: 'warning',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }
          })
      }  
    }
    return false;
  }

  submitManualReportForm(){
    //console.log(this.edit_id);
    this.formSubmittedAttempt = true;
    this.showSideBarLoader = true;
    if(this.VesselMasterForm.valid){
      if(this.edit_id){
        let postOBJ = this.VesselMasterForm.value;
        postOBJ.OLD_VESSEL_NAME = this.OLD_VESSEL_NAME;
        postOBJ.OLD_VESSEL_OWNER_FK = this.OLD_VESSEL_OWNER_FK;
        postOBJ.OLD_VESSEL_FLEET_FK = this.OLD_VESSEL_FLEET_FK;
        postOBJ.OLD_VESSEL_GROUP_FK = this.OLD_VESSEL_GROUP_FK;
        postOBJ.OLD_MARINE_SUPERINTENDENT_FK = this.OLD_MARINE_SUPERINTENDENT_FK;
        postOBJ.OLD_TECHNICIAN_SUPERINTENDENT_FK = this.OLD_TECHNICIAN_SUPERINTENDENT_FK;

        postOBJ.ACTIVE_FLAG = 0;
        this.commonService.sendRequestToNode({method :'put',path:'vessel_master/edit/'+this.edit_id,postData:postOBJ}).subscribe(
          data =>{
            var dialogueTitle = "Updated!";
            this.showSideBarLoader = false;
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }else{
              alert(data.message);
            }
          })
      }else{
        this.VesselMasterForm.value.ACTIVE_FLAG = 0;
        this.commonService.sendRequestToNode({method :'post',path:'vessel_master/add',postData:this.VesselMasterForm.value}).subscribe(
          data =>{
            var dialogueTitle = "Inserted!";
            this.showSideBarLoader = false;
            if(data.status){
              swal({
                title: dialogueTitle,
                text: data.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
              this.getData();
              this.openRightSidebar = false;
              this.resetForm();
            }else{
              alert(data.message);
            }
          })
      }
    }
  }

  getData()
  {
    let filterParams:any = {}
    
    //search filter 
    filterParams = JSON.parse(JSON.stringify(this.filterObj));
    //search filter -end

    // pagination
    filterParams.currentPage = this.currentPage-1;
    filterParams.itemsPerPage = this.itemsPerPage;
    // pagination - end

    //sorting 
    let sortKey = Object.keys(this.sortFilter);
    if(sortKey.length && this.sortFilter[sortKey[0]]){
      filterParams.sortBy = sortKey[0];
      filterParams.sortStatus = this.sortFilter[sortKey[0]];
    }
    //sorting - end

    this.showLoader = true;

    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/data_list',queryParam:filterParams}).subscribe(result => {
      this.showLoader = false;    
      if(result.status)
      {
        if(result.data.length > 0){
          this.totalItems = result.data[0].total_records;
          this.vesselMaster_data = result.data;
        }else{
          this.vesselMaster_data = [];
        }
      }
      else{
        this.vesselMaster_data = [];
        alert(result.message);
      }
    })
  }

  delete(id){
    //console.log(id);
    if (id) {

      swal({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        type: 'warning',
        showCancelButton: true,
        confirmButtonClass: 'btn btn-success',
        cancelButtonClass: 'btn btn-danger',
        confirmButtonText: 'Yes, delete it!',
        buttonsStyling: false
        
      }).then((result) => {
        if (result.value) {   
          this.commonService.sendRequestToNode({method :'delete',path:'vessel_master/delete/'+id}).subscribe(result => {
            if(result.status){
              var dialogueTitle = "Deleted!"
              if(this.vesselMaster_data.length == 1 && Math.ceil(this.totalItems / this.itemsPerPage) == this.currentPage){
                if(this.currentPage>1){
                  this.currentPage--;
                }
              }
              this.getData();
              swal({
                title: dialogueTitle,
                text: result.message,
                type: 'success',
                confirmButtonClass: "btn btn-success",
                buttonsStyling: false
              })
            }
          })
        }
      })
    }
  }

  view(id){
    this.directiveRef.scrollToTop();
    this.viewData = true;
    this.openRightSidebar = true;
    this.showSideBarLoader = true;
    // this.el.nativeElement.focus();
    //console.log(id);
    this.commonService.sendRequestToNode({method :'get',path:'vessel_master/getById/'+id}).subscribe(result => {
      this.showSideBarLoader = false;    
      if(result.status)
      {
        this.vesselMaster_view = result.data;
        //console.log(this.vesselMaster_view);
      }
      else{
        alert(result.message)
      }
    })
  }

  resetForm(){
    this.formSubmittedAttempt = false;
    this.openRightSidebar = false;
    this.fi ? this.fi.nativeElement.value = "" : '';
    this.viewData = false;
    this.edit_id = '';
    this.VesselMasterForm.patchValue({
      VESSEL_TYPE_FK: null,
      TEMPLATE_TYPE_FK : null,
      VESSEL_CLASS_FK: null,
      VESSEL_FLAG_FK: null,
      VESSEL_OWNER_FK: null,
      VESSEL_FLEET_FK: null,
      VESSEL_GROUP_FK: null,
      VESSEL_NAME: null,
      IMO_NO: null,
      OCIMF_ID: null,
      FLEET_MANAGER_FK: null,
      HVPQ_REF_NUMBER: null,
      DEADWEIGHT: null,
      MARINE_SUPERINTENDENT_FK: null,
      TECHNICIAN_SUPERINTENDENT_FK : null,
      // SHIP_BUILT_DATE: null,
      DELIVERY_DATE: null,
      ACTIVE_FLAG: '',
    });
    this.groupSireReportUpload.patchValue({
      FILE: null,
      VESSEL_OWNER_FK:null 
    });
  }

  //part of grid
  clickOnAction(actionObj){
    if(actionObj.actionName == 'View'){
      this.view(actionObj.object.ID);
    }else if(actionObj.actionName == 'Edit'){
      this.edit(actionObj.object.ID);
    }else if(actionObj.actionName == 'Delete'){
      this.delete(actionObj.object.ID);
    }else if(actionObj.actionName == 'Status'){
      this.statusChange(actionObj.object.ID,actionObj.object)
    }
  }

  statusChange(id,obj){
    if(obj.ACTIVE_FLAG == 1){
      obj.ACTIVE_FLAG = 0;
    }else{
      obj.ACTIVE_FLAG = 1;
    }

    this.commonService.sendRequestToNode({method :'put',path:'vessel_master/edit/'+id,postData:{ACTIVE_FLAG:obj.ACTIVE_FLAG}}).subscribe(
      data =>{
        var dialogueTitle = "Updated!";
        if(data.status){
          swal({
            title: dialogueTitle,
            text: data.message,
            type: 'success',
            confirmButtonClass: "btn btn-success",
            buttonsStyling: false
          })
          this.getData();
          this.openRightSidebar = false;
          this.resetForm();
        }else{
          alert(data.message);
        }
      })

  }


  
  //part of grid
  //when change filter ,change page no . etc, 
  filter($event){
    let obj = $event;
    this.currentPage = obj.page;
    this.filterObj = obj.filter;
    this.sortFilter = obj.sort
    this.getData();
  }

  //part of grid
  funOpenRightSidebar(){
    if(this.tabs) {
      this.tabs.select('upload')
    }
    this.directiveRef.scrollToTop();
    this.vesselType();
    this.templateTypeDropdown(0);
    this.vesselClass();
    this.vesselFlag();
    this.vesselOwner();
    this.getTechnicalUserData();
    this.getMarineUserData();
    this.getUserData();
    this.vesselGroup();
    this.vesselFleet();
    this.openRightSidebar = true;
    this.fi.nativeElement.focus()
    // $("autofoucs").scrollTop(0).perfectScrollbar('update');
  }



}
