import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule,ReactiveFormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';

import { NgbModule } from '@ng-bootstrap/ng-bootstrap';

import { VettingComponent } from './vettingApproval.component';

// import { GridViewComponent } from '../grid-view/grid-view.component';

import { PerfectScrollbarModule } from 'ngx-perfect-scrollbar';
import { PERFECT_SCROLLBAR_CONFIG } from 'ngx-perfect-scrollbar';
import { PerfectScrollbarConfigInterface } from 'ngx-perfect-scrollbar';
import { GridViewModule} from '../shared/grid-view/grid-view.module';
import { NgSelectModule } from '@ng-select/ng-select';
import { UiSwitchModule } from 'ngx-toggle-switch';

const DEFAULT_PERFECT_SCROLLBAR_CONFIG: PerfectScrollbarConfigInterface = {
  suppressScrollX: true,
  wheelSpeed: 1,
  wheelPropagation: true,
  minScrollbarLength: 20
};
const routes: Routes = [
  {
    path: '',
    data: {
      title: 'Vetting Approval',
      urls: [
        { title: 'Home', url: '/home' },
        { title: 'Vetting Approval' }
      ]
    },
    component: VettingComponent
  }
];

// @NgModule({
//   imports: [FormsModule, CommonModule, RouterModule.forChild(routes),NgbModule,NgSelectModule],
//   declarations: [InspectionPlanningComponent]
// })
@NgModule({
  imports: [
    FormsModule,
    CommonModule,
    RouterModule.forChild(routes),
    NgbModule,
    ReactiveFormsModule,
    PerfectScrollbarModule,
    GridViewModule,
    NgSelectModule,
    UiSwitchModule
  ],
  declarations: [
    VettingComponent
  ],
  providers: [
    {
      provide: PERFECT_SCROLLBAR_CONFIG,
      useValue: DEFAULT_PERFECT_SCROLLBAR_CONFIG
    },
  ]
})
export class VettingModule {}
