import { Component, OnInit, ViewChild, ElementRef } from '@angular/core';
import { CommonService } from '../common-service.service';
import { NgbModal, NgbModalRef } from '@ng-bootstrap/ng-bootstrap';
import swal from 'sweetalert2';
import { NgbTabset } from '@ng-bootstrap/ng-bootstrap';
import html2canvas from 'html2canvas';
import { saveAs } from 'file-saver';

//this is define because some issue in retention page(when load this page and go)
import * as pluginAnnotations from 'chartjs-plugin-annotation';
import 'chartjs-plugin-labels';
import { json } from 'd3';

//import { GoogleChartComponent } from 'angular-google-charts';

@Component({
    templateUrl: './wizard.component.html',
    styleUrls: ['./wizard.component.scss']
})
export class WizardComponent implements OnInit {
    tabStatus = 'justified';
    nameOfMonth = ['January', 'February', 'March', 'April', 'May', 'June', 'July', 'August', 'September', 'October', 'November', 'December'];;
    sortNameOfMonth = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'June', 'July', 'Aug', 'Sept', 'Oct', 'Nov', 'Dec'];;
    public saved_reports = [];
    // public timeLineArr = [];
    public timeLineArr = [];
    public timeLineLabelArr = [];
    public dataFilter = {};
    // public timeLineArr = [];
    // public timeLineArr = [];
    public vesselFleet_dropdown = [];
    public vesselGroup_dropdown = [];
    public vesselOwner_dropdown = [];
    public question_numbers = [];
    public sire_dropdown = [];
    public oilMajor_dropdown = [];
    public vesselType_dropdown = [];
    public vessel_dropdown = [];
    public pluginAnnotations = pluginAnnotations;
    public user_dropdown = [];
    public marineUser_dropDown = [];
    public techinalUser_dropDown = [];
    public isRiskCompany = false;
    public generate_report_id = [];
    public generateReportData;
    public headerInformation = [];
    public sortFilter: any = {};

    itemsPerPage: number = this.commonService.DefaultItemsPerPage;
    totalItems: number;
    currentPage: number = 1;

    public lineChartColors: Array<any> = [];
    public filterObj = {
        from_date: this.commonService.formatDate(new Date(new Date().setFullYear(new Date().getFullYear() - 1))),
        to_date: this.commonService.formatDate(new Date()),
        timespan: null,
        consolidated_ship: 'true',
        x_axis: null,
        y_axis: null,
        selectedValueForX_axis: null
    }

    public modalObj: any = {};
    public modalRef: NgbModalRef;
    public range_dropdown = [];
    public y_axis_dropdown = [
        { ID: 'avg_observation', ITEM: "Average Number of observations" },
        { ID: 'total_observation', ITEM: "Total Number of Observations" },
        { ID: 'total_inspection', ITEM: "Total number of Inspections" },
        { ID: 'avg_risk', ITEM: "Average Risk Value" },
        { ID: 'risk_value_count', ITEM: "Number of V.High, High, Medium, Low Obs" },
        { ID: 'oil_major', ITEM: "Inspection per Oil Major" },
        { ID: 'top_ten_repeat_question', ITEM: "Top 10 Repeat Questions" },

    ];
    public y_axis_label = {
        'avg_observation': "Average Number of observations",
        'total_observation': "Total Number of Observations",
        'total_inspection': "Total number of Inspections",
        'avg_risk': "Average Risk Value",
        'risk_value_count': "Number of V.High, High, Medium, Low Obs",
        'oil_major': 'Inspection per Oil Major',
        'top_ten_repeat_question': "Top 10 Repeat Questions"
    };
    public x_axis_dropdown = [];

    public x_axis_label = {
        'timespan': "Timespan",
        'vessel_group': "Vessel Group",
        'ship_owner': "Ship Owners",
        'oil_major': "Oil Majors",
        'viq_chapter': "VIQ Chapters",
        'number_of_observation': "Number of Observations",
        'vessel': 'Vessel',
        'vessel_type': "Vessel Type",
        'vessel_fleet': "Vessel Fleet",
        'vessel_marine': "Vessel Marine Superintendent",
        'vessel_technical': "Vessel Technical Superintendent",
    };

    public showLoader = false;

    constructor(private commonService: CommonService,
        private modalService: NgbModal, public tabset: NgbTabset) {
        this.declareGridVariable();
    }
    @ViewChild('screen') screen: ElementRef;
    @ViewChild('canvas') canvas: ElementRef;
    @ViewChild('downloadLink') downloadLink: ElementRef;
    @ViewChild('tabs')
    private tabs: NgbTabset;

    ngOnInit() {
        this.userDropdown();
        this.get_list_of_report();
        this.getTimeLineInDropDown();
    }

    declareGridVariable() {
        this.headerInformation = [
            {
                title: 'Vessel Name',// show title table header
                name: 'VESSEL_NAME',// name of column in data source
                width: '10%',// width of column in table
                isSortable: true,// sort by column false or true
                highlight: true, // name highlight
                isFilter: { // filter 
                    type: 'text',
                    placeholder: 'Filter By Vessel Name'
                }
            },
            {
                title: 'Oil Major',// show title table header
                name: 'INSPECTING_COMPANY',// name of column in data source
                width: '20%',// width of column in table
                // isSortable : true,// sort by column false or true
                isFilter: { // filter 
                    type: 'text',
                    placeholder: 'Filter By Oil Major'
                }
            },
            { title: 'Inspector ', name: 'INSPECTOR_NAME', width: '10%', isSortable: true, },
            { title: 'Port', name: 'PORT_OF_INSPECTION', width: '10%', isSortable: true, },
            {
                title: 'VIQ Question Number',
                name: 'QUESTION_NUMBER',
                width: '10%',
                isSortable: true,// sort by column false or true
                isFilter: { // filter 
                    type: 'text',
                    placeholder: 'Filter By VIQ'
                }
            },
            { title: 'Question Text', name: 'QUESTION_DESCRIPTION', width: '20%', isSortable: true, },
            { title: 'Observation Text', name: 'observation', width: '20%', isSortable: true, },
        ];

    }

    getXaxis(call_from_save_report = 0) {
        (call_from_save_report == 0) ? this.filterObj.x_axis = null : '';
        if (this.filterObj.y_axis == "avg_observation" || this.filterObj.y_axis == "risk_value_count" || this.filterObj.y_axis == 'total_observation') {
            this.x_axis_dropdown = [
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel', ITEM: "Vessel Name" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'ship_owner', ITEM: "Ship Owners" },
                { ID: 'oil_major', ITEM: "Oil Majors" },
                { ID: 'viq_chapter', ITEM: "VIQ Chapters" },
                { ID: 'vessel_type', ITEM: "Vessel Type" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" },
            ];
        }
        else if (this.filterObj.y_axis == "total_inspection") {
            this.x_axis_dropdown = [
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel', ITEM: "Vessel Name" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'ship_owner', ITEM: "Ship Owners" },
                { ID: 'oil_major', ITEM: "Oil Majors" },
                // { ID: 'number_of_observation', ITEM: "Number of Observations" },
                { ID: 'vessel_type', ITEM: "Vessel Type" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" },
            ];
        }
        else if (this.filterObj.y_axis == "oil_major") {
            this.x_axis_dropdown = [
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'ship_owner', ITEM: "Ship Owners" },
                { ID: 'vessel_type', ITEM: "Vessel Type" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
            ];
        } else if (this.filterObj.y_axis == "top_ten_repeat_question") {
            this.x_axis_dropdown = [
                { ID: 'vessel', ITEM: "Vessel Name" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'ship_owner', ITEM: "Ship Owners" },
                { ID: 'oil_major', ITEM: "Oil Majors" },
                { ID: 'viq_chapter', ITEM: "VIQ Chapters" },
                { ID: 'vessel_type', ITEM: "Vessel Type" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" },
            ];
        }
        else {
            this.x_axis_dropdown = [
                { ID: 'timespan', ITEM: "Timespan" },
                { ID: 'vessel', ITEM: "Vessel Name" },
                { ID: 'vessel_group', ITEM: "Vessel Group" },
                { ID: 'ship_owner', ITEM: "Ship Owners" },
                { ID: 'oil_major', ITEM: "Oil Majors" },
                { ID: 'viq_chapter', ITEM: "VIQ Chapters" },
                // { ID: 'number_of_observation', ITEM: "Number of Observations" },
                { ID: 'vessel_type', ITEM: "Vessel Type" },
                { ID: 'vessel_fleet', ITEM: "Vessel Fleet" },
                { ID: 'vessel_marine', ITEM: "Vessel Marine Superintendent" },
                { ID: 'vessel_technical', ITEM: "Vessel Technical Superintendent" },
            ];
        }
        if (this.filterObj.timespan) {
            // remove timespan from x_axis when Default timeSpan selected
            this.x_axis_dropdown = this.x_axis_dropdown.filter(ele => {
                if (ele.ID == 'timespan') {
                    return false;
                }
                else {
                    return true;
                }
            })
        }

        if (this.filterObj.timespan && this.filterObj.consolidated_ship == "false") {
            this.y_axis_dropdown = [
                { ID: 'avg_observation', ITEM: "Average Number of observations" },
                { ID: 'total_observation', ITEM: "Total Number of Observations" },
                { ID: 'total_inspection', ITEM: "Total number of Inspections" },
                { ID: 'avg_risk', ITEM: "Average Risk Value" },
                { ID: 'risk_value_count', ITEM: "Number of V.High, High, Medium, Low Obs" },
                { ID: 'oil_major', ITEM: "Inspection per Oil Major" },
            ];
        }

    }

    getDropDownFrom_xaxis(call_from_save_report = 0) {

        if (call_from_save_report != 1) {
            this.filterObj.selectedValueForX_axis = null;
        }
        if (this.filterObj.x_axis == 'timespan') {
            this.getTimeLineInDropDown();
        }
        else if (this.filterObj.x_axis == 'vessel') {
            this.vesselDropdown();
        }
        else if (this.filterObj.x_axis == 'vessel_group') {
            this.vesselGroupDropdown();
        }
        else if (this.filterObj.x_axis == 'ship_owner') {
            this.vesselOwnerDropdown();
        }
        else if (this.filterObj.x_axis == 'oil_major') {
            this.oilMajorDropdown();
        }
        else if (this.filterObj.x_axis == 'viq_chapter') {
            this.sireVersionDropdown();
        }
        else if (this.filterObj.x_axis == 'vessel_type') {
            this.vesselTypeDropdown();
        }
        else if (this.filterObj.x_axis == 'vessel_fleet') {
            this.vesselFleetDropdown();
        }
        else if (this.filterObj.x_axis == 'vessel_technical') {
            this.technicalUsersDropdown();
        }
        else if (this.filterObj.x_axis == 'vessel_marine') {
            this.marineUsersDropdown();
        }
    }
    monthDiff(DisplayTo, DisplayFrom) {
        return DisplayTo.getMonth() - DisplayFrom.getMonth()
            + (12 * (DisplayTo.getFullYear() - DisplayFrom.getFullYear()));
    }
    delete_wizard_report(id) {
        if (id) {
            console.log("delete this id: " + id);
            swal({
                title: 'Are you sure?',
                text: "You won't be able to revert this!",
                type: 'warning',
                showCancelButton: true,
                confirmButtonClass: 'btn btn-success',
                cancelButtonClass: 'btn btn-danger',
                confirmButtonText: 'Yes, delete it!',
                buttonsStyling: false
            }).then((result) => {
                if (result.value) {
                    var dialogueTitle = "Deleted!"
                    this.commonService.sendRequestToNode({ method: 'post', path: 'chart/delete_wizard_report', postData: { ID: id } }).subscribe(result => {
                        if (result.status) {
                            this.get_list_of_report();
                            swal({
                                title: dialogueTitle,
                                text: 'Report Template Deleted Successfully',
                                type: 'success',
                                confirmButtonClass: "btn btn-success",
                                buttonsStyling: false
                            })
                        }
                    })
                }
            })
        }
    }

    get_list_of_report() {
        this.commonService.sendRequestToNode({ method: 'get', path: 'chart/get_wizard_report', queryParam: { IS_FROM_TMSA: 0 } }).subscribe(result => {
            if (result.status) {
                this.saved_reports = result.data;
            } else {
                alert(result.message);
            }
        });
    }
    saveReport() {
        let name = 'Report';
        swal({
            title: 'Enter Name Of Report',
            confirmButtonClass: "btn btn-success",
            buttonsStyling: false,
            input: 'text',
            showCancelButton: true,
            cancelButtonClass: "btn-danger",
        }).then((popup_responce) => {
            if (popup_responce.value) {
                name = popup_responce.value;
                this.commonService.sendRequestToNode({ method: 'post', path: 'chart/save_wizard_report', postData: { TEMPLATE: JSON.stringify(this.filterObj), NAME: name, IS_FROM_TMSA: 0 } }).subscribe(result => {
                    if (result.status) {
                        this.get_list_of_report();
                        swal({
                            type: 'success',
                            title: result.message,
                            confirmButtonClass: "btn btn-success",
                            buttonsStyling: false,
                        })
                    } else {
                        swal({
                            type: 'warning',
                            title: result.message,
                            confirmButtonClass: "btn btn-success",
                            buttonsStyling: false,
                        })
                        alert(result.message);
                    }
                });
            }
            else {
                if (popup_responce.dismiss) {
                }
                else {
                    alert("Please Enter Name of Report");
                    this.saveReport();
                }
            }
        });
    }

    goForChart() {

        this.question_numbers = [];
        this.dataFilter = {};
        if (this.filterObj.y_axis == "risk_value_count") {
            this.lineChartColors = [
                {
                    // green for low
                    backgroundColor: 'rgba(69,182,73,0.5)',
                    borderColor: '#45b649',
                    pointBackgroundColor: '#45b649',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#45b649'
                },
                {
                    // yellow for medium
                    backgroundColor: 'rgba(255,188,52,0.5)',
                    borderColor: '#ffbc34',
                    pointBackgroundColor: '#ffbc34',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#ffbc34'
                },
                {
                    // orange for high
                    backgroundColor: 'rgba(251,140,0,0.5)',
                    borderColor: '#fb8c00',
                    pointBackgroundColor: '#fb8c00',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#fb8c00'
                },
                {
                    // red for v.high
                    backgroundColor: 'rgba(255,0,0,0.5)',
                    borderColor: '#ff0000',
                    pointBackgroundColor: '#ff0000',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#ff0000'
                }
            ];
        } else if (this.filterObj.timespan || (this.filterObj.consolidated_ship == 'false' && this.filterObj.y_axis == 'top_ten_repeat_question')) {
            this.lineChartColors = [{
                // green for low
                backgroundColor: 'rgba(69,182,73,0.5)',
                borderColor: '#45b649',
                pointBackgroundColor: '#45b649',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#45b649'
            },
            {
                // yellow for medium
                backgroundColor: 'rgba(255,188,52,0.5)',
                borderColor: '#ffbc34',
                pointBackgroundColor: '#ffbc34',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#ffbc34'
            },
            {
                // orange for high
                backgroundColor: 'rgba(251,140,0,0.5)',
                borderColor: '#fb8c00',
                pointBackgroundColor: '#fb8c00',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#fb8c00'
            },
            {
                // red for v.high
                backgroundColor: 'rgba(255,0,0,0.5)',
                borderColor: '#ff0000',
                pointBackgroundColor: '#ff0000',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#ff0000'
            },
            {
                // maroon
                backgroundColor: 'rgba(128, 0, 0,0.5)',
                borderColor: '#800000',
                pointBackgroundColor: '#800000',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#800000'
            },
            {
                // brown
                backgroundColor: 'rgba(154, 99, 36,0.5)',
                borderColor: '#9A6324',
                pointBackgroundColor: '#9A6324',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#9A6324'
            }
                ,
            {
                // Olive
                backgroundColor: 'rgba(128, 128, 0,0.5)',
                borderColor: '#808000',
                pointBackgroundColor: '#808000',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#808000'
            },
            {
                // purple
                backgroundColor: 'rgba(145, 30, 180,0.5)',
                borderColor: '#911eb4',
                pointBackgroundColor: '#911eb4',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#911eb4'
            },
            {
                // pink
                backgroundColor: 'rgba(250, 190, 190,0.5)',
                borderColor: '#fabebe',
                pointBackgroundColor: '#fabebe',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#fabebe'
            },
            {
                // Lime
                backgroundColor: 'rgba(191, 239, 69,0.5)',
                borderColor: '#bfef45',
                pointBackgroundColor: '#bfef45',
                pointBorderColor: '#fff',
                pointHoverBackgroundColor: '#fff',
                pointHoverBorderColor: '#bfef45'
            }
            ];
        }
        else {
            this.lineChartColors = [
                {
                    // grey
                    backgroundColor: 'rgb(246,196,41,.5)',
                    borderColor: '#F6C429',
                    pointBackgroundColor: '#F6C429',
                    pointBorderColor: '#fff',
                    pointHoverBackgroundColor: '#fff',
                    pointHoverBorderColor: '#F6C429'
                },
            ];
        }

        let from_time = new Date(this.filterObj.from_date).getTime();
        let to_time = new Date(this.filterObj.to_date).getTime();
        if (from_time > to_time) {
            alert('From-Date Can Not Be Greater Than To-Date')
        }
        else if (!this.filterObj.y_axis) {
            alert('please select Y axis');
        }
        else if (!this.filterObj.x_axis) {
            alert('please select X axis');
        }
        else if (!this.filterObj.selectedValueForX_axis && this.filterObj.x_axis != 'number_of_observation') {
            alert('please select X axis Value');
        }
        else {

            if (this.filterObj.y_axis == "oil_major") {
                this.getDataForDisplayOilMajorChart();
            } else {
                this.getDataForDisplayChart();
            }
        }
    }

    calculateTimeArray() {
        this.timeLineArr = [];
        this.timeLineLabelArr = [];
        var from_date_temp: any = new Date(this.filterObj.from_date);
        var to_date_temp: any = new Date(this.filterObj.to_date);
        var diff = Math.abs(to_date_temp.getTime() - from_date_temp.getTime());
        var diffDays = Math.ceil(diff / (1000 * 3600 * 24));
        var from_year = new Date(this.filterObj.from_date).getFullYear();
        var to_year = new Date(this.filterObj.to_date).getFullYear();
        var diff_year = to_year - from_year;
        var diff_month = this.monthDiff(to_date_temp, from_date_temp);
        let time_type = this.filterObj.timespan || this.filterObj.selectedValueForX_axis
        if (time_type == 'yearly') {
            for (let i = from_year; i <= to_year; i++) {
                this.timeLineArr.push(i.toString());
            }
        }
        else if (time_type == 'monthly') {
            // this.timeLineArr.push(this.nameOfMonth[from_date_temp.getMonth()] + '-' + from_date_temp.getFullYear());
            // console.log( diff_month );
            // for(let i = 1; i < diff_month; i++) {
            //     new Date(from_date_temp.setMonth(from_date_temp.getMonth() + 1));
            //     this.timeLineArr.push(this.nameOfMonth[from_date_temp.getMonth()] + '-' + from_date_temp.getFullYear());
            // }

            let sDate = from_date_temp.getFullYear() + "" + ("0" + (from_date_temp.getMonth() + 1)).slice(-2);
            let eDate = to_date_temp.getFullYear() + "" + ("0" + (to_date_temp.getMonth() + 1)).slice(-2);
            while (Number(sDate) <= Number(eDate)) {
                let year: any = sDate.substring(0, 4);
                let month: any = sDate.slice(4, 6);

                this.timeLineArr.push(this.nameOfMonth[Number(month) - 1] + '-' + year);
                if (month === "12") {
                    month = "01";
                    year = Number(year) + 1;
                }
                else {
                    month = ("0" + (Number(month) + 1)).slice(-2);
                }
                sDate = year + "" + month;

            }



            console.log(this.timeLineArr)
        }
        else if (time_type == 'quaterly') {
            let totalQuater = Math.ceil(diff_month / 3);
            console.log(totalQuater);
            let currentQuater = 0;
            let startDate;
            let endDate;
            for (let i = 0; i < totalQuater; i++) {
                currentQuater = Math.ceil((from_date_temp.getMonth() + 1) / 3)
                if (currentQuater == 1) {
                    startDate = from_date_temp.getFullYear() + '-01-01';
                    endDate = from_date_temp.getFullYear() + '-03-31'
                }
                else if (currentQuater == 2) {
                    startDate = from_date_temp.getFullYear() + '-04-01';
                    endDate = from_date_temp.getFullYear() + '-06-30'
                }
                else if (currentQuater == 3) {
                    startDate = from_date_temp.getFullYear() + '-07-01';
                    endDate = from_date_temp.getFullYear() + '-09-30'
                }
                else {
                    startDate = from_date_temp.getFullYear() + '-10-01';
                    endDate = from_date_temp.getFullYear() + '-12-31'
                }
                if (i == 0) {
                    startDate = new Date(this.filterObj.from_date);
                }
                if (i == totalQuater) {
                    endDate = new Date(this.filterObj.to_date);// ('0'+ new Date(this.filterObj.to_date).getDate()).slice(-2) + '-' + ('0'+ new Date(this.filterObj.to_date).getMonth()).slice(-2) + '-' + to_date_temp.getFullYear()
                }
                let sDate = new Date(startDate);
                let eDate = new Date(endDate);
                this.timeLineLabelArr.push(sDate.getFullYear() + ' ' + this.sortNameOfMonth[sDate.getMonth()] + ' ' + sDate.getDate() + '-' + this.sortNameOfMonth[eDate.getMonth()] + ' ' + eDate.getDate());

                // this.timeLineLabelArr.push(startDate + ' TO '+ endDate);
                this.timeLineArr.push(currentQuater + '-' + from_date_temp.getFullYear());
                from_date_temp.setMonth(from_date_temp.getMonth() + 3)
            }
        }
        else if (time_type == 'weekly') {
            // let day = 7;
            let startDate;
            let oldstartDate;
            let endDate;
            console.log(Math.ceil(diffDays / 7));
            let i = 0;
            let week = 0;
            while (from_date_temp.getTime() <= to_date_temp.getTime()) {
                let onejan: any = new Date(from_date_temp.getFullYear(), 0, 1);
                week = Math.ceil((((from_date_temp.getTime() - onejan.getTime()) / 86400000) + 1) / 7);
                this.timeLineArr.push(week + '-' + from_date_temp.getFullYear());
                let d = ((week - 1) * 7);
                if (startDate) {
                    oldstartDate = new Date(startDate);
                }
                startDate = new Date(from_date_temp.getFullYear(), 0, d);

                if (i == 0) {
                    startDate = new Date(this.filterObj.from_date);
                }
                endDate = new Date(startDate);
                endDate.setDate(endDate.getDate() - 1)

                if (i != 0) {
                    if (oldstartDate.getMonth() == endDate.getMonth()) {
                        this.timeLineLabelArr.push(oldstartDate.getFullYear() + '-' + this.sortNameOfMonth[oldstartDate.getMonth()] + ' ' + oldstartDate.getDate() + '-' + endDate.getDate());
                    } else {
                        this.timeLineLabelArr.push(oldstartDate.getFullYear() + '-' + this.sortNameOfMonth[oldstartDate.getMonth()] + ' ' + oldstartDate.getDate() + '-' + this.sortNameOfMonth[endDate.getMonth()] + ' ' + endDate.getDate());
                    }

                }
                from_date_temp.setDate(from_date_temp.getDate() - from_date_temp.getDay() + 8);//8 because we start week from monday
                // console.log(from_date_temp);
                i++;
            }

            if (startDate.getMonth() == new Date(this.filterObj.to_date).getMonth()) {
                this.timeLineLabelArr.push(startDate.getFullYear() + '-' + this.sortNameOfMonth[startDate.getMonth()] + ' ' + startDate.getDate() + '-' + new Date(this.filterObj.to_date).getDate());
            } else {
                this.timeLineLabelArr.push(startDate.getFullYear() + '-' + this.sortNameOfMonth[startDate.getMonth()] + ' ' + startDate.getDate() + '-' + this.sortNameOfMonth[new Date(this.filterObj.to_date).getMonth()] + ' ' + new Date(this.filterObj.to_date).getDate());
            }
        }
    }

    generateReport(redirect = true) {
        let sortBy;
        let sortStatus;
        let sortKey = Object.keys(this.sortFilter);


        if (sortKey.length && this.sortFilter[sortKey[0]]) {
            sortBy = sortKey[0];
            sortStatus = this.sortFilter[sortKey[0]];
        }
        console.log(this.generate_report_id)
        if (this.generate_report_id.length) {
            this.commonService.sendRequestToNode({ method: 'post', path: 'chart/generateReportByIds', postData: { report_ids: this.generate_report_id, question_numbers: this.question_numbers, dataFilter: this.dataFilter, itemsPerPage: this.itemsPerPage, currentPage: this.currentPage - 1, sortBy: sortBy, sortStatus: sortStatus } }).subscribe(result => {
                if (result.status) {
                    this.generateReportData = result.data;
                    this.totalItems = result.data[0].total_records;
                    if (redirect) {
                        this.tabs.select('step3');
                    }
                } else {
                    this.generateReportData = [];
                    alert(result.message);
                }
            });
        }
        else {
            this.generateReportData = [];
        }

    }
    getDataforcsv() {
        window.location.href = this.commonService.getNodeApi() + '/chart/generateReportCsv?report_ids=' + JSON.stringify(this.generate_report_id) + '&question_numbers=' + JSON.stringify(this.question_numbers) + '&dataFilter=' + JSON.stringify(this.dataFilter);
        // this.commonService.sendRequestToNode({method :'post',path:'chart/generateReportCsv',postData:{report_ids:this.generate_report_id}}).subscribe(result => {
        // if(result.status){
        // this.generateReportData = result.data;
        // this.tabs.select('step3'); 
        // }else{
        // this.generateReportData = [];
        // alert(result.message);
        // }
        // });
    }
    getDataforPdf() {
        let sortBy;
        let sortStatus;
        let sortKey = Object.keys(this.sortFilter);


        if (sortKey.length && this.sortFilter[sortKey[0]]) {
            sortBy = sortKey[0];
            sortStatus = this.sortFilter[sortKey[0]];
        }
        // window.location.href = this.commonService.getNodeApi() + '/?report_ids=' + JSON.stringify(this.generate_report_id);
        // console.log(this.generate_report_id);
        this.commonService.sendRequestToNode({ method: 'post', path: 'chart/generateReportPdf', postData: { report_ids: this.generate_report_id, question_numbers: this.question_numbers, dataFilter: this.dataFilter, x_axis_label: this.x_axis_label, y_axis_label: this.y_axis_label, filterObj: this.filterObj, select_x_axis_value: this.lineChartLabels, sortBy: sortBy, sortStatus: sortStatus } }, { responseType: 'blob' }).subscribe(result => {
            saveAs(result, `Seagraphsreport.pdf`)
        })
    }

    getTimeLineInDropDown() {
        if (this.filterObj.from_date && this.filterObj.to_date) {
            this.range_dropdown = [];
            let from_time = new Date(this.filterObj.from_date);
            let to_time = new Date(this.filterObj.to_date);
            var diff = Math.abs(to_time.getTime() - from_time.getTime());
            var diffDays = Math.ceil(diff / (1000 * 3600 * 24));
            let month_to = ('0' + (to_time.getMonth() + 1)).slice(-2);
            let month_from = ('0' + (from_time.getMonth() + 1)).slice(-2);
            let diffMonth = parseInt(month_to) - parseInt(month_from);
            let year_to = to_time.getFullYear();
            let year_from = from_time.getFullYear();
            let diffYear = year_to - year_from;

            // Day Calulation
            if (diffDays >= 7) {
                this.range_dropdown.push({ ID: 'weekly', RANGE: "Week" });
            }
            // Month Calulation
            if (diffYear > 0) {
                this.range_dropdown.push({ ID: 'monthly', RANGE: "Month" });
            }
            else if (diffMonth > 0) {
                this.range_dropdown.push({ ID: 'monthly', RANGE: "Month" });
            }
            // Quarter Calulation and for original Quarter nothing
            if (diffYear > 0) {
                this.range_dropdown.push({ ID: 'quaterly', RANGE: "Quarter" });
            } else if (diffMonth >= 3) {
                this.range_dropdown.push({ ID: 'quaterly', RANGE: "Quarter" });
            }
            // Year Calulation
            if (diffYear > 0) {
                this.range_dropdown.push({ ID: 'yearly', RANGE: "Year" });
            }
        }
    }
    vesselDropdown() {
        if (this.vessel_dropdown.length <= 0) {
            //queryParam : {ACTIVE_FLAG : 1}
            this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vessel-dropdown', queryParam: { 'from_date': this.filterObj.from_date, 'to_date': this.filterObj.to_date } }).subscribe(result => {
                if (result.status) {
                    let array = []
                    console.log(result.data, "vessel list")
                    result.data.forEach(element => {
                        var strActive = '';
                        if (!element.ACTIVE_FLAG) {
                            strActive = 'inactive_vessel';
                        }
                        array.push({ value: JSON.stringify(element), display: element.VESSEL_NAME, class_name: strActive })
                    });
                    this.vessel_dropdown = [{ display: 'All Vessels', value: 'ALL' }, ...array];
                }
                else {
                    this.vessel_dropdown = [];
                }
            });
        }
    }
    vesselGroupDropdown() {
        if (this.vesselGroup_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselGroup' }).subscribe(result => {
                if (result.status) {
                    let array = []
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.GROUP_NAME })
                    });
                    this.vesselGroup_dropdown = array;
                }
                else {
                    this.vesselGroup_dropdown = [];
                }
            });
        }
    }
    vesselOwnerDropdown() {
        if (this.vesselOwner_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselOwner' }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.COMPANY_NAME })
                    });
                    this.vesselOwner_dropdown = array;
                }
                else {
                    this.vesselOwner_dropdown = [];
                }
            });
        }
    }
    sireVersionDropdown() {
        //sire-dropdown
        this.commonService.sendRequestToNode({ method: 'get', path: 'template-type-dropdown' }).subscribe(result => {
            if (result.status) {
                let array = [];
                result.data.forEach(element => {
                    array.push({ value: JSON.stringify(element), display: element.TEMPLATE_TYPE })
                });
                this.sire_dropdown = array;
            }
            else {
                this.sire_dropdown = [];
            }
        });
    }
    vesselTypeDropdown() {
        if (this.vesselType_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'vessel_master/vesselType' }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.VESSEL_TYPE })
                    });
                    this.vesselType_dropdown = array;
                }
                else {
                    this.vesselType_dropdown = [];
                }
            });
        }
    }
    oilMajorDropdown() {
        if (this.oilMajor_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'oil-major-master/dropdown' }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.OFFICIAL_NAME })
                    });
                    this.oilMajor_dropdown = array;
                }
                else {
                    this.oilMajor_dropdown = [];
                }
            });
        }
    }
    marineUsersDropdown() {
        if (this.marineUser_dropDown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown', queryParam: { type: 'marine_superintendent' } }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    console.log(result.data)
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.FULL_NAME })
                    });
                    this.marineUser_dropDown = array;
                }
                else {
                    this.marineUser_dropDown = [];
                }
            });
        }
    }

    userDropdown() {
        if (this.user_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown' }).subscribe(result => {
                if (result.status) {
                    this.user_dropdown = result.data;
                }
                else {
                    this.user_dropdown = [];
                }
            });
        }
    }

    technicalUsersDropdown() {
        if (this.techinalUser_dropDown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'user-dropdown', queryParam: { type: 'technical_superintendent' } }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.FULL_NAME })
                    });
                    this.techinalUser_dropDown = array;
                }
                else {
                    this.techinalUser_dropDown = [];
                }
            });
        }
    }
    vesselFleetDropdown() {
        if (this.vesselFleet_dropdown.length <= 0) {
            this.commonService.sendRequestToNode({ method: 'get', path: 'fleet/fleet-dropdown' }).subscribe(result => {
                if (result.status) {
                    let array = [];
                    result.data.forEach(element => {
                        array.push({ value: JSON.stringify(element), display: element.FLEET_NAME })
                    });
                    this.vesselFleet_dropdown = array;
                }
                else {
                    this.vesselFleet_dropdown = [];
                }
            })
        }
    }


    public lineChartData: Array<any> = [
        // { data: [65, 39, 80, 15, 76, 35, 40], label: 'Series A' },
        {}
    ];
    public lineChartLabels: Array<any> = [
        // 'January',
        // 'February',
        // 'March',
        // 'April',
        // 'May',
        // 'June',
        // 'July'
    ];

    public lineChartOptions: any = {
        responsive: true,
        barThickness: 1,
        scales: {
            yAxes: [{
                ticks: {
                    beginAtZero: true,
                    // max : 2
                },
            }],
            xAxes: [{
                barPercentage: 0.5,
                ticks: {
                    autoSkip: false,
                },
            }]
        },
        plugins: {
            labels: {
                // render 'label', 'value', 'percentage', 'image' or custom function, default is 'percentage'
                render: 'value',

                // precision for percentage, default is 0
                precision: 0,

                // identifies whether or not labels of value 0 are displayed, default is false
                //   showZero: false,

                // font size, default is defaultFontSize
                fontSize: 10,

                // font color, can be color array for each data or function for dynamic color, default is defaultFontColor
                fontColor: '#000',

                // font style, default is defaultFontStyle
                fontStyle: 'normal',

                // font family, default is defaultFontFamily
                fontFamily: "'Helvetica Neue', 'Helvetica', 'Arial', sans-serif",

                // draw text shadows under labels, default is false
                //   textShadow: true,

                // text shadow intensity, default is 6
                //   shadowBlur: 10,

                // text shadow X offset, default is 3
                shadowOffsetX: -5,

                // text shadow Y offset, default is 3
                shadowOffsetY: 5,

                // text shadow color, default is 'rgba(0,0,0,0.3)'
                shadowColor: 'rgba(255,0,0,0.75)',

                // position to draw label, available value is 'default', 'border' and 'outside'
                // bar chart ignores this
                // default is 'default'
                position: 'outside',

                // draw label even it's overlap, default is true
                // bar chart ignores this
                overlap: false,

                // show the real calculated percentages from the values and don't apply the additional logic to fit the percentages to 100 in total, default is false
                showActualPercentages: true,



                // add padding when position is `outside`
                // default is 2
                outsidePadding: 4,

                // add margin of text when position is `outside` or `border`
                // default is 2
                textMargin: 2
            }
        }

    };

    public lineChartLegend = true;
    public lineChartType = 'bar';
    getDataForDisplayChart() {
        this.generate_report_id.length = 0;
        // if(this.filterObj.x_axis == 'viq_chapter'){
        //     this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-wizard-data-for-chart-viqRef', 'postData': this.filterObj }).subscribe(result => {

        //     })
        // }
        // else{
        console.log(this.filterObj)
        this.showLoader = true;
        this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-wizard-data-for-chart', 'postData': this.filterObj }).subscribe(result => {
            if (result.status) {
                console.log(result.data)
                console.log(this.filterObj, "this.filterObj");
                if (this.filterObj.y_axis == 'top_ten_repeat_question') {
                    if (this.filterObj.timespan || this.filterObj.consolidated_ship == 'false') {
                        this.makeChartThroughTimeLineFromData(result.data, 'QUESTION_NUMBER', 'QUESTION_NUMBER');
                    } else {
                        this.makeChartFromData(result.data, 'QUESTION_NUMBER', 'QUESTION_NUMBER');
                    }
                } else {

                    if (this.filterObj.x_axis == 'timespan') {
                        // this.calculateTimeArray();
                        this.makeChartFromData(result.data, '', 'time');
                    }
                    else if (this.filterObj.x_axis == 'vessel') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'VESSEL_NAME', 'VESSEL_FK');
                        } else {
                            this.makeChartFromData(result.data, 'VESSEL_NAME', 'VESSEL_FK');
                        }
                    }
                    else if (this.filterObj.x_axis == 'vessel_group') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'GROUP_NAME', 'VESSEL_GROUP_FK');

                        }
                        else {
                            this.makeChartFromData(result.data, 'GROUP_NAME', 'VESSEL_GROUP_FK');
                        }

                    }
                    else if (this.filterObj.x_axis == 'vessel_fleet') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'FLEET_NAME', 'VESSEL_FLEET_FK');
                        } else {
                            this.makeChartFromData(result.data, 'FLEET_NAME', 'VESSEL_FLEET_FK');
                        }

                    }
                    else if (this.filterObj.x_axis == 'oil_major') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'OFFICIAL_NAME', 'OIL_MAJOR_FK');
                        } else {
                            this.makeChartFromData(result.data, 'OFFICIAL_NAME', 'OIL_MAJOR_FK');
                        }
                    }
                    else if (this.filterObj.x_axis == 'ship_owner') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'COMPANY_NAME', 'VESSEL_OWNER_FK');
                        } else {
                            this.makeChartFromData(result.data, 'COMPANY_NAME', 'VESSEL_OWNER_FK');
                        }
                    }
                    else if (this.filterObj.x_axis == 'vessel_type') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'VESSEL_TYPE', 'VESSEL_TYPE_FK');
                        } else {
                            this.makeChartFromData(result.data, 'VESSEL_TYPE', 'VESSEL_TYPE_FK');
                        }
                    }
                    else if (this.filterObj.x_axis == 'vessel_marine') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'FULL_NAME', 'MARINE_SUPERINTENDENT_FK');
                        } else {
                            this.makeChartFromData(result.data, 'SHORT_NAME', 'MARINE_SUPERINTENDENT_FK');
                        }
                    }
                    else if (this.filterObj.x_axis == 'vessel_technical') {
                        if (this.filterObj.timespan) {
                            this.makeChartThroughTimeLineFromData(result.data, 'FULL_NAME', 'TECHNICIAN_SUPERINTENDENT_FK');
                        } else {
                            this.makeChartFromData(result.data, 'SHORT_NAME', 'TECHNICIAN_SUPERINTENDENT_FK');
                        }
                    }
                    else if (this.filterObj.x_axis == 'viq_chapter') {
                        this.makeChartFromData(result.data, '', 'chapter');
                    }
                    else if (this.filterObj.x_axis == 'number_of_observation') {
                        this.makeChartForNumberOfObs(result.data);
                    }
                }


                this.showLoader = false;
                this.tabs.select('step2');
            }
            else {
                alert(result.message);
            }
        })
        //  }

    }
    makeChartOfYear(data) {
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        this.timeLineArr.forEach((ele) => {
            this.lineChartLabels.push(ele)
        })


        data.forEach(element => {
            if (this.lineChartData.length > 0) {
                this.lineChartData[0].data.push(element.total_inspection)
            }
            else {
                if (this.filterObj.y_axis == "total_inspection") {
                    this.lineChartData.push({ data: [element.total_inspection], label: this.y_axis_label[this.filterObj.y_axis] });
                }

            }
        });
    }

    //filter key means key of filter object(use for label)
    // datakey means key of data of chart(use for display value)
    makeChartFromData(inChartData, filterKey, dataKey) {
        console.log(inChartData);
        let chartData = inChartData[0];
        let temp = [];
        let tempdata = [];
        let tmp2 = [];
        let tmp3 = [];
        let tmp4 = [];
        let labelData = [];
        let toolTipLabelData = [];
        let dataArr = [];
        let dataArr_tmp = {};
        let max = 0;
        if (this.filterObj.timespan) {
            this.calculateTimeArray();
        }
        if (this.filterObj.x_axis == "vessel_marine" || this.filterObj.x_axis == "vessel_technical") {
            this.lineChartOptions.tooltips = {
                mode: 'point',
                intersect: false,
                backgroundColor: 'rgb(95,22,21)',
                callbacks: {
                    title: function () {
                        return '';
                    },
                    beforeLabel: function (tooltipItem, data) {
                        //return formatted date
                        tooltipItem.xLabel = toolTipLabelData[tooltipItem.index]['FULL_NAME']
                        return tooltipItem.xLabel
                    }
                }
            }
        }
        else if (this.filterObj.y_axis == "avg_risk" || this.filterObj.y_axis == "avg_observation") {
            this.lineChartOptions.tooltips = {
                callbacks: {
                    label: function (tooltipItem, data) {
                        var label = data.datasets[tooltipItem.datasetIndex].label || '';
                        if (label) {
                            label += ': ';
                        }
                        let arr = tooltipItem.yLabel.toString().split('.');
                        arr[1] = arr[1] ? arr[1] : '00' // if NoT available Decimal Points
                        label += arr[0] + '.' + ((arr[1] + '0').slice(0, 2));
                        return label;
                    }
                }
            }
        }
        else {
            delete this.lineChartOptions.tooltips;
        }
        console.log(chartData);

        if (this.filterObj.y_axis == 'top_ten_repeat_question') {
            chartData.forEach(element => {
                temp.push(element.QUESTION_NUMBER);
                tempdata.push(0);
                tmp2.push(0);
                tmp3.push(0);
                tmp4.push(0);
                toolTipLabelData.push(element);
                labelData.push(element.QUESTION_NUMBER);
            })

        } else {
            if (this.filterObj.x_axis == 'viq_chapter') {
                let total_chapter = inChartData[1][0].total_chapter // latest version total_chapter
                for (let i = 1; i < total_chapter; i++) {
                    temp.push(i);
                    tempdata.push(0);
                    tmp2.push(0);
                    tmp3.push(0);
                    tmp4.push(0);
                    labelData.push('CH-' + i);
                }
            } else if (this.filterObj.x_axis == 'timespan') {
                if (this.filterObj.y_axis) {
                    this.timeLineArr.forEach((element, key) => {
                        temp.push(element);
                        tempdata.push(0);
                        tmp2.push(0);
                        tmp3.push(0);
                        tmp4.push(0);
                        if (this.timeLineLabelArr.length > 0) {
                            labelData.push(this.timeLineLabelArr[key]);
                        } else {
                            labelData.push(element);
                        }

                    })
                }
            } else {
                this.filterObj.selectedValueForX_axis.forEach(element => {
                    temp.push(JSON.parse(element).ID);
                    tempdata.push(0);
                    tmp2.push(0);
                    tmp3.push(0);
                    tmp4.push(0);
                    toolTipLabelData.push(JSON.parse(element));
                    labelData.push(JSON.parse(element)[filterKey]);
                });
            }
        }
        console.log(temp)
        console.log(labelData)

        if (chartData.length > 0) {
            let countData = 0;
            let ComulativeAvg = 0;
            let ComulativeAvg2 = 0;
            let ComulativeAvg3 = 0;
            let ComulativeAvg4 = 0;


            chartData.forEach(element => {
                console.log(element)
                // let tempI;
                //  if( this.filterObj.y_axis == 'top_ten_repeat_question' ) {
                //     let tempI = temp.indexOf(element[filterKey])
                //  } else {
                //     let tempI = temp.indexOf(element[dataKey])
                //  }
                let tempI = temp.indexOf(element[dataKey])

                console.log(tempI)
                if (tempI > -1) {
                    if (element.report_id) {
                        element.report_id.split(',').forEach(rId => {
                            if (this.generate_report_id.indexOf(rId) == -1) {
                                this.generate_report_id.push(rId);
                            }
                        });
                        if (this.filterObj.y_axis == 'top_ten_repeat_question') {
                            this.question_numbers.push(element.QUESTION_NUMBER);
                        }

                    }


                    if (this.filterObj.y_axis == 'total_inspection') {
                        if (this.filterObj.consolidated_ship == 'true') {
                            ComulativeAvg = Number(ComulativeAvg) + Number(element.total_inspection);
                            if (max < ComulativeAvg) {
                                max = ComulativeAvg;
                            }
                        } else {
                            if (max < parseInt(element.total_inspection)) {
                                max = parseInt(element.total_inspection);
                            }
                            if (dataArr.length > 0) {
                                dataArr[0].data[tempI] = element.total_inspection;
                            }
                            else {
                                tempdata[tempI] = element.total_inspection;
                                dataArr.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })
                            }
                        }

                    }
                    else if (this.filterObj.y_axis == 'total_observation') {

                        if (this.filterObj.consolidated_ship == 'true') {
                            ComulativeAvg = Number(ComulativeAvg) + Number(element.total_obs);
                            if (max < ComulativeAvg) {
                                max = ComulativeAvg;
                            }
                        } else {
                            if (max < parseInt(element.total_obs)) {
                                max = parseInt(element.total_obs);
                            }
                            if (dataArr.length > 0) {
                                dataArr[0].data[tempI] = element.total_obs;
                            }
                            else {
                                tempdata[tempI] = element.total_obs;
                                dataArr.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })
                            }
                        }

                    }
                    else if (this.filterObj.y_axis == 'avg_observation') {
                        let avg_observation: any = 0;
                        if (this.filterObj.x_axis == 'viq_chapter') {
                            let total_inspection = inChartData[1][0].total_inspection;// this is whole chapter total inspection
                            avg_observation = total_inspection ? (element.total_obs / total_inspection).toFixed(2) : 0;;
                        }
                        else {
                            avg_observation = element.total_inspection ? (element.total_obs / element.total_inspection).toFixed(2) : 0;
                        }
                        if (this.filterObj.consolidated_ship == 'true') {
                            countData++;
                            ComulativeAvg = Number(ComulativeAvg) + Number(avg_observation);
                            if (max < ComulativeAvg) {
                                max = ComulativeAvg;
                            }
                            // dataArr.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })  // need to handle 

                        } else {
                            if (max < parseInt(avg_observation)) {
                                max = parseInt(avg_observation);
                            }
                            if (dataArr.length > 0) {
                                console.log('Data Array')
                                dataArr[0].data[tempI] = avg_observation;
                            } else {
                                console.log('Temp  Array')
                                tempdata[tempI] = avg_observation;
                                dataArr.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })
                            }

                        }

                    }
                    else if (this.filterObj.y_axis == 'avg_risk') {
                        let avg_risk;
                        if (this.isRiskCompany) {
                            avg_risk = element.total_final_obs ? (element.company_total_risk / element.total_final_obs).toFixed(2) : 0;
                        } else {
                            avg_risk = element.total_final_obs ? (element.total_risk / element.total_final_obs).toFixed(2) : 0;
                        }

                        if (this.filterObj.consolidated_ship == 'true') {
                            countData++;
                            ComulativeAvg = Number(ComulativeAvg) + Number(avg_risk);
                            if (max < ComulativeAvg) {
                                max = ComulativeAvg;
                            }
                        } else {

                            if (max < parseInt(avg_risk)) {
                                max = parseInt(avg_risk);
                            }

                            if (dataArr.length > 0) {
                                dataArr[0].data[tempI] = avg_risk;
                            }
                            else {
                                tempdata[tempI] = avg_risk;
                                dataArr.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })

                            }

                        }

                    }
                    else if (this.filterObj.y_axis == 'risk_value_count') {
                        //alert(this.filterObj.y_axis); 
                        let low_risk, medium_risk, high_risk, vhigh_risk;

                        if (this.isRiskCompany) {
                            vhigh_risk = element.company_total_very_high_risk;
                            high_risk = element.company_total_high_risk;
                            medium_risk = element.company_total_medium_risk;
                            low_risk = element.company_total_low_risk;
                        } else {
                            vhigh_risk = element.total_very_high_risk;
                            high_risk = element.total_high_risk;
                            medium_risk = element.total_medium_risk;
                            low_risk = element.total_low_risk;
                        }

                        if (this.filterObj.consolidated_ship == 'true') {
                            countData++;
                            ComulativeAvg = Number(ComulativeAvg) + Number(low_risk);
                            ComulativeAvg2 = Number(ComulativeAvg2) + Number(medium_risk);
                            ComulativeAvg3 = Number(ComulativeAvg3) + Number(high_risk);
                            ComulativeAvg4 = Number(ComulativeAvg4) + Number(vhigh_risk);
                            if (max < ComulativeAvg) {
                                max = ComulativeAvg;
                            }
                            if (max < ComulativeAvg2 && ComulativeAvg < ComulativeAvg2) {
                                max = ComulativeAvg2;
                            }
                            if (max < ComulativeAvg3 && ComulativeAvg2 < ComulativeAvg3) {
                                max = ComulativeAvg3;
                            }
                            if (max < ComulativeAvg4 && ComulativeAvg3 < ComulativeAvg4) {
                                max = ComulativeAvg4;

                            }
                        } else {
                            if (dataArr.length > 0) {
                                dataArr[0].data[tempI] = low_risk;
                                dataArr[1].data[tempI] = medium_risk;
                                dataArr[2].data[tempI] = high_risk;
                                dataArr[3].data[tempI] = vhigh_risk;
                            }
                            else {
                                tempdata[tempI] = low_risk;
                                dataArr.push({ data: tempdata, label: 'Low' });
                                tmp2[tempI] = medium_risk;
                                dataArr.push({ data: tmp2, label: 'Medium' });
                                tmp3[tempI] = high_risk;
                                dataArr.push({ data: tmp3, label: 'High' });
                                tmp4[tempI] = vhigh_risk;
                                dataArr.push({ data: tmp4, label: 'V.High' });
                                if (max < low_risk) {
                                    max = low_risk;
                                }
                                if (max < medium_risk && low_risk < medium_risk) {
                                    max = medium_risk;
                                }
                                if (max < high_risk && medium_risk < high_risk) {
                                    max = high_risk;
                                }
                                if (max < vhigh_risk && high_risk < vhigh_risk) {
                                    max = vhigh_risk;
                                }

                            }

                        }
                    }
                    else if (this.filterObj.y_axis == 'top_ten_repeat_question') {
                        // alert( 'on ten ')
                        if (max < parseInt(element.count)) {
                            max = parseInt(element.count);
                        }
                        if (dataArr.length > 0) {
                            dataArr[0].data[tempI] = element.count;
                        }
                        else {
                            tempdata[tempI] = element.count;
                            dataArr.push({ data: tempdata, label: ['A Melody', 'A Symphony'] }) // need to handle
                        }
                    }
                }
            });



            if (this.filterObj.consolidated_ship == 'true' && (this.filterObj.y_axis == 'avg_observation' || this.filterObj.y_axis == 'total_observation' || this.filterObj.y_axis == 'total_inspection' || this.filterObj.y_axis == 'avg_risk' || this.filterObj.y_axis == 'risk_value_count')) { // need to handle
                if (this.filterObj.y_axis == 'risk_value_count') {
                    tempdata[0] = ComulativeAvg ? Math.round(ComulativeAvg / countData) : 0;
                    dataArr.push({ data: tempdata, label: 'Low' });
                    tmp2[0] = ComulativeAvg2 ? Math.round(ComulativeAvg2 / countData) : 0;
                    dataArr.push({ data: tmp2, label: 'Medium' });
                    tmp3[0] = ComulativeAvg3 ? Math.round(ComulativeAvg3 / countData) : 0;
                    dataArr.push({ data: tmp3, label: 'High' });
                    tmp4[0] = ComulativeAvg4 ? Math.round(ComulativeAvg4 / countData) : 0;
                    dataArr.push({ data: tmp4, label: 'V.High' });

                } else if (this.filterObj.y_axis == 'avg_observation' || this.filterObj.y_axis == 'avg_risk') {
                    tempdata[0] = ComulativeAvg ? (ComulativeAvg / countData).toFixed(2) : 0;
                    dataArr.push({ data: tempdata, label: labelData })
                } else {
                    tempdata[0] = ComulativeAvg;
                    dataArr.push({ data: tempdata, label: labelData })
                }

            }
        }
        console.log(max)
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        // set max dynamically
        if (this.filterObj.y_axis == 'risk_value_count') {
            this.lineChartOptions.scales.yAxes[0].ticks.max = Math.floor(max) + 25;
        } else {
            this.lineChartOptions.scales.yAxes[0].ticks.max = Math.floor(max) + 2;
        }

        console.log('dataArr');
        console.log(dataArr);
        if (this.filterObj.y_axis == 'top_ten_repeat_question') {
            // chartData.forEach((ele) => {
            //   this.lineChartData.push(ele)
            // })
            //  this.lineChartData = chartData;
        }
        console.log(this.lineChartData)
        if (dataArr.length > 0) {
            dataArr.forEach((ele) => {
                this.lineChartData.push(ele)
            })
        }
        else {
            if (this.filterObj.y_axis != 'risk_value_count') {
                this.lineChartData.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })
            }
            else {
                this.lineChartData.push({ data: tempdata, label: 'Low' });
                this.lineChartData.push({ data: tmp2, label: 'Medium' });
                this.lineChartData.push({ data: tmp3, label: 'High' });
                this.lineChartData.push({ data: tmp4, label: 'V.High' });
            }
        }
        //this.lineChartData.push({data : tempdata,label:this.y_axis_label[this.filterObj.y_axis]});
        if (this.filterObj.consolidated_ship == 'true' && (this.filterObj.y_axis == 'avg_observation' || this.filterObj.y_axis == 'total_observation' || this.filterObj.y_axis == 'total_inspection' || this.filterObj.y_axis == 'avg_risk' || this.filterObj.y_axis == 'risk_value_count')) {
            this.lineChartLabels = [this.y_axis_label[this.filterObj.y_axis]]
        } else {  // need to handle
            labelData.forEach((ele) => {
                this.lineChartLabels.push(ele)
            });
        }

        console.log(this.lineChartOptions)
        this.generateReport(false); // get report 
    }

    makeChartThroughTimeLineFromData(inChartData, filterKey, dataKey) {
        let chartData = inChartData[0];
        let temp = [];
        let tempdata = [];
        let tmp2 = [];
        let tmp3 = [];
        let tmp4 = [];
        let labelData = [];
        let toolTipLabelData = [];
        let max = 0;

        let DataTemp = []

        if (this.filterObj.timespan) {
            // need to handle 
            this.calculateTimeArray();
        } else {
            //..........................
            this.timeLineArr = [];
            temp = [];
            this.filterObj.selectedValueForX_axis.forEach(element => {
                console.log(JSON.parse(element))
                this.timeLineArr.push(JSON.parse(element).ID);
                // labelData.push( JSON.parse(element).VESSEL_NAME )
                if (this.filterObj.x_axis == 'vessel') {
                    labelData.push(JSON.parse(element).VESSEL_NAME);
                }
                else if (this.filterObj.x_axis == 'vessel_group') {
                    labelData.push(JSON.parse(element).GROUP_NAME)
                }
                else if (this.filterObj.x_axis == 'vessel_fleet') {
                    labelData.push(JSON.parse(element).FLEET_NAME);
                }
                else if (this.filterObj.x_axis == 'oil_major') {
                    labelData.push(JSON.parse(element).OFFICIAL_NAME);
                }
                else if (this.filterObj.x_axis == 'ship_owner') {
                    labelData.push(JSON.parse(element).COMPANY_NAME);
                }
                else if (this.filterObj.x_axis == 'vessel_type') {
                    labelData.push(JSON.parse(element).VESSEL_TYPE);
                }
                else if (this.filterObj.x_axis == 'vessel_marine' || this.filterObj.x_axis == 'vessel_technical') {
                    labelData.push(JSON.parse(element).SHORT_NAME);
                }

            });
        }
        var ChartFinalArr = {};
        let DataTempArr = [];

        console.log(chartData.length)

        if (this.filterObj.y_axis == 'top_ten_repeat_question') {
            chartData.forEach(element => {
                toolTipLabelData.push(element);
                ChartFinalArr[element.QUESTION_NUMBER] = {
                    label: element[filterKey], data: []
                }
            });
        } else {
            if (this.filterObj.consolidated_ship == 'true' && (this.filterObj.y_axis == "avg_observation" || this.filterObj.y_axis == "avg_risk" || this.filterObj.y_axis == "total_observation" || this.filterObj.y_axis == "total_inspection")) {

                ChartFinalArr["data"] = {
                    label: this.y_axis_label[this.filterObj.y_axis], data: []
                }
                this.timeLineArr.forEach(element => {
                    toolTipLabelData.push(element);
                });
            } else if (this.filterObj.y_axis == "risk_value_count") {
                this.timeLineArr.forEach((element, key) => {
                    toolTipLabelData.push(element);
                });
            } else {
                this.filterObj.selectedValueForX_axis.forEach(element => {
                    toolTipLabelData.push(JSON.parse(element));
                    ChartFinalArr[JSON.parse(element).ID] = {
                        label: JSON.parse(element)[filterKey], data: []
                    }
                });
            }

        }


        if (this.filterObj.y_axis == "avg_risk" || this.filterObj.y_axis == "avg_observation") {
            this.lineChartOptions.tooltips = {
                callbacks: {
                    label: function (tooltipItem, data) {
                        var label = data.datasets[tooltipItem.datasetIndex].label || '';
                        if (label) {
                            label += ': ';
                        }
                        let arr = tooltipItem.yLabel.toString().split('.');
                        arr[1] = arr[1] ? arr[1] : '00' // if NoT available Decimal Points
                        label += arr[0] + '.' + ((arr[1] + '0').slice(0, 2));
                        return label;
                    }
                }
            }
        }
        else {
            delete this.lineChartOptions.tooltips;
        }
        console.log(chartData);
        console.log(this.timeLineLabelArr)

        this.timeLineArr.forEach((element, key) => {
            temp.push(element);
            tempdata.push(0);
            tmp2.push(0);
            tmp3.push(0);
            tmp4.push(0);
            if (this.filterObj.timespan) {  // need to handle 
                if (this.timeLineLabelArr.length > 0) {
                    labelData.push(this.timeLineLabelArr[key]);
                } else {
                    labelData.push(element);
                }
            }

        })

        // console.log( labelData )
        // console.log( temp )
        // console.log( this.timeLineArr )
        console.log(ChartFinalArr);
        // return;

        if (chartData.length > 0) {
            let countData = 0;
            let ComulativeAvg = 0;
            let ComulativeAvg2 = 0;
            let ComulativeAvg3 = 0;
            let ComulativeAvg4 = 0;
            // for calculate avg in cumulative scenario
            let avg_obj = {};
            
            this.timeLineLabelArr.forEach(timeEle => {
                console.log(timeEle);
            });

            chartData.forEach(element => {

                

                console.log(element)
                // console.log( typeof element.GROUP_ID)

                let tempI;
                let tempIndexOfTimeLineArr;
                if (this.filterObj.timespan) {
                    tempI = temp.indexOf(element.time)
                    tempIndexOfTimeLineArr = this.timeLineArr.indexOf(element.time)
                } else {
                    // need to handle
                    if (this.filterObj.x_axis == 'vessel') {
                        tempI = temp.indexOf(element.VESSEL_FK)
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(element.VESSEL_FK)
                    }
                    else if (this.filterObj.x_axis == 'vessel_group') {
                        tempI = temp.indexOf(parseInt(element.GROUP_ID));
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(parseInt(element.GROUP_ID))
                    }
                    else if (this.filterObj.x_axis == 'vessel_fleet') {
                        tempI = temp.indexOf(parseInt(element.FLEET_ID))
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(parseInt(element.FLEET_ID))
                    }
                    else if (this.filterObj.x_axis == 'oil_major') {
                        console.log('ssd')
                        tempI = temp.indexOf(parseInt(element.OIL_MAJOR_FK));
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(parseInt(element.OIL_MAJOR_FK))
                    }
                    else if (this.filterObj.x_axis == 'ship_owner') {
                        tempI = temp.indexOf(parseInt(element.VESSEL_OWNER_FK));
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(parseInt(element.VESSEL_OWNER_FK))
                    }
                    else if (this.filterObj.x_axis == 'vessel_type') {
                        tempI = temp.indexOf(parseInt(element.VESSEL_TYPE_ID));
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(parseInt(element.VESSEL_TYPE_ID))
                    }
                    else if (this.filterObj.x_axis == 'vessel_marine' || this.filterObj.x_axis == 'vessel_technical') {
                        tempI = temp.indexOf(parseInt(element.USER_ID));
                        tempIndexOfTimeLineArr = this.timeLineArr.indexOf(parseInt(element.USER_ID))
                    }

                }


                
                // this is for avg obs and avg_risk
                if(!avg_obj[tempI]){
                    avg_obj[tempI] = {
                        total_inspection : 0,
                        total_obs : 0,
                        total_risk : 0
                    }
                }


                console.log(tempI, tempIndexOfTimeLineArr)
                if (tempI > -1 && tempIndexOfTimeLineArr > -1) {
                    if (element.report_id) {
                        element.report_id.split(',').forEach(rId => {
                            if (this.generate_report_id.indexOf(rId) == -1) {
                                this.generate_report_id.push(rId);
                            }
                        });
                    }

                    if (this.filterObj.y_axis == 'total_inspection') {

                        if (this.filterObj.consolidated_ship == 'true') {

                            // ComulativeAvg = Number( ComulativeAvg ) + Number( element.total_inspection );
                            // if(max < ComulativeAvg){
                            //     max = ComulativeAvg;
                            // }
                            //  ChartFinalArr["data"].data[tempI] = ComulativeAvg;
                            if (ChartFinalArr["data"].data[tempI]) {
                                ChartFinalArr["data"].data[tempI] += Number(element.total_inspection);;
                            }
                            else {
                                ChartFinalArr["data"].data[tempI] = Number(element.total_inspection);
                            }
                        } else {
                            if (max < parseInt(element.total_inspection)) {
                                max = parseInt(element.total_inspection);
                            }
                            ChartFinalArr[element[dataKey]].data[tempI] = element.total_inspection;
                        }
                    }
                    else if (this.filterObj.y_axis == 'total_observation') {

                        if (this.filterObj.consolidated_ship == 'true') {
                            // ComulativeAvg = Number( ComulativeAvg ) + Number( element.total_obs );
                            // if(max < ComulativeAvg){
                            //     max = ComulativeAvg;
                            // }
                            // ChartFinalArr["data"].data[tempI] = ComulativeAvg;
                            if (ChartFinalArr["data"].data[tempI]) {
                                ChartFinalArr["data"].data[tempI] += Number(element.total_final_obs);;
                            }
                            else {
                                ChartFinalArr["data"].data[tempI] = Number(element.total_final_obs);
                            }
                        } else {
                            if (max < parseInt(element.total_final_obs)) {
                                max = parseInt(element.total_final_obs);
                            }
                            ChartFinalArr[element[dataKey]].data[tempI] = element.total_final_obs;
                        }

                    }
                    else if (this.filterObj.y_axis == 'avg_observation') {

                        let avg_observation: any = 0;
                        if (this.filterObj.x_axis == 'viq_chapter') {
                            let total_inspection = inChartData[1][0].total_inspection;// this is whole chapter total inspection
                            avg_observation = total_inspection ? (element.total_final_obs / total_inspection).toFixed(2) : 0;;
                        } else {

                            avg_observation = element.total_inspection ? (element.total_final_obs / element.total_inspection).toFixed(2) : 0;
                        }

                        if (this.filterObj.consolidated_ship == 'true') {
                            countData++;
                            // ComulativeAvg = Number( ComulativeAvg ) + Number( avg_observation );
                            // if(max < ComulativeAvg){
                            //     max = ComulativeAvg;
                            // }
                            //  ChartFinalArr["data"].data[tempI] = ComulativeAvg;
                            
                            avg_obj[tempI].total_inspection += Number(element.total_inspection)
                            avg_obj[tempI].total_obs += Number(element.total_final_obs)
                            console.log("total_inspection,total_obs --- ",avg_obj);
                            if (ChartFinalArr["data"].data[tempI]) {
                                ChartFinalArr["data"].data[tempI] = (avg_obj[tempI].total_obs / avg_obj[tempI].total_inspection).toFixed(2);
                            }
                            else {
                                ChartFinalArr["data"].data[tempI] = Number(avg_observation);
                            }
                        } else {
                            if (max < parseInt(avg_observation)) {
                                max = parseInt(avg_observation);
                            }
                            ChartFinalArr[element[dataKey]].data[tempI] = avg_observation;
                        }

                    } else if (this.filterObj.y_axis == 'avg_risk') {
                        let avg_risk;
                        if (this.isRiskCompany) {
                            avg_risk = element.total_final_obs ? (element.company_total_risk / element.total_final_obs).toFixed(2) : 0;
                        } else {
                            avg_risk = element.total_final_obs ? (element.total_risk / element.total_final_obs).toFixed(2) : 0;
                        }

                        if (this.filterObj.consolidated_ship == 'true') {
                            countData++;
                            // ComulativeAvg = Number( ComulativeAvg ) + Number( avg_risk );
                            // if(max < ComulativeAvg){
                            //     max = ComulativeAvg;
                            // }
                            //  ChartFinalArr["data"].data[tempI] = ComulativeAvg;
                            if (this.isRiskCompany) {
                                avg_obj[tempI].total_risk += Number(element.company_total_risk)
                            } else {
                                avg_obj[tempI].total_risk += Number(element.total_risk)
                            }
                            avg_obj[tempI].total_obs = + Number(element.total_obs)

                            if (ChartFinalArr["data"].data[tempI]) {
                                ChartFinalArr["data"].data[tempI] += avg_obj[tempI].total_risk / avg_obj[tempI].total_obs;
                            }
                            else {
                                ChartFinalArr["data"].data[tempI] = avg_obj[tempI].total_risk / avg_obj[tempI].total_obs;
                            }
                        } else {
                            if (max < parseInt(avg_risk)) {
                                max = parseInt(avg_risk);
                            }
                            ChartFinalArr[element[dataKey]].data[tempI] = avg_risk;

                        }

                    } else if (this.filterObj.y_axis == 'top_ten_repeat_question') {
                        if (max < parseInt(element.count)) {
                            max = parseInt(element.count);
                        }

                        ChartFinalArr[element[dataKey]].data[tempI] = element.count;
                    } else if (this.filterObj.y_axis == 'risk_value_count') {
                        let low_risk, medium_risk, high_risk, vhigh_risk;

                        if (this.isRiskCompany) {
                            vhigh_risk = element.company_total_very_high_risk;
                            high_risk = element.company_total_high_risk;
                            medium_risk = element.company_total_medium_risk;
                            low_risk = element.company_total_low_risk;
                        } else {
                            vhigh_risk = element.total_very_high_risk;
                            high_risk = element.total_high_risk;
                            medium_risk = element.total_medium_risk;
                            low_risk = element.total_low_risk;
                        }

                        if (this.filterObj.consolidated_ship == 'true') {
                            countData++;
                            ComulativeAvg = Number(ComulativeAvg) + Number(low_risk);
                            ComulativeAvg2 = Number(ComulativeAvg2) + Number(medium_risk);
                            ComulativeAvg3 = Number(ComulativeAvg3) + Number(high_risk);
                            ComulativeAvg4 = Number(ComulativeAvg4) + Number(vhigh_risk);

                            if (DataTempArr.length > 0) {
                                DataTempArr[0].data[tempI] = ComulativeAvg;
                                DataTempArr[1].data[tempI] = ComulativeAvg2;
                                DataTempArr[2].data[tempI] = ComulativeAvg3;
                                DataTempArr[3].data[tempI] = ComulativeAvg4;
                            }
                            else {
                                tempdata[tempI] = ComulativeAvg;
                                DataTempArr.push({ data: tempdata, label: 'Low' });
                                tmp2[tempI] = ComulativeAvg2;
                                DataTempArr.push({ data: tmp2, label: 'Medium' });
                                tmp3[tempI] = ComulativeAvg3;
                                DataTempArr.push({ data: tmp3, label: 'High' });
                                tmp4[tempI] = ComulativeAvg4;
                                DataTempArr.push({ data: tmp4, label: 'V.High' });
                                if (max < ComulativeAvg) {
                                    max = ComulativeAvg;
                                }
                                if (max < ComulativeAvg2 && ComulativeAvg < ComulativeAvg2) {
                                    max = ComulativeAvg2;
                                }
                                if (max < ComulativeAvg3 && ComulativeAvg2 < ComulativeAvg3) {
                                    max = ComulativeAvg3;
                                }
                                if (max < ComulativeAvg4 && ComulativeAvg3 < ComulativeAvg4) {
                                    max = ComulativeAvg4;

                                }

                            }

                            if (max < ComulativeAvg) {
                                max = ComulativeAvg;
                            }
                            if (max < ComulativeAvg2 && ComulativeAvg < ComulativeAvg2) {
                                max = ComulativeAvg2;
                            }
                            if (max < ComulativeAvg3 && ComulativeAvg2 < ComulativeAvg3) {
                                max = ComulativeAvg3;
                            }
                            if (max < ComulativeAvg4 && ComulativeAvg3 < ComulativeAvg4) {
                                max = ComulativeAvg4;

                            }
                        } else {


                            if (DataTempArr.length > 0) {
                                DataTempArr[0].data[tempI] = low_risk;
                                DataTempArr[1].data[tempI] = medium_risk;
                                DataTempArr[2].data[tempI] = high_risk;
                                DataTempArr[3].data[tempI] = vhigh_risk;
                            }
                            else {
                                tempdata[tempI] = low_risk;
                                DataTempArr.push({ data: tempdata, label: 'Low' });
                                tmp2[tempI] = medium_risk;
                                DataTempArr.push({ data: tmp2, label: 'Medium' });
                                tmp3[tempI] = high_risk;
                                DataTempArr.push({ data: tmp3, label: 'High' });
                                tmp4[tempI] = vhigh_risk;
                                DataTempArr.push({ data: tmp4, label: 'V.High' });
                                if (max < low_risk) {
                                    max = low_risk;
                                }
                                if (max < medium_risk && low_risk < medium_risk) {
                                    max = medium_risk;
                                }
                                if (max < high_risk && medium_risk < high_risk) {
                                    max = high_risk;
                                }
                                if (max < vhigh_risk && high_risk < vhigh_risk) {
                                    max = vhigh_risk;
                                }

                            }

                            if (max < low_risk) {
                                max = low_risk;
                            }
                            if (max < medium_risk && low_risk < medium_risk) {
                                max = medium_risk;
                            }
                            if (max < high_risk && medium_risk < high_risk) {
                                max = high_risk;
                            }
                            if (max < vhigh_risk && high_risk < vhigh_risk) {
                                max = vhigh_risk;
                            }

                            // }

                        }
                    }
                }
            });

            // if(this.filterObj.y_axis == 'risk_value_count' ) {
            //     tempdata[0] = ComulativeAvg ? Math.round( ComulativeAvg / countData) : 0 ;
            //     DataTempArr.push({ data: tempdata, label: 'Low' });
            //     tmp2[0] = ComulativeAvg2 ?  Math.round( ComulativeAvg2 / countData) : 0 ;
            //     DataTempArr.push({ data: tmp2, label: 'Medium' });
            //     tmp3[0] = ComulativeAvg3 ?  Math.round( ComulativeAvg3 / countData) : 0 ;
            //     DataTempArr.push({ data: tmp3, label: 'High' });
            //     tmp4[0] = ComulativeAvg4 ?  Math.round( ComulativeAvg4 / countData) : 0 ;
            //     DataTempArr.push({ data: tmp4, label: 'V.High' });

            // }
        }
        console.log(ChartFinalArr)

        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        // this.lineChartOptions.scales.yAxes[0].ticks.max = Math.ceil(max)+2;
        // console.log('dataArr');
        // console.log(dataArr);
        if (Object.keys(ChartFinalArr).length > 0) {
            Object.keys(ChartFinalArr).forEach((ele) => {
                this.lineChartData.push(ChartFinalArr[ele])
            })
        }

        else {
            if (this.filterObj.y_axis != 'risk_value_count') {
                this.lineChartData.push({ data: tempdata, label: this.y_axis_label[this.filterObj.y_axis] })
            }
            else {
                if (DataTempArr.length > 0) {
                    DataTempArr.forEach((ele) => {
                        this.lineChartData.push(ele)
                    })
                } else {
                    this.lineChartData.push({ data: tempdata, label: 'Low' });
                    this.lineChartData.push({ data: tmp2, label: 'Medium' });
                    this.lineChartData.push({ data: tmp3, label: 'High' });
                    this.lineChartData.push({ data: tmp4, label: 'V.High' });
                }
            }
        }
        //this.lineChartData.push({data : tempdata,label:this.y_axis_label[this.filterObj.y_axis]});
        labelData.forEach((ele) => {
            this.lineChartLabels.push(ele)
        })
        console.log(this.lineChartData);
        console.log(this.lineChartLabels);
        this.generateReport(false); // get report 
    }



    makeChartForNumberOfObs(chartData) {
        let labelData = [];
        let dataArr = [];
        let j = 0;
        chartData.forEach(element => {
            if (element.total_obs - j > 0) {
                let length = element.total_obs - j;
                for (let i = 0; i < length; i++) {
                    labelData.push(j++);
                    dataArr.push(0);
                }
            }
            j = element.total_obs + 1;
            labelData.push(element.total_obs);
            if (this.filterObj.y_axis == 'total_inspection') {
                dataArr.push(element.TOTAL_INSPECTION);
            }
            else if (this.filterObj.y_axis == 'avg_risk') {
                if (this.isRiskCompany) {
                    dataArr.push(element.total_obs ? (element.company_total_risk / element.total_obs).toFixed(2) : 0);
                } else {
                    dataArr.push(element.total_obs ? (element.total_risk / element.total_obs).toFixed(2) : 0);
                }
            }
        });
        this.lineChartData.length = 0;
        this.lineChartLabels.length = 0;
        labelData.forEach((ele) => {
            this.lineChartLabels.push(ele);
        })
        this.lineChartData.push({ data: dataArr, label: this.y_axis_label[this.filterObj.y_axis] })
    }
    getDataForDisplayOilMajorChart() {
        this.generate_report_id.length = 0;
        this.showLoader = true;
        this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-wizard-data-for-oil-major-chart', 'postData': this.filterObj }).subscribe(result => {
            if (result.status) {
                let chartData = result.data;
                let dataArr = [];
                this.lineChartLabels.length = 0;
                this.lineChartData.length = 0;
                chartData.forEach(element => {
                    element.report_id.split(',').forEach(rId => {
                        if (this.generate_report_id.indexOf(rId) == -1) {
                            this.generate_report_id.push(rId);
                        }
                    });
                    this.lineChartLabels.push(element.INSPECTING_COMPANY);
                    dataArr.push(element.total_inspection);
                });
                this.lineChartData.push({ data: dataArr, label: this.y_axis_label[this.filterObj.y_axis] });
                this.showLoader = false;
                this.tabs.select('step2');
            }
        })
    }
    openModelForShareReport(id, content) {
        let postData = { templateId: id };
        this.commonService.sendRequestToNode({ method: 'post', path: 'chart/get-share-wizard-report', 'postData': postData }).subscribe(result => {
            if (result.data.user_ids && result.data.user_ids != null) {
                this.modalObj.users = result.data.user_ids.split(',').map(res => parseInt(res));
            }
            else {
                this.modalObj.users = []
            }
            if (id) {
                this.modalObj.templateId = id;
                this.modalRef = this.modalService.open(content, { size: 'sm' });
            }
        })
    }
    shareReport() {
        if (this.modalObj.templateId && this.modalObj.users.length > 0) {
            this.commonService.sendRequestToNode({ method: 'post', path: 'chart/share-wizard-report', postData: this.modalObj }).subscribe(result => {
                if (result.status) {
                    this.modalRef.close();
                    swal({
                        title: 'Success',
                        text: 'Report Template Shared Successfully',
                        type: 'success',
                        confirmButtonClass: "btn btn-success",
                        buttonsStyling: false
                    });
                } else {
                    alert(result.message);
                }
            });
        }
    }

    show_wizard_report_from_list(obj) {
        if (obj) {
            this.filterObj = JSON.parse(obj);
            this.getDropDownFrom_xaxis(1);
            this.getXaxis(1);
            this.goForChart();
        }
        else {
        }
    }

    exportGraph() {
        // var canvas:any = document.getElementById("contentToConvert");
        // var image = canvas.toDataURL("image/png"); 
        // var link = document.createElement('a');
        //     link.download = this.filterObj.x_axis + '-'+ this.filterObj.y_axis +'.png';
        //     link.href = image;
        //     link.click();

        html2canvas(this.screen.nativeElement).then(canvas => {
            this.canvas.nativeElement.src = canvas.toDataURL();
            this.downloadLink.nativeElement.href = canvas.toDataURL('image/png');
            this.canvas.nativeElement.remove();
            this.downloadLink.nativeElement.download = this.y_axis_label[this.filterObj.y_axis] + "/ " + this.x_axis_label[this.filterObj.x_axis] + '.png';
            this.downloadLink.nativeElement.click();

        });
    }

    change_vessel() {
        let arr = []
        this.filterObj.selectedValueForX_axis.forEach(ele => {
            if (ele == 'ALL') {
                arr = this.vessel_dropdown.map(e => {
                    return e.value;
                })
                arr = arr.filter(e => {
                    return !(e == 'ALL');
                })

            }
        })
        if (arr.length > 0) {
            this.filterObj.selectedValueForX_axis = arr;
        }
        // console.log(arr);return false;

    }

    filter($event) {
        console.log($event)
        let obj = $event;
        this.currentPage = obj.page;
        this.dataFilter = obj.filter;
        this.sortFilter = obj.sort
        this.generateReport();
    }
    resetYAxisValue() {
        // this.filterOberverCodeByAuditType();
        this.getYaxis();
        this.getXaxis();
        // if(this.filterObj.audit_type == 2){
        //    this.filterObj.X_axis_max_item_selection = 9999;
        // }
        // else{
        //     this.filterObj.X_axis_max_item_selection = (this.filterObj.timespan && this.filterObj.consolidated_ship == 'false') ? 1 : 9999;
        // }
        // alert(this.filterObj.X_axis_max_item_selection)
        // this.filterObj.selectedValueForX_axis = null;
    }

    getYaxis(call_from_save_report = 0) {
        (call_from_save_report == 0) ? this.filterObj.x_axis = null : '';
        this.filterObj.y_axis = null;

        if (this.filterObj.consolidated_ship == 'true') {
            // Commulative
            this.y_axis_dropdown = [
                { ID: 'avg_observation', ITEM: "Average Number of observations" },
                { ID: 'total_observation', ITEM: "Total Number of Observations" },
                { ID: 'total_inspection', ITEM: "Total number of Inspections" },
                { ID: 'avg_risk', ITEM: "Average Risk Value" },
                { ID: 'risk_value_count', ITEM: "Number of V.High, High, Medium, Low Obs" },
                { ID: 'oil_major', ITEM: "Inspection per Oil Major" },
                { ID: 'top_ten_repeat_question', ITEM: "Top 10 Repeat Questions" },

            ];
        } else {
            // Vessel wise
            if (this.filterObj.timespan) {
                this.y_axis_dropdown = [
                    { ID: 'avg_observation', ITEM: "Average Number of observations" },
                    { ID: 'total_observation', ITEM: "Total Number of Observations" },
                    { ID: 'total_inspection', ITEM: "Total number of Inspections" },
                    { ID: 'avg_risk', ITEM: "Average Risk Value" },
                    { ID: 'risk_value_count', ITEM: "Number of V.High, High, Medium, Low Obs" },
                    { ID: 'oil_major', ITEM: "Inspection per Oil Major" },
                ];
            } else {
                this.y_axis_dropdown = [
                    { ID: 'avg_observation', ITEM: "Average Number of observations" },
                    { ID: 'total_observation', ITEM: "Total Number of Observations" },
                    { ID: 'total_inspection', ITEM: "Total number of Inspections" },
                    { ID: 'avg_risk', ITEM: "Average Risk Value" },
                    { ID: 'risk_value_count', ITEM: "Number of V.High, High, Medium, Low Obs" },
                    { ID: 'oil_major', ITEM: "Inspection per Oil Major" },
                    { ID: 'top_ten_repeat_question', ITEM: "Top 10 Repeat Questions" },
                ];
            }
        }



        // if(this.filterObj.timespan){
        //     // remove timespan from x_axis when Default timeSpan selected
        //     this.x_axis_dropdown = this.x_axis_dropdown.filter(ele=>{
        //         if(ele.ID == 'timespan'){
        //             return false;
        //         }
        //         else{
        //             return true;
        //         }
        //     })
        // }

    }

}