import { NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';
import { FormsModule } from '@angular/forms';
import { Routes, RouterModule } from '@angular/router';
import { NgbModule } from '@ng-bootstrap/ng-bootstrap';
import { NgSelectModule } from '@ng-select/ng-select';
import { ChartsModule } from 'ng2-charts';
import { GoogleChartsModule } from 'angular-google-charts';
import { UiSwitchModule } from 'ngx-toggle-switch';
import { NgbTabset } from '@ng-bootstrap/ng-bootstrap';

import { WizardComponent } from './wizard.component';

import { TagInputModule } from 'ngx-chips';
import { GridViewModule} from '../shared/grid-view/grid-view.module';
import { gray } from 'd3';


const routes: Routes = [
  {
    path: '',
    data: {
      title: 'Vetting Analytics',
      urls: [
        { title: 'Home', url: '/home' },
        { title: 'Vetting Analytics' }
      ]
    },
    component: WizardComponent
  }
];

@NgModule({
  imports: [
    FormsModule,
    CommonModule,
    RouterModule.forChild(routes),
    NgbModule,
    NgSelectModule,
    ChartsModule,
    GoogleChartsModule.forRoot(),
    UiSwitchModule,
    TagInputModule,
    GridViewModule
    
  ],
  declarations: [
    WizardComponent
  ],
  providers: [
    NgbTabset
]
})
export class WizardModule {}
